MODULE MODE_BUDGET
USE MODD_BUDGET, ONLY : TBUDGETDATA
USE MODI_BUDGET_DDH, ONLY: BUDGET_DDH
IMPLICIT NONE
CONTAINS

SUBROUTINE BUDGET_STORE_INIT(TPBUDGET, HSOURCE, PVARS)
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(:,:,:), INTENT(IN)    :: PVARS    ! Current value to be stored
END SUBROUTINE BUDGET_STORE_INIT
!
SUBROUTINE BUDGET_STORE_INIT_PHY(D,TPBUDGET, HSOURCE, PVARS)
  USE MODD_DIMPHYEX, ONLY: DIMPHYEX_t
  TYPE(DIMPHYEX_t),       INTENT(IN)    :: D
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(D%NIT,D%NJT,D%NKT), INTENT(IN)    :: PVARS    ! Current value to be stored
END SUBROUTINE BUDGET_STORE_INIT_PHY
!
SUBROUTINE BUDGET_STORE_END(TPBUDGET, HSOURCE, PVARS)
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(:,:,:), INTENT(IN)    :: PVARS    ! Current value to be stored
  CALL BUDGET_DDH(PVARS, TPBUDGET%NBUDGET, HSOURCE, TPBUDGET%YDDDH, TPBUDGET%YDLDDH, TPBUDGET%YDMDDH)
END SUBROUTINE BUDGET_STORE_END
!
SUBROUTINE BUDGET_STORE_END_PHY(D,TPBUDGET, HSOURCE, PVARS)
  USE MODD_DIMPHYEX, ONLY: DIMPHYEX_t
  TYPE(DIMPHYEX_t),       INTENT(IN)    :: D
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(D%NIT,D%NJT,D%NKT), INTENT(IN)    :: PVARS    ! Current value to be stored
  CALL BUDGET_STORE_END(TPBUDGET, HSOURCE, PVARS)
END SUBROUTINE BUDGET_STORE_END_PHY
!
SUBROUTINE BUDGET_STORE_ADD_PHY(D,TPBUDGET, HSOURCE, PVARS)
  USE MODD_DIMPHYEX, ONLY: DIMPHYEX_t
  TYPE(DIMPHYEX_t),       INTENT(IN)    :: D
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(D%NIT,D%NJT,D%NKT), INTENT(IN)    :: PVARS    ! Current value to be stored
  CALL BUDGET_STORE_ADD(TPBUDGET, HSOURCE, PVARS)
END SUBROUTINE BUDGET_STORE_ADD_PHY
!
SUBROUTINE BUDGET_STORE_ADD(TPBUDGET, HSOURCE, PVARS)
#ifdef REPRO48
USE DDH_MIX, ONLY:NFLEVGDDH
USE MODDB_INTBUDGET, ONLY:TVARSM
#endif
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(:,:,:), INTENT(IN)    :: PVARS    ! Current value to be stored
#ifdef REPRO48
  REAL, DIMENSION(SIZE(PVARS, 1), SIZE(PVARS, 2), SIZE(PVARS, 3)) :: ZVARS
  INTEGER :: JLON, JLEV, IOFF
  IF (SIZE(PVARS,3)==NFLEVGDDH+2) THEN
    IOFF=1
  ELSE
    IOFF=0
  ENDIF
  ZVARS=PVARS
  DO JLEV=1, NFLEVGDDH
    DO JLON=1, SIZE(PVARS,1)
      IF (TPBUDGET%YDLDDH%LDDH_OMP) THEN
        ZVARS(JLON,1,JLEV+IOFF)=TPBUDGET%YDDDH%RVARSM(JLON,1,JLEV,TPBUDGET%NBUDGET)+ZVARS(JLON,1,JLEV+IOFF)
      ELSE
        ZVARS(JLON,1,JLEV+IOFF)=TVARSM(JLON,1,JLEV,TPBUDGET%NBUDGET)+ZVARS(JLON,1,JLEV+IOFF)
      ENDIF
    ENDDO
  ENDDO
  CALL BUDGET_DDH(ZVARS, TPBUDGET%NBUDGET, HSOURCE, TPBUDGET%YDDDH, TPBUDGET%YDLDDH, TPBUDGET%YDMDDH)
#else
  CALL BUDGET_DDH(PVARS, TPBUDGET%NBUDGET, HSOURCE, TPBUDGET%YDDDH, TPBUDGET%YDLDDH, TPBUDGET%YDMDDH, &
                 &LDISDIFF=.TRUE.)
#endif
END SUBROUTINE BUDGET_STORE_ADD
END MODULE MODE_BUDGET
