!     ######spl
      SUBROUTINE CH_JAC(PTIME,PCONC,PJAC,KMI,KVECNPT,KEQ)
      USE PARKIND1, ONLY : JPRB
      USE YOMHOOK , ONLY : LHOOK, DR_HOOK
!!    #######################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *CH_JAC*
!!
!!    PURPOSE
!!    -------
!       calculation of the JACOBIAN matrix
!!
!!**  METHOD
!!    ------
!!      The Jacobian matrix J is calculated as defined by the chemical
!!    reaction mechanism.
!!    The reaction rates and other user-defined auxiliary variables are
!!    transfered in the TYPE(CCSTYPE) variable TPK%.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                              :: PTIME
INTEGER, INTENT(IN)                              :: KVECNPT
INTEGER, INTENT(IN)                              :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KEQ) :: PJAC
INTEGER, INTENT(IN)                              :: KMI
!
TYPE(CCSTYPE),                    POINTER        :: TPK
!!
!!----------------------------------------------------------------------
!!
REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('CH_JAC',0,ZHOOK_HANDLE)
TPK=>TACCS(KMI)
!
! /BEGIN_CODE/
 TPK%O1D(:)=(TPK%K002(:)*PCONC(:,JP_O3))/(TPK%K020(:)*TPK%N2(:)+TPK%K021(:)*TPK%O2(:)+&
            &TPK%K022(:)*TPK%H2O(:))


 TPK%O3P(:)=(TPK%K001(:)*PCONC(:,JP_NO2)+TPK%K003(:)*PCONC(:,JP_O3)+TPK%K008(:)*PCONC(:,JP_NO3)+&
            &TPK%K020(:)*TPK%O1D(:)*TPK%N2(:)+TPK%K021(:)*TPK%O1D(:)*TPK%O2(:)+&
            &0.00000*TPK%K076(:)*PCONC(:,JP_ALKE)*PCONC(:,JP_O3)+&
            &0.09000*TPK%K077(:)*PCONC(:,JP_BIO)*PCONC(:,JP_O3))/&
            &(TPK%K018(:)*TPK%O2(:)+TPK%K019(:)*PCONC(:,JP_O3)+TPK%K029(:)*PCONC(:,JP_NO)+&
            &TPK%K030(:)*PCONC(:,JP_NO2)+TPK%K031(:)*PCONC(:,JP_NO2)+TPK%K053(:)*PCONC(:,JP_BIO)+&
            &TPK%K054(:)*PCONC(:,JP_CARBO))


! /END_CODE/
PJAC(:,:,:) = 0.0
!
!O3/O3=-K002-K003-K019*<O3P>-K023*<OH>-K024*<HO2>-K042*<NO>-K043*<NO2>-K076*<AL
!KE>-K077*<BIO>-K078*<CARBO>-K079*<PAN>-K084*<ADD>
 PJAC(:,1,1)=-TPK%K002(:)-TPK%K003(:)-TPK%K019(:)*TPK%O3P(:)-TPK%K023(:)*PCONC(&
&:,14)-TPK%K024(:)*PCONC(:,15)-TPK%K042(:)*PCONC(:,3)-TPK%K043(:)*PCONC(:,4)-TP&
&K%K076(:)*PCONC(:,19)-TPK%K077(:)*PCONC(:,20)-TPK%K078(:)*PCONC(:,25)-TPK%K079&
&(:)*PCONC(:,27)-TPK%K084(:)*PCONC(:,36)
!
!O3/H2O2=0.0
!
!O3/NO=-K042*<O3>
 PJAC(:,1,3)=-TPK%K042(:)*PCONC(:,1)
!
!O3/NO2=-K043*<O3>
 PJAC(:,1,4)=-TPK%K043(:)*PCONC(:,1)
!
!O3/NO3=0.0
!
!O3/N2O5=0.0
!
!O3/HONO=0.0
!
!O3/HNO3=0.0
!
!O3/HNO4=0.0
!
!O3/NH3=0.0
!
!O3/SO2=0.0
!
!O3/SULF=0.0
!
!O3/CO=0.0
!
!O3/OH=-K023*<O3>
 PJAC(:,1,14)=-TPK%K023(:)*PCONC(:,1)
!
!O3/HO2=-K024*<O3>+0.17307*K099*<CARBOP>
 PJAC(:,1,15)=-TPK%K024(:)*PCONC(:,1)+0.17307*TPK%K099(:)*PCONC(:,38)
!
!O3/CH4=0.0
!
!O3/ETH=0.0
!
!O3/ALKA=0.0
!
!O3/ALKE=-K076*<O3>
 PJAC(:,1,19)=-TPK%K076(:)*PCONC(:,1)
!
!O3/BIO=-K077*<O3>
 PJAC(:,1,20)=-TPK%K077(:)*PCONC(:,1)
!
!O3/ARO=0.0
!
!O3/HCHO=0.0
!
!O3/ALD=0.0
!
!O3/KET=0.0
!
!O3/CARBO=-K078*<O3>
 PJAC(:,1,25)=-TPK%K078(:)*PCONC(:,1)
!
!O3/ONIT=0.0
!
!O3/PAN=-K079*<O3>
 PJAC(:,1,27)=-TPK%K079(:)*PCONC(:,1)
!
!O3/OP1=0.0
!
!O3/OP2=0.0
!
!O3/ORA2=0.0
!
!O3/MO2=0.0
!
!O3/ALKAP=0.0
!
!O3/ALKEP=0.0
!
!O3/BIOP=0.0
!
!O3/PHO=0.0
!
!O3/ADD=-K084*<O3>
 PJAC(:,1,36)=-TPK%K084(:)*PCONC(:,1)
!
!O3/AROP=0.0
!
!O3/CARBOP=+0.17307*K099*<HO2>
 PJAC(:,1,38)=+0.17307*TPK%K099(:)*PCONC(:,15)
!
!O3/OLN=0.0
!
!O3/XO2=0.0
!
!H2O2/O3=+0.01833*K076*<ALKE>+0.00100*K077*<BIO>
 PJAC(:,2,1)=+0.01833*TPK%K076(:)*PCONC(:,19)+0.00100*TPK%K077(:)*PCONC(:,20)
!
!H2O2/H2O2=-K009-K026*<OH>
 PJAC(:,2,2)=-TPK%K009(:)-TPK%K026(:)*PCONC(:,14)
!
!H2O2/NO=0.0
!
!H2O2/NO2=0.0
!
!H2O2/NO3=0.0
!
!H2O2/N2O5=0.0
!
!H2O2/HONO=0.0
!
!H2O2/HNO3=0.0
!
!H2O2/HNO4=0.0
!
!H2O2/NH3=0.0
!
!H2O2/SO2=0.0
!
!H2O2/SULF=0.0
!
!H2O2/CO=0.0
!
!H2O2/OH=-K026*<H2O2>
 PJAC(:,2,14)=-TPK%K026(:)*PCONC(:,2)
!
!H2O2/HO2=+K027*<HO2>+K027*<HO2>+K028*<HO2>*<H2O>+K028*<HO2>*<H2O>
 PJAC(:,2,15)=+TPK%K027(:)*PCONC(:,15)+TPK%K027(:)*PCONC(:,15)+TPK%K028(:)*PCON&
&C(:,15)*TPK%H2O(:)+TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)
!
!H2O2/CH4=0.0
!
!H2O2/ETH=0.0
!
!H2O2/ALKA=0.0
!
!H2O2/ALKE=+0.01833*K076*<O3>
 PJAC(:,2,19)=+0.01833*TPK%K076(:)*PCONC(:,1)
!
!H2O2/BIO=+0.00100*K077*<O3>
 PJAC(:,2,20)=+0.00100*TPK%K077(:)*PCONC(:,1)
!
!H2O2/ARO=0.0
!
!H2O2/HCHO=0.0
!
!H2O2/ALD=0.0
!
!H2O2/KET=0.0
!
!H2O2/CARBO=0.0
!
!H2O2/ONIT=0.0
!
!H2O2/PAN=0.0
!
!H2O2/OP1=0.0
!
!H2O2/OP2=0.0
!
!H2O2/ORA2=0.0
!
!H2O2/MO2=0.0
!
!H2O2/ALKAP=0.0
!
!H2O2/ALKEP=0.0
!
!H2O2/BIOP=0.0
!
!H2O2/PHO=0.0
!
!H2O2/ADD=0.0
!
!H2O2/AROP=0.0
!
!H2O2/CARBOP=0.0
!
!H2O2/OLN=0.0
!
!H2O2/XO2=0.0
!
!NO/O3=-K042*<NO>
 PJAC(:,3,1)=-TPK%K042(:)*PCONC(:,3)
!
!NO/H2O2=0.0
!
!NO/NO=-K029*<O3P>-K032*<OH>-K035*<HO2>-K042*<O3>-K044*<NO>*<O2>-K044*<NO>*<O2>
!-K044*<NO>*<O2>-K044*<NO>*<O2>-K045*<NO3>-K087*<MO2>-K088*<ALKAP>-K089*<ALKEP>
!-K090*<BIOP>-K091*<AROP>-K092*<CARBOP>-K093*<OLN>-K127*<XO2>
 PJAC(:,3,3)=-TPK%K029(:)*TPK%O3P(:)-TPK%K032(:)*PCONC(:,14)-TPK%K035(:)*PCONC(&
&:,15)-TPK%K042(:)*PCONC(:,1)-TPK%K044(:)*PCONC(:,3)*TPK%O2(:)-TPK%K044(:)*PCON&
&C(:,3)*TPK%O2(:)-TPK%K044(:)*PCONC(:,3)*TPK%O2(:)-TPK%K044(:)*PCONC(:,3)*TPK%O&
&2(:)-TPK%K045(:)*PCONC(:,5)-TPK%K087(:)*PCONC(:,31)-TPK%K088(:)*PCONC(:,32)-TP&
&K%K089(:)*PCONC(:,33)-TPK%K090(:)*PCONC(:,34)-TPK%K091(:)*PCONC(:,37)-TPK%K092&
&(:)*PCONC(:,38)-TPK%K093(:)*PCONC(:,39)-TPK%K127(:)*PCONC(:,40)
!
!NO/NO2=+K001+K030*<O3P>+K046*<NO3>
 PJAC(:,3,4)=+TPK%K001(:)+TPK%K030(:)*TPK%O3P(:)+TPK%K046(:)*PCONC(:,5)
!
!NO/NO3=+K007-K045*<NO>+K046*<NO2>
 PJAC(:,3,5)=+TPK%K007(:)-TPK%K045(:)*PCONC(:,3)+TPK%K046(:)*PCONC(:,4)
!
!NO/N2O5=0.0
!
!NO/HONO=+K004
 PJAC(:,3,7)=+TPK%K004(:)
!
!NO/HNO3=0.0
!
!NO/HNO4=0.0
!
!NO/NH3=0.0
!
!NO/SO2=0.0
!
!NO/SULF=0.0
!
!NO/CO=0.0
!
!NO/OH=-K032*<NO>
 PJAC(:,3,14)=-TPK%K032(:)*PCONC(:,3)
!
!NO/HO2=-K035*<NO>
 PJAC(:,3,15)=-TPK%K035(:)*PCONC(:,3)
!
!NO/CH4=0.0
!
!NO/ETH=0.0
!
!NO/ALKA=0.0
!
!NO/ALKE=0.0
!
!NO/BIO=0.0
!
!NO/ARO=0.0
!
!NO/HCHO=0.0
!
!NO/ALD=0.0
!
!NO/KET=0.0
!
!NO/CARBO=0.0
!
!NO/ONIT=0.0
!
!NO/PAN=0.0
!
!NO/OP1=0.0
!
!NO/OP2=0.0
!
!NO/ORA2=0.0
!
!NO/MO2=-K087*<NO>
 PJAC(:,3,31)=-TPK%K087(:)*PCONC(:,3)
!
!NO/ALKAP=-K088*<NO>
 PJAC(:,3,32)=-TPK%K088(:)*PCONC(:,3)
!
!NO/ALKEP=-K089*<NO>
 PJAC(:,3,33)=-TPK%K089(:)*PCONC(:,3)
!
!NO/BIOP=-K090*<NO>
 PJAC(:,3,34)=-TPK%K090(:)*PCONC(:,3)
!
!NO/PHO=0.0
!
!NO/ADD=0.0
!
!NO/AROP=-K091*<NO>
 PJAC(:,3,37)=-TPK%K091(:)*PCONC(:,3)
!
!NO/CARBOP=-K092*<NO>
 PJAC(:,3,38)=-TPK%K092(:)*PCONC(:,3)
!
!NO/OLN=-K093*<NO>
 PJAC(:,3,39)=-TPK%K093(:)*PCONC(:,3)
!
!NO/XO2=-K127*<NO>
 PJAC(:,3,40)=-TPK%K127(:)*PCONC(:,3)
!
!NO2/O3=+K042*<NO>-K043*<NO2>+0.70*K079*<PAN>
 PJAC(:,4,1)=+TPK%K042(:)*PCONC(:,3)-TPK%K043(:)*PCONC(:,4)+0.70*TPK%K079(:)*PC&
&ONC(:,27)
!
!NO2/H2O2=0.0
!
!NO2/NO=+K029*<O3P>+K035*<HO2>+K042*<O3>+K044*<NO>*<O2>+K044*<NO>*<O2>+K044*<NO
!>*<O2>+K044*<NO>*<O2>+K045*<NO3>+K045*<NO3>+K087*<MO2>+0.91541*K088*<ALKAP>+K0
!89*<ALKEP>+0.84700*K090*<BIOP>+0.95115*K091*<AROP>+K092*<CARBOP>+1.81599*K093*
!<OLN>+K127*<XO2>
 PJAC(:,4,3)=+TPK%K029(:)*TPK%O3P(:)+TPK%K035(:)*PCONC(:,15)+TPK%K042(:)*PCONC(&
&:,1)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K04&
&4(:)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K045(:)*PCONC(:&
&,5)+TPK%K045(:)*PCONC(:,5)+TPK%K087(:)*PCONC(:,31)+0.91541*TPK%K088(:)*PCONC(:&
&,32)+TPK%K089(:)*PCONC(:,33)+0.84700*TPK%K090(:)*PCONC(:,34)+0.95115*TPK%K091(&
&:)*PCONC(:,37)+TPK%K092(:)*PCONC(:,38)+1.81599*TPK%K093(:)*PCONC(:,39)+TPK%K12&
&7(:)*PCONC(:,40)
!
!NO2/NO2=-K001-K030*<O3P>-K031*<O3P>-K033*<OH>-K036*<HO2>-K043*<O3>+K046*<NO3>-
!K046*<NO3>-K047*<NO3>-K080*<PHO>-K082*<ADD>-K085*<CARBOP>
 PJAC(:,4,4)=-TPK%K001(:)-TPK%K030(:)*TPK%O3P(:)-TPK%K031(:)*TPK%O3P(:)-TPK%K03&
&3(:)*PCONC(:,14)-TPK%K036(:)*PCONC(:,15)-TPK%K043(:)*PCONC(:,1)+TPK%K046(:)*PC&
&ONC(:,5)-TPK%K046(:)*PCONC(:,5)-TPK%K047(:)*PCONC(:,5)-TPK%K080(:)*PCONC(:,35)&
&-TPK%K082(:)*PCONC(:,36)-TPK%K085(:)*PCONC(:,38)
!
!NO2/NO3=+K008+K034*<OH>+0.7*K038*<HO2>+K045*<NO>+K045*<NO>+K046*<NO2>-K046*<NO
!2>-K047*<NO2>+K049*<NO3>+K049*<NO3>+K049*<NO3>+K049*<NO3>+0.10530*K071*<CARBO>
!+0.40*K075*<PAN>+K116*<MO2>+K117*<ALKAP>+K118*<ALKEP>+K119*<BIOP>+K120*<AROP>+
!K121*<CARBOP>+1.74072*K122*<OLN>+K128*<XO2>
 PJAC(:,4,5)=+TPK%K008(:)+TPK%K034(:)*PCONC(:,14)+0.7*TPK%K038(:)*PCONC(:,15)+T&
&PK%K045(:)*PCONC(:,3)+TPK%K045(:)*PCONC(:,3)+TPK%K046(:)*PCONC(:,4)-TPK%K046(:&
&)*PCONC(:,4)-TPK%K047(:)*PCONC(:,4)+TPK%K049(:)*PCONC(:,5)+TPK%K049(:)*PCONC(:&
&,5)+TPK%K049(:)*PCONC(:,5)+TPK%K049(:)*PCONC(:,5)+0.10530*TPK%K071(:)*PCONC(:,&
&25)+0.40*TPK%K075(:)*PCONC(:,27)+TPK%K116(:)*PCONC(:,31)+TPK%K117(:)*PCONC(:,3&
&2)+TPK%K118(:)*PCONC(:,33)+TPK%K119(:)*PCONC(:,34)+TPK%K120(:)*PCONC(:,37)+TPK&
&%K121(:)*PCONC(:,38)+1.74072*TPK%K122(:)*PCONC(:,39)+TPK%K128(:)*PCONC(:,40)
!
!NO2/N2O5=+K048
 PJAC(:,4,6)=+TPK%K048(:)
!
!NO2/HONO=+K039*<OH>
 PJAC(:,4,7)=+TPK%K039(:)*PCONC(:,14)
!
!NO2/HNO3=+K005
 PJAC(:,4,8)=+TPK%K005(:)
!
!NO2/HNO4=+0.65*K006+K037+K041*<OH>
 PJAC(:,4,9)=+0.65*TPK%K006(:)+TPK%K037(:)+TPK%K041(:)*PCONC(:,14)
!
!NO2/NH3=0.0
!
!NO2/SO2=0.0
!
!NO2/SULF=0.0
!
!NO2/CO=0.0
!
!NO2/OH=-K033*<NO2>+K034*<NO3>+K039*<HONO>+K041*<HNO4>+K068*<ONIT>
 PJAC(:,4,14)=-TPK%K033(:)*PCONC(:,4)+TPK%K034(:)*PCONC(:,5)+TPK%K039(:)*PCONC(&
&:,7)+TPK%K041(:)*PCONC(:,9)+TPK%K068(:)*PCONC(:,26)
!
!NO2/HO2=+K035*<NO>-K036*<NO2>+0.7*K038*<NO3>
 PJAC(:,4,15)=+TPK%K035(:)*PCONC(:,3)-TPK%K036(:)*PCONC(:,4)+0.7*TPK%K038(:)*PC&
&ONC(:,5)
!
!NO2/CH4=0.0
!
!NO2/ETH=0.0
!
!NO2/ALKA=0.0
!
!NO2/ALKE=0.0
!
!NO2/BIO=0.0
!
!NO2/ARO=0.0
!
!NO2/HCHO=0.0
!
!NO2/ALD=0.0
!
!NO2/KET=0.0
!
!NO2/CARBO=+0.10530*K071*<NO3>
 PJAC(:,4,25)=+0.10530*TPK%K071(:)*PCONC(:,5)
!
!NO2/ONIT=+K017+K068*<OH>
 PJAC(:,4,26)=+TPK%K017(:)+TPK%K068(:)*PCONC(:,14)
!
!NO2/PAN=+0.40*K075*<NO3>+0.70*K079*<O3>+K086
 PJAC(:,4,27)=+0.40*TPK%K075(:)*PCONC(:,5)+0.70*TPK%K079(:)*PCONC(:,1)+TPK%K086&
&(:)
!
!NO2/OP1=0.0
!
!NO2/OP2=0.0
!
!NO2/ORA2=0.0
!
!NO2/MO2=+K087*<NO>+0.32440*K107*<OLN>+K116*<NO3>
 PJAC(:,4,31)=+TPK%K087(:)*PCONC(:,3)+0.32440*TPK%K107(:)*PCONC(:,39)+TPK%K116(&
&:)*PCONC(:,5)
!
!NO2/ALKAP=+0.91541*K088*<NO>+K117*<NO3>
 PJAC(:,4,32)=+0.91541*TPK%K088(:)*PCONC(:,3)+TPK%K117(:)*PCONC(:,5)
!
!NO2/ALKEP=+K089*<NO>+K118*<NO3>
 PJAC(:,4,33)=+TPK%K089(:)*PCONC(:,3)+TPK%K118(:)*PCONC(:,5)
!
!NO2/BIOP=+0.84700*K090*<NO>+K119*<NO3>
 PJAC(:,4,34)=+0.84700*TPK%K090(:)*PCONC(:,3)+TPK%K119(:)*PCONC(:,5)
!
!NO2/PHO=-K080*<NO2>
 PJAC(:,4,35)=-TPK%K080(:)*PCONC(:,4)
!
!NO2/ADD=-K082*<NO2>
 PJAC(:,4,36)=-TPK%K082(:)*PCONC(:,4)
!
!NO2/AROP=+0.95115*K091*<NO>+K120*<NO3>
 PJAC(:,4,37)=+0.95115*TPK%K091(:)*PCONC(:,3)+TPK%K120(:)*PCONC(:,5)
!
!NO2/CARBOP=-K085*<NO2>+K092*<NO>+0.00000*K113*<OLN>+K121*<NO3>
 PJAC(:,4,38)=-TPK%K085(:)*PCONC(:,4)+TPK%K092(:)*PCONC(:,3)+0.00000*TPK%K113(:&
&)*PCONC(:,39)+TPK%K121(:)*PCONC(:,5)
!
!NO2/OLN=+1.81599*K093*<NO>+0.32440*K107*<MO2>+0.00000*K113*<CARBOP>+0.00000*K1
!15*<OLN>+0.00000*K115*<OLN>+1.74072*K122*<NO3>
 PJAC(:,4,39)=+1.81599*TPK%K093(:)*PCONC(:,3)+0.32440*TPK%K107(:)*PCONC(:,31)+0&
&.00000*TPK%K113(:)*PCONC(:,38)+0.00000*TPK%K115(:)*PCONC(:,39)+0.00000*TPK%K11&
&5(:)*PCONC(:,39)+1.74072*TPK%K122(:)*PCONC(:,5)
!
!NO2/XO2=+K127*<NO>+K128*<NO3>
 PJAC(:,4,40)=+TPK%K127(:)*PCONC(:,3)+TPK%K128(:)*PCONC(:,5)
!
!NO3/O3=+K043*<NO2>
 PJAC(:,5,1)=+TPK%K043(:)*PCONC(:,4)
!
!NO3/H2O2=0.0
!
!NO3/NO=-K045*<NO3>
 PJAC(:,5,3)=-TPK%K045(:)*PCONC(:,5)
!
!NO3/NO2=+K031*<O3P>+K043*<O3>-K046*<NO3>-K047*<NO3>
 PJAC(:,5,4)=+TPK%K031(:)*TPK%O3P(:)+TPK%K043(:)*PCONC(:,1)-TPK%K046(:)*PCONC(:&
&,5)-TPK%K047(:)*PCONC(:,5)
!
!NO3/NO3=-K007-K008-K034*<OH>-K038*<HO2>-K045*<NO>-K046*<NO2>-K047*<NO2>-K049*<
!NO3>-K049*<NO3>-K049*<NO3>-K049*<NO3>-K069*<HCHO>-K070*<ALD>-K071*<CARBO>-K072
!*<ARO>-K073*<ALKE>-K074*<BIO>+0.60*K075*<PAN>-K075*<PAN>-K116*<MO2>-K117*<ALKA
!P>-K118*<ALKEP>-K119*<BIOP>-K120*<AROP>-K121*<CARBOP>-K122*<OLN>-K128*<XO2>
 PJAC(:,5,5)=-TPK%K007(:)-TPK%K008(:)-TPK%K034(:)*PCONC(:,14)-TPK%K038(:)*PCONC&
&(:,15)-TPK%K045(:)*PCONC(:,3)-TPK%K046(:)*PCONC(:,4)-TPK%K047(:)*PCONC(:,4)-TP&
&K%K049(:)*PCONC(:,5)-TPK%K049(:)*PCONC(:,5)-TPK%K049(:)*PCONC(:,5)-TPK%K049(:)&
&*PCONC(:,5)-TPK%K069(:)*PCONC(:,22)-TPK%K070(:)*PCONC(:,23)-TPK%K071(:)*PCONC(&
&:,25)-TPK%K072(:)*PCONC(:,21)-TPK%K073(:)*PCONC(:,19)-TPK%K074(:)*PCONC(:,20)+&
&0.60*TPK%K075(:)*PCONC(:,27)-TPK%K075(:)*PCONC(:,27)-TPK%K116(:)*PCONC(:,31)-T&
&PK%K117(:)*PCONC(:,32)-TPK%K118(:)*PCONC(:,33)-TPK%K119(:)*PCONC(:,34)-TPK%K12&
&0(:)*PCONC(:,37)-TPK%K121(:)*PCONC(:,38)-TPK%K122(:)*PCONC(:,39)-TPK%K128(:)*P&
&CONC(:,40)
!
!NO3/N2O5=+K048
 PJAC(:,5,6)=+TPK%K048(:)
!
!NO3/HONO=0.0
!
!NO3/HNO3=+K040*<OH>
 PJAC(:,5,8)=+TPK%K040(:)*PCONC(:,14)
!
!NO3/HNO4=+0.35*K006
 PJAC(:,5,9)=+0.35*TPK%K006(:)
!
!NO3/NH3=0.0
!
!NO3/SO2=0.0
!
!NO3/SULF=0.0
!
!NO3/CO=0.0
!
!NO3/OH=-K034*<NO3>+K040*<HNO3>+0.71893*K067*<PAN>
 PJAC(:,5,14)=-TPK%K034(:)*PCONC(:,5)+TPK%K040(:)*PCONC(:,8)+0.71893*TPK%K067(:&
&)*PCONC(:,27)
!
!NO3/HO2=-K038*<NO3>
 PJAC(:,5,15)=-TPK%K038(:)*PCONC(:,5)
!
!NO3/CH4=0.0
!
!NO3/ETH=0.0
!
!NO3/ALKA=0.0
!
!NO3/ALKE=-K073*<NO3>
 PJAC(:,5,19)=-TPK%K073(:)*PCONC(:,5)
!
!NO3/BIO=-K074*<NO3>
 PJAC(:,5,20)=-TPK%K074(:)*PCONC(:,5)
!
!NO3/ARO=-K072*<NO3>
 PJAC(:,5,21)=-TPK%K072(:)*PCONC(:,5)
!
!NO3/HCHO=-K069*<NO3>
 PJAC(:,5,22)=-TPK%K069(:)*PCONC(:,5)
!
!NO3/ALD=-K070*<NO3>
 PJAC(:,5,23)=-TPK%K070(:)*PCONC(:,5)
!
!NO3/KET=0.0
!
!NO3/CARBO=-K071*<NO3>
 PJAC(:,5,25)=-TPK%K071(:)*PCONC(:,5)
!
!NO3/ONIT=0.0
!
!NO3/PAN=+0.71893*K067*<OH>+0.60*K075*<NO3>-K075*<NO3>
 PJAC(:,5,27)=+0.71893*TPK%K067(:)*PCONC(:,14)+0.60*TPK%K075(:)*PCONC(:,5)-TPK%&
&K075(:)*PCONC(:,5)
!
!NO3/OP1=0.0
!
!NO3/OP2=0.0
!
!NO3/ORA2=0.0
!
!NO3/MO2=-K116*<NO3>
 PJAC(:,5,31)=-TPK%K116(:)*PCONC(:,5)
!
!NO3/ALKAP=-K117*<NO3>
 PJAC(:,5,32)=-TPK%K117(:)*PCONC(:,5)
!
!NO3/ALKEP=-K118*<NO3>
 PJAC(:,5,33)=-TPK%K118(:)*PCONC(:,5)
!
!NO3/BIOP=-K119*<NO3>
 PJAC(:,5,34)=-TPK%K119(:)*PCONC(:,5)
!
!NO3/PHO=0.0
!
!NO3/ADD=0.0
!
!NO3/AROP=-K120*<NO3>
 PJAC(:,5,37)=-TPK%K120(:)*PCONC(:,5)
!
!NO3/CARBOP=-K121*<NO3>
 PJAC(:,5,38)=-TPK%K121(:)*PCONC(:,5)
!
!NO3/OLN=-K122*<NO3>
 PJAC(:,5,39)=-TPK%K122(:)*PCONC(:,5)
!
!NO3/XO2=-K128*<NO3>
 PJAC(:,5,40)=-TPK%K128(:)*PCONC(:,5)
!
!N2O5/O3=0.0
!
!N2O5/H2O2=0.0
!
!N2O5/NO=0.0
!
!N2O5/NO2=+K047*<NO3>
 PJAC(:,6,4)=+TPK%K047(:)*PCONC(:,5)
!
!N2O5/NO3=+K047*<NO2>
 PJAC(:,6,5)=+TPK%K047(:)*PCONC(:,4)
!
!N2O5/N2O5=-K048
 PJAC(:,6,6)=-TPK%K048(:)
!
!N2O5/HONO=0.0
!
!N2O5/HNO3=0.0
!
!N2O5/HNO4=0.0
!
!N2O5/NH3=0.0
!
!N2O5/SO2=0.0
!
!N2O5/SULF=0.0
!
!N2O5/CO=0.0
!
!N2O5/OH=0.0
!
!N2O5/HO2=0.0
!
!N2O5/CH4=0.0
!
!N2O5/ETH=0.0
!
!N2O5/ALKA=0.0
!
!N2O5/ALKE=0.0
!
!N2O5/BIO=0.0
!
!N2O5/ARO=0.0
!
!N2O5/HCHO=0.0
!
!N2O5/ALD=0.0
!
!N2O5/KET=0.0
!
!N2O5/CARBO=0.0
!
!N2O5/ONIT=0.0
!
!N2O5/PAN=0.0
!
!N2O5/OP1=0.0
!
!N2O5/OP2=0.0
!
!N2O5/ORA2=0.0
!
!N2O5/MO2=0.0
!
!N2O5/ALKAP=0.0
!
!N2O5/ALKEP=0.0
!
!N2O5/BIOP=0.0
!
!N2O5/PHO=0.0
!
!N2O5/ADD=0.0
!
!N2O5/AROP=0.0
!
!N2O5/CARBOP=0.0
!
!N2O5/OLN=0.0
!
!N2O5/XO2=0.0
!
!HONO/O3=0.0
!
!HONO/H2O2=0.0
!
!HONO/NO=+K032*<OH>
 PJAC(:,7,3)=+TPK%K032(:)*PCONC(:,14)
!
!HONO/NO2=+K082*<ADD>
 PJAC(:,7,4)=+TPK%K082(:)*PCONC(:,36)
!
!HONO/NO3=0.0
!
!HONO/N2O5=0.0
!
!HONO/HONO=-K004-K039*<OH>
 PJAC(:,7,7)=-TPK%K004(:)-TPK%K039(:)*PCONC(:,14)
!
!HONO/HNO3=0.0
!
!HONO/HNO4=0.0
!
!HONO/NH3=0.0
!
!HONO/SO2=0.0
!
!HONO/SULF=0.0
!
!HONO/CO=0.0
!
!HONO/OH=+K032*<NO>-K039*<HONO>
 PJAC(:,7,14)=+TPK%K032(:)*PCONC(:,3)-TPK%K039(:)*PCONC(:,7)
!
!HONO/HO2=0.0
!
!HONO/CH4=0.0
!
!HONO/ETH=0.0
!
!HONO/ALKA=0.0
!
!HONO/ALKE=0.0
!
!HONO/BIO=0.0
!
!HONO/ARO=0.0
!
!HONO/HCHO=0.0
!
!HONO/ALD=0.0
!
!HONO/KET=0.0
!
!HONO/CARBO=0.0
!
!HONO/ONIT=0.0
!
!HONO/PAN=0.0
!
!HONO/OP1=0.0
!
!HONO/OP2=0.0
!
!HONO/ORA2=0.0
!
!HONO/MO2=0.0
!
!HONO/ALKAP=0.0
!
!HONO/ALKEP=0.0
!
!HONO/BIOP=0.0
!
!HONO/PHO=0.0
!
!HONO/ADD=+K082*<NO2>
 PJAC(:,7,36)=+TPK%K082(:)*PCONC(:,4)
!
!HONO/AROP=0.0
!
!HONO/CARBOP=0.0
!
!HONO/OLN=0.0
!
!HONO/XO2=0.0
!
!HNO3/O3=0.0
!
!HNO3/H2O2=0.0
!
!HNO3/NO=0.0
!
!HNO3/NO2=+K033*<OH>
 PJAC(:,8,4)=+TPK%K033(:)*PCONC(:,14)
!
!HNO3/NO3=+0.3*K038*<HO2>+K069*<HCHO>+K070*<ALD>+0.91567*K071*<CARBO>+K072*<ARO
!>
 PJAC(:,8,5)=+0.3*TPK%K038(:)*PCONC(:,15)+TPK%K069(:)*PCONC(:,22)+TPK%K070(:)*P&
&CONC(:,23)+0.91567*TPK%K071(:)*PCONC(:,25)+TPK%K072(:)*PCONC(:,21)
!
!HNO3/N2O5=0.0
!
!HNO3/HONO=0.0
!
!HNO3/HNO3=-K005-K040*<OH>
 PJAC(:,8,8)=-TPK%K005(:)-TPK%K040(:)*PCONC(:,14)
!
!HNO3/HNO4=0.0
!
!HNO3/NH3=0.0
!
!HNO3/SO2=0.0
!
!HNO3/SULF=0.0
!
!HNO3/CO=0.0
!
!HNO3/OH=+K033*<NO2>-K040*<HNO3>
 PJAC(:,8,14)=+TPK%K033(:)*PCONC(:,4)-TPK%K040(:)*PCONC(:,8)
!
!HNO3/HO2=+0.3*K038*<NO3>
 PJAC(:,8,15)=+0.3*TPK%K038(:)*PCONC(:,5)
!
!HNO3/CH4=0.0
!
!HNO3/ETH=0.0
!
!HNO3/ALKA=0.0
!
!HNO3/ALKE=0.0
!
!HNO3/BIO=0.0
!
!HNO3/ARO=+K072*<NO3>
 PJAC(:,8,21)=+TPK%K072(:)*PCONC(:,5)
!
!HNO3/HCHO=+K069*<NO3>
 PJAC(:,8,22)=+TPK%K069(:)*PCONC(:,5)
!
!HNO3/ALD=+K070*<NO3>
 PJAC(:,8,23)=+TPK%K070(:)*PCONC(:,5)
!
!HNO3/KET=0.0
!
!HNO3/CARBO=+0.91567*K071*<NO3>
 PJAC(:,8,25)=+0.91567*TPK%K071(:)*PCONC(:,5)
!
!HNO3/ONIT=0.0
!
!HNO3/PAN=0.0
!
!HNO3/OP1=0.0
!
!HNO3/OP2=0.0
!
!HNO3/ORA2=0.0
!
!HNO3/MO2=0.0
!
!HNO3/ALKAP=0.0
!
!HNO3/ALKEP=0.0
!
!HNO3/BIOP=0.0
!
!HNO3/PHO=0.0
!
!HNO3/ADD=0.0
!
!HNO3/AROP=0.0
!
!HNO3/CARBOP=0.0
!
!HNO3/OLN=0.0
!
!HNO3/XO2=0.0
!
!HNO4/O3=0.0
!
!HNO4/H2O2=0.0
!
!HNO4/NO=0.0
!
!HNO4/NO2=+K036*<HO2>
 PJAC(:,9,4)=+TPK%K036(:)*PCONC(:,15)
!
!HNO4/NO3=0.0
!
!HNO4/N2O5=0.0
!
!HNO4/HONO=0.0
!
!HNO4/HNO3=0.0
!
!HNO4/HNO4=-K006-K037-K041*<OH>
 PJAC(:,9,9)=-TPK%K006(:)-TPK%K037(:)-TPK%K041(:)*PCONC(:,14)
!
!HNO4/NH3=0.0
!
!HNO4/SO2=0.0
!
!HNO4/SULF=0.0
!
!HNO4/CO=0.0
!
!HNO4/OH=-K041*<HNO4>
 PJAC(:,9,14)=-TPK%K041(:)*PCONC(:,9)
!
!HNO4/HO2=+K036*<NO2>
 PJAC(:,9,15)=+TPK%K036(:)*PCONC(:,4)
!
!HNO4/CH4=0.0
!
!HNO4/ETH=0.0
!
!HNO4/ALKA=0.0
!
!HNO4/ALKE=0.0
!
!HNO4/BIO=0.0
!
!HNO4/ARO=0.0
!
!HNO4/HCHO=0.0
!
!HNO4/ALD=0.0
!
!HNO4/KET=0.0
!
!HNO4/CARBO=0.0
!
!HNO4/ONIT=0.0
!
!HNO4/PAN=0.0
!
!HNO4/OP1=0.0
!
!HNO4/OP2=0.0
!
!HNO4/ORA2=0.0
!
!HNO4/MO2=0.0
!
!HNO4/ALKAP=0.0
!
!HNO4/ALKEP=0.0
!
!HNO4/BIOP=0.0
!
!HNO4/PHO=0.0
!
!HNO4/ADD=0.0
!
!HNO4/AROP=0.0
!
!HNO4/CARBOP=0.0
!
!HNO4/OLN=0.0
!
!HNO4/XO2=0.0
!
!NH3/O3=0.0
!
!NH3/H2O2=0.0
!
!NH3/NO=0.0
!
!NH3/NO2=0.0
!
!NH3/NO3=0.0
!
!NH3/N2O5=0.0
!
!NH3/HONO=0.0
!
!NH3/HNO3=0.0
!
!NH3/HNO4=0.0
!
!NH3/NH3=0.0
!
!NH3/SO2=0.0
!
!NH3/SULF=0.0
!
!NH3/CO=0.0
!
!NH3/OH=0.0
!
!NH3/HO2=0.0
!
!NH3/CH4=0.0
!
!NH3/ETH=0.0
!
!NH3/ALKA=0.0
!
!NH3/ALKE=0.0
!
!NH3/BIO=0.0
!
!NH3/ARO=0.0
!
!NH3/HCHO=0.0
!
!NH3/ALD=0.0
!
!NH3/KET=0.0
!
!NH3/CARBO=0.0
!
!NH3/ONIT=0.0
!
!NH3/PAN=0.0
!
!NH3/OP1=0.0
!
!NH3/OP2=0.0
!
!NH3/ORA2=0.0
!
!NH3/MO2=0.0
!
!NH3/ALKAP=0.0
!
!NH3/ALKEP=0.0
!
!NH3/BIOP=0.0
!
!NH3/PHO=0.0
!
!NH3/ADD=0.0
!
!NH3/AROP=0.0
!
!NH3/CARBOP=0.0
!
!NH3/OLN=0.0
!
!NH3/XO2=0.0
!
!SO2/O3=0.0
!
!SO2/H2O2=0.0
!
!SO2/NO=0.0
!
!SO2/NO2=0.0
!
!SO2/NO3=0.0
!
!SO2/N2O5=0.0
!
!SO2/HONO=0.0
!
!SO2/HNO3=0.0
!
!SO2/HNO4=0.0
!
!SO2/NH3=0.0
!
!SO2/SO2=-K051*<OH>
 PJAC(:,11,11)=-TPK%K051(:)*PCONC(:,14)
!
!SO2/SULF=0.0
!
!SO2/CO=0.0
!
!SO2/OH=-K051*<SO2>
 PJAC(:,11,14)=-TPK%K051(:)*PCONC(:,11)
!
!SO2/HO2=0.0
!
!SO2/CH4=0.0
!
!SO2/ETH=0.0
!
!SO2/ALKA=0.0
!
!SO2/ALKE=0.0
!
!SO2/BIO=0.0
!
!SO2/ARO=0.0
!
!SO2/HCHO=0.0
!
!SO2/ALD=0.0
!
!SO2/KET=0.0
!
!SO2/CARBO=0.0
!
!SO2/ONIT=0.0
!
!SO2/PAN=0.0
!
!SO2/OP1=0.0
!
!SO2/OP2=0.0
!
!SO2/ORA2=0.0
!
!SO2/MO2=0.0
!
!SO2/ALKAP=0.0
!
!SO2/ALKEP=0.0
!
!SO2/BIOP=0.0
!
!SO2/PHO=0.0
!
!SO2/ADD=0.0
!
!SO2/AROP=0.0
!
!SO2/CARBOP=0.0
!
!SO2/OLN=0.0
!
!SO2/XO2=0.0
!
!SULF/O3=0.0
!
!SULF/H2O2=0.0
!
!SULF/NO=0.0
!
!SULF/NO2=0.0
!
!SULF/NO3=0.0
!
!SULF/N2O5=0.0
!
!SULF/HONO=0.0
!
!SULF/HNO3=0.0
!
!SULF/HNO4=0.0
!
!SULF/NH3=0.0
!
!SULF/SO2=+K051*<OH>
 PJAC(:,12,11)=+TPK%K051(:)*PCONC(:,14)
!
!SULF/SULF=0.0
!
!SULF/CO=0.0
!
!SULF/OH=+K051*<SO2>
 PJAC(:,12,14)=+TPK%K051(:)*PCONC(:,11)
!
!SULF/HO2=0.0
!
!SULF/CH4=0.0
!
!SULF/ETH=0.0
!
!SULF/ALKA=0.0
!
!SULF/ALKE=0.0
!
!SULF/BIO=0.0
!
!SULF/ARO=0.0
!
!SULF/HCHO=0.0
!
!SULF/ALD=0.0
!
!SULF/KET=0.0
!
!SULF/CARBO=0.0
!
!SULF/ONIT=0.0
!
!SULF/PAN=0.0
!
!SULF/OP1=0.0
!
!SULF/OP2=0.0
!
!SULF/ORA2=0.0
!
!SULF/MO2=0.0
!
!SULF/ALKAP=0.0
!
!SULF/ALKEP=0.0
!
!SULF/BIOP=0.0
!
!SULF/PHO=0.0
!
!SULF/ADD=0.0
!
!SULF/AROP=0.0
!
!SULF/CARBOP=0.0
!
!SULF/OLN=0.0
!
!SULF/XO2=0.0
!
!CO/O3=+0.35120*K076*<ALKE>+0.36000*K077*<BIO>+0.64728*K078*<CARBO>+0.13*K079*<
!PAN>
 PJAC(:,13,1)=+0.35120*TPK%K076(:)*PCONC(:,19)+0.36000*TPK%K077(:)*PCONC(:,20)+&
&0.64728*TPK%K078(:)*PCONC(:,25)+0.13*TPK%K079(:)*PCONC(:,27)
!
!CO/H2O2=0.0
!
!CO/NO=0.0
!
!CO/NO2=0.0
!
!CO/NO3=+K069*<HCHO>+1.33723*K071*<CARBO>
 PJAC(:,13,5)=+TPK%K069(:)*PCONC(:,22)+1.33723*TPK%K071(:)*PCONC(:,25)
!
!CO/N2O5=0.0
!
!CO/HONO=0.0
!
!CO/HNO3=0.0
!
!CO/HNO4=0.0
!
!CO/NH3=0.0
!
!CO/SO2=0.0
!
!CO/SULF=0.0
!
!CO/CO=-K052*<OH>
 PJAC(:,13,13)=-TPK%K052(:)*PCONC(:,14)
!
!CO/OH=-K052*<CO>+0.00878*K057*<ALKA>+K061*<HCHO>+1.01732*K064*<CARBO>
 PJAC(:,13,14)=-TPK%K052(:)*PCONC(:,13)+0.00878*TPK%K057(:)*PCONC(:,18)+TPK%K06&
&1(:)*PCONC(:,22)+1.01732*TPK%K064(:)*PCONC(:,25)
!
!CO/HO2=0.0
!
!CO/CH4=0.0
!
!CO/ETH=0.0
!
!CO/ALKA=+0.00878*K057*<OH>
 PJAC(:,13,18)=+0.00878*TPK%K057(:)*PCONC(:,14)
!
!CO/ALKE=+0.35120*K076*<O3>
 PJAC(:,13,19)=+0.35120*TPK%K076(:)*PCONC(:,1)
!
!CO/BIO=+0.01*K053*<O3P>+0.36000*K077*<O3>
 PJAC(:,13,20)=+0.01*TPK%K053(:)*TPK%O3P(:)+0.36000*TPK%K077(:)*PCONC(:,1)
!
!CO/ARO=0.0
!
!CO/HCHO=+K010+K011+K061*<OH>+K069*<NO3>
 PJAC(:,13,22)=+TPK%K010(:)+TPK%K011(:)+TPK%K061(:)*PCONC(:,14)+TPK%K069(:)*PCO&
&NC(:,5)
!
!CO/ALD=+K012
 PJAC(:,13,23)=+TPK%K012(:)
!
!CO/KET=0.0
!
!CO/CARBO=+0.91924*K016+1.01732*K064*<OH>+1.33723*K071*<NO3>+0.64728*K078*<O3>
 PJAC(:,13,25)=+0.91924*TPK%K016(:)+1.01732*TPK%K064(:)*PCONC(:,14)+1.33723*TPK&
&%K071(:)*PCONC(:,5)+0.64728*TPK%K078(:)*PCONC(:,1)
!
!CO/ONIT=0.0
!
!CO/PAN=+0.13*K079*<O3>
 PJAC(:,13,27)=+0.13*TPK%K079(:)*PCONC(:,1)
!
!CO/OP1=0.0
!
!CO/OP2=0.0
!
!CO/ORA2=0.0
!
!CO/MO2=0.0
!
!CO/ALKAP=0.0
!
!CO/ALKEP=0.0
!
!CO/BIOP=0.0
!
!CO/PHO=0.0
!
!CO/ADD=0.0
!
!CO/AROP=0.0
!
!CO/CARBOP=0.0
!
!CO/OLN=0.0
!
!CO/XO2=0.0
!
!OH/O3=-K023*<OH>+K024*<HO2>+0.39435*K076*<ALKE>+0.28000*K077*<BIO>+0.20595*K07
!8*<CARBO>+0.036*K079*<PAN>+K084*<ADD>
 PJAC(:,14,1)=-TPK%K023(:)*PCONC(:,14)+TPK%K024(:)*PCONC(:,15)+0.39435*TPK%K076&
&(:)*PCONC(:,19)+0.28000*TPK%K077(:)*PCONC(:,20)+0.20595*TPK%K078(:)*PCONC(:,25&
&)+0.036*TPK%K079(:)*PCONC(:,27)+TPK%K084(:)*PCONC(:,36)
!
!OH/H2O2=+K009+K009-K026*<OH>
 PJAC(:,14,2)=+TPK%K009(:)+TPK%K009(:)-TPK%K026(:)*PCONC(:,14)
!
!OH/NO=-K032*<OH>+K035*<HO2>
 PJAC(:,14,3)=-TPK%K032(:)*PCONC(:,14)+TPK%K035(:)*PCONC(:,15)
!
!OH/NO2=-K033*<OH>
 PJAC(:,14,4)=-TPK%K033(:)*PCONC(:,14)
!
!OH/NO3=-K034*<OH>+0.7*K038*<HO2>
 PJAC(:,14,5)=-TPK%K034(:)*PCONC(:,14)+0.7*TPK%K038(:)*PCONC(:,15)
!
!OH/N2O5=0.0
!
!OH/HONO=+K004-K039*<OH>
 PJAC(:,14,7)=+TPK%K004(:)-TPK%K039(:)*PCONC(:,14)
!
!OH/HNO3=+K005-K040*<OH>
 PJAC(:,14,8)=+TPK%K005(:)-TPK%K040(:)*PCONC(:,14)
!
!OH/HNO4=+0.35*K006-K041*<OH>
 PJAC(:,14,9)=+0.35*TPK%K006(:)-TPK%K041(:)*PCONC(:,14)
!
!OH/NH3=0.0
!
!OH/SO2=-K051*<OH>
 PJAC(:,14,11)=-TPK%K051(:)*PCONC(:,14)
!
!OH/SULF=0.0
!
!OH/CO=-K052*<OH>
 PJAC(:,14,13)=-TPK%K052(:)*PCONC(:,14)
!
!OH/OH=-K023*<O3>-K025*<HO2>-K026*<H2O2>-K032*<NO>-K033*<NO2>-K034*<NO3>-K039*<
!HONO>-K040*<HNO3>-K041*<HNO4>-K050*<H2>-K051*<SO2>-K052*<CO>-K055*<CH4>-K056*<
!ETH>+0.00878*K057*<ALKA>-K057*<ALKA>-K058*<ALKE>-K059*<BIO>-K060*<ARO>-K061*<H
!CHO>-K062*<ALD>-K063*<KET>-K064*<CARBO>+0.35*K065*<OP1>-K065*<OP1>+0.44925*K06
!6*<OP2>-K066*<OP2>-K067*<PAN>-K068*<ONIT>
 PJAC(:,14,14)=-TPK%K023(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,15)-TPK%K026(:)*PCON&
&C(:,2)-TPK%K032(:)*PCONC(:,3)-TPK%K033(:)*PCONC(:,4)-TPK%K034(:)*PCONC(:,5)-TP&
&K%K039(:)*PCONC(:,7)-TPK%K040(:)*PCONC(:,8)-TPK%K041(:)*PCONC(:,9)-TPK%K050(:)&
&*TPK%H2(:)-TPK%K051(:)*PCONC(:,11)-TPK%K052(:)*PCONC(:,13)-TPK%K055(:)*PCONC(:&
&,16)-TPK%K056(:)*PCONC(:,17)+0.00878*TPK%K057(:)*PCONC(:,18)-TPK%K057(:)*PCONC&
&(:,18)-TPK%K058(:)*PCONC(:,19)-TPK%K059(:)*PCONC(:,20)-TPK%K060(:)*PCONC(:,21)&
&-TPK%K061(:)*PCONC(:,22)-TPK%K062(:)*PCONC(:,23)-TPK%K063(:)*PCONC(:,24)-TPK%K&
&064(:)*PCONC(:,25)+0.35*TPK%K065(:)*PCONC(:,28)-TPK%K065(:)*PCONC(:,28)+0.4492&
&5*TPK%K066(:)*PCONC(:,29)-TPK%K066(:)*PCONC(:,29)-TPK%K067(:)*PCONC(:,27)-TPK%&
&K068(:)*PCONC(:,26)
!
!OH/HO2=+K024*<O3>-K025*<OH>+K035*<NO>+0.7*K038*<NO3>
 PJAC(:,14,15)=+TPK%K024(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,14)+TPK%K035(:)*PCON&
&C(:,3)+0.7*TPK%K038(:)*PCONC(:,5)
!
!OH/CH4=-K055*<OH>
 PJAC(:,14,16)=-TPK%K055(:)*PCONC(:,14)
!
!OH/ETH=-K056*<OH>
 PJAC(:,14,17)=-TPK%K056(:)*PCONC(:,14)
!
!OH/ALKA=+0.00878*K057*<OH>-K057*<OH>
 PJAC(:,14,18)=+0.00878*TPK%K057(:)*PCONC(:,14)-TPK%K057(:)*PCONC(:,14)
!
!OH/ALKE=-K058*<OH>+0.39435*K076*<O3>
 PJAC(:,14,19)=-TPK%K058(:)*PCONC(:,14)+0.39435*TPK%K076(:)*PCONC(:,1)
!
!OH/BIO=+0.02*K053*<O3P>-K059*<OH>+0.28000*K077*<O3>
 PJAC(:,14,20)=+0.02*TPK%K053(:)*TPK%O3P(:)-TPK%K059(:)*PCONC(:,14)+0.28000*TPK&
&%K077(:)*PCONC(:,1)
!
!OH/ARO=-K060*<OH>
 PJAC(:,14,21)=-TPK%K060(:)*PCONC(:,14)
!
!OH/HCHO=-K061*<OH>
 PJAC(:,14,22)=-TPK%K061(:)*PCONC(:,14)
!
!OH/ALD=-K062*<OH>
 PJAC(:,14,23)=-TPK%K062(:)*PCONC(:,14)
!
!OH/KET=-K063*<OH>
 PJAC(:,14,24)=-TPK%K063(:)*PCONC(:,14)
!
!OH/CARBO=-K064*<OH>+0.20595*K078*<O3>
 PJAC(:,14,25)=-TPK%K064(:)*PCONC(:,14)+0.20595*TPK%K078(:)*PCONC(:,1)
!
!OH/ONIT=-K068*<OH>
 PJAC(:,14,26)=-TPK%K068(:)*PCONC(:,14)
!
!OH/PAN=-K067*<OH>+0.036*K079*<O3>
 PJAC(:,14,27)=-TPK%K067(:)*PCONC(:,14)+0.036*TPK%K079(:)*PCONC(:,1)
!
!OH/OP1=+K013+0.35*K065*<OH>-K065*<OH>
 PJAC(:,14,28)=+TPK%K013(:)+0.35*TPK%K065(:)*PCONC(:,14)-TPK%K065(:)*PCONC(:,14&
&)
!
!OH/OP2=+K014+0.44925*K066*<OH>-K066*<OH>
 PJAC(:,14,29)=+TPK%K014(:)+0.44925*TPK%K066(:)*PCONC(:,14)-TPK%K066(:)*PCONC(:&
&,14)
!
!OH/ORA2=0.0
!
!OH/MO2=0.0
!
!OH/ALKAP=0.0
!
!OH/ALKEP=0.0
!
!OH/BIOP=0.0
!
!OH/PHO=0.0
!
!OH/ADD=+K084*<O3>
 PJAC(:,14,36)=+TPK%K084(:)*PCONC(:,1)
!
!OH/AROP=0.0
!
!OH/CARBOP=0.0
!
!OH/OLN=0.0
!
!OH/XO2=0.0
!
!HO2/O3=+K023*<OH>-K024*<HO2>+0.23451*K076*<ALKE>+0.30000*K077*<BIO>+0.28441*K0
!78*<CARBO>+0.08*K079*<PAN>
 PJAC(:,15,1)=+TPK%K023(:)*PCONC(:,14)-TPK%K024(:)*PCONC(:,15)+0.23451*TPK%K076&
&(:)*PCONC(:,19)+0.30000*TPK%K077(:)*PCONC(:,20)+0.28441*TPK%K078(:)*PCONC(:,25&
&)+0.08*TPK%K079(:)*PCONC(:,27)
!
!HO2/H2O2=+K026*<OH>
 PJAC(:,15,2)=+TPK%K026(:)*PCONC(:,14)
!
!HO2/NO=-K035*<HO2>+K087*<MO2>+0.74265*K088*<ALKAP>+K089*<ALKEP>+0.84700*K090*<
!BIOP>+0.95115*K091*<AROP>+0.12334*K092*<CARBOP>+0.18401*K093*<OLN>
 PJAC(:,15,3)=-TPK%K035(:)*PCONC(:,15)+TPK%K087(:)*PCONC(:,31)+0.74265*TPK%K088&
&(:)*PCONC(:,32)+TPK%K089(:)*PCONC(:,33)+0.84700*TPK%K090(:)*PCONC(:,34)+0.9511&
&5*TPK%K091(:)*PCONC(:,37)+0.12334*TPK%K092(:)*PCONC(:,38)+0.18401*TPK%K093(:)*&
&PCONC(:,39)
!
!HO2/NO2=-K036*<HO2>
 PJAC(:,15,4)=-TPK%K036(:)*PCONC(:,15)
!
!HO2/NO3=+K034*<OH>-K038*<HO2>+K069*<HCHO>+0.63217*K071*<CARBO>+K116*<MO2>+0.81
!290*K117*<ALKAP>+K118*<ALKEP>+K119*<BIOP>+K120*<AROP>+0.04915*K121*<CARBOP>+0.
!25928*K122*<OLN>
 PJAC(:,15,5)=+TPK%K034(:)*PCONC(:,14)-TPK%K038(:)*PCONC(:,15)+TPK%K069(:)*PCON&
&C(:,22)+0.63217*TPK%K071(:)*PCONC(:,25)+TPK%K116(:)*PCONC(:,31)+0.81290*TPK%K1&
&17(:)*PCONC(:,32)+TPK%K118(:)*PCONC(:,33)+TPK%K119(:)*PCONC(:,34)+TPK%K120(:)*&
&PCONC(:,37)+0.04915*TPK%K121(:)*PCONC(:,38)+0.25928*TPK%K122(:)*PCONC(:,39)
!
!HO2/N2O5=0.0
!
!HO2/HONO=0.0
!
!HO2/HNO3=0.0
!
!HO2/HNO4=+0.65*K006+K037
 PJAC(:,15,9)=+0.65*TPK%K006(:)+TPK%K037(:)
!
!HO2/NH3=0.0
!
!HO2/SO2=+K051*<OH>
 PJAC(:,15,11)=+TPK%K051(:)*PCONC(:,14)
!
!HO2/SULF=0.0
!
!HO2/CO=+K052*<OH>
 PJAC(:,15,13)=+TPK%K052(:)*PCONC(:,14)
!
!HO2/OH=+K023*<O3>-K025*<HO2>+K026*<H2O2>+K034*<NO3>+K050*<H2>+K051*<SO2>+K052*
!<CO>+0.12793*K057*<ALKA>+0.10318*K060*<ARO>+K061*<HCHO>+0.51208*K064*<CARBO>+0
!.02915*K066*<OP2>+0.28107*K067*<PAN>
 PJAC(:,15,14)=+TPK%K023(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,15)+TPK%K026(:)*PCON&
&C(:,2)+TPK%K034(:)*PCONC(:,5)+TPK%K050(:)*TPK%H2(:)+TPK%K051(:)*PCONC(:,11)+TP&
&K%K052(:)*PCONC(:,13)+0.12793*TPK%K057(:)*PCONC(:,18)+0.10318*TPK%K060(:)*PCON&
&C(:,21)+TPK%K061(:)*PCONC(:,22)+0.51208*TPK%K064(:)*PCONC(:,25)+0.02915*TPK%K0&
&66(:)*PCONC(:,29)+0.28107*TPK%K067(:)*PCONC(:,27)
!
!HO2/HO2=-K024*<O3>-K025*<OH>-K027*<HO2>-K027*<HO2>-K027*<HO2>-K027*<HO2>-K028*
!<HO2>*<H2O>-K028*<HO2>*<H2O>-K028*<HO2>*<H2O>-K028*<HO2>*<H2O>-K035*<NO>-K036*
!<NO2>-K038*<NO3>-K081*<PHO>-K094*<MO2>-K095*<ALKAP>-K096*<ALKEP>-K097*<BIOP>-K
!098*<AROP>-K099*<CARBOP>-K100*<OLN>-K123*<XO2>
 PJAC(:,15,15)=-TPK%K024(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,14)-TPK%K027(:)*PCON&
&C(:,15)-TPK%K027(:)*PCONC(:,15)-TPK%K027(:)*PCONC(:,15)-TPK%K027(:)*PCONC(:,15&
&)-TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K0&
&28(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K035(:)*PC&
&ONC(:,3)-TPK%K036(:)*PCONC(:,4)-TPK%K038(:)*PCONC(:,5)-TPK%K081(:)*PCONC(:,35)&
&-TPK%K094(:)*PCONC(:,31)-TPK%K095(:)*PCONC(:,32)-TPK%K096(:)*PCONC(:,33)-TPK%K&
&097(:)*PCONC(:,34)-TPK%K098(:)*PCONC(:,37)-TPK%K099(:)*PCONC(:,38)-TPK%K100(:)&
&*PCONC(:,39)-TPK%K123(:)*PCONC(:,40)
!
!HO2/CH4=0.0
!
!HO2/ETH=0.0
!
!HO2/ALKA=+0.12793*K057*<OH>
 PJAC(:,15,18)=+0.12793*TPK%K057(:)*PCONC(:,14)
!
!HO2/ALKE=+0.23451*K076*<O3>
 PJAC(:,15,19)=+0.23451*TPK%K076(:)*PCONC(:,1)
!
!HO2/BIO=+0.28*K053*<O3P>+0.30000*K077*<O3>
 PJAC(:,15,20)=+0.28*TPK%K053(:)*TPK%O3P(:)+0.30000*TPK%K077(:)*PCONC(:,1)
!
!HO2/ARO=+0.10318*K060*<OH>
 PJAC(:,15,21)=+0.10318*TPK%K060(:)*PCONC(:,14)
!
!HO2/HCHO=+K011+K011+K061*<OH>+K069*<NO3>
 PJAC(:,15,22)=+TPK%K011(:)+TPK%K011(:)+TPK%K061(:)*PCONC(:,14)+TPK%K069(:)*PCO&
&NC(:,5)
!
!HO2/ALD=+K012
 PJAC(:,15,23)=+TPK%K012(:)
!
!HO2/KET=0.0
!
!HO2/CARBO=+0.75830*K016+0.51208*K064*<OH>+0.63217*K071*<NO3>+0.28441*K078*<O3>
 PJAC(:,15,25)=+0.75830*TPK%K016(:)+0.51208*TPK%K064(:)*PCONC(:,14)+0.63217*TPK&
&%K071(:)*PCONC(:,5)+0.28441*TPK%K078(:)*PCONC(:,1)
!
!HO2/ONIT=+K017
 PJAC(:,15,26)=+TPK%K017(:)
!
!HO2/PAN=+0.28107*K067*<OH>+0.08*K079*<O3>
 PJAC(:,15,27)=+0.28107*TPK%K067(:)*PCONC(:,14)+0.08*TPK%K079(:)*PCONC(:,1)
!
!HO2/OP1=+K013
 PJAC(:,15,28)=+TPK%K013(:)
!
!HO2/OP2=+0.96205*K014+0.02915*K066*<OH>
 PJAC(:,15,29)=+0.96205*TPK%K014(:)+0.02915*TPK%K066(:)*PCONC(:,14)
!
!HO2/ORA2=0.0
!
!HO2/MO2=+K087*<NO>-K094*<HO2>+0.66*K101*<MO2>+0.66*K101*<MO2>+0.98383*K102*<AL
!KAP>+K103*<ALKEP>+1.00000*K104*<BIOP>+1.02767*K105*<AROP>+0.82998*K106*<CARBOP
!>+0.67560*K107*<OLN>+K116*<NO3>+K124*<XO2>
 PJAC(:,15,31)=+TPK%K087(:)*PCONC(:,3)-TPK%K094(:)*PCONC(:,15)+0.66*TPK%K101(:)&
&*PCONC(:,31)+0.66*TPK%K101(:)*PCONC(:,31)+0.98383*TPK%K102(:)*PCONC(:,32)+TPK%&
&K103(:)*PCONC(:,33)+1.00000*TPK%K104(:)*PCONC(:,34)+1.02767*TPK%K105(:)*PCONC(&
&:,37)+0.82998*TPK%K106(:)*PCONC(:,38)+0.67560*TPK%K107(:)*PCONC(:,39)+TPK%K116&
&(:)*PCONC(:,5)+TPK%K124(:)*PCONC(:,40)
!
!HO2/ALKAP=+0.74265*K088*<NO>-K095*<HO2>+0.98383*K102*<MO2>+0.48079*K108*<CARBO
!P>+0.81290*K117*<NO3>
 PJAC(:,15,32)=+0.74265*TPK%K088(:)*PCONC(:,3)-TPK%K095(:)*PCONC(:,15)+0.98383*&
&TPK%K102(:)*PCONC(:,31)+0.48079*TPK%K108(:)*PCONC(:,38)+0.81290*TPK%K117(:)*PC&
&ONC(:,5)
!
!HO2/ALKEP=+K089*<NO>-K096*<HO2>+K103*<MO2>+0.50078*K109*<CARBOP>+K118*<NO3>
 PJAC(:,15,33)=+TPK%K089(:)*PCONC(:,3)-TPK%K096(:)*PCONC(:,15)+TPK%K103(:)*PCON&
&C(:,31)+0.50078*TPK%K109(:)*PCONC(:,38)+TPK%K118(:)*PCONC(:,5)
!
!HO2/BIOP=+0.84700*K090*<NO>-K097*<HO2>+1.00000*K104*<MO2>+0.50600*K110*<CARBOP
!>+K119*<NO3>
 PJAC(:,15,34)=+0.84700*TPK%K090(:)*PCONC(:,3)-TPK%K097(:)*PCONC(:,15)+1.00000*&
&TPK%K104(:)*PCONC(:,31)+0.50600*TPK%K110(:)*PCONC(:,38)+TPK%K119(:)*PCONC(:,5)
!
!HO2/PHO=-K081*<HO2>
 PJAC(:,15,35)=-TPK%K081(:)*PCONC(:,15)
!
!HO2/ADD=+0.02*K083*<O2>
 PJAC(:,15,36)=+0.02*TPK%K083(:)*TPK%O2(:)
!
!HO2/AROP=+0.95115*K091*<NO>-K098*<HO2>+1.02767*K105*<MO2>+K111*<CARBOP>+K120*<
!NO3>
 PJAC(:,15,37)=+0.95115*TPK%K091(:)*PCONC(:,3)-TPK%K098(:)*PCONC(:,15)+1.02767*&
&TPK%K105(:)*PCONC(:,31)+TPK%K111(:)*PCONC(:,38)+TPK%K120(:)*PCONC(:,5)
!
!HO2/CARBOP=+0.12334*K092*<NO>-K099*<HO2>+0.82998*K106*<MO2>+0.48079*K108*<ALKA
!P>+0.50078*K109*<ALKEP>+0.50600*K110*<BIOP>+K111*<AROP>+0.07566*K112*<CARBOP>+
!0.07566*K112*<CARBOP>+0.17599*K113*<OLN>+0.04915*K121*<NO3>
 PJAC(:,15,38)=+0.12334*TPK%K092(:)*PCONC(:,3)-TPK%K099(:)*PCONC(:,15)+0.82998*&
&TPK%K106(:)*PCONC(:,31)+0.48079*TPK%K108(:)*PCONC(:,32)+0.50078*TPK%K109(:)*PC&
&ONC(:,33)+0.50600*TPK%K110(:)*PCONC(:,34)+TPK%K111(:)*PCONC(:,37)+0.07566*TPK%&
&K112(:)*PCONC(:,38)+0.07566*TPK%K112(:)*PCONC(:,38)+0.17599*TPK%K113(:)*PCONC(&
&:,39)+0.04915*TPK%K121(:)*PCONC(:,5)
!
!HO2/OLN=+0.18401*K093*<NO>-K100*<HO2>+0.67560*K107*<MO2>+0.17599*K113*<CARBOP>
!+K114*<OLN>+K114*<OLN>+0.00000*K115*<OLN>+0.00000*K115*<OLN>+0.25928*K122*<NO3
!>
 PJAC(:,15,39)=+0.18401*TPK%K093(:)*PCONC(:,3)-TPK%K100(:)*PCONC(:,15)+0.67560*&
&TPK%K107(:)*PCONC(:,31)+0.17599*TPK%K113(:)*PCONC(:,38)+TPK%K114(:)*PCONC(:,39&
&)+TPK%K114(:)*PCONC(:,39)+0.00000*TPK%K115(:)*PCONC(:,39)+0.00000*TPK%K115(:)*&
&PCONC(:,39)+0.25928*TPK%K122(:)*PCONC(:,5)
!
!HO2/XO2=-K123*<HO2>+K124*<MO2>
 PJAC(:,15,40)=-TPK%K123(:)*PCONC(:,15)+TPK%K124(:)*PCONC(:,31)
!
!CH4/O3=+0.04300*K076*<ALKE>
 PJAC(:,16,1)=+0.04300*TPK%K076(:)*PCONC(:,19)
!
!CH4/H2O2=0.0
!
!CH4/NO=0.0
!
!CH4/NO2=0.0
!
!CH4/NO3=0.0
!
!CH4/N2O5=0.0
!
!CH4/HONO=0.0
!
!CH4/HNO3=0.0
!
!CH4/HNO4=0.0
!
!CH4/NH3=0.0
!
!CH4/SO2=0.0
!
!CH4/SULF=0.0
!
!CH4/CO=0.0
!
!CH4/OH=-K055*<CH4>
 PJAC(:,16,14)=-TPK%K055(:)*PCONC(:,16)
!
!CH4/HO2=0.0
!
!CH4/CH4=-K055*<OH>
 PJAC(:,16,16)=-TPK%K055(:)*PCONC(:,14)
!
!CH4/ETH=0.0
!
!CH4/ALKA=0.0
!
!CH4/ALKE=+0.04300*K076*<O3>
 PJAC(:,16,19)=+0.04300*TPK%K076(:)*PCONC(:,1)
!
!CH4/BIO=0.0
!
!CH4/ARO=0.0
!
!CH4/HCHO=0.0
!
!CH4/ALD=0.0
!
!CH4/KET=0.0
!
!CH4/CARBO=0.0
!
!CH4/ONIT=0.0
!
!CH4/PAN=0.0
!
!CH4/OP1=0.0
!
!CH4/OP2=0.0
!
!CH4/ORA2=0.0
!
!CH4/MO2=0.0
!
!CH4/ALKAP=0.0
!
!CH4/ALKEP=0.0
!
!CH4/BIOP=0.0
!
!CH4/PHO=0.0
!
!CH4/ADD=0.0
!
!CH4/AROP=0.0
!
!CH4/CARBOP=0.0
!
!CH4/OLN=0.0
!
!CH4/XO2=0.0
!
!ETH/O3=+0.03196*K076*<ALKE>
 PJAC(:,17,1)=+0.03196*TPK%K076(:)*PCONC(:,19)
!
!ETH/H2O2=0.0
!
!ETH/NO=0.0
!
!ETH/NO2=0.0
!
!ETH/NO3=0.0
!
!ETH/N2O5=0.0
!
!ETH/HONO=0.0
!
!ETH/HNO3=0.0
!
!ETH/HNO4=0.0
!
!ETH/NH3=0.0
!
!ETH/SO2=0.0
!
!ETH/SULF=0.0
!
!ETH/CO=0.0
!
!ETH/OH=-K056*<ETH>
 PJAC(:,17,14)=-TPK%K056(:)*PCONC(:,17)
!
!ETH/HO2=0.0
!
!ETH/CH4=0.0
!
!ETH/ETH=-K056*<OH>
 PJAC(:,17,17)=-TPK%K056(:)*PCONC(:,14)
!
!ETH/ALKA=0.0
!
!ETH/ALKE=+0.03196*K076*<O3>
 PJAC(:,17,19)=+0.03196*TPK%K076(:)*PCONC(:,1)
!
!ETH/BIO=0.0
!
!ETH/ARO=0.0
!
!ETH/HCHO=0.0
!
!ETH/ALD=0.0
!
!ETH/KET=0.0
!
!ETH/CARBO=0.0
!
!ETH/ONIT=0.0
!
!ETH/PAN=0.0
!
!ETH/OP1=0.0
!
!ETH/OP2=0.0
!
!ETH/ORA2=0.0
!
!ETH/MO2=0.0
!
!ETH/ALKAP=0.0
!
!ETH/ALKEP=0.0
!
!ETH/BIOP=0.0
!
!ETH/PHO=0.0
!
!ETH/ADD=0.0
!
!ETH/AROP=0.0
!
!ETH/CARBOP=0.0
!
!ETH/OLN=0.0
!
!ETH/XO2=0.0
!
!ALKA/O3=0.0
!
!ALKA/H2O2=0.0
!
!ALKA/NO=0.0
!
!ALKA/NO2=0.0
!
!ALKA/NO3=0.0
!
!ALKA/N2O5=0.0
!
!ALKA/HONO=0.0
!
!ALKA/HNO3=0.0
!
!ALKA/HNO4=0.0
!
!ALKA/NH3=0.0
!
!ALKA/SO2=0.0
!
!ALKA/SULF=0.0
!
!ALKA/CO=0.0
!
!ALKA/OH=-K057*<ALKA>
 PJAC(:,18,14)=-TPK%K057(:)*PCONC(:,18)
!
!ALKA/HO2=0.0
!
!ALKA/CH4=0.0
!
!ALKA/ETH=0.0
!
!ALKA/ALKA=-K057*<OH>
 PJAC(:,18,18)=-TPK%K057(:)*PCONC(:,14)
!
!ALKA/ALKE=0.0
!
!ALKA/BIO=0.0
!
!ALKA/ARO=0.0
!
!ALKA/HCHO=0.0
!
!ALKA/ALD=0.0
!
!ALKA/KET=0.0
!
!ALKA/CARBO=0.0
!
!ALKA/ONIT=0.0
!
!ALKA/PAN=0.0
!
!ALKA/OP1=0.0
!
!ALKA/OP2=0.0
!
!ALKA/ORA2=0.0
!
!ALKA/MO2=0.0
!
!ALKA/ALKAP=0.0
!
!ALKA/ALKEP=0.0
!
!ALKA/BIOP=0.0
!
!ALKA/PHO=0.0
!
!ALKA/ADD=0.0
!
!ALKA/AROP=0.0
!
!ALKA/CARBOP=0.0
!
!ALKA/OLN=0.0
!
!ALKA/XO2=0.0
!
!ALKE/O3=+0.00000*K076*<ALKE>-K076*<ALKE>+0.37388*K077*<BIO>
 PJAC(:,19,1)=+0.00000*TPK%K076(:)*PCONC(:,19)-TPK%K076(:)*PCONC(:,19)+0.37388*&
&TPK%K077(:)*PCONC(:,20)
!
!ALKE/H2O2=0.0
!
!ALKE/NO=+0.37815*K090*<BIOP>
 PJAC(:,19,3)=+0.37815*TPK%K090(:)*PCONC(:,34)
!
!ALKE/NO2=0.0
!
!ALKE/NO3=-K073*<ALKE>+0.42729*K119*<BIOP>
 PJAC(:,19,5)=-TPK%K073(:)*PCONC(:,19)+0.42729*TPK%K119(:)*PCONC(:,34)
!
!ALKE/N2O5=0.0
!
!ALKE/HONO=0.0
!
!ALKE/HNO3=0.0
!
!ALKE/HNO4=0.0
!
!ALKE/NH3=0.0
!
!ALKE/SO2=0.0
!
!ALKE/SULF=0.0
!
!ALKE/CO=0.0
!
!ALKE/OH=-K058*<ALKE>
 PJAC(:,19,14)=-TPK%K058(:)*PCONC(:,19)
!
!ALKE/HO2=0.0
!
!ALKE/CH4=0.0
!
!ALKE/ETH=0.0
!
!ALKE/ALKA=0.0
!
!ALKE/ALKE=-K058*<OH>-K073*<NO3>+0.00000*K076*<O3>-K076*<O3>
 PJAC(:,19,19)=-TPK%K058(:)*PCONC(:,14)-TPK%K073(:)*PCONC(:,5)+0.00000*TPK%K076&
&(:)*PCONC(:,1)-TPK%K076(:)*PCONC(:,1)
!
!ALKE/BIO=+0.91868*K053*<O3P>+0.37388*K077*<O3>
 PJAC(:,19,20)=+0.91868*TPK%K053(:)*TPK%O3P(:)+0.37388*TPK%K077(:)*PCONC(:,1)
!
!ALKE/ARO=0.0
!
!ALKE/HCHO=0.0
!
!ALKE/ALD=0.0
!
!ALKE/KET=0.0
!
!ALKE/CARBO=0.0
!
!ALKE/ONIT=0.0
!
!ALKE/PAN=0.0
!
!ALKE/OP1=0.0
!
!ALKE/OP2=0.0
!
!ALKE/ORA2=0.0
!
!ALKE/MO2=+0.48074*K104*<BIOP>
 PJAC(:,19,31)=+0.48074*TPK%K104(:)*PCONC(:,34)
!
!ALKE/ALKAP=0.0
!
!ALKE/ALKEP=0.0
!
!ALKE/BIOP=+0.37815*K090*<NO>+0.48074*K104*<MO2>+0.24463*K110*<CARBOP>+0.42729*
!K119*<NO3>
 PJAC(:,19,34)=+0.37815*TPK%K090(:)*PCONC(:,3)+0.48074*TPK%K104(:)*PCONC(:,31)+&
&0.24463*TPK%K110(:)*PCONC(:,38)+0.42729*TPK%K119(:)*PCONC(:,5)
!
!ALKE/PHO=0.0
!
!ALKE/ADD=0.0
!
!ALKE/AROP=0.0
!
!ALKE/CARBOP=+0.24463*K110*<BIOP>
 PJAC(:,19,38)=+0.24463*TPK%K110(:)*PCONC(:,34)
!
!ALKE/OLN=0.0
!
!ALKE/XO2=0.0
!
!BIO/O3=-K077*<BIO>
 PJAC(:,20,1)=-TPK%K077(:)*PCONC(:,20)
!
!BIO/H2O2=0.0
!
!BIO/NO=0.0
!
!BIO/NO2=0.0
!
!BIO/NO3=-K074*<BIO>
 PJAC(:,20,5)=-TPK%K074(:)*PCONC(:,20)
!
!BIO/N2O5=0.0
!
!BIO/HONO=0.0
!
!BIO/HNO3=0.0
!
!BIO/HNO4=0.0
!
!BIO/NH3=0.0
!
!BIO/SO2=0.0
!
!BIO/SULF=0.0
!
!BIO/CO=0.0
!
!BIO/OH=-K059*<BIO>
 PJAC(:,20,14)=-TPK%K059(:)*PCONC(:,20)
!
!BIO/HO2=0.0
!
!BIO/CH4=0.0
!
!BIO/ETH=0.0
!
!BIO/ALKA=0.0
!
!BIO/ALKE=0.0
!
!BIO/BIO=-K053*<O3P>-K059*<OH>-K074*<NO3>-K077*<O3>
 PJAC(:,20,20)=-TPK%K053(:)*TPK%O3P(:)-TPK%K059(:)*PCONC(:,14)-TPK%K074(:)*PCON&
&C(:,5)-TPK%K077(:)*PCONC(:,1)
!
!BIO/ARO=0.0
!
!BIO/HCHO=0.0
!
!BIO/ALD=0.0
!
!BIO/KET=0.0
!
!BIO/CARBO=0.0
!
!BIO/ONIT=0.0
!
!BIO/PAN=0.0
!
!BIO/OP1=0.0
!
!BIO/OP2=0.0
!
!BIO/ORA2=0.0
!
!BIO/MO2=0.0
!
!BIO/ALKAP=0.0
!
!BIO/ALKEP=0.0
!
!BIO/BIOP=0.0
!
!BIO/PHO=0.0
!
!BIO/ADD=0.0
!
!BIO/AROP=0.0
!
!BIO/CARBOP=0.0
!
!BIO/OLN=0.0
!
!BIO/XO2=0.0
!
!ARO/O3=+K084*<ADD>
 PJAC(:,21,1)=+TPK%K084(:)*PCONC(:,36)
!
!ARO/H2O2=0.0
!
!ARO/NO=0.0
!
!ARO/NO2=+0.10670*K080*<PHO>+K082*<ADD>
 PJAC(:,21,4)=+0.10670*TPK%K080(:)*PCONC(:,35)+TPK%K082(:)*PCONC(:,36)
!
!ARO/NO3=-K072*<ARO>
 PJAC(:,21,5)=-TPK%K072(:)*PCONC(:,21)
!
!ARO/N2O5=0.0
!
!ARO/HONO=0.0
!
!ARO/HNO3=0.0
!
!ARO/HNO4=0.0
!
!ARO/NH3=0.0
!
!ARO/SO2=0.0
!
!ARO/SULF=0.0
!
!ARO/CO=0.0
!
!ARO/OH=-K060*<ARO>
 PJAC(:,21,14)=-TPK%K060(:)*PCONC(:,21)
!
!ARO/HO2=+1.06698*K081*<PHO>
 PJAC(:,21,15)=+1.06698*TPK%K081(:)*PCONC(:,35)
!
!ARO/CH4=0.0
!
!ARO/ETH=0.0
!
!ARO/ALKA=0.0
!
!ARO/ALKE=0.0
!
!ARO/BIO=0.0
!
!ARO/ARO=-K060*<OH>-K072*<NO3>
 PJAC(:,21,21)=-TPK%K060(:)*PCONC(:,14)-TPK%K072(:)*PCONC(:,5)
!
!ARO/HCHO=0.0
!
!ARO/ALD=0.0
!
!ARO/KET=0.0
!
!ARO/CARBO=0.0
!
!ARO/ONIT=0.0
!
!ARO/PAN=0.0
!
!ARO/OP1=0.0
!
!ARO/OP2=0.0
!
!ARO/ORA2=0.0
!
!ARO/MO2=0.0
!
!ARO/ALKAP=0.0
!
!ARO/ALKEP=0.0
!
!ARO/BIOP=0.0
!
!ARO/PHO=+0.10670*K080*<NO2>+1.06698*K081*<HO2>
 PJAC(:,21,35)=+0.10670*TPK%K080(:)*PCONC(:,4)+1.06698*TPK%K081(:)*PCONC(:,15)
!
!ARO/ADD=+K082*<NO2>+0.02*K083*<O2>+K084*<O3>
 PJAC(:,21,36)=+TPK%K082(:)*PCONC(:,4)+0.02*TPK%K083(:)*TPK%O2(:)+TPK%K084(:)*P&
&CONC(:,1)
!
!ARO/AROP=0.0
!
!ARO/CARBOP=0.0
!
!ARO/OLN=0.0
!
!ARO/XO2=0.0
!
!HCHO/O3=+0.48290*K076*<ALKE>+0.90000*K077*<BIO>+0.00000*K078*<CARBO>+0.70*K079
!*<PAN>
 PJAC(:,22,1)=+0.48290*TPK%K076(:)*PCONC(:,19)+0.90000*TPK%K077(:)*PCONC(:,20)+&
&0.00000*TPK%K078(:)*PCONC(:,25)+0.70*TPK%K079(:)*PCONC(:,27)
!
!HCHO/H2O2=0.0
!
!HCHO/NO=+K087*<MO2>+0.03002*K088*<ALKAP>+1.39870*K089*<ALKEP>+0.60600*K090*<BI
!OP>+0.05848*K092*<CARBOP>+0.23419*K093*<OLN>
 PJAC(:,22,3)=+TPK%K087(:)*PCONC(:,31)+0.03002*TPK%K088(:)*PCONC(:,32)+1.39870*&
&TPK%K089(:)*PCONC(:,33)+0.60600*TPK%K090(:)*PCONC(:,34)+0.05848*TPK%K092(:)*PC&
&ONC(:,38)+0.23419*TPK%K093(:)*PCONC(:,39)
!
!HCHO/NO2=0.0
!
!HCHO/NO3=-K069*<HCHO>+0.40*K075*<PAN>+K116*<MO2>+0.03142*K117*<ALKAP>+1.40909*
!K118*<ALKEP>+0.68600*K119*<BIOP>+0.03175*K121*<CARBOP>+0.20740*K122*<OLN>
 PJAC(:,22,5)=-TPK%K069(:)*PCONC(:,22)+0.40*TPK%K075(:)*PCONC(:,27)+TPK%K116(:)&
&*PCONC(:,31)+0.03142*TPK%K117(:)*PCONC(:,32)+1.40909*TPK%K118(:)*PCONC(:,33)+0&
&.68600*TPK%K119(:)*PCONC(:,34)+0.03175*TPK%K121(:)*PCONC(:,38)+0.20740*TPK%K12&
&2(:)*PCONC(:,39)
!
!HCHO/N2O5=0.0
!
!HCHO/HONO=0.0
!
!HCHO/HNO3=0.0
!
!HCHO/HNO4=0.0
!
!HCHO/NH3=0.0
!
!HCHO/SO2=0.0
!
!HCHO/SULF=0.0
!
!HCHO/CO=0.0
!
!HCHO/OH=+0.00140*K057*<ALKA>-K061*<HCHO>+0.00000*K064*<CARBO>+0.35*K065*<OP1>+
!0.02915*K066*<OP2>+0.57839*K067*<PAN>
 PJAC(:,22,14)=+0.00140*TPK%K057(:)*PCONC(:,18)-TPK%K061(:)*PCONC(:,22)+0.00000&
&*TPK%K064(:)*PCONC(:,25)+0.35*TPK%K065(:)*PCONC(:,28)+0.02915*TPK%K066(:)*PCON&
&C(:,29)+0.57839*TPK%K067(:)*PCONC(:,27)
!
!HCHO/HO2=0.0
!
!HCHO/CH4=0.0
!
!HCHO/ETH=0.0
!
!HCHO/ALKA=+0.00140*K057*<OH>
 PJAC(:,22,18)=+0.00140*TPK%K057(:)*PCONC(:,14)
!
!HCHO/ALKE=+0.48290*K076*<O3>
 PJAC(:,22,19)=+0.48290*TPK%K076(:)*PCONC(:,1)
!
!HCHO/BIO=+0.05*K053*<O3P>+0.90000*K077*<O3>
 PJAC(:,22,20)=+0.05*TPK%K053(:)*TPK%O3P(:)+0.90000*TPK%K077(:)*PCONC(:,1)
!
!HCHO/ARO=0.0
!
!HCHO/HCHO=-K010-K011-K061*<OH>-K069*<NO3>
 PJAC(:,22,22)=-TPK%K010(:)-TPK%K011(:)-TPK%K061(:)*PCONC(:,14)-TPK%K069(:)*PCO&
&NC(:,5)
!
!HCHO/ALD=0.0
!
!HCHO/KET=0.0
!
!HCHO/CARBO=+0.06517*K016+0.00000*K064*<OH>+0.00000*K078*<O3>
 PJAC(:,22,25)=+0.06517*TPK%K016(:)+0.00000*TPK%K064(:)*PCONC(:,14)+0.00000*TPK&
&%K078(:)*PCONC(:,1)
!
!HCHO/ONIT=0.0
!
!HCHO/PAN=+0.57839*K067*<OH>+0.40*K075*<NO3>+0.70*K079*<O3>
 PJAC(:,22,27)=+0.57839*TPK%K067(:)*PCONC(:,14)+0.40*TPK%K075(:)*PCONC(:,5)+0.7&
&0*TPK%K079(:)*PCONC(:,1)
!
!HCHO/OP1=+K013+0.35*K065*<OH>
 PJAC(:,22,28)=+TPK%K013(:)+0.35*TPK%K065(:)*PCONC(:,14)
!
!HCHO/OP2=+0.02915*K066*<OH>
 PJAC(:,22,29)=+0.02915*TPK%K066(:)*PCONC(:,14)
!
!HCHO/ORA2=0.0
!
!HCHO/MO2=+K087*<NO>+1.33*K101*<MO2>+1.33*K101*<MO2>+0.80556*K102*<ALKAP>+1.428
!94*K103*<ALKEP>+1.09000*K104*<BIOP>+K105*<AROP>+0.95723*K106*<CARBOP>+0.88625*
!K107*<OLN>+K116*<NO3>+K124*<XO2>
 PJAC(:,22,31)=+TPK%K087(:)*PCONC(:,3)+1.33*TPK%K101(:)*PCONC(:,31)+1.33*TPK%K1&
&01(:)*PCONC(:,31)+0.80556*TPK%K102(:)*PCONC(:,32)+1.42894*TPK%K103(:)*PCONC(:,&
&33)+1.09000*TPK%K104(:)*PCONC(:,34)+TPK%K105(:)*PCONC(:,37)+0.95723*TPK%K106(:&
&)*PCONC(:,38)+0.88625*TPK%K107(:)*PCONC(:,39)+TPK%K116(:)*PCONC(:,5)+TPK%K124(&
&:)*PCONC(:,40)
!
!HCHO/ALKAP=+0.03002*K088*<NO>+0.80556*K102*<MO2>+0.07600*K108*<CARBOP>+0.03142
!*K117*<NO3>
 PJAC(:,22,32)=+0.03002*TPK%K088(:)*PCONC(:,3)+0.80556*TPK%K102(:)*PCONC(:,31)+&
&0.07600*TPK%K108(:)*PCONC(:,38)+0.03142*TPK%K117(:)*PCONC(:,5)
!
!HCHO/ALKEP=+1.39870*K089*<NO>+1.42894*K103*<MO2>+0.68192*K109*<CARBOP>+1.40909
!*K118*<NO3>
 PJAC(:,22,33)=+1.39870*TPK%K089(:)*PCONC(:,3)+1.42894*TPK%K103(:)*PCONC(:,31)+&
&0.68192*TPK%K109(:)*PCONC(:,38)+1.40909*TPK%K118(:)*PCONC(:,5)
!
!HCHO/BIOP=+0.60600*K090*<NO>+1.09000*K104*<MO2>+0.34000*K110*<CARBOP>+0.68600*
!K119*<NO3>
 PJAC(:,22,34)=+0.60600*TPK%K090(:)*PCONC(:,3)+1.09000*TPK%K104(:)*PCONC(:,31)+&
&0.34000*TPK%K110(:)*PCONC(:,38)+0.68600*TPK%K119(:)*PCONC(:,5)
!
!HCHO/PHO=0.0
!
!HCHO/ADD=0.0
!
!HCHO/AROP=+K105*<MO2>
 PJAC(:,22,37)=+TPK%K105(:)*PCONC(:,31)
!
!HCHO/CARBOP=+0.05848*K092*<NO>+0.95723*K106*<MO2>+0.07600*K108*<ALKAP>+0.68192
!*K109*<ALKEP>+0.34000*K110*<BIOP>+0.03432*K112*<CARBOP>+0.03432*K112*<CARBOP>+
!0.13414*K113*<OLN>+0.03175*K121*<NO3>
 PJAC(:,22,38)=+0.05848*TPK%K092(:)*PCONC(:,3)+0.95723*TPK%K106(:)*PCONC(:,31)+&
&0.07600*TPK%K108(:)*PCONC(:,32)+0.68192*TPK%K109(:)*PCONC(:,33)+0.34000*TPK%K1&
&10(:)*PCONC(:,34)+0.03432*TPK%K112(:)*PCONC(:,38)+0.03432*TPK%K112(:)*PCONC(:,&
&38)+0.13414*TPK%K113(:)*PCONC(:,39)+0.03175*TPK%K121(:)*PCONC(:,5)
!
!HCHO/OLN=+0.23419*K093*<NO>+0.88625*K107*<MO2>+0.13414*K113*<CARBOP>+0.00000*K
!115*<OLN>+0.00000*K115*<OLN>+0.20740*K122*<NO3>
 PJAC(:,22,39)=+0.23419*TPK%K093(:)*PCONC(:,3)+0.88625*TPK%K107(:)*PCONC(:,31)+&
&0.13414*TPK%K113(:)*PCONC(:,38)+0.00000*TPK%K115(:)*PCONC(:,39)+0.00000*TPK%K1&
&15(:)*PCONC(:,39)+0.20740*TPK%K122(:)*PCONC(:,5)
!
!HCHO/XO2=+K124*<MO2>
 PJAC(:,22,40)=+TPK%K124(:)*PCONC(:,31)
!
!ALD/O3=+0.51468*K076*<ALKE>+0.00000*K077*<BIO>+0.15692*K078*<CARBO>
 PJAC(:,23,1)=+0.51468*TPK%K076(:)*PCONC(:,19)+0.00000*TPK%K077(:)*PCONC(:,20)+&
&0.15692*TPK%K078(:)*PCONC(:,25)
!
!ALD/H2O2=0.0
!
!ALD/NO=+0.33144*K088*<ALKAP>+0.42125*K089*<ALKEP>+0.00000*K090*<BIOP>+0.07368*
!K092*<CARBOP>+1.01182*K093*<OLN>
 PJAC(:,23,3)=+0.33144*TPK%K088(:)*PCONC(:,32)+0.42125*TPK%K089(:)*PCONC(:,33)+&
&0.00000*TPK%K090(:)*PCONC(:,34)+0.07368*TPK%K092(:)*PCONC(:,38)+1.01182*TPK%K0&
&93(:)*PCONC(:,39)
!
!ALD/NO2=0.0
!
!ALD/NO3=-K070*<ALD>+0.05265*K071*<CARBO>+0.33743*K117*<ALKAP>+0.43039*K118*<AL
!KEP>+0.00000*K119*<BIOP>+0.02936*K121*<CARBOP>+0.91850*K122*<OLN>
 PJAC(:,23,5)=-TPK%K070(:)*PCONC(:,23)+0.05265*TPK%K071(:)*PCONC(:,25)+0.33743*&
&TPK%K117(:)*PCONC(:,32)+0.43039*TPK%K118(:)*PCONC(:,33)+0.00000*TPK%K119(:)*PC&
&ONC(:,34)+0.02936*TPK%K121(:)*PCONC(:,38)+0.91850*TPK%K122(:)*PCONC(:,39)
!
!ALD/N2O5=0.0
!
!ALD/HONO=0.0
!
!ALD/HNO3=0.0
!
!ALD/HNO4=0.0
!
!ALD/NH3=0.0
!
!ALD/SO2=0.0
!
!ALD/SULF=0.0
!
!ALD/CO=0.0
!
!ALD/OH=+0.08173*K057*<ALKA>-K062*<ALD>+0.06253*K064*<CARBO>+0.07335*K066*<OP2>
 PJAC(:,23,14)=+0.08173*TPK%K057(:)*PCONC(:,18)-TPK%K062(:)*PCONC(:,23)+0.06253&
&*TPK%K064(:)*PCONC(:,25)+0.07335*TPK%K066(:)*PCONC(:,29)
!
!ALD/HO2=0.0
!
!ALD/CH4=0.0
!
!ALD/ETH=0.0
!
!ALD/ALKA=+0.08173*K057*<OH>
 PJAC(:,23,18)=+0.08173*TPK%K057(:)*PCONC(:,14)
!
!ALD/ALKE=+0.51468*K076*<O3>
 PJAC(:,23,19)=+0.51468*TPK%K076(:)*PCONC(:,1)
!
!ALD/BIO=+0.00000*K077*<O3>
 PJAC(:,23,20)=+0.00000*TPK%K077(:)*PCONC(:,1)
!
!ALD/ARO=0.0
!
!ALD/HCHO=0.0
!
!ALD/ALD=-K012-K062*<OH>-K070*<NO3>
 PJAC(:,23,23)=-TPK%K012(:)-TPK%K062(:)*PCONC(:,14)-TPK%K070(:)*PCONC(:,5)
!
!ALD/KET=0.0
!
!ALD/CARBO=+K054*<O3P>+0.06253*K064*<OH>+0.05265*K071*<NO3>+0.15692*K078*<O3>
 PJAC(:,23,25)=+TPK%K054(:)*TPK%O3P(:)+0.06253*TPK%K064(:)*PCONC(:,14)+0.05265*&
&TPK%K071(:)*PCONC(:,5)+0.15692*TPK%K078(:)*PCONC(:,1)
!
!ALD/ONIT=+0.20*K017
 PJAC(:,23,26)=+0.20*TPK%K017(:)
!
!ALD/PAN=0.0
!
!ALD/OP1=0.0
!
!ALD/OP2=+0.96205*K014+0.07335*K066*<OH>
 PJAC(:,23,29)=+0.96205*TPK%K014(:)+0.07335*TPK%K066(:)*PCONC(:,14)
!
!ALD/ORA2=0.0
!
!ALD/MO2=+0.56070*K102*<ALKAP>+0.46413*K103*<ALKEP>+0.00000*K104*<BIOP>+0.08295
!*K106*<CARBOP>+0.41524*K107*<OLN>
 PJAC(:,23,31)=+0.56070*TPK%K102(:)*PCONC(:,32)+0.46413*TPK%K103(:)*PCONC(:,33)&
&+0.00000*TPK%K104(:)*PCONC(:,34)+0.08295*TPK%K106(:)*PCONC(:,38)+0.41524*TPK%K&
&107(:)*PCONC(:,39)
!
!ALD/ALKAP=+0.33144*K088*<NO>+0.56070*K102*<MO2>+0.71461*K108*<CARBOP>+0.33743*
!K117*<NO3>
 PJAC(:,23,32)=+0.33144*TPK%K088(:)*PCONC(:,3)+0.56070*TPK%K102(:)*PCONC(:,31)+&
&0.71461*TPK%K108(:)*PCONC(:,38)+0.33743*TPK%K117(:)*PCONC(:,5)
!
!ALD/ALKEP=+0.42125*K089*<NO>+0.46413*K103*<MO2>+0.68374*K109*<CARBOP>+0.43039*
!K118*<NO3>
 PJAC(:,23,33)=+0.42125*TPK%K089(:)*PCONC(:,3)+0.46413*TPK%K103(:)*PCONC(:,31)+&
&0.68374*TPK%K109(:)*PCONC(:,38)+0.43039*TPK%K118(:)*PCONC(:,5)
!
!ALD/BIOP=+0.00000*K090*<NO>+0.00000*K104*<MO2>+0.00000*K110*<CARBOP>+0.00000*K
!119*<NO3>
 PJAC(:,23,34)=+0.00000*TPK%K090(:)*PCONC(:,3)+0.00000*TPK%K104(:)*PCONC(:,31)+&
&0.00000*TPK%K110(:)*PCONC(:,38)+0.00000*TPK%K119(:)*PCONC(:,5)
!
!ALD/PHO=0.0
!
!ALD/ADD=0.0
!
!ALD/AROP=0.0
!
!ALD/CARBOP=+0.07368*K092*<NO>+0.08295*K106*<MO2>+0.71461*K108*<ALKAP>+0.68374*
!K109*<ALKEP>+0.00000*K110*<BIOP>+0.06969*K112*<CARBOP>+0.06969*K112*<CARBOP>+0
!.42122*K113*<OLN>+0.02936*K121*<NO3>
 PJAC(:,23,38)=+0.07368*TPK%K092(:)*PCONC(:,3)+0.08295*TPK%K106(:)*PCONC(:,31)+&
&0.71461*TPK%K108(:)*PCONC(:,32)+0.68374*TPK%K109(:)*PCONC(:,33)+0.00000*TPK%K1&
&10(:)*PCONC(:,34)+0.06969*TPK%K112(:)*PCONC(:,38)+0.06969*TPK%K112(:)*PCONC(:,&
&38)+0.42122*TPK%K113(:)*PCONC(:,39)+0.02936*TPK%K121(:)*PCONC(:,5)
!
!ALD/OLN=+1.01182*K093*<NO>+0.41524*K107*<MO2>+0.42122*K113*<CARBOP>+0.00000*K1
!15*<OLN>+0.00000*K115*<OLN>+0.91850*K122*<NO3>
 PJAC(:,23,39)=+1.01182*TPK%K093(:)*PCONC(:,3)+0.41524*TPK%K107(:)*PCONC(:,31)+&
&0.42122*TPK%K113(:)*PCONC(:,38)+0.00000*TPK%K115(:)*PCONC(:,39)+0.00000*TPK%K1&
&15(:)*PCONC(:,39)+0.91850*TPK%K122(:)*PCONC(:,5)
!
!ALD/XO2=0.0
!
!KET/O3=+0.07377*K076*<ALKE>+0.00000*K077*<BIO>
 PJAC(:,24,1)=+0.07377*TPK%K076(:)*PCONC(:,19)+0.00000*TPK%K077(:)*PCONC(:,20)
!
!KET/H2O2=0.0
!
!KET/NO=+0.54531*K088*<ALKAP>+0.05220*K089*<ALKEP>+0.00000*K090*<BIOP>+0.37862*
!K093*<OLN>
 PJAC(:,24,3)=+0.54531*TPK%K088(:)*PCONC(:,32)+0.05220*TPK%K089(:)*PCONC(:,33)+&
&0.00000*TPK%K090(:)*PCONC(:,34)+0.37862*TPK%K093(:)*PCONC(:,39)
!
!KET/NO2=0.0
!
!KET/NO3=+0.00632*K071*<CARBO>+0.62978*K117*<ALKAP>+0.02051*K118*<ALKEP>+0.0000
!0*K119*<BIOP>+0.34740*K122*<OLN>
 PJAC(:,24,5)=+0.00632*TPK%K071(:)*PCONC(:,25)+0.62978*TPK%K117(:)*PCONC(:,32)+&
&0.02051*TPK%K118(:)*PCONC(:,33)+0.00000*TPK%K119(:)*PCONC(:,34)+0.34740*TPK%K1&
&22(:)*PCONC(:,39)
!
!KET/N2O5=0.0
!
!KET/HONO=0.0
!
!KET/HNO3=0.0
!
!KET/HNO4=0.0
!
!KET/NH3=0.0
!
!KET/SO2=0.0
!
!KET/SULF=0.0
!
!KET/CO=0.0
!
!KET/OH=+0.03498*K057*<ALKA>-K063*<KET>+0.00853*K064*<CARBO>+0.37591*K066*<OP2>
 PJAC(:,24,14)=+0.03498*TPK%K057(:)*PCONC(:,18)-TPK%K063(:)*PCONC(:,24)+0.00853&
&*TPK%K064(:)*PCONC(:,25)+0.37591*TPK%K066(:)*PCONC(:,29)
!
!KET/HO2=0.0
!
!KET/CH4=0.0
!
!KET/ETH=0.0
!
!KET/ALKA=+0.03498*K057*<OH>
 PJAC(:,24,18)=+0.03498*TPK%K057(:)*PCONC(:,14)
!
!KET/ALKE=+0.07377*K076*<O3>
 PJAC(:,24,19)=+0.07377*TPK%K076(:)*PCONC(:,1)
!
!KET/BIO=+0.00000*K077*<O3>
 PJAC(:,24,20)=+0.00000*TPK%K077(:)*PCONC(:,1)
!
!KET/ARO=0.0
!
!KET/HCHO=0.0
!
!KET/ALD=0.0
!
!KET/KET=-K015-K063*<OH>
 PJAC(:,24,24)=-TPK%K015(:)-TPK%K063(:)*PCONC(:,14)
!
!KET/CARBO=+0.00853*K064*<OH>+0.00632*K071*<NO3>
 PJAC(:,24,25)=+0.00853*TPK%K064(:)*PCONC(:,14)+0.00632*TPK%K071(:)*PCONC(:,5)
!
!KET/ONIT=+0.80*K017
 PJAC(:,24,26)=+0.80*TPK%K017(:)
!
!KET/PAN=0.0
!
!KET/OP1=0.0
!
!KET/OP2=+0.37591*K066*<OH>
 PJAC(:,24,29)=+0.37591*TPK%K066(:)*PCONC(:,14)
!
!KET/ORA2=0.0
!
!KET/MO2=+0.09673*K102*<ALKAP>+0.03814*K103*<ALKEP>+0.00000*K104*<BIOP>+0.09667
!*K107*<OLN>
 PJAC(:,24,31)=+0.09673*TPK%K102(:)*PCONC(:,32)+0.03814*TPK%K103(:)*PCONC(:,33)&
&+0.00000*TPK%K104(:)*PCONC(:,34)+0.09667*TPK%K107(:)*PCONC(:,39)
!
!KET/ALKAP=+0.54531*K088*<NO>+0.09673*K102*<MO2>+0.18819*K108*<CARBOP>+0.62978*
!K117*<NO3>
 PJAC(:,24,32)=+0.54531*TPK%K088(:)*PCONC(:,3)+0.09673*TPK%K102(:)*PCONC(:,31)+&
&0.18819*TPK%K108(:)*PCONC(:,38)+0.62978*TPK%K117(:)*PCONC(:,5)
!
!KET/ALKEP=+0.05220*K089*<NO>+0.03814*K103*<MO2>+0.06579*K109*<CARBOP>+0.02051*
!K118*<NO3>
 PJAC(:,24,33)=+0.05220*TPK%K089(:)*PCONC(:,3)+0.03814*TPK%K103(:)*PCONC(:,31)+&
&0.06579*TPK%K109(:)*PCONC(:,38)+0.02051*TPK%K118(:)*PCONC(:,5)
!
!KET/BIOP=+0.00000*K090*<NO>+0.00000*K104*<MO2>+0.00000*K110*<CARBOP>+0.00000*K
!119*<NO3>
 PJAC(:,24,34)=+0.00000*TPK%K090(:)*PCONC(:,3)+0.00000*TPK%K104(:)*PCONC(:,31)+&
&0.00000*TPK%K110(:)*PCONC(:,38)+0.00000*TPK%K119(:)*PCONC(:,5)
!
!KET/PHO=0.0
!
!KET/ADD=0.0
!
!KET/AROP=0.0
!
!KET/CARBOP=+0.18819*K108*<ALKAP>+0.06579*K109*<ALKEP>+0.00000*K110*<BIOP>+0.02
!190*K112*<CARBOP>+0.02190*K112*<CARBOP>+0.10822*K113*<OLN>
 PJAC(:,24,38)=+0.18819*TPK%K108(:)*PCONC(:,32)+0.06579*TPK%K109(:)*PCONC(:,33)&
&+0.00000*TPK%K110(:)*PCONC(:,34)+0.02190*TPK%K112(:)*PCONC(:,38)+0.02190*TPK%K&
&112(:)*PCONC(:,38)+0.10822*TPK%K113(:)*PCONC(:,39)
!
!KET/OLN=+0.37862*K093*<NO>+0.09667*K107*<MO2>+0.10822*K113*<CARBOP>+0.00000*K1
!15*<OLN>+0.00000*K115*<OLN>+0.34740*K122*<NO3>
 PJAC(:,24,39)=+0.37862*TPK%K093(:)*PCONC(:,3)+0.09667*TPK%K107(:)*PCONC(:,31)+&
&0.10822*TPK%K113(:)*PCONC(:,38)+0.00000*TPK%K115(:)*PCONC(:,39)+0.00000*TPK%K1&
&15(:)*PCONC(:,39)+0.34740*TPK%K122(:)*PCONC(:,5)
!
!KET/XO2=0.0
!
!CARBO/O3=+0.00000*K076*<ALKE>+0.39754*K077*<BIO>+1.07583*K078*<CARBO>-K078*<CA
!RBO>
 PJAC(:,25,1)=+0.00000*TPK%K076(:)*PCONC(:,19)+0.39754*TPK%K077(:)*PCONC(:,20)+&
&1.07583*TPK%K078(:)*PCONC(:,25)-TPK%K078(:)*PCONC(:,25)
!
!CARBO/H2O2=0.0
!
!CARBO/NO=+0.03407*K088*<ALKAP>+0.45463*K090*<BIOP>+2.06993*K091*<AROP>+0.08670
!*K092*<CARBOP>
 PJAC(:,25,3)=+0.03407*TPK%K088(:)*PCONC(:,32)+0.45463*TPK%K090(:)*PCONC(:,34)+&
&2.06993*TPK%K091(:)*PCONC(:,37)+0.08670*TPK%K092(:)*PCONC(:,38)
!
!CARBO/NO2=0.0
!
!CARBO/NO3=+0.10530*K071*<CARBO>-K071*<CARBO>+0.00000*K073*<ALKE>+0.91741*K074*
!<BIO>+0.03531*K117*<ALKAP>+0.61160*K119*<BIOP>+2.81904*K120*<AROP>+0.03455*K12
!1*<CARBOP>
 PJAC(:,25,5)=+0.10530*TPK%K071(:)*PCONC(:,25)-TPK%K071(:)*PCONC(:,25)+0.00000*&
&TPK%K073(:)*PCONC(:,19)+0.91741*TPK%K074(:)*PCONC(:,20)+0.03531*TPK%K117(:)*PC&
&ONC(:,32)+0.61160*TPK%K119(:)*PCONC(:,34)+2.81904*TPK%K120(:)*PCONC(:,37)+0.03&
&455*TPK%K121(:)*PCONC(:,38)
!
!CARBO/N2O5=0.0
!
!CARBO/HONO=0.0
!
!CARBO/HNO3=0.0
!
!CARBO/HNO4=0.0
!
!CARBO/NH3=0.0
!
!CARBO/SO2=0.0
!
!CARBO/SULF=0.0
!
!CARBO/CO=0.0
!
!CARBO/OH=+0.00835*K057*<ALKA>+0.16919*K064*<CARBO>-K064*<CARBO>+0.21863*K067*<
!PAN>
 PJAC(:,25,14)=+0.00835*TPK%K057(:)*PCONC(:,18)+0.16919*TPK%K064(:)*PCONC(:,25)&
&-TPK%K064(:)*PCONC(:,25)+0.21863*TPK%K067(:)*PCONC(:,27)
!
!CARBO/HO2=0.0
!
!CARBO/CH4=0.0
!
!CARBO/ETH=0.0
!
!CARBO/ALKA=+0.00835*K057*<OH>
 PJAC(:,25,18)=+0.00835*TPK%K057(:)*PCONC(:,14)
!
!CARBO/ALKE=+0.00000*K073*<NO3>+0.00000*K076*<O3>
 PJAC(:,25,19)=+0.00000*TPK%K073(:)*PCONC(:,5)+0.00000*TPK%K076(:)*PCONC(:,1)
!
!CARBO/BIO=+0.13255*K053*<O3P>+0.91741*K074*<NO3>+0.39754*K077*<O3>
 PJAC(:,25,20)=+0.13255*TPK%K053(:)*TPK%O3P(:)+0.91741*TPK%K074(:)*PCONC(:,5)+0&
&.39754*TPK%K077(:)*PCONC(:,1)
!
!CARBO/ARO=0.0
!
!CARBO/HCHO=0.0
!
!CARBO/ALD=0.0
!
!CARBO/KET=0.0
!
!CARBO/CARBO=-K016-K054*<O3P>+0.16919*K064*<OH>-K064*<OH>+0.10530*K071*<NO3>-K0
!71*<NO3>+1.07583*K078*<O3>-K078*<O3>
 PJAC(:,25,25)=-TPK%K016(:)-TPK%K054(:)*TPK%O3P(:)+0.16919*TPK%K064(:)*PCONC(:,&
&14)-TPK%K064(:)*PCONC(:,14)+0.10530*TPK%K071(:)*PCONC(:,5)-TPK%K071(:)*PCONC(:&
&,5)+1.07583*TPK%K078(:)*PCONC(:,1)-TPK%K078(:)*PCONC(:,1)
!
!CARBO/ONIT=0.0
!
!CARBO/PAN=+0.21863*K067*<OH>
 PJAC(:,25,27)=+0.21863*TPK%K067(:)*PCONC(:,14)
!
!CARBO/OP1=0.0
!
!CARBO/OP2=0.0
!
!CARBO/ORA2=0.0
!
!CARBO/MO2=+0.07976*K102*<ALKAP>+0.56064*K104*<BIOP>+1.99461*K105*<AROP>+0.1538
!7*K106*<CARBOP>
 PJAC(:,25,31)=+0.07976*TPK%K102(:)*PCONC(:,32)+0.56064*TPK%K104(:)*PCONC(:,34)&
&+1.99461*TPK%K105(:)*PCONC(:,37)+0.15387*TPK%K106(:)*PCONC(:,38)
!
!CARBO/ALKAP=+0.03407*K088*<NO>+0.07976*K102*<MO2>+0.06954*K108*<CARBOP>+0.0353
!1*K117*<NO3>
 PJAC(:,25,32)=+0.03407*TPK%K088(:)*PCONC(:,3)+0.07976*TPK%K102(:)*PCONC(:,31)+&
&0.06954*TPK%K108(:)*PCONC(:,38)+0.03531*TPK%K117(:)*PCONC(:,5)
!
!CARBO/ALKEP=0.0
!
!CARBO/BIOP=+0.45463*K090*<NO>+0.56064*K104*<MO2>+0.78591*K110*<CARBOP>+0.61160
!*K119*<NO3>
 PJAC(:,25,34)=+0.45463*TPK%K090(:)*PCONC(:,3)+0.56064*TPK%K104(:)*PCONC(:,31)+&
&0.78591*TPK%K110(:)*PCONC(:,38)+0.61160*TPK%K119(:)*PCONC(:,5)
!
!CARBO/PHO=0.0
!
!CARBO/ADD=0.0
!
!CARBO/AROP=+2.06993*K091*<NO>+1.99461*K105*<MO2>+1.99455*K111*<CARBOP>+2.81904
!*K120*<NO3>
 PJAC(:,25,37)=+2.06993*TPK%K091(:)*PCONC(:,3)+1.99461*TPK%K105(:)*PCONC(:,31)+&
&1.99455*TPK%K111(:)*PCONC(:,38)+2.81904*TPK%K120(:)*PCONC(:,5)
!
!CARBO/CARBOP=+0.08670*K092*<NO>+0.15387*K106*<MO2>+0.06954*K108*<ALKAP>+0.7859
!1*K110*<BIOP>+1.99455*K111*<AROP>+0.10777*K112*<CARBOP>+0.10777*K112*<CARBOP>+
!0.03455*K121*<NO3>
 PJAC(:,25,38)=+0.08670*TPK%K092(:)*PCONC(:,3)+0.15387*TPK%K106(:)*PCONC(:,31)+&
&0.06954*TPK%K108(:)*PCONC(:,32)+0.78591*TPK%K110(:)*PCONC(:,34)+1.99455*TPK%K1&
&11(:)*PCONC(:,37)+0.10777*TPK%K112(:)*PCONC(:,38)+0.10777*TPK%K112(:)*PCONC(:,&
&38)+0.03455*TPK%K121(:)*PCONC(:,5)
!
!CARBO/OLN=0.0
!
!CARBO/XO2=0.0
!
!ONIT/O3=0.0
!
!ONIT/H2O2=0.0
!
!ONIT/NO=+0.08459*K088*<ALKAP>+0.15300*K090*<BIOP>+0.04885*K091*<AROP>+0.18401*
!K093*<OLN>
 PJAC(:,26,3)=+0.08459*TPK%K088(:)*PCONC(:,32)+0.15300*TPK%K090(:)*PCONC(:,34)+&
&0.04885*TPK%K091(:)*PCONC(:,37)+0.18401*TPK%K093(:)*PCONC(:,39)
!
!ONIT/NO2=+K080*<PHO>
 PJAC(:,26,4)=+TPK%K080(:)*PCONC(:,35)
!
!ONIT/NO3=+0.60*K075*<PAN>+0.25928*K122*<OLN>
 PJAC(:,26,5)=+0.60*TPK%K075(:)*PCONC(:,27)+0.25928*TPK%K122(:)*PCONC(:,39)
!
!ONIT/N2O5=0.0
!
!ONIT/HONO=0.0
!
!ONIT/HNO3=0.0
!
!ONIT/HNO4=0.0
!
!ONIT/NH3=0.0
!
!ONIT/SO2=0.0
!
!ONIT/SULF=0.0
!
!ONIT/CO=0.0
!
!ONIT/OH=-K068*<ONIT>
 PJAC(:,26,14)=-TPK%K068(:)*PCONC(:,26)
!
!ONIT/HO2=+K100*<OLN>
 PJAC(:,26,15)=+TPK%K100(:)*PCONC(:,39)
!
!ONIT/CH4=0.0
!
!ONIT/ETH=0.0
!
!ONIT/ALKA=0.0
!
!ONIT/ALKE=0.0
!
!ONIT/BIO=0.0
!
!ONIT/ARO=0.0
!
!ONIT/HCHO=0.0
!
!ONIT/ALD=0.0
!
!ONIT/KET=0.0
!
!ONIT/CARBO=0.0
!
!ONIT/ONIT=-K017-K068*<OH>
 PJAC(:,26,26)=-TPK%K017(:)-TPK%K068(:)*PCONC(:,14)
!
!ONIT/PAN=+0.60*K075*<NO3>
 PJAC(:,26,27)=+0.60*TPK%K075(:)*PCONC(:,5)
!
!ONIT/OP1=0.0
!
!ONIT/OP2=0.0
!
!ONIT/ORA2=0.0
!
!ONIT/MO2=+0.67560*K107*<OLN>
 PJAC(:,26,31)=+0.67560*TPK%K107(:)*PCONC(:,39)
!
!ONIT/ALKAP=+0.08459*K088*<NO>
 PJAC(:,26,32)=+0.08459*TPK%K088(:)*PCONC(:,3)
!
!ONIT/ALKEP=0.0
!
!ONIT/BIOP=+0.15300*K090*<NO>
 PJAC(:,26,34)=+0.15300*TPK%K090(:)*PCONC(:,3)
!
!ONIT/PHO=+K080*<NO2>
 PJAC(:,26,35)=+TPK%K080(:)*PCONC(:,4)
!
!ONIT/ADD=0.0
!
!ONIT/AROP=+0.04885*K091*<NO>
 PJAC(:,26,37)=+0.04885*TPK%K091(:)*PCONC(:,3)
!
!ONIT/CARBOP=+0.66562*K113*<OLN>
 PJAC(:,26,38)=+0.66562*TPK%K113(:)*PCONC(:,39)
!
!ONIT/OLN=+0.18401*K093*<NO>+K100*<HO2>+0.67560*K107*<MO2>+0.66562*K113*<CARBOP
!>+2.00*K114*<OLN>+2.00*K114*<OLN>+0.00000*K115*<OLN>+0.00000*K115*<OLN>+0.2592
!8*K122*<NO3>
 PJAC(:,26,39)=+0.18401*TPK%K093(:)*PCONC(:,3)+TPK%K100(:)*PCONC(:,15)+0.67560*&
&TPK%K107(:)*PCONC(:,31)+0.66562*TPK%K113(:)*PCONC(:,38)+2.00*TPK%K114(:)*PCONC&
&(:,39)+2.00*TPK%K114(:)*PCONC(:,39)+0.00000*TPK%K115(:)*PCONC(:,39)+0.00000*TP&
&K%K115(:)*PCONC(:,39)+0.25928*TPK%K122(:)*PCONC(:,5)
!
!ONIT/XO2=0.0
!
!PAN/O3=+0.30000*K079*<PAN>-K079*<PAN>
 PJAC(:,27,1)=+0.30000*TPK%K079(:)*PCONC(:,27)-TPK%K079(:)*PCONC(:,27)
!
!PAN/H2O2=0.0
!
!PAN/NO=0.0
!
!PAN/NO2=+1.00000*K085*<CARBOP>
 PJAC(:,27,4)=+1.00000*TPK%K085(:)*PCONC(:,38)
!
!PAN/NO3=+0.40000*K075*<PAN>-K075*<PAN>
 PJAC(:,27,5)=+0.40000*TPK%K075(:)*PCONC(:,27)-TPK%K075(:)*PCONC(:,27)
!
!PAN/N2O5=0.0
!
!PAN/HONO=0.0
!
!PAN/HNO3=0.0
!
!PAN/HNO4=0.0
!
!PAN/NH3=0.0
!
!PAN/SO2=0.0
!
!PAN/SULF=0.0
!
!PAN/CO=0.0
!
!PAN/OH=+0.28107*K067*<PAN>-K067*<PAN>
 PJAC(:,27,14)=+0.28107*TPK%K067(:)*PCONC(:,27)-TPK%K067(:)*PCONC(:,27)
!
!PAN/HO2=0.0
!
!PAN/CH4=0.0
!
!PAN/ETH=0.0
!
!PAN/ALKA=0.0
!
!PAN/ALKE=0.0
!
!PAN/BIO=0.0
!
!PAN/ARO=0.0
!
!PAN/HCHO=0.0
!
!PAN/ALD=0.0
!
!PAN/KET=0.0
!
!PAN/CARBO=0.0
!
!PAN/ONIT=0.0
!
!PAN/PAN=+0.28107*K067*<OH>-K067*<OH>+0.40000*K075*<NO3>-K075*<NO3>+0.30000*K07
!9*<O3>-K079*<O3>-K086
 PJAC(:,27,27)=+0.28107*TPK%K067(:)*PCONC(:,14)-TPK%K067(:)*PCONC(:,14)+0.40000&
&*TPK%K075(:)*PCONC(:,5)-TPK%K075(:)*PCONC(:,5)+0.30000*TPK%K079(:)*PCONC(:,1)-&
&TPK%K079(:)*PCONC(:,1)-TPK%K086(:)
!
!PAN/OP1=0.0
!
!PAN/OP2=0.0
!
!PAN/ORA2=0.0
!
!PAN/MO2=0.0
!
!PAN/ALKAP=0.0
!
!PAN/ALKEP=0.0
!
!PAN/BIOP=0.0
!
!PAN/PHO=0.0
!
!PAN/ADD=0.0
!
!PAN/AROP=0.0
!
!PAN/CARBOP=+1.00000*K085*<NO2>
 PJAC(:,27,38)=+1.00000*TPK%K085(:)*PCONC(:,4)
!
!PAN/OLN=0.0
!
!PAN/XO2=0.0
!
!OP1/O3=0.0
!
!OP1/H2O2=0.0
!
!OP1/NO=0.0
!
!OP1/NO2=0.0
!
!OP1/NO3=0.0
!
!OP1/N2O5=0.0
!
!OP1/HONO=0.0
!
!OP1/HNO3=0.0
!
!OP1/HNO4=0.0
!
!OP1/NH3=0.0
!
!OP1/SO2=0.0
!
!OP1/SULF=0.0
!
!OP1/CO=0.0
!
!OP1/OH=-K065*<OP1>
 PJAC(:,28,14)=-TPK%K065(:)*PCONC(:,28)
!
!OP1/HO2=+K094*<MO2>
 PJAC(:,28,15)=+TPK%K094(:)*PCONC(:,31)
!
!OP1/CH4=0.0
!
!OP1/ETH=0.0
!
!OP1/ALKA=0.0
!
!OP1/ALKE=0.0
!
!OP1/BIO=0.0
!
!OP1/ARO=0.0
!
!OP1/HCHO=0.0
!
!OP1/ALD=0.0
!
!OP1/KET=0.0
!
!OP1/CARBO=0.0
!
!OP1/ONIT=0.0
!
!OP1/PAN=0.0
!
!OP1/OP1=-K013-K065*<OH>
 PJAC(:,28,28)=-TPK%K013(:)-TPK%K065(:)*PCONC(:,14)
!
!OP1/OP2=0.0
!
!OP1/ORA2=0.0
!
!OP1/MO2=+K094*<HO2>
 PJAC(:,28,31)=+TPK%K094(:)*PCONC(:,15)
!
!OP1/ALKAP=0.0
!
!OP1/ALKEP=0.0
!
!OP1/BIOP=0.0
!
!OP1/PHO=0.0
!
!OP1/ADD=0.0
!
!OP1/AROP=0.0
!
!OP1/CARBOP=0.0
!
!OP1/OLN=0.0
!
!OP1/XO2=0.0
!
!OP2/O3=+0.10149*K078*<CARBO>
 PJAC(:,29,1)=+0.10149*TPK%K078(:)*PCONC(:,25)
!
!OP2/H2O2=0.0
!
!OP2/NO=0.0
!
!OP2/NO2=0.0
!
!OP2/NO3=0.0
!
!OP2/N2O5=0.0
!
!OP2/HONO=0.0
!
!OP2/HNO3=0.0
!
!OP2/HNO4=0.0
!
!OP2/NH3=0.0
!
!OP2/SO2=0.0
!
!OP2/SULF=0.0
!
!OP2/CO=0.0
!
!OP2/OH=-K066*<OP2>
 PJAC(:,29,14)=-TPK%K066(:)*PCONC(:,29)
!
!OP2/HO2=+1.00524*K095*<ALKAP>+1.00524*K096*<ALKEP>+1.00524*K097*<BIOP>+1.00524
!*K098*<AROP>+0.80904*K099*<CARBOP>+1.00524*K123*<XO2>
 PJAC(:,29,15)=+1.00524*TPK%K095(:)*PCONC(:,32)+1.00524*TPK%K096(:)*PCONC(:,33)&
&+1.00524*TPK%K097(:)*PCONC(:,34)+1.00524*TPK%K098(:)*PCONC(:,37)+0.80904*TPK%K&
&099(:)*PCONC(:,38)+1.00524*TPK%K123(:)*PCONC(:,40)
!
!OP2/CH4=0.0
!
!OP2/ETH=0.0
!
!OP2/ALKA=0.0
!
!OP2/ALKE=0.0
!
!OP2/BIO=0.0
!
!OP2/ARO=0.0
!
!OP2/HCHO=0.0
!
!OP2/ALD=0.0
!
!OP2/KET=0.0
!
!OP2/CARBO=+0.10149*K078*<O3>
 PJAC(:,29,25)=+0.10149*TPK%K078(:)*PCONC(:,1)
!
!OP2/ONIT=0.0
!
!OP2/PAN=0.0
!
!OP2/OP1=0.0
!
!OP2/OP2=-K014-K066*<OH>
 PJAC(:,29,29)=-TPK%K014(:)-TPK%K066(:)*PCONC(:,14)
!
!OP2/ORA2=0.0
!
!OP2/MO2=0.0
!
!OP2/ALKAP=+1.00524*K095*<HO2>
 PJAC(:,29,32)=+1.00524*TPK%K095(:)*PCONC(:,15)
!
!OP2/ALKEP=+1.00524*K096*<HO2>
 PJAC(:,29,33)=+1.00524*TPK%K096(:)*PCONC(:,15)
!
!OP2/BIOP=+1.00524*K097*<HO2>
 PJAC(:,29,34)=+1.00524*TPK%K097(:)*PCONC(:,15)
!
!OP2/PHO=0.0
!
!OP2/ADD=0.0
!
!OP2/AROP=+1.00524*K098*<HO2>
 PJAC(:,29,37)=+1.00524*TPK%K098(:)*PCONC(:,15)
!
!OP2/CARBOP=+0.80904*K099*<HO2>
 PJAC(:,29,38)=+0.80904*TPK%K099(:)*PCONC(:,15)
!
!OP2/OLN=0.0
!
!OP2/XO2=+1.00524*K123*<HO2>
 PJAC(:,29,40)=+1.00524*TPK%K123(:)*PCONC(:,15)
!
!ORA2/O3=+0.08143*K076*<ALKE>+0.00000*K077*<BIO>+0.20595*K078*<CARBO>
 PJAC(:,30,1)=+0.08143*TPK%K076(:)*PCONC(:,19)+0.00000*TPK%K077(:)*PCONC(:,20)+&
&0.20595*TPK%K078(:)*PCONC(:,25)
!
!ORA2/H2O2=0.0
!
!ORA2/NO=0.0
!
!ORA2/NO2=0.0
!
!ORA2/NO3=0.0
!
!ORA2/N2O5=0.0
!
!ORA2/HONO=0.0
!
!ORA2/HNO3=0.0
!
!ORA2/HNO4=0.0
!
!ORA2/NH3=0.0
!
!ORA2/SO2=0.0
!
!ORA2/SULF=0.0
!
!ORA2/CO=0.0
!
!ORA2/OH=0.0
!
!ORA2/HO2=+0.17307*K099*<CARBOP>
 PJAC(:,30,15)=+0.17307*TPK%K099(:)*PCONC(:,38)
!
!ORA2/CH4=0.0
!
!ORA2/ETH=0.0
!
!ORA2/ALKA=0.0
!
!ORA2/ALKE=+0.08143*K076*<O3>
 PJAC(:,30,19)=+0.08143*TPK%K076(:)*PCONC(:,1)
!
!ORA2/BIO=+0.00000*K077*<O3>
 PJAC(:,30,20)=+0.00000*TPK%K077(:)*PCONC(:,1)
!
!ORA2/ARO=0.0
!
!ORA2/HCHO=0.0
!
!ORA2/ALD=0.0
!
!ORA2/KET=0.0
!
!ORA2/CARBO=+0.20595*K078*<O3>
 PJAC(:,30,25)=+0.20595*TPK%K078(:)*PCONC(:,1)
!
!ORA2/ONIT=0.0
!
!ORA2/PAN=0.0
!
!ORA2/OP1=0.0
!
!ORA2/OP2=0.0
!
!ORA2/ORA2=0.0
!
!ORA2/MO2=+0.13684*K106*<CARBOP>
 PJAC(:,30,31)=+0.13684*TPK%K106(:)*PCONC(:,38)
!
!ORA2/ALKAP=+0.49810*K108*<CARBOP>
 PJAC(:,30,32)=+0.49810*TPK%K108(:)*PCONC(:,38)
!
!ORA2/ALKEP=+0.49922*K109*<CARBOP>
 PJAC(:,30,33)=+0.49922*TPK%K109(:)*PCONC(:,38)
!
!ORA2/BIOP=+0.49400*K110*<CARBOP>
 PJAC(:,30,34)=+0.49400*TPK%K110(:)*PCONC(:,38)
!
!ORA2/PHO=0.0
!
!ORA2/ADD=0.0
!
!ORA2/AROP=0.0
!
!ORA2/CARBOP=+0.17307*K099*<HO2>+0.13684*K106*<MO2>+0.49810*K108*<ALKAP>+0.4992
!2*K109*<ALKEP>+0.49400*K110*<BIOP>+0.09955*K112*<CARBOP>+0.09955*K112*<CARBOP>
!+0.48963*K113*<OLN>
 PJAC(:,30,38)=+0.17307*TPK%K099(:)*PCONC(:,15)+0.13684*TPK%K106(:)*PCONC(:,31)&
&+0.49810*TPK%K108(:)*PCONC(:,32)+0.49922*TPK%K109(:)*PCONC(:,33)+0.49400*TPK%K&
&110(:)*PCONC(:,34)+0.09955*TPK%K112(:)*PCONC(:,38)+0.09955*TPK%K112(:)*PCONC(:&
&,38)+0.48963*TPK%K113(:)*PCONC(:,39)
!
!ORA2/OLN=+0.48963*K113*<CARBOP>
 PJAC(:,30,39)=+0.48963*TPK%K113(:)*PCONC(:,38)
!
!ORA2/XO2=0.0
!
!MO2/O3=+0.13966*K076*<ALKE>+0.03000*K077*<BIO>
 PJAC(:,31,1)=+0.13966*TPK%K076(:)*PCONC(:,19)+0.03000*TPK%K077(:)*PCONC(:,20)
!
!MO2/H2O2=0.0
!
!MO2/NO=-K087*<MO2>+0.09016*K088*<ALKAP>+0.78134*K092*<CARBOP>
 PJAC(:,31,3)=-TPK%K087(:)*PCONC(:,31)+0.09016*TPK%K088(:)*PCONC(:,32)+0.78134*&
&TPK%K092(:)*PCONC(:,38)
!
!MO2/NO2=0.0
!
!MO2/NO3=-K116*<MO2>+0.09731*K117*<ALKAP>+0.91910*K121*<CARBOP>
 PJAC(:,31,5)=-TPK%K116(:)*PCONC(:,31)+0.09731*TPK%K117(:)*PCONC(:,32)+0.91910*&
&TPK%K121(:)*PCONC(:,38)
!
!MO2/N2O5=0.0
!
!MO2/HONO=0.0
!
!MO2/HNO3=0.0
!
!MO2/HNO4=0.0
!
!MO2/NH3=0.0
!
!MO2/SO2=0.0
!
!MO2/SULF=0.0
!
!MO2/CO=0.0
!
!MO2/OH=+K055*<CH4>+0.65*K065*<OP1>
 PJAC(:,31,14)=+TPK%K055(:)*PCONC(:,16)+0.65*TPK%K065(:)*PCONC(:,28)
!
!MO2/HO2=-K094*<MO2>
 PJAC(:,31,15)=-TPK%K094(:)*PCONC(:,31)
!
!MO2/CH4=+K055*<OH>
 PJAC(:,31,16)=+TPK%K055(:)*PCONC(:,14)
!
!MO2/ETH=0.0
!
!MO2/ALKA=0.0
!
!MO2/ALKE=+0.13966*K076*<O3>
 PJAC(:,31,19)=+0.13966*TPK%K076(:)*PCONC(:,1)
!
!MO2/BIO=+0.03000*K077*<O3>
 PJAC(:,31,20)=+0.03000*TPK%K077(:)*PCONC(:,1)
!
!MO2/ARO=0.0
!
!MO2/HCHO=0.0
!
!MO2/ALD=+K012
 PJAC(:,31,23)=+TPK%K012(:)
!
!MO2/KET=0.0
!
!MO2/CARBO=0.0
!
!MO2/ONIT=0.0
!
!MO2/PAN=0.0
!
!MO2/OP1=+0.65*K065*<OH>
 PJAC(:,31,28)=+0.65*TPK%K065(:)*PCONC(:,14)
!
!MO2/OP2=+0.03795*K014
 PJAC(:,31,29)=+0.03795*TPK%K014(:)
!
!MO2/ORA2=0.0
!
!MO2/MO2=-K087*<NO>-K094*<HO2>-K101*<MO2>-K101*<MO2>-K101*<MO2>-K101*<MO2>+0.01
!390*K102*<ALKAP>-K102*<ALKAP>-K103*<ALKEP>-K104*<BIOP>-K105*<AROP>+0.56031*K10
!6*<CARBOP>-K106*<CARBOP>-K107*<OLN>-K116*<NO3>-K124*<XO2>
 PJAC(:,31,31)=-TPK%K087(:)*PCONC(:,3)-TPK%K094(:)*PCONC(:,15)-TPK%K101(:)*PCON&
&C(:,31)-TPK%K101(:)*PCONC(:,31)-TPK%K101(:)*PCONC(:,31)-TPK%K101(:)*PCONC(:,31&
&)+0.01390*TPK%K102(:)*PCONC(:,32)-TPK%K102(:)*PCONC(:,32)-TPK%K103(:)*PCONC(:,&
&33)-TPK%K104(:)*PCONC(:,34)-TPK%K105(:)*PCONC(:,37)+0.56031*TPK%K106(:)*PCONC(&
&:,38)-TPK%K106(:)*PCONC(:,38)-TPK%K107(:)*PCONC(:,39)-TPK%K116(:)*PCONC(:,5)-T&
&PK%K124(:)*PCONC(:,40)
!
!MO2/ALKAP=+0.09016*K088*<NO>+0.01390*K102*<MO2>-K102*<MO2>+0.51480*K108*<CARBO
!P>+0.09731*K117*<NO3>
 PJAC(:,31,32)=+0.09016*TPK%K088(:)*PCONC(:,3)+0.01390*TPK%K102(:)*PCONC(:,31)-&
&TPK%K102(:)*PCONC(:,31)+0.51480*TPK%K108(:)*PCONC(:,38)+0.09731*TPK%K117(:)*PC&
&ONC(:,5)
!
!MO2/ALKEP=-K103*<MO2>+0.50078*K109*<CARBOP>
 PJAC(:,31,33)=-TPK%K103(:)*PCONC(:,31)+0.50078*TPK%K109(:)*PCONC(:,38)
!
!MO2/BIOP=-K104*<MO2>+0.50600*K110*<CARBOP>
 PJAC(:,31,34)=-TPK%K104(:)*PCONC(:,31)+0.50600*TPK%K110(:)*PCONC(:,38)
!
!MO2/PHO=0.0
!
!MO2/ADD=0.0
!
!MO2/AROP=-K105*<MO2>+K111*<CARBOP>
 PJAC(:,31,37)=-TPK%K105(:)*PCONC(:,31)+TPK%K111(:)*PCONC(:,38)
!
!MO2/CARBOP=+0.78134*K092*<NO>+0.56031*K106*<MO2>-K106*<MO2>+0.51480*K108*<ALKA
!P>+0.50078*K109*<ALKEP>+0.50600*K110*<BIOP>+K111*<AROP>+1.66702*K112*<CARBOP>+
!1.66702*K112*<CARBOP>+0.51037*K113*<OLN>+0.91910*K121*<NO3>+K125*<XO2>
 PJAC(:,31,38)=+0.78134*TPK%K092(:)*PCONC(:,3)+0.56031*TPK%K106(:)*PCONC(:,31)-&
&TPK%K106(:)*PCONC(:,31)+0.51480*TPK%K108(:)*PCONC(:,32)+0.50078*TPK%K109(:)*PC&
&ONC(:,33)+0.50600*TPK%K110(:)*PCONC(:,34)+TPK%K111(:)*PCONC(:,37)+1.66702*TPK%&
&K112(:)*PCONC(:,38)+1.66702*TPK%K112(:)*PCONC(:,38)+0.51037*TPK%K113(:)*PCONC(&
&:,39)+0.91910*TPK%K121(:)*PCONC(:,5)+TPK%K125(:)*PCONC(:,40)
!
!MO2/OLN=-K107*<MO2>+0.51037*K113*<CARBOP>
 PJAC(:,31,39)=-TPK%K107(:)*PCONC(:,31)+0.51037*TPK%K113(:)*PCONC(:,38)
!
!MO2/XO2=-K124*<MO2>+K125*<CARBOP>
 PJAC(:,31,40)=-TPK%K124(:)*PCONC(:,31)+TPK%K125(:)*PCONC(:,38)
!
!ALKAP/O3=+0.09815*K076*<ALKE>+0.00000*K077*<BIO>
 PJAC(:,32,1)=+0.09815*TPK%K076(:)*PCONC(:,19)+0.00000*TPK%K077(:)*PCONC(:,20)
!
!ALKAP/H2O2=0.0
!
!ALKAP/NO=+0.08187*K088*<ALKAP>-K088*<ALKAP>
 PJAC(:,32,3)=+0.08187*TPK%K088(:)*PCONC(:,32)-TPK%K088(:)*PCONC(:,32)
!
!ALKAP/NO2=0.0
!
!ALKAP/NO3=+0.08994*K117*<ALKAP>-K117*<ALKAP>
 PJAC(:,32,5)=+0.08994*TPK%K117(:)*PCONC(:,32)-TPK%K117(:)*PCONC(:,32)
!
!ALKAP/N2O5=0.0
!
!ALKAP/HONO=0.0
!
!ALKAP/HNO3=0.0
!
!ALKAP/HNO4=0.0
!
!ALKAP/NH3=0.0
!
!ALKAP/SO2=0.0
!
!ALKAP/SULF=0.0
!
!ALKAP/CO=0.0
!
!ALKAP/OH=+K056*<ETH>+0.87811*K057*<ALKA>+0.40341*K066*<OP2>+1.00000*K068*<ONIT
!>
 PJAC(:,32,14)=+TPK%K056(:)*PCONC(:,17)+0.87811*TPK%K057(:)*PCONC(:,18)+0.40341&
&*TPK%K066(:)*PCONC(:,29)+1.00000*TPK%K068(:)*PCONC(:,26)
!
!ALKAP/HO2=-K095*<ALKAP>
 PJAC(:,32,15)=-TPK%K095(:)*PCONC(:,32)
!
!ALKAP/CH4=0.0
!
!ALKAP/ETH=+K056*<OH>
 PJAC(:,32,17)=+TPK%K056(:)*PCONC(:,14)
!
!ALKAP/ALKA=+0.87811*K057*<OH>
 PJAC(:,32,18)=+0.87811*TPK%K057(:)*PCONC(:,14)
!
!ALKAP/ALKE=+0.09815*K076*<O3>
 PJAC(:,32,19)=+0.09815*TPK%K076(:)*PCONC(:,1)
!
!ALKAP/BIO=+0.00000*K077*<O3>
 PJAC(:,32,20)=+0.00000*TPK%K077(:)*PCONC(:,1)
!
!ALKAP/ARO=0.0
!
!ALKAP/HCHO=0.0
!
!ALKAP/ALD=0.0
!
!ALKAP/KET=+1.00000*K015
 PJAC(:,32,24)=+1.00000*TPK%K015(:)
!
!ALKAP/CARBO=0.0
!
!ALKAP/ONIT=+1.00000*K068*<OH>
 PJAC(:,32,26)=+1.00000*TPK%K068(:)*PCONC(:,14)
!
!ALKAP/PAN=0.0
!
!ALKAP/OP1=0.0
!
!ALKAP/OP2=+0.40341*K066*<OH>
 PJAC(:,32,29)=+0.40341*TPK%K066(:)*PCONC(:,14)
!
!ALKAP/ORA2=0.0
!
!ALKAP/MO2=+0.00385*K102*<ALKAP>-K102*<ALKAP>
 PJAC(:,32,31)=+0.00385*TPK%K102(:)*PCONC(:,32)-TPK%K102(:)*PCONC(:,32)
!
!ALKAP/ALKAP=+0.08187*K088*<NO>-K088*<NO>-K095*<HO2>+0.00385*K102*<MO2>-K102*<M
!O2>+0.00828*K108*<CARBOP>-K108*<CARBOP>+0.08994*K117*<NO3>-K117*<NO3>
 PJAC(:,32,32)=+0.08187*TPK%K088(:)*PCONC(:,3)-TPK%K088(:)*PCONC(:,3)-TPK%K095(&
&:)*PCONC(:,15)+0.00385*TPK%K102(:)*PCONC(:,31)-TPK%K102(:)*PCONC(:,31)+0.00828&
&*TPK%K108(:)*PCONC(:,38)-TPK%K108(:)*PCONC(:,38)+0.08994*TPK%K117(:)*PCONC(:,5&
&)-TPK%K117(:)*PCONC(:,5)
!
!ALKAP/ALKEP=0.0
!
!ALKAP/BIOP=0.0
!
!ALKAP/PHO=0.0
!
!ALKAP/ADD=0.0
!
!ALKAP/AROP=0.0
!
!ALKAP/CARBOP=+0.00828*K108*<ALKAP>-K108*<ALKAP>
 PJAC(:,32,38)=+0.00828*TPK%K108(:)*PCONC(:,32)-TPK%K108(:)*PCONC(:,32)
!
!ALKAP/OLN=0.0
!
!ALKAP/XO2=0.0
!
!ALKEP/O3=0.0
!
!ALKEP/H2O2=0.0
!
!ALKEP/NO=-K089*<ALKEP>
 PJAC(:,33,3)=-TPK%K089(:)*PCONC(:,33)
!
!ALKEP/NO2=0.0
!
!ALKEP/NO3=-K118*<ALKEP>
 PJAC(:,33,5)=-TPK%K118(:)*PCONC(:,33)
!
!ALKEP/N2O5=0.0
!
!ALKEP/HONO=0.0
!
!ALKEP/HNO3=0.0
!
!ALKEP/HNO4=0.0
!
!ALKEP/NH3=0.0
!
!ALKEP/SO2=0.0
!
!ALKEP/SULF=0.0
!
!ALKEP/CO=0.0
!
!ALKEP/OH=+1.02529*K058*<ALKE>
 PJAC(:,33,14)=+1.02529*TPK%K058(:)*PCONC(:,19)
!
!ALKEP/HO2=-K096*<ALKEP>
 PJAC(:,33,15)=-TPK%K096(:)*PCONC(:,33)
!
!ALKEP/CH4=0.0
!
!ALKEP/ETH=0.0
!
!ALKEP/ALKA=0.0
!
!ALKEP/ALKE=+1.02529*K058*<OH>
 PJAC(:,33,19)=+1.02529*TPK%K058(:)*PCONC(:,14)
!
!ALKEP/BIO=0.0
!
!ALKEP/ARO=0.0
!
!ALKEP/HCHO=0.0
!
!ALKEP/ALD=0.0
!
!ALKEP/KET=0.0
!
!ALKEP/CARBO=0.0
!
!ALKEP/ONIT=0.0
!
!ALKEP/PAN=0.0
!
!ALKEP/OP1=0.0
!
!ALKEP/OP2=0.0
!
!ALKEP/ORA2=0.0
!
!ALKEP/MO2=-K103*<ALKEP>
 PJAC(:,33,31)=-TPK%K103(:)*PCONC(:,33)
!
!ALKEP/ALKAP=0.0
!
!ALKEP/ALKEP=-K089*<NO>-K096*<HO2>-K103*<MO2>-K109*<CARBOP>-K118*<NO3>
 PJAC(:,33,33)=-TPK%K089(:)*PCONC(:,3)-TPK%K096(:)*PCONC(:,15)-TPK%K103(:)*PCON&
&C(:,31)-TPK%K109(:)*PCONC(:,38)-TPK%K118(:)*PCONC(:,5)
!
!ALKEP/BIOP=0.0
!
!ALKEP/PHO=0.0
!
!ALKEP/ADD=0.0
!
!ALKEP/AROP=0.0
!
!ALKEP/CARBOP=-K109*<ALKEP>
 PJAC(:,33,38)=-TPK%K109(:)*PCONC(:,33)
!
!ALKEP/OLN=0.0
!
!ALKEP/XO2=0.0
!
!BIOP/O3=0.0
!
!BIOP/H2O2=0.0
!
!BIOP/NO=-K090*<BIOP>
 PJAC(:,34,3)=-TPK%K090(:)*PCONC(:,34)
!
!BIOP/NO2=0.0
!
!BIOP/NO3=-K119*<BIOP>
 PJAC(:,34,5)=-TPK%K119(:)*PCONC(:,34)
!
!BIOP/N2O5=0.0
!
!BIOP/HONO=0.0
!
!BIOP/HNO3=0.0
!
!BIOP/HNO4=0.0
!
!BIOP/NH3=0.0
!
!BIOP/SO2=0.0
!
!BIOP/SULF=0.0
!
!BIOP/CO=0.0
!
!BIOP/OH=+0.00000*K058*<ALKE>+1.00000*K059*<BIO>
 PJAC(:,34,14)=+0.00000*TPK%K058(:)*PCONC(:,19)+1.00000*TPK%K059(:)*PCONC(:,20)
!
!BIOP/HO2=-K097*<BIOP>
 PJAC(:,34,15)=-TPK%K097(:)*PCONC(:,34)
!
!BIOP/CH4=0.0
!
!BIOP/ETH=0.0
!
!BIOP/ALKA=0.0
!
!BIOP/ALKE=+0.00000*K058*<OH>
 PJAC(:,34,19)=+0.00000*TPK%K058(:)*PCONC(:,14)
!
!BIOP/BIO=+1.00000*K059*<OH>
 PJAC(:,34,20)=+1.00000*TPK%K059(:)*PCONC(:,14)
!
!BIOP/ARO=0.0
!
!BIOP/HCHO=0.0
!
!BIOP/ALD=0.0
!
!BIOP/KET=0.0
!
!BIOP/CARBO=0.0
!
!BIOP/ONIT=0.0
!
!BIOP/PAN=0.0
!
!BIOP/OP1=0.0
!
!BIOP/OP2=0.0
!
!BIOP/ORA2=0.0
!
!BIOP/MO2=-K104*<BIOP>
 PJAC(:,34,31)=-TPK%K104(:)*PCONC(:,34)
!
!BIOP/ALKAP=0.0
!
!BIOP/ALKEP=0.0
!
!BIOP/BIOP=-K090*<NO>-K097*<HO2>-K104*<MO2>-K110*<CARBOP>-K119*<NO3>
 PJAC(:,34,34)=-TPK%K090(:)*PCONC(:,3)-TPK%K097(:)*PCONC(:,15)-TPK%K104(:)*PCON&
&C(:,31)-TPK%K110(:)*PCONC(:,38)-TPK%K119(:)*PCONC(:,5)
!
!BIOP/PHO=0.0
!
!BIOP/ADD=0.0
!
!BIOP/AROP=0.0
!
!BIOP/CARBOP=-K110*<BIOP>
 PJAC(:,34,38)=-TPK%K110(:)*PCONC(:,34)
!
!BIOP/OLN=0.0
!
!BIOP/XO2=0.0
!
!PHO/O3=0.0
!
!PHO/H2O2=0.0
!
!PHO/NO=0.0
!
!PHO/NO2=-K080*<PHO>
 PJAC(:,35,4)=-TPK%K080(:)*PCONC(:,35)
!
!PHO/NO3=+K072*<ARO>
 PJAC(:,35,5)=+TPK%K072(:)*PCONC(:,21)
!
!PHO/N2O5=0.0
!
!PHO/HONO=0.0
!
!PHO/HNO3=0.0
!
!PHO/HNO4=0.0
!
!PHO/NH3=0.0
!
!PHO/SO2=0.0
!
!PHO/SULF=0.0
!
!PHO/CO=0.0
!
!PHO/OH=+0.00276*K060*<ARO>
 PJAC(:,35,14)=+0.00276*TPK%K060(:)*PCONC(:,21)
!
!PHO/HO2=-K081*<PHO>
 PJAC(:,35,15)=-TPK%K081(:)*PCONC(:,35)
!
!PHO/CH4=0.0
!
!PHO/ETH=0.0
!
!PHO/ALKA=0.0
!
!PHO/ALKE=0.0
!
!PHO/BIO=0.0
!
!PHO/ARO=+0.00276*K060*<OH>+K072*<NO3>
 PJAC(:,35,21)=+0.00276*TPK%K060(:)*PCONC(:,14)+TPK%K072(:)*PCONC(:,5)
!
!PHO/HCHO=0.0
!
!PHO/ALD=0.0
!
!PHO/KET=0.0
!
!PHO/CARBO=0.0
!
!PHO/ONIT=0.0
!
!PHO/PAN=0.0
!
!PHO/OP1=0.0
!
!PHO/OP2=0.0
!
!PHO/ORA2=0.0
!
!PHO/MO2=0.0
!
!PHO/ALKAP=0.0
!
!PHO/ALKEP=0.0
!
!PHO/BIOP=0.0
!
!PHO/PHO=-K080*<NO2>-K081*<HO2>
 PJAC(:,35,35)=-TPK%K080(:)*PCONC(:,4)-TPK%K081(:)*PCONC(:,15)
!
!PHO/ADD=0.0
!
!PHO/AROP=0.0
!
!PHO/CARBOP=0.0
!
!PHO/OLN=0.0
!
!PHO/XO2=0.0
!
!ADD/O3=-K084*<ADD>
 PJAC(:,36,1)=-TPK%K084(:)*PCONC(:,36)
!
!ADD/H2O2=0.0
!
!ADD/NO=0.0
!
!ADD/NO2=-K082*<ADD>
 PJAC(:,36,4)=-TPK%K082(:)*PCONC(:,36)
!
!ADD/NO3=0.0
!
!ADD/N2O5=0.0
!
!ADD/HONO=0.0
!
!ADD/HNO3=0.0
!
!ADD/HNO4=0.0
!
!ADD/NH3=0.0
!
!ADD/SO2=0.0
!
!ADD/SULF=0.0
!
!ADD/CO=0.0
!
!ADD/OH=+0.93968*K060*<ARO>
 PJAC(:,36,14)=+0.93968*TPK%K060(:)*PCONC(:,21)
!
!ADD/HO2=0.0
!
!ADD/CH4=0.0
!
!ADD/ETH=0.0
!
!ADD/ALKA=0.0
!
!ADD/ALKE=0.0
!
!ADD/BIO=0.0
!
!ADD/ARO=+0.93968*K060*<OH>
 PJAC(:,36,21)=+0.93968*TPK%K060(:)*PCONC(:,14)
!
!ADD/HCHO=0.0
!
!ADD/ALD=0.0
!
!ADD/KET=0.0
!
!ADD/CARBO=0.0
!
!ADD/ONIT=0.0
!
!ADD/PAN=0.0
!
!ADD/OP1=0.0
!
!ADD/OP2=0.0
!
!ADD/ORA2=0.0
!
!ADD/MO2=0.0
!
!ADD/ALKAP=0.0
!
!ADD/ALKEP=0.0
!
!ADD/BIOP=0.0
!
!ADD/PHO=0.0
!
!ADD/ADD=-K082*<NO2>-K083*<O2>-K084*<O3>
 PJAC(:,36,36)=-TPK%K082(:)*PCONC(:,4)-TPK%K083(:)*TPK%O2(:)-TPK%K084(:)*PCONC(&
&:,1)
!
!ADD/AROP=0.0
!
!ADD/CARBOP=0.0
!
!ADD/OLN=0.0
!
!ADD/XO2=0.0
!
!AROP/O3=0.0
!
!AROP/H2O2=0.0
!
!AROP/NO=-K091*<AROP>
 PJAC(:,37,3)=-TPK%K091(:)*PCONC(:,37)
!
!AROP/NO2=0.0
!
!AROP/NO3=-K120*<AROP>
 PJAC(:,37,5)=-TPK%K120(:)*PCONC(:,37)
!
!AROP/N2O5=0.0
!
!AROP/HONO=0.0
!
!AROP/HNO3=0.0
!
!AROP/HNO4=0.0
!
!AROP/NH3=0.0
!
!AROP/SO2=0.0
!
!AROP/SULF=0.0
!
!AROP/CO=0.0
!
!AROP/OH=0.0
!
!AROP/HO2=-K098*<AROP>
 PJAC(:,37,15)=-TPK%K098(:)*PCONC(:,37)
!
!AROP/CH4=0.0
!
!AROP/ETH=0.0
!
!AROP/ALKA=0.0
!
!AROP/ALKE=0.0
!
!AROP/BIO=0.0
!
!AROP/ARO=0.0
!
!AROP/HCHO=0.0
!
!AROP/ALD=0.0
!
!AROP/KET=0.0
!
!AROP/CARBO=0.0
!
!AROP/ONIT=0.0
!
!AROP/PAN=0.0
!
!AROP/OP1=0.0
!
!AROP/OP2=0.0
!
!AROP/ORA2=0.0
!
!AROP/MO2=-K105*<AROP>
 PJAC(:,37,31)=-TPK%K105(:)*PCONC(:,37)
!
!AROP/ALKAP=0.0
!
!AROP/ALKEP=0.0
!
!AROP/BIOP=0.0
!
!AROP/PHO=0.0
!
!AROP/ADD=+0.98*K083*<O2>
 PJAC(:,37,36)=+0.98*TPK%K083(:)*TPK%O2(:)
!
!AROP/AROP=-K091*<NO>-K098*<HO2>-K105*<MO2>-K111*<CARBOP>-K120*<NO3>
 PJAC(:,37,37)=-TPK%K091(:)*PCONC(:,3)-TPK%K098(:)*PCONC(:,15)-TPK%K105(:)*PCON&
&C(:,31)-TPK%K111(:)*PCONC(:,38)-TPK%K120(:)*PCONC(:,5)
!
!AROP/CARBOP=-K111*<AROP>
 PJAC(:,37,38)=-TPK%K111(:)*PCONC(:,37)
!
!AROP/OLN=0.0
!
!AROP/XO2=0.0
!
!CARBOP/O3=+0.05705*K076*<ALKE>+0.17000*K077*<BIO>+0.27460*K078*<CARBO>+0.70000
!*K079*<PAN>
 PJAC(:,38,1)=+0.05705*TPK%K076(:)*PCONC(:,19)+0.17000*TPK%K077(:)*PCONC(:,20)+&
&0.27460*TPK%K078(:)*PCONC(:,25)+0.70000*TPK%K079(:)*PCONC(:,27)
!
!CARBOP/H2O2=0.0
!
!CARBOP/NO=+0.09532*K092*<CARBOP>-K092*<CARBOP>
 PJAC(:,38,3)=+0.09532*TPK%K092(:)*PCONC(:,38)-TPK%K092(:)*PCONC(:,38)
!
!CARBOP/NO2=-K085*<CARBOP>
 PJAC(:,38,4)=-TPK%K085(:)*PCONC(:,38)
!
!CARBOP/NO3=+1.00000*K070*<ALD>+0.38881*K071*<CARBO>+0.03175*K121*<CARBOP>-K121
!*<CARBOP>
 PJAC(:,38,5)=+1.00000*TPK%K070(:)*PCONC(:,23)+0.38881*TPK%K071(:)*PCONC(:,25)+&
&0.03175*TPK%K121(:)*PCONC(:,38)-TPK%K121(:)*PCONC(:,38)
!
!CARBOP/N2O5=0.0
!
!CARBOP/HONO=0.0
!
!CARBOP/HNO3=0.0
!
!CARBOP/HNO4=0.0
!
!CARBOP/NH3=0.0
!
!CARBOP/SO2=0.0
!
!CARBOP/SULF=0.0
!
!CARBOP/CO=0.0
!
!CARBOP/OH=+1.00000*K062*<ALD>+1.00000*K063*<KET>+0.51419*K064*<CARBO>+0.05413*
!K066*<OP2>
 PJAC(:,38,14)=+1.00000*TPK%K062(:)*PCONC(:,23)+1.00000*TPK%K063(:)*PCONC(:,24)&
&+0.51419*TPK%K064(:)*PCONC(:,25)+0.05413*TPK%K066(:)*PCONC(:,29)
!
!CARBOP/HO2=-K099*<CARBOP>
 PJAC(:,38,15)=-TPK%K099(:)*PCONC(:,38)
!
!CARBOP/CH4=0.0
!
!CARBOP/ETH=0.0
!
!CARBOP/ALKA=0.0
!
!CARBOP/ALKE=+0.05705*K076*<O3>
 PJAC(:,38,19)=+0.05705*TPK%K076(:)*PCONC(:,1)
!
!CARBOP/BIO=+0.17000*K077*<O3>
 PJAC(:,38,20)=+0.17000*TPK%K077(:)*PCONC(:,1)
!
!CARBOP/ARO=0.0
!
!CARBOP/HCHO=0.0
!
!CARBOP/ALD=+1.00000*K062*<OH>+1.00000*K070*<NO3>
 PJAC(:,38,23)=+1.00000*TPK%K062(:)*PCONC(:,14)+1.00000*TPK%K070(:)*PCONC(:,5)
!
!CARBOP/KET=+1.00000*K015+1.00000*K063*<OH>
 PJAC(:,38,24)=+1.00000*TPK%K015(:)+1.00000*TPK%K063(:)*PCONC(:,14)
!
!CARBOP/CARBO=+0.69622*K016+0.51419*K064*<OH>+0.38881*K071*<NO3>+0.27460*K078*<
!O3>
 PJAC(:,38,25)=+0.69622*TPK%K016(:)+0.51419*TPK%K064(:)*PCONC(:,14)+0.38881*TPK&
&%K071(:)*PCONC(:,5)+0.27460*TPK%K078(:)*PCONC(:,1)
!
!CARBOP/ONIT=0.0
!
!CARBOP/PAN=+0.70000*K079*<O3>+1.00000*K086
 PJAC(:,38,27)=+0.70000*TPK%K079(:)*PCONC(:,1)+1.00000*TPK%K086(:)
!
!CARBOP/OP1=0.0
!
!CARBOP/OP2=+0.05413*K066*<OH>
 PJAC(:,38,29)=+0.05413*TPK%K066(:)*PCONC(:,14)
!
!CARBOP/ORA2=0.0
!
!CARBOP/MO2=+0.05954*K106*<CARBOP>-K106*<CARBOP>
 PJAC(:,38,31)=+0.05954*TPK%K106(:)*PCONC(:,38)-TPK%K106(:)*PCONC(:,38)
!
!CARBOP/ALKAP=-K108*<CARBOP>
 PJAC(:,38,32)=-TPK%K108(:)*PCONC(:,38)
!
!CARBOP/ALKEP=-K109*<CARBOP>
 PJAC(:,38,33)=-TPK%K109(:)*PCONC(:,38)
!
!CARBOP/BIOP=-K110*<CARBOP>
 PJAC(:,38,34)=-TPK%K110(:)*PCONC(:,38)
!
!CARBOP/PHO=0.0
!
!CARBOP/ADD=0.0
!
!CARBOP/AROP=-K111*<CARBOP>
 PJAC(:,38,37)=-TPK%K111(:)*PCONC(:,38)
!
!CARBOP/CARBOP=-K085*<NO2>+0.09532*K092*<NO>-K092*<NO>-K099*<HO2>+0.05954*K106*
!<MO2>-K106*<MO2>-K108*<ALKAP>-K109*<ALKEP>-K110*<BIOP>-K111*<AROP>+0.05821*K11
!2*<CARBOP>+0.05821*K112*<CARBOP>-K112*<CARBOP>-K112*<CARBOP>-K112*<CARBOP>-K11
!2*<CARBOP>-K113*<OLN>+0.03175*K121*<NO3>-K121*<NO3>-K125*<XO2>
 PJAC(:,38,38)=-TPK%K085(:)*PCONC(:,4)+0.09532*TPK%K092(:)*PCONC(:,3)-TPK%K092(&
&:)*PCONC(:,3)-TPK%K099(:)*PCONC(:,15)+0.05954*TPK%K106(:)*PCONC(:,31)-TPK%K106&
&(:)*PCONC(:,31)-TPK%K108(:)*PCONC(:,32)-TPK%K109(:)*PCONC(:,33)-TPK%K110(:)*PC&
&ONC(:,34)-TPK%K111(:)*PCONC(:,37)+0.05821*TPK%K112(:)*PCONC(:,38)+0.05821*TPK%&
&K112(:)*PCONC(:,38)-TPK%K112(:)*PCONC(:,38)-TPK%K112(:)*PCONC(:,38)-TPK%K112(:&
&)*PCONC(:,38)-TPK%K112(:)*PCONC(:,38)-TPK%K113(:)*PCONC(:,39)+0.03175*TPK%K121&
&(:)*PCONC(:,5)-TPK%K121(:)*PCONC(:,5)-TPK%K125(:)*PCONC(:,40)
!
!CARBOP/OLN=-K113*<CARBOP>
 PJAC(:,38,39)=-TPK%K113(:)*PCONC(:,38)
!
!CARBOP/XO2=-K125*<CARBOP>
 PJAC(:,38,40)=-TPK%K125(:)*PCONC(:,38)
!
!OLN/O3=0.0
!
!OLN/H2O2=0.0
!
!OLN/NO=-K093*<OLN>
 PJAC(:,39,3)=-TPK%K093(:)*PCONC(:,39)
!
!OLN/NO2=0.0
!
!OLN/NO3=+0.00000*K071*<CARBO>+0.93768*K073*<ALKE>+1.00000*K074*<BIO>-K122*<OLN
!>
 PJAC(:,39,5)=+0.00000*TPK%K071(:)*PCONC(:,25)+0.93768*TPK%K073(:)*PCONC(:,19)+&
&1.00000*TPK%K074(:)*PCONC(:,20)-TPK%K122(:)*PCONC(:,39)
!
!OLN/N2O5=0.0
!
!OLN/HONO=0.0
!
!OLN/HNO3=0.0
!
!OLN/HNO4=0.0
!
!OLN/NH3=0.0
!
!OLN/SO2=0.0
!
!OLN/SULF=0.0
!
!OLN/CO=0.0
!
!OLN/OH=0.0
!
!OLN/HO2=-K100*<OLN>
 PJAC(:,39,15)=-TPK%K100(:)*PCONC(:,39)
!
!OLN/CH4=0.0
!
!OLN/ETH=0.0
!
!OLN/ALKA=0.0
!
!OLN/ALKE=+0.93768*K073*<NO3>
 PJAC(:,39,19)=+0.93768*TPK%K073(:)*PCONC(:,5)
!
!OLN/BIO=+1.00000*K074*<NO3>
 PJAC(:,39,20)=+1.00000*TPK%K074(:)*PCONC(:,5)
!
!OLN/ARO=0.0
!
!OLN/HCHO=0.0
!
!OLN/ALD=0.0
!
!OLN/KET=0.0
!
!OLN/CARBO=+0.00000*K071*<NO3>
 PJAC(:,39,25)=+0.00000*TPK%K071(:)*PCONC(:,5)
!
!OLN/ONIT=0.0
!
!OLN/PAN=0.0
!
!OLN/OP1=0.0
!
!OLN/OP2=0.0
!
!OLN/ORA2=0.0
!
!OLN/MO2=-K107*<OLN>
 PJAC(:,39,31)=-TPK%K107(:)*PCONC(:,39)
!
!OLN/ALKAP=0.0
!
!OLN/ALKEP=0.0
!
!OLN/BIOP=0.0
!
!OLN/PHO=0.0
!
!OLN/ADD=0.0
!
!OLN/AROP=0.0
!
!OLN/CARBOP=-K113*<OLN>
 PJAC(:,39,38)=-TPK%K113(:)*PCONC(:,39)
!
!OLN/OLN=-K093*<NO>-K100*<HO2>-K107*<MO2>-K113*<CARBOP>-K114*<OLN>-K114*<OLN>-K
!114*<OLN>-K114*<OLN>-K115*<OLN>-K115*<OLN>-K115*<OLN>-K115*<OLN>-K122*<NO3>
 PJAC(:,39,39)=-TPK%K093(:)*PCONC(:,3)-TPK%K100(:)*PCONC(:,15)-TPK%K107(:)*PCON&
&C(:,31)-TPK%K113(:)*PCONC(:,38)-TPK%K114(:)*PCONC(:,39)-TPK%K114(:)*PCONC(:,39&
&)-TPK%K114(:)*PCONC(:,39)-TPK%K114(:)*PCONC(:,39)-TPK%K115(:)*PCONC(:,39)-TPK%&
&K115(:)*PCONC(:,39)-TPK%K115(:)*PCONC(:,39)-TPK%K115(:)*PCONC(:,39)-TPK%K122(:&
&)*PCONC(:,5)
!
!OLN/XO2=0.0
!
!XO2/O3=+0.00000*K076*<ALKE>+0.13000*K077*<BIO>
 PJAC(:,40,1)=+0.00000*TPK%K076(:)*PCONC(:,19)+0.13000*TPK%K077(:)*PCONC(:,20)
!
!XO2/H2O2=0.0
!
!XO2/NO=+0.13007*K088*<ALKAP>+0.02563*K092*<CARBOP>-K127*<XO2>
 PJAC(:,40,3)=+0.13007*TPK%K088(:)*PCONC(:,32)+0.02563*TPK%K092(:)*PCONC(:,38)-&
&TPK%K127(:)*PCONC(:,40)
!
!XO2/NO2=0.0
!
!XO2/NO3=+0.10530*K071*<CARBO>+K075*<PAN>+0.16271*K117*<ALKAP>+0.01021*K121*<CA
!RBOP>-K128*<XO2>
 PJAC(:,40,5)=+0.10530*TPK%K071(:)*PCONC(:,25)+TPK%K075(:)*PCONC(:,27)+0.16271*&
&TPK%K117(:)*PCONC(:,32)+0.01021*TPK%K121(:)*PCONC(:,38)-TPK%K128(:)*PCONC(:,40&
&)
!
!XO2/N2O5=0.0
!
!XO2/HONO=0.0
!
!XO2/HNO3=0.0
!
!XO2/HNO4=0.0
!
!XO2/NH3=0.0
!
!XO2/SO2=0.0
!
!XO2/SULF=0.0
!
!XO2/CO=0.0
!
!XO2/OH=+0.10318*K060*<ARO>+0.10162*K064*<CARBO>+0.09333*K066*<OP2>+K067*<PAN>
 PJAC(:,40,14)=+0.10318*TPK%K060(:)*PCONC(:,21)+0.10162*TPK%K064(:)*PCONC(:,25)&
&+0.09333*TPK%K066(:)*PCONC(:,29)+TPK%K067(:)*PCONC(:,27)
!
!XO2/HO2=-K123*<XO2>
 PJAC(:,40,15)=-TPK%K123(:)*PCONC(:,40)
!
!XO2/CH4=0.0
!
!XO2/ETH=0.0
!
!XO2/ALKA=0.0
!
!XO2/ALKE=+0.00000*K076*<O3>
 PJAC(:,40,19)=+0.00000*TPK%K076(:)*PCONC(:,1)
!
!XO2/BIO=+0.15*K053*<O3P>+0.13000*K077*<O3>
 PJAC(:,40,20)=+0.15*TPK%K053(:)*TPK%O3P(:)+0.13000*TPK%K077(:)*PCONC(:,1)
!
!XO2/ARO=+0.10318*K060*<OH>
 PJAC(:,40,21)=+0.10318*TPK%K060(:)*PCONC(:,14)
!
!XO2/HCHO=0.0
!
!XO2/ALD=0.0
!
!XO2/KET=0.0
!
!XO2/CARBO=+0.10162*K064*<OH>+0.10530*K071*<NO3>
 PJAC(:,40,25)=+0.10162*TPK%K064(:)*PCONC(:,14)+0.10530*TPK%K071(:)*PCONC(:,5)
!
!XO2/ONIT=0.0
!
!XO2/PAN=+K067*<OH>+K075*<NO3>
 PJAC(:,40,27)=+TPK%K067(:)*PCONC(:,14)+TPK%K075(:)*PCONC(:,5)
!
!XO2/OP1=0.0
!
!XO2/OP2=+0.09333*K066*<OH>
 PJAC(:,40,29)=+0.09333*TPK%K066(:)*PCONC(:,14)
!
!XO2/ORA2=0.0
!
!XO2/MO2=+0.13370*K102*<ALKAP>+0.02212*K106*<CARBOP>-K124*<XO2>
 PJAC(:,40,31)=+0.13370*TPK%K102(:)*PCONC(:,32)+0.02212*TPK%K106(:)*PCONC(:,38)&
&-TPK%K124(:)*PCONC(:,40)
!
!XO2/ALKAP=+0.13007*K088*<NO>+0.13370*K102*<MO2>+0.11306*K108*<CARBOP>+0.16271*
!K117*<NO3>
 PJAC(:,40,32)=+0.13007*TPK%K088(:)*PCONC(:,3)+0.13370*TPK%K102(:)*PCONC(:,31)+&
&0.11306*TPK%K108(:)*PCONC(:,38)+0.16271*TPK%K117(:)*PCONC(:,5)
!
!XO2/ALKEP=0.0
!
!XO2/BIOP=0.0
!
!XO2/PHO=0.0
!
!XO2/ADD=0.0
!
!XO2/AROP=0.0
!
!XO2/CARBOP=+0.02563*K092*<NO>+0.02212*K106*<MO2>+0.11306*K108*<ALKAP>+0.01593*
!K112*<CARBOP>+0.01593*K112*<CARBOP>+0.01021*K121*<NO3>-K125*<XO2>
 PJAC(:,40,38)=+0.02563*TPK%K092(:)*PCONC(:,3)+0.02212*TPK%K106(:)*PCONC(:,31)+&
&0.11306*TPK%K108(:)*PCONC(:,32)+0.01593*TPK%K112(:)*PCONC(:,38)+0.01593*TPK%K1&
&12(:)*PCONC(:,38)+0.01021*TPK%K121(:)*PCONC(:,5)-TPK%K125(:)*PCONC(:,40)
!
!XO2/OLN=0.0
!
!XO2/XO2=-K123*<HO2>-K124*<MO2>-K125*<CARBOP>-K126*<XO2>-K126*<XO2>-K126*<XO2>-
!K126*<XO2>-K127*<NO>-K128*<NO3>
 PJAC(:,40,40)=-TPK%K123(:)*PCONC(:,15)-TPK%K124(:)*PCONC(:,31)-TPK%K125(:)*PCO&
&NC(:,38)-TPK%K126(:)*PCONC(:,40)-TPK%K126(:)*PCONC(:,40)-TPK%K126(:)*PCONC(:,4&
&0)-TPK%K126(:)*PCONC(:,40)-TPK%K127(:)*PCONC(:,3)-TPK%K128(:)*PCONC(:,5)
IF (LHOOK) CALL DR_HOOK('CH_JAC',1,ZHOOK_HANDLE)
RETURN
END SUBROUTINE CH_JAC
