!     ######spl
      SUBROUTINE CH_TERMS(PTIME,PCONC,PTERMS,KMI,KVECNPT,KEQ,KREAC)
      USE PARKIND1, ONLY : JPRB
      USE YOMHOOK , ONLY : LHOOK, DR_HOOK
!!    ##################################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_TERMS*
!!
!!    PURPOSE
!!    -------
!       calculation of the contribution of each term in each reaction
!!
!!**  METHOD
!!    ------
!!      The contribution of reaction i to the evolution of species j
!!    is returned in PTERMS.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                               :: PTIME
INTEGER, INTENT(IN)                               :: KVECNPT
INTEGER, INTENT(IN)                               :: KEQ, KREAC
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)      :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KREAC):: PTERMS
INTEGER, INTENT(IN)                               :: KMI
!!
TYPE(CCSTYPE), POINTER                            :: TPK
REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('CH_TERMS',0,ZHOOK_HANDLE)
TPK=>TACCS(KMI)
! /BEGIN_CODE/
 TPK%O1D(:)=(TPK%K002(:)*PCONC(:,JP_O3))/(TPK%K020(:)*TPK%N2(:)+TPK%K021(:)*TPK%O2(:)+&
            &TPK%K022(:)*TPK%H2O(:))


 TPK%O3P(:)=(TPK%K001(:)*PCONC(:,JP_NO2)+TPK%K003(:)*PCONC(:,JP_O3)+TPK%K008(:)*PCONC(:,JP_NO3)+&
            &TPK%K020(:)*TPK%O1D(:)*TPK%N2(:)+TPK%K021(:)*TPK%O1D(:)*TPK%O2(:)+&
            &0.00000*TPK%K076(:)*PCONC(:,JP_ALKE)*PCONC(:,JP_O3)+&
            &0.09000*TPK%K077(:)*PCONC(:,JP_BIO)*PCONC(:,JP_O3))/&
            &(TPK%K018(:)*TPK%O2(:)+TPK%K019(:)*PCONC(:,JP_O3)+TPK%K029(:)*PCONC(:,JP_NO)+&
            &TPK%K030(:)*PCONC(:,JP_NO2)+TPK%K031(:)*PCONC(:,JP_NO2)+TPK%K053(:)*PCONC(:,JP_BIO)+&
            &TPK%K054(:)*PCONC(:,JP_CARBO))


! /END_CODE/
PTERMS(:,:,:) = 0.0
!PTERMS(NO,K001) = +K001*<NO2>
 PTERMS(:,3,1) = +TPK%K001(:)*PCONC(:,4)

!PTERMS(NO2,K001) = -K001*<NO2>
 PTERMS(:,4,1) = -TPK%K001(:)*PCONC(:,4)

!PTERMS(O3,K002) = -K002*<O3>
 PTERMS(:,1,2) = -TPK%K002(:)*PCONC(:,1)

!PTERMS(O3,K003) = -K003*<O3>
 PTERMS(:,1,3) = -TPK%K003(:)*PCONC(:,1)

!PTERMS(NO,K004) = +K004*<HONO>
 PTERMS(:,3,4) = +TPK%K004(:)*PCONC(:,7)

!PTERMS(HONO,K004) = -K004*<HONO>
 PTERMS(:,7,4) = -TPK%K004(:)*PCONC(:,7)

!PTERMS(OH,K004) = +K004*<HONO>
 PTERMS(:,14,4) = +TPK%K004(:)*PCONC(:,7)

!PTERMS(NO2,K005) = +K005*<HNO3>
 PTERMS(:,4,5) = +TPK%K005(:)*PCONC(:,8)

!PTERMS(HNO3,K005) = -K005*<HNO3>
 PTERMS(:,8,5) = -TPK%K005(:)*PCONC(:,8)

!PTERMS(OH,K005) = +K005*<HNO3>
 PTERMS(:,14,5) = +TPK%K005(:)*PCONC(:,8)

!PTERMS(NO2,K006) = +0.65*K006*<HNO4>
 PTERMS(:,4,6) = +0.65*TPK%K006(:)*PCONC(:,9)

!PTERMS(NO3,K006) = +0.35*K006*<HNO4>
 PTERMS(:,5,6) = +0.35*TPK%K006(:)*PCONC(:,9)

!PTERMS(HNO4,K006) = -K006*<HNO4>
 PTERMS(:,9,6) = -TPK%K006(:)*PCONC(:,9)

!PTERMS(OH,K006) = +0.35*K006*<HNO4>
 PTERMS(:,14,6) = +0.35*TPK%K006(:)*PCONC(:,9)

!PTERMS(HO2,K006) = +0.65*K006*<HNO4>
 PTERMS(:,15,6) = +0.65*TPK%K006(:)*PCONC(:,9)

!PTERMS(NO,K007) = +K007*<NO3>
 PTERMS(:,3,7) = +TPK%K007(:)*PCONC(:,5)

!PTERMS(NO3,K007) = -K007*<NO3>
 PTERMS(:,5,7) = -TPK%K007(:)*PCONC(:,5)

!PTERMS(NO2,K008) = +K008*<NO3>
 PTERMS(:,4,8) = +TPK%K008(:)*PCONC(:,5)

!PTERMS(NO3,K008) = -K008*<NO3>
 PTERMS(:,5,8) = -TPK%K008(:)*PCONC(:,5)

!PTERMS(H2O2,K009) = -K009*<H2O2>
 PTERMS(:,2,9) = -TPK%K009(:)*PCONC(:,2)

!PTERMS(OH,K009) = +K009*<H2O2>
 PTERMS(:,14,9) = +TPK%K009(:)*PCONC(:,2)

!PTERMS(CO,K010) = +K010*<HCHO>
 PTERMS(:,13,10) = +TPK%K010(:)*PCONC(:,22)

!PTERMS(HCHO,K010) = -K010*<HCHO>
 PTERMS(:,22,10) = -TPK%K010(:)*PCONC(:,22)

!PTERMS(CO,K011) = +K011*<HCHO>
 PTERMS(:,13,11) = +TPK%K011(:)*PCONC(:,22)

!PTERMS(HO2,K011) = +K011*<HCHO>
 PTERMS(:,15,11) = +TPK%K011(:)*PCONC(:,22)

!PTERMS(HCHO,K011) = -K011*<HCHO>
 PTERMS(:,22,11) = -TPK%K011(:)*PCONC(:,22)

!PTERMS(CO,K012) = +K012*<ALD>
 PTERMS(:,13,12) = +TPK%K012(:)*PCONC(:,23)

!PTERMS(HO2,K012) = +K012*<ALD>
 PTERMS(:,15,12) = +TPK%K012(:)*PCONC(:,23)

!PTERMS(ALD,K012) = -K012*<ALD>
 PTERMS(:,23,12) = -TPK%K012(:)*PCONC(:,23)

!PTERMS(MO2,K012) = +K012*<ALD>
 PTERMS(:,31,12) = +TPK%K012(:)*PCONC(:,23)

!PTERMS(OH,K013) = +K013*<OP1>
 PTERMS(:,14,13) = +TPK%K013(:)*PCONC(:,28)

!PTERMS(HO2,K013) = +K013*<OP1>
 PTERMS(:,15,13) = +TPK%K013(:)*PCONC(:,28)

!PTERMS(HCHO,K013) = +K013*<OP1>
 PTERMS(:,22,13) = +TPK%K013(:)*PCONC(:,28)

!PTERMS(OP1,K013) = -K013*<OP1>
 PTERMS(:,28,13) = -TPK%K013(:)*PCONC(:,28)

!PTERMS(OH,K014) = +K014*<OP2>
 PTERMS(:,14,14) = +TPK%K014(:)*PCONC(:,29)

!PTERMS(HO2,K014) = +0.96205*K014*<OP2>
 PTERMS(:,15,14) = +0.96205*TPK%K014(:)*PCONC(:,29)

!PTERMS(ALD,K014) = +0.96205*K014*<OP2>
 PTERMS(:,23,14) = +0.96205*TPK%K014(:)*PCONC(:,29)

!PTERMS(OP2,K014) = -K014*<OP2>
 PTERMS(:,29,14) = -TPK%K014(:)*PCONC(:,29)

!PTERMS(MO2,K014) = +0.03795*K014*<OP2>
 PTERMS(:,31,14) = +0.03795*TPK%K014(:)*PCONC(:,29)

!PTERMS(KET,K015) = -K015*<KET>
 PTERMS(:,24,15) = -TPK%K015(:)*PCONC(:,24)

!PTERMS(ALKAP,K015) = +1.00000*K015*<KET>
 PTERMS(:,32,15) = +1.00000*TPK%K015(:)*PCONC(:,24)

!PTERMS(CARBOP,K015) = +1.00000*K015*<KET>
 PTERMS(:,38,15) = +1.00000*TPK%K015(:)*PCONC(:,24)

!PTERMS(CO,K016) = +0.91924*K016*<CARBO>
 PTERMS(:,13,16) = +0.91924*TPK%K016(:)*PCONC(:,25)

!PTERMS(HO2,K016) = +0.75830*K016*<CARBO>
 PTERMS(:,15,16) = +0.75830*TPK%K016(:)*PCONC(:,25)

!PTERMS(HCHO,K016) = +0.06517*K016*<CARBO>
 PTERMS(:,22,16) = +0.06517*TPK%K016(:)*PCONC(:,25)

!PTERMS(CARBO,K016) = -K016*<CARBO>
 PTERMS(:,25,16) = -TPK%K016(:)*PCONC(:,25)

!PTERMS(CARBOP,K016) = +0.69622*K016*<CARBO>
 PTERMS(:,38,16) = +0.69622*TPK%K016(:)*PCONC(:,25)

!PTERMS(NO2,K017) = +K017*<ONIT>
 PTERMS(:,4,17) = +TPK%K017(:)*PCONC(:,26)

!PTERMS(HO2,K017) = +K017*<ONIT>
 PTERMS(:,15,17) = +TPK%K017(:)*PCONC(:,26)

!PTERMS(ALD,K017) = +0.20*K017*<ONIT>
 PTERMS(:,23,17) = +0.20*TPK%K017(:)*PCONC(:,26)

!PTERMS(KET,K017) = +0.80*K017*<ONIT>
 PTERMS(:,24,17) = +0.80*TPK%K017(:)*PCONC(:,26)

!PTERMS(ONIT,K017) = -K017*<ONIT>
 PTERMS(:,26,17) = -TPK%K017(:)*PCONC(:,26)

!PTERMS(O3,K018) = +K018*<O3P>*<O2>
 PTERMS(:,1,18) = +TPK%K018(:)*TPK%O3P(:)*TPK%O2(:)

!PTERMS(O3,K019) = -K019*<O3P>*<O3>
 PTERMS(:,1,19) = -TPK%K019(:)*TPK%O3P(:)*PCONC(:,1)

!PTERMS(OH,K022) = +K022*<O1D>*<H2O>
 PTERMS(:,14,22) = +TPK%K022(:)*TPK%O1D(:)*TPK%H2O(:)

!PTERMS(O3,K023) = -K023*<O3>*<OH>
 PTERMS(:,1,23) = -TPK%K023(:)*PCONC(:,1)*PCONC(:,14)

!PTERMS(OH,K023) = -K023*<O3>*<OH>
 PTERMS(:,14,23) = -TPK%K023(:)*PCONC(:,1)*PCONC(:,14)

!PTERMS(HO2,K023) = +K023*<O3>*<OH>
 PTERMS(:,15,23) = +TPK%K023(:)*PCONC(:,1)*PCONC(:,14)

!PTERMS(O3,K024) = -K024*<O3>*<HO2>
 PTERMS(:,1,24) = -TPK%K024(:)*PCONC(:,1)*PCONC(:,15)

!PTERMS(OH,K024) = +K024*<O3>*<HO2>
 PTERMS(:,14,24) = +TPK%K024(:)*PCONC(:,1)*PCONC(:,15)

!PTERMS(HO2,K024) = -K024*<O3>*<HO2>
 PTERMS(:,15,24) = -TPK%K024(:)*PCONC(:,1)*PCONC(:,15)

!PTERMS(OH,K025) = -K025*<OH>*<HO2>
 PTERMS(:,14,25) = -TPK%K025(:)*PCONC(:,14)*PCONC(:,15)

!PTERMS(HO2,K025) = -K025*<OH>*<HO2>
 PTERMS(:,15,25) = -TPK%K025(:)*PCONC(:,14)*PCONC(:,15)

!PTERMS(H2O2,K026) = -K026*<H2O2>*<OH>
 PTERMS(:,2,26) = -TPK%K026(:)*PCONC(:,2)*PCONC(:,14)

!PTERMS(OH,K026) = -K026*<H2O2>*<OH>
 PTERMS(:,14,26) = -TPK%K026(:)*PCONC(:,2)*PCONC(:,14)

!PTERMS(HO2,K026) = +K026*<H2O2>*<OH>
 PTERMS(:,15,26) = +TPK%K026(:)*PCONC(:,2)*PCONC(:,14)

!PTERMS(H2O2,K027) = +K027*<HO2>*<HO2>
 PTERMS(:,2,27) = +TPK%K027(:)*PCONC(:,15)*PCONC(:,15)

!PTERMS(HO2,K027) = -K027*<HO2>*<HO2>
 PTERMS(:,15,27) = -TPK%K027(:)*PCONC(:,15)*PCONC(:,15)

!PTERMS(H2O2,K028) = +K028*<HO2>*<HO2>*<H2O>
 PTERMS(:,2,28) = +TPK%K028(:)*PCONC(:,15)*PCONC(:,15)*TPK%H2O(:)

!PTERMS(HO2,K028) = -K028*<HO2>*<HO2>*<H2O>
 PTERMS(:,15,28) = -TPK%K028(:)*PCONC(:,15)*PCONC(:,15)*TPK%H2O(:)

!PTERMS(NO,K029) = -K029*<O3P>*<NO>
 PTERMS(:,3,29) = -TPK%K029(:)*TPK%O3P(:)*PCONC(:,3)

!PTERMS(NO2,K029) = +K029*<O3P>*<NO>
 PTERMS(:,4,29) = +TPK%K029(:)*TPK%O3P(:)*PCONC(:,3)

!PTERMS(NO,K030) = +K030*<O3P>*<NO2>
 PTERMS(:,3,30) = +TPK%K030(:)*TPK%O3P(:)*PCONC(:,4)

!PTERMS(NO2,K030) = -K030*<O3P>*<NO2>
 PTERMS(:,4,30) = -TPK%K030(:)*TPK%O3P(:)*PCONC(:,4)

!PTERMS(NO2,K031) = -K031*<O3P>*<NO2>
 PTERMS(:,4,31) = -TPK%K031(:)*TPK%O3P(:)*PCONC(:,4)

!PTERMS(NO3,K031) = +K031*<O3P>*<NO2>
 PTERMS(:,5,31) = +TPK%K031(:)*TPK%O3P(:)*PCONC(:,4)

!PTERMS(NO,K032) = -K032*<OH>*<NO>
 PTERMS(:,3,32) = -TPK%K032(:)*PCONC(:,14)*PCONC(:,3)

!PTERMS(HONO,K032) = +K032*<OH>*<NO>
 PTERMS(:,7,32) = +TPK%K032(:)*PCONC(:,14)*PCONC(:,3)

!PTERMS(OH,K032) = -K032*<OH>*<NO>
 PTERMS(:,14,32) = -TPK%K032(:)*PCONC(:,14)*PCONC(:,3)

!PTERMS(NO2,K033) = -K033*<OH>*<NO2>
 PTERMS(:,4,33) = -TPK%K033(:)*PCONC(:,14)*PCONC(:,4)

!PTERMS(HNO3,K033) = +K033*<OH>*<NO2>
 PTERMS(:,8,33) = +TPK%K033(:)*PCONC(:,14)*PCONC(:,4)

!PTERMS(OH,K033) = -K033*<OH>*<NO2>
 PTERMS(:,14,33) = -TPK%K033(:)*PCONC(:,14)*PCONC(:,4)

!PTERMS(NO2,K034) = +K034*<OH>*<NO3>
 PTERMS(:,4,34) = +TPK%K034(:)*PCONC(:,14)*PCONC(:,5)

!PTERMS(NO3,K034) = -K034*<OH>*<NO3>
 PTERMS(:,5,34) = -TPK%K034(:)*PCONC(:,14)*PCONC(:,5)

!PTERMS(OH,K034) = -K034*<OH>*<NO3>
 PTERMS(:,14,34) = -TPK%K034(:)*PCONC(:,14)*PCONC(:,5)

!PTERMS(HO2,K034) = +K034*<OH>*<NO3>
 PTERMS(:,15,34) = +TPK%K034(:)*PCONC(:,14)*PCONC(:,5)

!PTERMS(NO,K035) = -K035*<HO2>*<NO>
 PTERMS(:,3,35) = -TPK%K035(:)*PCONC(:,15)*PCONC(:,3)

!PTERMS(NO2,K035) = +K035*<HO2>*<NO>
 PTERMS(:,4,35) = +TPK%K035(:)*PCONC(:,15)*PCONC(:,3)

!PTERMS(OH,K035) = +K035*<HO2>*<NO>
 PTERMS(:,14,35) = +TPK%K035(:)*PCONC(:,15)*PCONC(:,3)

!PTERMS(HO2,K035) = -K035*<HO2>*<NO>
 PTERMS(:,15,35) = -TPK%K035(:)*PCONC(:,15)*PCONC(:,3)

!PTERMS(NO2,K036) = -K036*<HO2>*<NO2>
 PTERMS(:,4,36) = -TPK%K036(:)*PCONC(:,15)*PCONC(:,4)

!PTERMS(HNO4,K036) = +K036*<HO2>*<NO2>
 PTERMS(:,9,36) = +TPK%K036(:)*PCONC(:,15)*PCONC(:,4)

!PTERMS(HO2,K036) = -K036*<HO2>*<NO2>
 PTERMS(:,15,36) = -TPK%K036(:)*PCONC(:,15)*PCONC(:,4)

!PTERMS(NO2,K037) = +K037*<HNO4>
 PTERMS(:,4,37) = +TPK%K037(:)*PCONC(:,9)

!PTERMS(HNO4,K037) = -K037*<HNO4>
 PTERMS(:,9,37) = -TPK%K037(:)*PCONC(:,9)

!PTERMS(HO2,K037) = +K037*<HNO4>
 PTERMS(:,15,37) = +TPK%K037(:)*PCONC(:,9)

!PTERMS(NO2,K038) = +0.7*K038*<HO2>*<NO3>
 PTERMS(:,4,38) = +0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)

!PTERMS(NO3,K038) = -K038*<HO2>*<NO3>
 PTERMS(:,5,38) = -TPK%K038(:)*PCONC(:,15)*PCONC(:,5)

!PTERMS(HNO3,K038) = +0.3*K038*<HO2>*<NO3>
 PTERMS(:,8,38) = +0.3*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)

!PTERMS(OH,K038) = +0.7*K038*<HO2>*<NO3>
 PTERMS(:,14,38) = +0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)

!PTERMS(HO2,K038) = -K038*<HO2>*<NO3>
 PTERMS(:,15,38) = -TPK%K038(:)*PCONC(:,15)*PCONC(:,5)

!PTERMS(NO2,K039) = +K039*<OH>*<HONO>
 PTERMS(:,4,39) = +TPK%K039(:)*PCONC(:,14)*PCONC(:,7)

!PTERMS(HONO,K039) = -K039*<OH>*<HONO>
 PTERMS(:,7,39) = -TPK%K039(:)*PCONC(:,14)*PCONC(:,7)

!PTERMS(OH,K039) = -K039*<OH>*<HONO>
 PTERMS(:,14,39) = -TPK%K039(:)*PCONC(:,14)*PCONC(:,7)

!PTERMS(NO3,K040) = +K040*<OH>*<HNO3>
 PTERMS(:,5,40) = +TPK%K040(:)*PCONC(:,14)*PCONC(:,8)

!PTERMS(HNO3,K040) = -K040*<OH>*<HNO3>
 PTERMS(:,8,40) = -TPK%K040(:)*PCONC(:,14)*PCONC(:,8)

!PTERMS(OH,K040) = -K040*<OH>*<HNO3>
 PTERMS(:,14,40) = -TPK%K040(:)*PCONC(:,14)*PCONC(:,8)

!PTERMS(NO2,K041) = +K041*<OH>*<HNO4>
 PTERMS(:,4,41) = +TPK%K041(:)*PCONC(:,14)*PCONC(:,9)

!PTERMS(HNO4,K041) = -K041*<OH>*<HNO4>
 PTERMS(:,9,41) = -TPK%K041(:)*PCONC(:,14)*PCONC(:,9)

!PTERMS(OH,K041) = -K041*<OH>*<HNO4>
 PTERMS(:,14,41) = -TPK%K041(:)*PCONC(:,14)*PCONC(:,9)

!PTERMS(O3,K042) = -K042*<O3>*<NO>
 PTERMS(:,1,42) = -TPK%K042(:)*PCONC(:,1)*PCONC(:,3)

!PTERMS(NO,K042) = -K042*<O3>*<NO>
 PTERMS(:,3,42) = -TPK%K042(:)*PCONC(:,1)*PCONC(:,3)

!PTERMS(NO2,K042) = +K042*<O3>*<NO>
 PTERMS(:,4,42) = +TPK%K042(:)*PCONC(:,1)*PCONC(:,3)

!PTERMS(O3,K043) = -K043*<O3>*<NO2>
 PTERMS(:,1,43) = -TPK%K043(:)*PCONC(:,1)*PCONC(:,4)

!PTERMS(NO2,K043) = -K043*<O3>*<NO2>
 PTERMS(:,4,43) = -TPK%K043(:)*PCONC(:,1)*PCONC(:,4)

!PTERMS(NO3,K043) = +K043*<O3>*<NO2>
 PTERMS(:,5,43) = +TPK%K043(:)*PCONC(:,1)*PCONC(:,4)

!PTERMS(NO,K044) = -K044*<NO>*<NO>*<O2>
 PTERMS(:,3,44) = -TPK%K044(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:)

!PTERMS(NO2,K044) = +K044*<NO>*<NO>*<O2>
 PTERMS(:,4,44) = +TPK%K044(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:)

!PTERMS(NO,K045) = -K045*<NO3>*<NO>
 PTERMS(:,3,45) = -TPK%K045(:)*PCONC(:,5)*PCONC(:,3)

!PTERMS(NO2,K045) = +K045*<NO3>*<NO>
 PTERMS(:,4,45) = +TPK%K045(:)*PCONC(:,5)*PCONC(:,3)

!PTERMS(NO3,K045) = -K045*<NO3>*<NO>
 PTERMS(:,5,45) = -TPK%K045(:)*PCONC(:,5)*PCONC(:,3)

!PTERMS(NO,K046) = +K046*<NO3>*<NO2>
 PTERMS(:,3,46) = +TPK%K046(:)*PCONC(:,5)*PCONC(:,4)

!PTERMS(NO2,K046) = -K046*<NO3>*<NO2>
 PTERMS(:,4,46) = -TPK%K046(:)*PCONC(:,5)*PCONC(:,4)

!PTERMS(NO3,K046) = -K046*<NO3>*<NO2>
 PTERMS(:,5,46) = -TPK%K046(:)*PCONC(:,5)*PCONC(:,4)

!PTERMS(NO2,K047) = -K047*<NO3>*<NO2>
 PTERMS(:,4,47) = -TPK%K047(:)*PCONC(:,5)*PCONC(:,4)

!PTERMS(NO3,K047) = -K047*<NO3>*<NO2>
 PTERMS(:,5,47) = -TPK%K047(:)*PCONC(:,5)*PCONC(:,4)

!PTERMS(N2O5,K047) = +K047*<NO3>*<NO2>
 PTERMS(:,6,47) = +TPK%K047(:)*PCONC(:,5)*PCONC(:,4)

!PTERMS(NO2,K048) = +K048*<N2O5>
 PTERMS(:,4,48) = +TPK%K048(:)*PCONC(:,6)

!PTERMS(NO3,K048) = +K048*<N2O5>
 PTERMS(:,5,48) = +TPK%K048(:)*PCONC(:,6)

!PTERMS(N2O5,K048) = -K048*<N2O5>
 PTERMS(:,6,48) = -TPK%K048(:)*PCONC(:,6)

!PTERMS(NO2,K049) = +K049*<NO3>*<NO3>
 PTERMS(:,4,49) = +TPK%K049(:)*PCONC(:,5)*PCONC(:,5)

!PTERMS(NO3,K049) = -K049*<NO3>*<NO3>
 PTERMS(:,5,49) = -TPK%K049(:)*PCONC(:,5)*PCONC(:,5)

!PTERMS(OH,K050) = -K050*<OH>*<H2>
 PTERMS(:,14,50) = -TPK%K050(:)*PCONC(:,14)*TPK%H2(:)

!PTERMS(HO2,K050) = +K050*<OH>*<H2>
 PTERMS(:,15,50) = +TPK%K050(:)*PCONC(:,14)*TPK%H2(:)

!PTERMS(SO2,K051) = -K051*<OH>*<SO2>
 PTERMS(:,11,51) = -TPK%K051(:)*PCONC(:,14)*PCONC(:,11)

!PTERMS(SULF,K051) = +K051*<OH>*<SO2>
 PTERMS(:,12,51) = +TPK%K051(:)*PCONC(:,14)*PCONC(:,11)

!PTERMS(OH,K051) = -K051*<OH>*<SO2>
 PTERMS(:,14,51) = -TPK%K051(:)*PCONC(:,14)*PCONC(:,11)

!PTERMS(HO2,K051) = +K051*<OH>*<SO2>
 PTERMS(:,15,51) = +TPK%K051(:)*PCONC(:,14)*PCONC(:,11)

!PTERMS(CO,K052) = -K052*<CO>*<OH>
 PTERMS(:,13,52) = -TPK%K052(:)*PCONC(:,13)*PCONC(:,14)

!PTERMS(OH,K052) = -K052*<CO>*<OH>
 PTERMS(:,14,52) = -TPK%K052(:)*PCONC(:,13)*PCONC(:,14)

!PTERMS(HO2,K052) = +K052*<CO>*<OH>
 PTERMS(:,15,52) = +TPK%K052(:)*PCONC(:,13)*PCONC(:,14)

!PTERMS(CO,K053) = +0.01*K053*<BIO>*<O3P>
 PTERMS(:,13,53) = +0.01*TPK%K053(:)*PCONC(:,20)*TPK%O3P(:)

!PTERMS(OH,K053) = +0.02*K053*<BIO>*<O3P>
 PTERMS(:,14,53) = +0.02*TPK%K053(:)*PCONC(:,20)*TPK%O3P(:)

!PTERMS(HO2,K053) = +0.28*K053*<BIO>*<O3P>
 PTERMS(:,15,53) = +0.28*TPK%K053(:)*PCONC(:,20)*TPK%O3P(:)

!PTERMS(ALKE,K053) = +0.91868*K053*<BIO>*<O3P>
 PTERMS(:,19,53) = +0.91868*TPK%K053(:)*PCONC(:,20)*TPK%O3P(:)

!PTERMS(BIO,K053) = -K053*<BIO>*<O3P>
 PTERMS(:,20,53) = -TPK%K053(:)*PCONC(:,20)*TPK%O3P(:)

!PTERMS(HCHO,K053) = +0.05*K053*<BIO>*<O3P>
 PTERMS(:,22,53) = +0.05*TPK%K053(:)*PCONC(:,20)*TPK%O3P(:)

!PTERMS(CARBO,K053) = +0.13255*K053*<BIO>*<O3P>
 PTERMS(:,25,53) = +0.13255*TPK%K053(:)*PCONC(:,20)*TPK%O3P(:)

!PTERMS(XO2,K053) = +0.15*K053*<BIO>*<O3P>
 PTERMS(:,40,53) = +0.15*TPK%K053(:)*PCONC(:,20)*TPK%O3P(:)

!PTERMS(ALD,K054) = +K054*<CARBO>*<O3P>
 PTERMS(:,23,54) = +TPK%K054(:)*PCONC(:,25)*TPK%O3P(:)

!PTERMS(CARBO,K054) = -K054*<CARBO>*<O3P>
 PTERMS(:,25,54) = -TPK%K054(:)*PCONC(:,25)*TPK%O3P(:)

!PTERMS(OH,K055) = -K055*<CH4>*<OH>
 PTERMS(:,14,55) = -TPK%K055(:)*PCONC(:,16)*PCONC(:,14)

!PTERMS(CH4,K055) = -K055*<CH4>*<OH>
 PTERMS(:,16,55) = -TPK%K055(:)*PCONC(:,16)*PCONC(:,14)

!PTERMS(MO2,K055) = +K055*<CH4>*<OH>
 PTERMS(:,31,55) = +TPK%K055(:)*PCONC(:,16)*PCONC(:,14)

!PTERMS(OH,K056) = -K056*<ETH>*<OH>
 PTERMS(:,14,56) = -TPK%K056(:)*PCONC(:,17)*PCONC(:,14)

!PTERMS(ETH,K056) = -K056*<ETH>*<OH>
 PTERMS(:,17,56) = -TPK%K056(:)*PCONC(:,17)*PCONC(:,14)

!PTERMS(ALKAP,K056) = +K056*<ETH>*<OH>
 PTERMS(:,32,56) = +TPK%K056(:)*PCONC(:,17)*PCONC(:,14)

!PTERMS(CO,K057) = +0.00878*K057*<ALKA>*<OH>
 PTERMS(:,13,57) = +0.00878*TPK%K057(:)*PCONC(:,18)*PCONC(:,14)

!PTERMS(OH,K057) = -K057*<ALKA>*<OH>
 PTERMS(:,14,57) = -TPK%K057(:)*PCONC(:,18)*PCONC(:,14)

!PTERMS(HO2,K057) = +0.12793*K057*<ALKA>*<OH>
 PTERMS(:,15,57) = +0.12793*TPK%K057(:)*PCONC(:,18)*PCONC(:,14)

!PTERMS(ALKA,K057) = -K057*<ALKA>*<OH>
 PTERMS(:,18,57) = -TPK%K057(:)*PCONC(:,18)*PCONC(:,14)

!PTERMS(HCHO,K057) = +0.00140*K057*<ALKA>*<OH>
 PTERMS(:,22,57) = +0.00140*TPK%K057(:)*PCONC(:,18)*PCONC(:,14)

!PTERMS(ALD,K057) = +0.08173*K057*<ALKA>*<OH>
 PTERMS(:,23,57) = +0.08173*TPK%K057(:)*PCONC(:,18)*PCONC(:,14)

!PTERMS(KET,K057) = +0.03498*K057*<ALKA>*<OH>
 PTERMS(:,24,57) = +0.03498*TPK%K057(:)*PCONC(:,18)*PCONC(:,14)

!PTERMS(CARBO,K057) = +0.00835*K057*<ALKA>*<OH>
 PTERMS(:,25,57) = +0.00835*TPK%K057(:)*PCONC(:,18)*PCONC(:,14)

!PTERMS(ALKAP,K057) = +0.87811*K057*<ALKA>*<OH>
 PTERMS(:,32,57) = +0.87811*TPK%K057(:)*PCONC(:,18)*PCONC(:,14)

!PTERMS(OH,K058) = -K058*<ALKE>*<OH>
 PTERMS(:,14,58) = -TPK%K058(:)*PCONC(:,19)*PCONC(:,14)

!PTERMS(ALKE,K058) = -K058*<ALKE>*<OH>
 PTERMS(:,19,58) = -TPK%K058(:)*PCONC(:,19)*PCONC(:,14)

!PTERMS(ALKEP,K058) = +1.02529*K058*<ALKE>*<OH>
 PTERMS(:,33,58) = +1.02529*TPK%K058(:)*PCONC(:,19)*PCONC(:,14)

!PTERMS(BIOP,K058) = +0.00000*K058*<ALKE>*<OH>
 PTERMS(:,34,58) = +0.00000*TPK%K058(:)*PCONC(:,19)*PCONC(:,14)

!PTERMS(OH,K059) = -K059*<BIO>*<OH>
 PTERMS(:,14,59) = -TPK%K059(:)*PCONC(:,20)*PCONC(:,14)

!PTERMS(BIO,K059) = -K059*<BIO>*<OH>
 PTERMS(:,20,59) = -TPK%K059(:)*PCONC(:,20)*PCONC(:,14)

!PTERMS(BIOP,K059) = +1.00000*K059*<BIO>*<OH>
 PTERMS(:,34,59) = +1.00000*TPK%K059(:)*PCONC(:,20)*PCONC(:,14)

!PTERMS(OH,K060) = -K060*<ARO>*<OH>
 PTERMS(:,14,60) = -TPK%K060(:)*PCONC(:,21)*PCONC(:,14)

!PTERMS(HO2,K060) = +0.10318*K060*<ARO>*<OH>
 PTERMS(:,15,60) = +0.10318*TPK%K060(:)*PCONC(:,21)*PCONC(:,14)

!PTERMS(ARO,K060) = -K060*<ARO>*<OH>
 PTERMS(:,21,60) = -TPK%K060(:)*PCONC(:,21)*PCONC(:,14)

!PTERMS(PHO,K060) = +0.00276*K060*<ARO>*<OH>
 PTERMS(:,35,60) = +0.00276*TPK%K060(:)*PCONC(:,21)*PCONC(:,14)

!PTERMS(ADD,K060) = +0.93968*K060*<ARO>*<OH>
 PTERMS(:,36,60) = +0.93968*TPK%K060(:)*PCONC(:,21)*PCONC(:,14)

!PTERMS(XO2,K060) = +0.10318*K060*<ARO>*<OH>
 PTERMS(:,40,60) = +0.10318*TPK%K060(:)*PCONC(:,21)*PCONC(:,14)

!PTERMS(CO,K061) = +K061*<HCHO>*<OH>
 PTERMS(:,13,61) = +TPK%K061(:)*PCONC(:,22)*PCONC(:,14)

!PTERMS(OH,K061) = -K061*<HCHO>*<OH>
 PTERMS(:,14,61) = -TPK%K061(:)*PCONC(:,22)*PCONC(:,14)

!PTERMS(HO2,K061) = +K061*<HCHO>*<OH>
 PTERMS(:,15,61) = +TPK%K061(:)*PCONC(:,22)*PCONC(:,14)

!PTERMS(HCHO,K061) = -K061*<HCHO>*<OH>
 PTERMS(:,22,61) = -TPK%K061(:)*PCONC(:,22)*PCONC(:,14)

!PTERMS(OH,K062) = -K062*<ALD>*<OH>
 PTERMS(:,14,62) = -TPK%K062(:)*PCONC(:,23)*PCONC(:,14)

!PTERMS(ALD,K062) = -K062*<ALD>*<OH>
 PTERMS(:,23,62) = -TPK%K062(:)*PCONC(:,23)*PCONC(:,14)

!PTERMS(CARBOP,K062) = +1.00000*K062*<ALD>*<OH>
 PTERMS(:,38,62) = +1.00000*TPK%K062(:)*PCONC(:,23)*PCONC(:,14)

!PTERMS(OH,K063) = -K063*<KET>*<OH>
 PTERMS(:,14,63) = -TPK%K063(:)*PCONC(:,24)*PCONC(:,14)

!PTERMS(KET,K063) = -K063*<KET>*<OH>
 PTERMS(:,24,63) = -TPK%K063(:)*PCONC(:,24)*PCONC(:,14)

!PTERMS(CARBOP,K063) = +1.00000*K063*<KET>*<OH>
 PTERMS(:,38,63) = +1.00000*TPK%K063(:)*PCONC(:,24)*PCONC(:,14)

!PTERMS(CO,K064) = +1.01732*K064*<CARBO>*<OH>
 PTERMS(:,13,64) = +1.01732*TPK%K064(:)*PCONC(:,25)*PCONC(:,14)

!PTERMS(OH,K064) = -K064*<CARBO>*<OH>
 PTERMS(:,14,64) = -TPK%K064(:)*PCONC(:,25)*PCONC(:,14)

!PTERMS(HO2,K064) = +0.51208*K064*<CARBO>*<OH>
 PTERMS(:,15,64) = +0.51208*TPK%K064(:)*PCONC(:,25)*PCONC(:,14)

!PTERMS(HCHO,K064) = +0.00000*K064*<CARBO>*<OH>
 PTERMS(:,22,64) = +0.00000*TPK%K064(:)*PCONC(:,25)*PCONC(:,14)

!PTERMS(ALD,K064) = +0.06253*K064*<CARBO>*<OH>
 PTERMS(:,23,64) = +0.06253*TPK%K064(:)*PCONC(:,25)*PCONC(:,14)

!PTERMS(KET,K064) = +0.00853*K064*<CARBO>*<OH>
 PTERMS(:,24,64) = +0.00853*TPK%K064(:)*PCONC(:,25)*PCONC(:,14)

!PTERMS(CARBO,K064) = -K064*<CARBO>*<OH>
 PTERMS(:,25,64) = -TPK%K064(:)*PCONC(:,25)*PCONC(:,14)

!PTERMS(CARBOP,K064) = +0.51419*K064*<CARBO>*<OH>
 PTERMS(:,38,64) = +0.51419*TPK%K064(:)*PCONC(:,25)*PCONC(:,14)

!PTERMS(XO2,K064) = +0.10162*K064*<CARBO>*<OH>
 PTERMS(:,40,64) = +0.10162*TPK%K064(:)*PCONC(:,25)*PCONC(:,14)

!PTERMS(OH,K065) = -K065*<OP1>*<OH>
 PTERMS(:,14,65) = -TPK%K065(:)*PCONC(:,28)*PCONC(:,14)

!PTERMS(HCHO,K065) = +0.35*K065*<OP1>*<OH>
 PTERMS(:,22,65) = +0.35*TPK%K065(:)*PCONC(:,28)*PCONC(:,14)

!PTERMS(OP1,K065) = -K065*<OP1>*<OH>
 PTERMS(:,28,65) = -TPK%K065(:)*PCONC(:,28)*PCONC(:,14)

!PTERMS(MO2,K065) = +0.65*K065*<OP1>*<OH>
 PTERMS(:,31,65) = +0.65*TPK%K065(:)*PCONC(:,28)*PCONC(:,14)

!PTERMS(OH,K066) = -K066*<OP2>*<OH>
 PTERMS(:,14,66) = -TPK%K066(:)*PCONC(:,29)*PCONC(:,14)

!PTERMS(HO2,K066) = +0.02915*K066*<OP2>*<OH>
 PTERMS(:,15,66) = +0.02915*TPK%K066(:)*PCONC(:,29)*PCONC(:,14)

!PTERMS(HCHO,K066) = +0.02915*K066*<OP2>*<OH>
 PTERMS(:,22,66) = +0.02915*TPK%K066(:)*PCONC(:,29)*PCONC(:,14)

!PTERMS(ALD,K066) = +0.07335*K066*<OP2>*<OH>
 PTERMS(:,23,66) = +0.07335*TPK%K066(:)*PCONC(:,29)*PCONC(:,14)

!PTERMS(KET,K066) = +0.37591*K066*<OP2>*<OH>
 PTERMS(:,24,66) = +0.37591*TPK%K066(:)*PCONC(:,29)*PCONC(:,14)

!PTERMS(OP2,K066) = -K066*<OP2>*<OH>
 PTERMS(:,29,66) = -TPK%K066(:)*PCONC(:,29)*PCONC(:,14)

!PTERMS(ALKAP,K066) = +0.40341*K066*<OP2>*<OH>
 PTERMS(:,32,66) = +0.40341*TPK%K066(:)*PCONC(:,29)*PCONC(:,14)

!PTERMS(CARBOP,K066) = +0.05413*K066*<OP2>*<OH>
 PTERMS(:,38,66) = +0.05413*TPK%K066(:)*PCONC(:,29)*PCONC(:,14)

!PTERMS(XO2,K066) = +0.09333*K066*<OP2>*<OH>
 PTERMS(:,40,66) = +0.09333*TPK%K066(:)*PCONC(:,29)*PCONC(:,14)

!PTERMS(NO3,K067) = +0.71893*K067*<PAN>*<OH>
 PTERMS(:,5,67) = +0.71893*TPK%K067(:)*PCONC(:,27)*PCONC(:,14)

!PTERMS(OH,K067) = -K067*<PAN>*<OH>
 PTERMS(:,14,67) = -TPK%K067(:)*PCONC(:,27)*PCONC(:,14)

!PTERMS(HO2,K067) = +0.28107*K067*<PAN>*<OH>
 PTERMS(:,15,67) = +0.28107*TPK%K067(:)*PCONC(:,27)*PCONC(:,14)

!PTERMS(HCHO,K067) = +0.57839*K067*<PAN>*<OH>
 PTERMS(:,22,67) = +0.57839*TPK%K067(:)*PCONC(:,27)*PCONC(:,14)

!PTERMS(CARBO,K067) = +0.21863*K067*<PAN>*<OH>
 PTERMS(:,25,67) = +0.21863*TPK%K067(:)*PCONC(:,27)*PCONC(:,14)

!PTERMS(PAN,K067) = -K067*<PAN>*<OH>
 PTERMS(:,27,67) = -TPK%K067(:)*PCONC(:,27)*PCONC(:,14)

!PTERMS(XO2,K067) = +K067*<PAN>*<OH>
 PTERMS(:,40,67) = +TPK%K067(:)*PCONC(:,27)*PCONC(:,14)

!PTERMS(NO2,K068) = +K068*<ONIT>*<OH>
 PTERMS(:,4,68) = +TPK%K068(:)*PCONC(:,26)*PCONC(:,14)

!PTERMS(OH,K068) = -K068*<ONIT>*<OH>
 PTERMS(:,14,68) = -TPK%K068(:)*PCONC(:,26)*PCONC(:,14)

!PTERMS(ONIT,K068) = -K068*<ONIT>*<OH>
 PTERMS(:,26,68) = -TPK%K068(:)*PCONC(:,26)*PCONC(:,14)

!PTERMS(ALKAP,K068) = +1.00000*K068*<ONIT>*<OH>
 PTERMS(:,32,68) = +1.00000*TPK%K068(:)*PCONC(:,26)*PCONC(:,14)

!PTERMS(NO3,K069) = -K069*<HCHO>*<NO3>
 PTERMS(:,5,69) = -TPK%K069(:)*PCONC(:,22)*PCONC(:,5)

!PTERMS(HNO3,K069) = +K069*<HCHO>*<NO3>
 PTERMS(:,8,69) = +TPK%K069(:)*PCONC(:,22)*PCONC(:,5)

!PTERMS(CO,K069) = +K069*<HCHO>*<NO3>
 PTERMS(:,13,69) = +TPK%K069(:)*PCONC(:,22)*PCONC(:,5)

!PTERMS(HO2,K069) = +K069*<HCHO>*<NO3>
 PTERMS(:,15,69) = +TPK%K069(:)*PCONC(:,22)*PCONC(:,5)

!PTERMS(HCHO,K069) = -K069*<HCHO>*<NO3>
 PTERMS(:,22,69) = -TPK%K069(:)*PCONC(:,22)*PCONC(:,5)

!PTERMS(NO3,K070) = -K070*<ALD>*<NO3>
 PTERMS(:,5,70) = -TPK%K070(:)*PCONC(:,23)*PCONC(:,5)

!PTERMS(HNO3,K070) = +K070*<ALD>*<NO3>
 PTERMS(:,8,70) = +TPK%K070(:)*PCONC(:,23)*PCONC(:,5)

!PTERMS(ALD,K070) = -K070*<ALD>*<NO3>
 PTERMS(:,23,70) = -TPK%K070(:)*PCONC(:,23)*PCONC(:,5)

!PTERMS(CARBOP,K070) = +1.00000*K070*<ALD>*<NO3>
 PTERMS(:,38,70) = +1.00000*TPK%K070(:)*PCONC(:,23)*PCONC(:,5)

!PTERMS(NO2,K071) = +0.10530*K071*<CARBO>*<NO3>
 PTERMS(:,4,71) = +0.10530*TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(NO3,K071) = -K071*<CARBO>*<NO3>
 PTERMS(:,5,71) = -TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(HNO3,K071) = +0.91567*K071*<CARBO>*<NO3>
 PTERMS(:,8,71) = +0.91567*TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(CO,K071) = +1.33723*K071*<CARBO>*<NO3>
 PTERMS(:,13,71) = +1.33723*TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(HO2,K071) = +0.63217*K071*<CARBO>*<NO3>
 PTERMS(:,15,71) = +0.63217*TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(ALD,K071) = +0.05265*K071*<CARBO>*<NO3>
 PTERMS(:,23,71) = +0.05265*TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(KET,K071) = +0.00632*K071*<CARBO>*<NO3>
 PTERMS(:,24,71) = +0.00632*TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(CARBO,K071) = -K071*<CARBO>*<NO3>
 PTERMS(:,25,71) = -TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(CARBOP,K071) = +0.38881*K071*<CARBO>*<NO3>
 PTERMS(:,38,71) = +0.38881*TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(OLN,K071) = +0.00000*K071*<CARBO>*<NO3>
 PTERMS(:,39,71) = +0.00000*TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(XO2,K071) = +0.10530*K071*<CARBO>*<NO3>
 PTERMS(:,40,71) = +0.10530*TPK%K071(:)*PCONC(:,25)*PCONC(:,5)

!PTERMS(NO3,K072) = -K072*<ARO>*<NO3>
 PTERMS(:,5,72) = -TPK%K072(:)*PCONC(:,21)*PCONC(:,5)

!PTERMS(HNO3,K072) = +K072*<ARO>*<NO3>
 PTERMS(:,8,72) = +TPK%K072(:)*PCONC(:,21)*PCONC(:,5)

!PTERMS(ARO,K072) = -K072*<ARO>*<NO3>
 PTERMS(:,21,72) = -TPK%K072(:)*PCONC(:,21)*PCONC(:,5)

!PTERMS(PHO,K072) = +K072*<ARO>*<NO3>
 PTERMS(:,35,72) = +TPK%K072(:)*PCONC(:,21)*PCONC(:,5)

!PTERMS(NO3,K073) = -K073*<ALKE>*<NO3>
 PTERMS(:,5,73) = -TPK%K073(:)*PCONC(:,19)*PCONC(:,5)

!PTERMS(ALKE,K073) = -K073*<ALKE>*<NO3>
 PTERMS(:,19,73) = -TPK%K073(:)*PCONC(:,19)*PCONC(:,5)

!PTERMS(CARBO,K073) = +0.00000*K073*<ALKE>*<NO3>
 PTERMS(:,25,73) = +0.00000*TPK%K073(:)*PCONC(:,19)*PCONC(:,5)

!PTERMS(OLN,K073) = +0.93768*K073*<ALKE>*<NO3>
 PTERMS(:,39,73) = +0.93768*TPK%K073(:)*PCONC(:,19)*PCONC(:,5)

!PTERMS(NO3,K074) = -K074*<BIO>*<NO3>
 PTERMS(:,5,74) = -TPK%K074(:)*PCONC(:,20)*PCONC(:,5)

!PTERMS(BIO,K074) = -K074*<BIO>*<NO3>
 PTERMS(:,20,74) = -TPK%K074(:)*PCONC(:,20)*PCONC(:,5)

!PTERMS(CARBO,K074) = +0.91741*K074*<BIO>*<NO3>
 PTERMS(:,25,74) = +0.91741*TPK%K074(:)*PCONC(:,20)*PCONC(:,5)

!PTERMS(OLN,K074) = +1.00000*K074*<BIO>*<NO3>
 PTERMS(:,39,74) = +1.00000*TPK%K074(:)*PCONC(:,20)*PCONC(:,5)

!PTERMS(NO2,K075) = +0.40*K075*<PAN>*<NO3>
 PTERMS(:,4,75) = +0.40*TPK%K075(:)*PCONC(:,27)*PCONC(:,5)

!PTERMS(NO3,K075) = -K075*<PAN>*<NO3>
 PTERMS(:,5,75) = -TPK%K075(:)*PCONC(:,27)*PCONC(:,5)

!PTERMS(HCHO,K075) = +0.40*K075*<PAN>*<NO3>
 PTERMS(:,22,75) = +0.40*TPK%K075(:)*PCONC(:,27)*PCONC(:,5)

!PTERMS(ONIT,K075) = +0.60*K075*<PAN>*<NO3>
 PTERMS(:,26,75) = +0.60*TPK%K075(:)*PCONC(:,27)*PCONC(:,5)

!PTERMS(PAN,K075) = -K075*<PAN>*<NO3>
 PTERMS(:,27,75) = -TPK%K075(:)*PCONC(:,27)*PCONC(:,5)

!PTERMS(XO2,K075) = +K075*<PAN>*<NO3>
 PTERMS(:,40,75) = +TPK%K075(:)*PCONC(:,27)*PCONC(:,5)

!PTERMS(O3,K076) = -K076*<ALKE>*<O3>
 PTERMS(:,1,76) = -TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(H2O2,K076) = +0.01833*K076*<ALKE>*<O3>
 PTERMS(:,2,76) = +0.01833*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(CO,K076) = +0.35120*K076*<ALKE>*<O3>
 PTERMS(:,13,76) = +0.35120*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(OH,K076) = +0.39435*K076*<ALKE>*<O3>
 PTERMS(:,14,76) = +0.39435*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(HO2,K076) = +0.23451*K076*<ALKE>*<O3>
 PTERMS(:,15,76) = +0.23451*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(CH4,K076) = +0.04300*K076*<ALKE>*<O3>
 PTERMS(:,16,76) = +0.04300*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(ETH,K076) = +0.03196*K076*<ALKE>*<O3>
 PTERMS(:,17,76) = +0.03196*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(ALKE,K076) = -K076*<ALKE>*<O3>
 PTERMS(:,19,76) = -TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(HCHO,K076) = +0.48290*K076*<ALKE>*<O3>
 PTERMS(:,22,76) = +0.48290*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(ALD,K076) = +0.51468*K076*<ALKE>*<O3>
 PTERMS(:,23,76) = +0.51468*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(KET,K076) = +0.07377*K076*<ALKE>*<O3>
 PTERMS(:,24,76) = +0.07377*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(CARBO,K076) = +0.00000*K076*<ALKE>*<O3>
 PTERMS(:,25,76) = +0.00000*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(ORA2,K076) = +0.08143*K076*<ALKE>*<O3>
 PTERMS(:,30,76) = +0.08143*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(MO2,K076) = +0.13966*K076*<ALKE>*<O3>
 PTERMS(:,31,76) = +0.13966*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(ALKAP,K076) = +0.09815*K076*<ALKE>*<O3>
 PTERMS(:,32,76) = +0.09815*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(CARBOP,K076) = +0.05705*K076*<ALKE>*<O3>
 PTERMS(:,38,76) = +0.05705*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(XO2,K076) = +0.00000*K076*<ALKE>*<O3>
 PTERMS(:,40,76) = +0.00000*TPK%K076(:)*PCONC(:,19)*PCONC(:,1)

!PTERMS(O3,K077) = -K077*<BIO>*<O3>
 PTERMS(:,1,77) = -TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(H2O2,K077) = +0.00100*K077*<BIO>*<O3>
 PTERMS(:,2,77) = +0.00100*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(CO,K077) = +0.36000*K077*<BIO>*<O3>
 PTERMS(:,13,77) = +0.36000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(OH,K077) = +0.28000*K077*<BIO>*<O3>
 PTERMS(:,14,77) = +0.28000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(HO2,K077) = +0.30000*K077*<BIO>*<O3>
 PTERMS(:,15,77) = +0.30000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(ALKE,K077) = +0.37388*K077*<BIO>*<O3>
 PTERMS(:,19,77) = +0.37388*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(BIO,K077) = -K077*<BIO>*<O3>
 PTERMS(:,20,77) = -TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(HCHO,K077) = +0.90000*K077*<BIO>*<O3>
 PTERMS(:,22,77) = +0.90000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(ALD,K077) = +0.00000*K077*<BIO>*<O3>
 PTERMS(:,23,77) = +0.00000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(KET,K077) = +0.00000*K077*<BIO>*<O3>
 PTERMS(:,24,77) = +0.00000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(CARBO,K077) = +0.39754*K077*<BIO>*<O3>
 PTERMS(:,25,77) = +0.39754*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(ORA2,K077) = +0.00000*K077*<BIO>*<O3>
 PTERMS(:,30,77) = +0.00000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(MO2,K077) = +0.03000*K077*<BIO>*<O3>
 PTERMS(:,31,77) = +0.03000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(ALKAP,K077) = +0.00000*K077*<BIO>*<O3>
 PTERMS(:,32,77) = +0.00000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(CARBOP,K077) = +0.17000*K077*<BIO>*<O3>
 PTERMS(:,38,77) = +0.17000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(XO2,K077) = +0.13000*K077*<BIO>*<O3>
 PTERMS(:,40,77) = +0.13000*TPK%K077(:)*PCONC(:,20)*PCONC(:,1)

!PTERMS(O3,K078) = -K078*<CARBO>*<O3>
 PTERMS(:,1,78) = -TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(CO,K078) = +0.64728*K078*<CARBO>*<O3>
 PTERMS(:,13,78) = +0.64728*TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(OH,K078) = +0.20595*K078*<CARBO>*<O3>
 PTERMS(:,14,78) = +0.20595*TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(HO2,K078) = +0.28441*K078*<CARBO>*<O3>
 PTERMS(:,15,78) = +0.28441*TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(HCHO,K078) = +0.00000*K078*<CARBO>*<O3>
 PTERMS(:,22,78) = +0.00000*TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(ALD,K078) = +0.15692*K078*<CARBO>*<O3>
 PTERMS(:,23,78) = +0.15692*TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(CARBO,K078) = -K078*<CARBO>*<O3>
 PTERMS(:,25,78) = -TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(OP2,K078) = +0.10149*K078*<CARBO>*<O3>
 PTERMS(:,29,78) = +0.10149*TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(ORA2,K078) = +0.20595*K078*<CARBO>*<O3>
 PTERMS(:,30,78) = +0.20595*TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(CARBOP,K078) = +0.27460*K078*<CARBO>*<O3>
 PTERMS(:,38,78) = +0.27460*TPK%K078(:)*PCONC(:,25)*PCONC(:,1)

!PTERMS(O3,K079) = -K079*<PAN>*<O3>
 PTERMS(:,1,79) = -TPK%K079(:)*PCONC(:,27)*PCONC(:,1)

!PTERMS(NO2,K079) = +0.70*K079*<PAN>*<O3>
 PTERMS(:,4,79) = +0.70*TPK%K079(:)*PCONC(:,27)*PCONC(:,1)

!PTERMS(CO,K079) = +0.13*K079*<PAN>*<O3>
 PTERMS(:,13,79) = +0.13*TPK%K079(:)*PCONC(:,27)*PCONC(:,1)

!PTERMS(OH,K079) = +0.036*K079*<PAN>*<O3>
 PTERMS(:,14,79) = +0.036*TPK%K079(:)*PCONC(:,27)*PCONC(:,1)

!PTERMS(HO2,K079) = +0.08*K079*<PAN>*<O3>
 PTERMS(:,15,79) = +0.08*TPK%K079(:)*PCONC(:,27)*PCONC(:,1)

!PTERMS(HCHO,K079) = +0.70*K079*<PAN>*<O3>
 PTERMS(:,22,79) = +0.70*TPK%K079(:)*PCONC(:,27)*PCONC(:,1)

!PTERMS(PAN,K079) = -K079*<PAN>*<O3>
 PTERMS(:,27,79) = -TPK%K079(:)*PCONC(:,27)*PCONC(:,1)

!PTERMS(CARBOP,K079) = +0.70000*K079*<PAN>*<O3>
 PTERMS(:,38,79) = +0.70000*TPK%K079(:)*PCONC(:,27)*PCONC(:,1)

!PTERMS(NO2,K080) = -K080*<PHO>*<NO2>
 PTERMS(:,4,80) = -TPK%K080(:)*PCONC(:,35)*PCONC(:,4)

!PTERMS(ARO,K080) = +0.10670*K080*<PHO>*<NO2>
 PTERMS(:,21,80) = +0.10670*TPK%K080(:)*PCONC(:,35)*PCONC(:,4)

!PTERMS(ONIT,K080) = +K080*<PHO>*<NO2>
 PTERMS(:,26,80) = +TPK%K080(:)*PCONC(:,35)*PCONC(:,4)

!PTERMS(PHO,K080) = -K080*<PHO>*<NO2>
 PTERMS(:,35,80) = -TPK%K080(:)*PCONC(:,35)*PCONC(:,4)

!PTERMS(HO2,K081) = -K081*<PHO>*<HO2>
 PTERMS(:,15,81) = -TPK%K081(:)*PCONC(:,35)*PCONC(:,15)

!PTERMS(ARO,K081) = +1.06698*K081*<PHO>*<HO2>
 PTERMS(:,21,81) = +1.06698*TPK%K081(:)*PCONC(:,35)*PCONC(:,15)

!PTERMS(PHO,K081) = -K081*<PHO>*<HO2>
 PTERMS(:,35,81) = -TPK%K081(:)*PCONC(:,35)*PCONC(:,15)

!PTERMS(NO2,K082) = -K082*<ADD>*<NO2>
 PTERMS(:,4,82) = -TPK%K082(:)*PCONC(:,36)*PCONC(:,4)

!PTERMS(HONO,K082) = +K082*<ADD>*<NO2>
 PTERMS(:,7,82) = +TPK%K082(:)*PCONC(:,36)*PCONC(:,4)

!PTERMS(ARO,K082) = +K082*<ADD>*<NO2>
 PTERMS(:,21,82) = +TPK%K082(:)*PCONC(:,36)*PCONC(:,4)

!PTERMS(ADD,K082) = -K082*<ADD>*<NO2>
 PTERMS(:,36,82) = -TPK%K082(:)*PCONC(:,36)*PCONC(:,4)

!PTERMS(HO2,K083) = +0.02*K083*<ADD>*<O2>
 PTERMS(:,15,83) = +0.02*TPK%K083(:)*PCONC(:,36)*TPK%O2(:)

!PTERMS(ARO,K083) = +0.02*K083*<ADD>*<O2>
 PTERMS(:,21,83) = +0.02*TPK%K083(:)*PCONC(:,36)*TPK%O2(:)

!PTERMS(ADD,K083) = -K083*<ADD>*<O2>
 PTERMS(:,36,83) = -TPK%K083(:)*PCONC(:,36)*TPK%O2(:)

!PTERMS(AROP,K083) = +0.98*K083*<ADD>*<O2>
 PTERMS(:,37,83) = +0.98*TPK%K083(:)*PCONC(:,36)*TPK%O2(:)

!PTERMS(O3,K084) = -K084*<ADD>*<O3>
 PTERMS(:,1,84) = -TPK%K084(:)*PCONC(:,36)*PCONC(:,1)

!PTERMS(OH,K084) = +K084*<ADD>*<O3>
 PTERMS(:,14,84) = +TPK%K084(:)*PCONC(:,36)*PCONC(:,1)

!PTERMS(ARO,K084) = +K084*<ADD>*<O3>
 PTERMS(:,21,84) = +TPK%K084(:)*PCONC(:,36)*PCONC(:,1)

!PTERMS(ADD,K084) = -K084*<ADD>*<O3>
 PTERMS(:,36,84) = -TPK%K084(:)*PCONC(:,36)*PCONC(:,1)

!PTERMS(NO2,K085) = -K085*<CARBOP>*<NO2>
 PTERMS(:,4,85) = -TPK%K085(:)*PCONC(:,38)*PCONC(:,4)

!PTERMS(PAN,K085) = +1.00000*K085*<CARBOP>*<NO2>
 PTERMS(:,27,85) = +1.00000*TPK%K085(:)*PCONC(:,38)*PCONC(:,4)

!PTERMS(CARBOP,K085) = -K085*<CARBOP>*<NO2>
 PTERMS(:,38,85) = -TPK%K085(:)*PCONC(:,38)*PCONC(:,4)

!PTERMS(NO2,K086) = +K086*<PAN>
 PTERMS(:,4,86) = +TPK%K086(:)*PCONC(:,27)

!PTERMS(PAN,K086) = -K086*<PAN>
 PTERMS(:,27,86) = -TPK%K086(:)*PCONC(:,27)

!PTERMS(CARBOP,K086) = +1.00000*K086*<PAN>
 PTERMS(:,38,86) = +1.00000*TPK%K086(:)*PCONC(:,27)

!PTERMS(NO,K087) = -K087*<MO2>*<NO>
 PTERMS(:,3,87) = -TPK%K087(:)*PCONC(:,31)*PCONC(:,3)

!PTERMS(NO2,K087) = +K087*<MO2>*<NO>
 PTERMS(:,4,87) = +TPK%K087(:)*PCONC(:,31)*PCONC(:,3)

!PTERMS(HO2,K087) = +K087*<MO2>*<NO>
 PTERMS(:,15,87) = +TPK%K087(:)*PCONC(:,31)*PCONC(:,3)

!PTERMS(HCHO,K087) = +K087*<MO2>*<NO>
 PTERMS(:,22,87) = +TPK%K087(:)*PCONC(:,31)*PCONC(:,3)

!PTERMS(MO2,K087) = -K087*<MO2>*<NO>
 PTERMS(:,31,87) = -TPK%K087(:)*PCONC(:,31)*PCONC(:,3)

!PTERMS(NO,K088) = -K088*<ALKAP>*<NO>
 PTERMS(:,3,88) = -TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(NO2,K088) = +0.91541*K088*<ALKAP>*<NO>
 PTERMS(:,4,88) = +0.91541*TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(HO2,K088) = +0.74265*K088*<ALKAP>*<NO>
 PTERMS(:,15,88) = +0.74265*TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(HCHO,K088) = +0.03002*K088*<ALKAP>*<NO>
 PTERMS(:,22,88) = +0.03002*TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(ALD,K088) = +0.33144*K088*<ALKAP>*<NO>
 PTERMS(:,23,88) = +0.33144*TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(KET,K088) = +0.54531*K088*<ALKAP>*<NO>
 PTERMS(:,24,88) = +0.54531*TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(CARBO,K088) = +0.03407*K088*<ALKAP>*<NO>
 PTERMS(:,25,88) = +0.03407*TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(ONIT,K088) = +0.08459*K088*<ALKAP>*<NO>
 PTERMS(:,26,88) = +0.08459*TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(MO2,K088) = +0.09016*K088*<ALKAP>*<NO>
 PTERMS(:,31,88) = +0.09016*TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(ALKAP,K088) = -K088*<ALKAP>*<NO>
 PTERMS(:,32,88) = -TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(XO2,K088) = +0.13007*K088*<ALKAP>*<NO>
 PTERMS(:,40,88) = +0.13007*TPK%K088(:)*PCONC(:,32)*PCONC(:,3)

!PTERMS(NO,K089) = -K089*<ALKEP>*<NO>
 PTERMS(:,3,89) = -TPK%K089(:)*PCONC(:,33)*PCONC(:,3)

!PTERMS(NO2,K089) = +K089*<ALKEP>*<NO>
 PTERMS(:,4,89) = +TPK%K089(:)*PCONC(:,33)*PCONC(:,3)

!PTERMS(HO2,K089) = +K089*<ALKEP>*<NO>
 PTERMS(:,15,89) = +TPK%K089(:)*PCONC(:,33)*PCONC(:,3)

!PTERMS(HCHO,K089) = +1.39870*K089*<ALKEP>*<NO>
 PTERMS(:,22,89) = +1.39870*TPK%K089(:)*PCONC(:,33)*PCONC(:,3)

!PTERMS(ALD,K089) = +0.42125*K089*<ALKEP>*<NO>
 PTERMS(:,23,89) = +0.42125*TPK%K089(:)*PCONC(:,33)*PCONC(:,3)

!PTERMS(KET,K089) = +0.05220*K089*<ALKEP>*<NO>
 PTERMS(:,24,89) = +0.05220*TPK%K089(:)*PCONC(:,33)*PCONC(:,3)

!PTERMS(ALKEP,K089) = -K089*<ALKEP>*<NO>
 PTERMS(:,33,89) = -TPK%K089(:)*PCONC(:,33)*PCONC(:,3)

!PTERMS(NO,K090) = -K090*<BIOP>*<NO>
 PTERMS(:,3,90) = -TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(NO2,K090) = +0.84700*K090*<BIOP>*<NO>
 PTERMS(:,4,90) = +0.84700*TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(HO2,K090) = +0.84700*K090*<BIOP>*<NO>
 PTERMS(:,15,90) = +0.84700*TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(ALKE,K090) = +0.37815*K090*<BIOP>*<NO>
 PTERMS(:,19,90) = +0.37815*TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(HCHO,K090) = +0.60600*K090*<BIOP>*<NO>
 PTERMS(:,22,90) = +0.60600*TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(ALD,K090) = +0.00000*K090*<BIOP>*<NO>
 PTERMS(:,23,90) = +0.00000*TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(KET,K090) = +0.00000*K090*<BIOP>*<NO>
 PTERMS(:,24,90) = +0.00000*TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(CARBO,K090) = +0.45463*K090*<BIOP>*<NO>
 PTERMS(:,25,90) = +0.45463*TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(ONIT,K090) = +0.15300*K090*<BIOP>*<NO>
 PTERMS(:,26,90) = +0.15300*TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(BIOP,K090) = -K090*<BIOP>*<NO>
 PTERMS(:,34,90) = -TPK%K090(:)*PCONC(:,34)*PCONC(:,3)

!PTERMS(NO,K091) = -K091*<AROP>*<NO>
 PTERMS(:,3,91) = -TPK%K091(:)*PCONC(:,37)*PCONC(:,3)

!PTERMS(NO2,K091) = +0.95115*K091*<AROP>*<NO>
 PTERMS(:,4,91) = +0.95115*TPK%K091(:)*PCONC(:,37)*PCONC(:,3)

!PTERMS(HO2,K091) = +0.95115*K091*<AROP>*<NO>
 PTERMS(:,15,91) = +0.95115*TPK%K091(:)*PCONC(:,37)*PCONC(:,3)

!PTERMS(CARBO,K091) = +2.06993*K091*<AROP>*<NO>
 PTERMS(:,25,91) = +2.06993*TPK%K091(:)*PCONC(:,37)*PCONC(:,3)

!PTERMS(ONIT,K091) = +0.04885*K091*<AROP>*<NO>
 PTERMS(:,26,91) = +0.04885*TPK%K091(:)*PCONC(:,37)*PCONC(:,3)

!PTERMS(AROP,K091) = -K091*<AROP>*<NO>
 PTERMS(:,37,91) = -TPK%K091(:)*PCONC(:,37)*PCONC(:,3)

!PTERMS(NO,K092) = -K092*<CARBOP>*<NO>
 PTERMS(:,3,92) = -TPK%K092(:)*PCONC(:,38)*PCONC(:,3)

!PTERMS(NO2,K092) = +K092*<CARBOP>*<NO>
 PTERMS(:,4,92) = +TPK%K092(:)*PCONC(:,38)*PCONC(:,3)

!PTERMS(HO2,K092) = +0.12334*K092*<CARBOP>*<NO>
 PTERMS(:,15,92) = +0.12334*TPK%K092(:)*PCONC(:,38)*PCONC(:,3)

!PTERMS(HCHO,K092) = +0.05848*K092*<CARBOP>*<NO>
 PTERMS(:,22,92) = +0.05848*TPK%K092(:)*PCONC(:,38)*PCONC(:,3)

!PTERMS(ALD,K092) = +0.07368*K092*<CARBOP>*<NO>
 PTERMS(:,23,92) = +0.07368*TPK%K092(:)*PCONC(:,38)*PCONC(:,3)

!PTERMS(CARBO,K092) = +0.08670*K092*<CARBOP>*<NO>
 PTERMS(:,25,92) = +0.08670*TPK%K092(:)*PCONC(:,38)*PCONC(:,3)

!PTERMS(MO2,K092) = +0.78134*K092*<CARBOP>*<NO>
 PTERMS(:,31,92) = +0.78134*TPK%K092(:)*PCONC(:,38)*PCONC(:,3)

!PTERMS(CARBOP,K092) = -K092*<CARBOP>*<NO>
 PTERMS(:,38,92) = -TPK%K092(:)*PCONC(:,38)*PCONC(:,3)

!PTERMS(XO2,K092) = +0.02563*K092*<CARBOP>*<NO>
 PTERMS(:,40,92) = +0.02563*TPK%K092(:)*PCONC(:,38)*PCONC(:,3)

!PTERMS(NO,K093) = -K093*<OLN>*<NO>
 PTERMS(:,3,93) = -TPK%K093(:)*PCONC(:,39)*PCONC(:,3)

!PTERMS(NO2,K093) = +1.81599*K093*<OLN>*<NO>
 PTERMS(:,4,93) = +1.81599*TPK%K093(:)*PCONC(:,39)*PCONC(:,3)

!PTERMS(HO2,K093) = +0.18401*K093*<OLN>*<NO>
 PTERMS(:,15,93) = +0.18401*TPK%K093(:)*PCONC(:,39)*PCONC(:,3)

!PTERMS(HCHO,K093) = +0.23419*K093*<OLN>*<NO>
 PTERMS(:,22,93) = +0.23419*TPK%K093(:)*PCONC(:,39)*PCONC(:,3)

!PTERMS(ALD,K093) = +1.01182*K093*<OLN>*<NO>
 PTERMS(:,23,93) = +1.01182*TPK%K093(:)*PCONC(:,39)*PCONC(:,3)

!PTERMS(KET,K093) = +0.37862*K093*<OLN>*<NO>
 PTERMS(:,24,93) = +0.37862*TPK%K093(:)*PCONC(:,39)*PCONC(:,3)

!PTERMS(ONIT,K093) = +0.18401*K093*<OLN>*<NO>
 PTERMS(:,26,93) = +0.18401*TPK%K093(:)*PCONC(:,39)*PCONC(:,3)

!PTERMS(OLN,K093) = -K093*<OLN>*<NO>
 PTERMS(:,39,93) = -TPK%K093(:)*PCONC(:,39)*PCONC(:,3)

!PTERMS(HO2,K094) = -K094*<MO2>*<HO2>
 PTERMS(:,15,94) = -TPK%K094(:)*PCONC(:,31)*PCONC(:,15)

!PTERMS(OP1,K094) = +K094*<MO2>*<HO2>
 PTERMS(:,28,94) = +TPK%K094(:)*PCONC(:,31)*PCONC(:,15)

!PTERMS(MO2,K094) = -K094*<MO2>*<HO2>
 PTERMS(:,31,94) = -TPK%K094(:)*PCONC(:,31)*PCONC(:,15)

!PTERMS(HO2,K095) = -K095*<ALKAP>*<HO2>
 PTERMS(:,15,95) = -TPK%K095(:)*PCONC(:,32)*PCONC(:,15)

!PTERMS(OP2,K095) = +1.00524*K095*<ALKAP>*<HO2>
 PTERMS(:,29,95) = +1.00524*TPK%K095(:)*PCONC(:,32)*PCONC(:,15)

!PTERMS(ALKAP,K095) = -K095*<ALKAP>*<HO2>
 PTERMS(:,32,95) = -TPK%K095(:)*PCONC(:,32)*PCONC(:,15)

!PTERMS(HO2,K096) = -K096*<ALKEP>*<HO2>
 PTERMS(:,15,96) = -TPK%K096(:)*PCONC(:,33)*PCONC(:,15)

!PTERMS(OP2,K096) = +1.00524*K096*<ALKEP>*<HO2>
 PTERMS(:,29,96) = +1.00524*TPK%K096(:)*PCONC(:,33)*PCONC(:,15)

!PTERMS(ALKEP,K096) = -K096*<ALKEP>*<HO2>
 PTERMS(:,33,96) = -TPK%K096(:)*PCONC(:,33)*PCONC(:,15)

!PTERMS(HO2,K097) = -K097*<BIOP>*<HO2>
 PTERMS(:,15,97) = -TPK%K097(:)*PCONC(:,34)*PCONC(:,15)

!PTERMS(OP2,K097) = +1.00524*K097*<BIOP>*<HO2>
 PTERMS(:,29,97) = +1.00524*TPK%K097(:)*PCONC(:,34)*PCONC(:,15)

!PTERMS(BIOP,K097) = -K097*<BIOP>*<HO2>
 PTERMS(:,34,97) = -TPK%K097(:)*PCONC(:,34)*PCONC(:,15)

!PTERMS(HO2,K098) = -K098*<AROP>*<HO2>
 PTERMS(:,15,98) = -TPK%K098(:)*PCONC(:,37)*PCONC(:,15)

!PTERMS(OP2,K098) = +1.00524*K098*<AROP>*<HO2>
 PTERMS(:,29,98) = +1.00524*TPK%K098(:)*PCONC(:,37)*PCONC(:,15)

!PTERMS(AROP,K098) = -K098*<AROP>*<HO2>
 PTERMS(:,37,98) = -TPK%K098(:)*PCONC(:,37)*PCONC(:,15)

!PTERMS(O3,K099) = +0.17307*K099*<CARBOP>*<HO2>
 PTERMS(:,1,99) = +0.17307*TPK%K099(:)*PCONC(:,38)*PCONC(:,15)

!PTERMS(HO2,K099) = -K099*<CARBOP>*<HO2>
 PTERMS(:,15,99) = -TPK%K099(:)*PCONC(:,38)*PCONC(:,15)

!PTERMS(OP2,K099) = +0.80904*K099*<CARBOP>*<HO2>
 PTERMS(:,29,99) = +0.80904*TPK%K099(:)*PCONC(:,38)*PCONC(:,15)

!PTERMS(ORA2,K099) = +0.17307*K099*<CARBOP>*<HO2>
 PTERMS(:,30,99) = +0.17307*TPK%K099(:)*PCONC(:,38)*PCONC(:,15)

!PTERMS(CARBOP,K099) = -K099*<CARBOP>*<HO2>
 PTERMS(:,38,99) = -TPK%K099(:)*PCONC(:,38)*PCONC(:,15)

!PTERMS(HO2,K100) = -K100*<OLN>*<HO2>
 PTERMS(:,15,100) = -TPK%K100(:)*PCONC(:,39)*PCONC(:,15)

!PTERMS(ONIT,K100) = +K100*<OLN>*<HO2>
 PTERMS(:,26,100) = +TPK%K100(:)*PCONC(:,39)*PCONC(:,15)

!PTERMS(OLN,K100) = -K100*<OLN>*<HO2>
 PTERMS(:,39,100) = -TPK%K100(:)*PCONC(:,39)*PCONC(:,15)

!PTERMS(HO2,K101) = +0.66*K101*<MO2>*<MO2>
 PTERMS(:,15,101) = +0.66*TPK%K101(:)*PCONC(:,31)*PCONC(:,31)

!PTERMS(HCHO,K101) = +1.33*K101*<MO2>*<MO2>
 PTERMS(:,22,101) = +1.33*TPK%K101(:)*PCONC(:,31)*PCONC(:,31)

!PTERMS(MO2,K101) = -K101*<MO2>*<MO2>
 PTERMS(:,31,101) = -TPK%K101(:)*PCONC(:,31)*PCONC(:,31)

!PTERMS(HO2,K102) = +0.98383*K102*<ALKAP>*<MO2>
 PTERMS(:,15,102) = +0.98383*TPK%K102(:)*PCONC(:,32)*PCONC(:,31)

!PTERMS(HCHO,K102) = +0.80556*K102*<ALKAP>*<MO2>
 PTERMS(:,22,102) = +0.80556*TPK%K102(:)*PCONC(:,32)*PCONC(:,31)

!PTERMS(ALD,K102) = +0.56070*K102*<ALKAP>*<MO2>
 PTERMS(:,23,102) = +0.56070*TPK%K102(:)*PCONC(:,32)*PCONC(:,31)

!PTERMS(KET,K102) = +0.09673*K102*<ALKAP>*<MO2>
 PTERMS(:,24,102) = +0.09673*TPK%K102(:)*PCONC(:,32)*PCONC(:,31)

!PTERMS(CARBO,K102) = +0.07976*K102*<ALKAP>*<MO2>
 PTERMS(:,25,102) = +0.07976*TPK%K102(:)*PCONC(:,32)*PCONC(:,31)

!PTERMS(MO2,K102) = -K102*<ALKAP>*<MO2>
 PTERMS(:,31,102) = -TPK%K102(:)*PCONC(:,32)*PCONC(:,31)

!PTERMS(ALKAP,K102) = -K102*<ALKAP>*<MO2>
 PTERMS(:,32,102) = -TPK%K102(:)*PCONC(:,32)*PCONC(:,31)

!PTERMS(XO2,K102) = +0.13370*K102*<ALKAP>*<MO2>
 PTERMS(:,40,102) = +0.13370*TPK%K102(:)*PCONC(:,32)*PCONC(:,31)

!PTERMS(HO2,K103) = +K103*<ALKEP>*<MO2>
 PTERMS(:,15,103) = +TPK%K103(:)*PCONC(:,33)*PCONC(:,31)

!PTERMS(HCHO,K103) = +1.42894*K103*<ALKEP>*<MO2>
 PTERMS(:,22,103) = +1.42894*TPK%K103(:)*PCONC(:,33)*PCONC(:,31)

!PTERMS(ALD,K103) = +0.46413*K103*<ALKEP>*<MO2>
 PTERMS(:,23,103) = +0.46413*TPK%K103(:)*PCONC(:,33)*PCONC(:,31)

!PTERMS(KET,K103) = +0.03814*K103*<ALKEP>*<MO2>
 PTERMS(:,24,103) = +0.03814*TPK%K103(:)*PCONC(:,33)*PCONC(:,31)

!PTERMS(MO2,K103) = -K103*<ALKEP>*<MO2>
 PTERMS(:,31,103) = -TPK%K103(:)*PCONC(:,33)*PCONC(:,31)

!PTERMS(ALKEP,K103) = -K103*<ALKEP>*<MO2>
 PTERMS(:,33,103) = -TPK%K103(:)*PCONC(:,33)*PCONC(:,31)

!PTERMS(HO2,K104) = +1.00000*K104*<BIOP>*<MO2>
 PTERMS(:,15,104) = +1.00000*TPK%K104(:)*PCONC(:,34)*PCONC(:,31)

!PTERMS(ALKE,K104) = +0.48074*K104*<BIOP>*<MO2>
 PTERMS(:,19,104) = +0.48074*TPK%K104(:)*PCONC(:,34)*PCONC(:,31)

!PTERMS(HCHO,K104) = +1.09000*K104*<BIOP>*<MO2>
 PTERMS(:,22,104) = +1.09000*TPK%K104(:)*PCONC(:,34)*PCONC(:,31)

!PTERMS(ALD,K104) = +0.00000*K104*<BIOP>*<MO2>
 PTERMS(:,23,104) = +0.00000*TPK%K104(:)*PCONC(:,34)*PCONC(:,31)

!PTERMS(KET,K104) = +0.00000*K104*<BIOP>*<MO2>
 PTERMS(:,24,104) = +0.00000*TPK%K104(:)*PCONC(:,34)*PCONC(:,31)

!PTERMS(CARBO,K104) = +0.56064*K104*<BIOP>*<MO2>
 PTERMS(:,25,104) = +0.56064*TPK%K104(:)*PCONC(:,34)*PCONC(:,31)

!PTERMS(MO2,K104) = -K104*<BIOP>*<MO2>
 PTERMS(:,31,104) = -TPK%K104(:)*PCONC(:,34)*PCONC(:,31)

!PTERMS(BIOP,K104) = -K104*<BIOP>*<MO2>
 PTERMS(:,34,104) = -TPK%K104(:)*PCONC(:,34)*PCONC(:,31)

!PTERMS(HO2,K105) = +1.02767*K105*<AROP>*<MO2>
 PTERMS(:,15,105) = +1.02767*TPK%K105(:)*PCONC(:,37)*PCONC(:,31)

!PTERMS(HCHO,K105) = +K105*<AROP>*<MO2>
 PTERMS(:,22,105) = +TPK%K105(:)*PCONC(:,37)*PCONC(:,31)

!PTERMS(CARBO,K105) = +1.99461*K105*<AROP>*<MO2>
 PTERMS(:,25,105) = +1.99461*TPK%K105(:)*PCONC(:,37)*PCONC(:,31)

!PTERMS(MO2,K105) = -K105*<AROP>*<MO2>
 PTERMS(:,31,105) = -TPK%K105(:)*PCONC(:,37)*PCONC(:,31)

!PTERMS(AROP,K105) = -K105*<AROP>*<MO2>
 PTERMS(:,37,105) = -TPK%K105(:)*PCONC(:,37)*PCONC(:,31)

!PTERMS(HO2,K106) = +0.82998*K106*<CARBOP>*<MO2>
 PTERMS(:,15,106) = +0.82998*TPK%K106(:)*PCONC(:,38)*PCONC(:,31)

!PTERMS(HCHO,K106) = +0.95723*K106*<CARBOP>*<MO2>
 PTERMS(:,22,106) = +0.95723*TPK%K106(:)*PCONC(:,38)*PCONC(:,31)

!PTERMS(ALD,K106) = +0.08295*K106*<CARBOP>*<MO2>
 PTERMS(:,23,106) = +0.08295*TPK%K106(:)*PCONC(:,38)*PCONC(:,31)

!PTERMS(CARBO,K106) = +0.15387*K106*<CARBOP>*<MO2>
 PTERMS(:,25,106) = +0.15387*TPK%K106(:)*PCONC(:,38)*PCONC(:,31)

!PTERMS(ORA2,K106) = +0.13684*K106*<CARBOP>*<MO2>
 PTERMS(:,30,106) = +0.13684*TPK%K106(:)*PCONC(:,38)*PCONC(:,31)

!PTERMS(MO2,K106) = -K106*<CARBOP>*<MO2>
 PTERMS(:,31,106) = -TPK%K106(:)*PCONC(:,38)*PCONC(:,31)

!PTERMS(CARBOP,K106) = -K106*<CARBOP>*<MO2>
 PTERMS(:,38,106) = -TPK%K106(:)*PCONC(:,38)*PCONC(:,31)

!PTERMS(XO2,K106) = +0.02212*K106*<CARBOP>*<MO2>
 PTERMS(:,40,106) = +0.02212*TPK%K106(:)*PCONC(:,38)*PCONC(:,31)

!PTERMS(NO2,K107) = +0.32440*K107*<OLN>*<MO2>
 PTERMS(:,4,107) = +0.32440*TPK%K107(:)*PCONC(:,39)*PCONC(:,31)

!PTERMS(HO2,K107) = +0.67560*K107*<OLN>*<MO2>
 PTERMS(:,15,107) = +0.67560*TPK%K107(:)*PCONC(:,39)*PCONC(:,31)

!PTERMS(HCHO,K107) = +0.88625*K107*<OLN>*<MO2>
 PTERMS(:,22,107) = +0.88625*TPK%K107(:)*PCONC(:,39)*PCONC(:,31)

!PTERMS(ALD,K107) = +0.41524*K107*<OLN>*<MO2>
 PTERMS(:,23,107) = +0.41524*TPK%K107(:)*PCONC(:,39)*PCONC(:,31)

!PTERMS(KET,K107) = +0.09667*K107*<OLN>*<MO2>
 PTERMS(:,24,107) = +0.09667*TPK%K107(:)*PCONC(:,39)*PCONC(:,31)

!PTERMS(ONIT,K107) = +0.67560*K107*<OLN>*<MO2>
 PTERMS(:,26,107) = +0.67560*TPK%K107(:)*PCONC(:,39)*PCONC(:,31)

!PTERMS(MO2,K107) = -K107*<OLN>*<MO2>
 PTERMS(:,31,107) = -TPK%K107(:)*PCONC(:,39)*PCONC(:,31)

!PTERMS(OLN,K107) = -K107*<OLN>*<MO2>
 PTERMS(:,39,107) = -TPK%K107(:)*PCONC(:,39)*PCONC(:,31)

!PTERMS(HO2,K108) = +0.48079*K108*<ALKAP>*<CARBOP>
 PTERMS(:,15,108) = +0.48079*TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(HCHO,K108) = +0.07600*K108*<ALKAP>*<CARBOP>
 PTERMS(:,22,108) = +0.07600*TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(ALD,K108) = +0.71461*K108*<ALKAP>*<CARBOP>
 PTERMS(:,23,108) = +0.71461*TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(KET,K108) = +0.18819*K108*<ALKAP>*<CARBOP>
 PTERMS(:,24,108) = +0.18819*TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(CARBO,K108) = +0.06954*K108*<ALKAP>*<CARBOP>
 PTERMS(:,25,108) = +0.06954*TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(ORA2,K108) = +0.49810*K108*<ALKAP>*<CARBOP>
 PTERMS(:,30,108) = +0.49810*TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(MO2,K108) = +0.51480*K108*<ALKAP>*<CARBOP>
 PTERMS(:,31,108) = +0.51480*TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(ALKAP,K108) = -K108*<ALKAP>*<CARBOP>
 PTERMS(:,32,108) = -TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(CARBOP,K108) = -K108*<ALKAP>*<CARBOP>
 PTERMS(:,38,108) = -TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(XO2,K108) = +0.11306*K108*<ALKAP>*<CARBOP>
 PTERMS(:,40,108) = +0.11306*TPK%K108(:)*PCONC(:,32)*PCONC(:,38)

!PTERMS(HO2,K109) = +0.50078*K109*<ALKEP>*<CARBOP>
 PTERMS(:,15,109) = +0.50078*TPK%K109(:)*PCONC(:,33)*PCONC(:,38)

!PTERMS(HCHO,K109) = +0.68192*K109*<ALKEP>*<CARBOP>
 PTERMS(:,22,109) = +0.68192*TPK%K109(:)*PCONC(:,33)*PCONC(:,38)

!PTERMS(ALD,K109) = +0.68374*K109*<ALKEP>*<CARBOP>
 PTERMS(:,23,109) = +0.68374*TPK%K109(:)*PCONC(:,33)*PCONC(:,38)

!PTERMS(KET,K109) = +0.06579*K109*<ALKEP>*<CARBOP>
 PTERMS(:,24,109) = +0.06579*TPK%K109(:)*PCONC(:,33)*PCONC(:,38)

!PTERMS(ORA2,K109) = +0.49922*K109*<ALKEP>*<CARBOP>
 PTERMS(:,30,109) = +0.49922*TPK%K109(:)*PCONC(:,33)*PCONC(:,38)

!PTERMS(MO2,K109) = +0.50078*K109*<ALKEP>*<CARBOP>
 PTERMS(:,31,109) = +0.50078*TPK%K109(:)*PCONC(:,33)*PCONC(:,38)

!PTERMS(ALKEP,K109) = -K109*<ALKEP>*<CARBOP>
 PTERMS(:,33,109) = -TPK%K109(:)*PCONC(:,33)*PCONC(:,38)

!PTERMS(CARBOP,K109) = -K109*<ALKEP>*<CARBOP>
 PTERMS(:,38,109) = -TPK%K109(:)*PCONC(:,33)*PCONC(:,38)

!PTERMS(HO2,K110) = +0.50600*K110*<BIOP>*<CARBOP>
 PTERMS(:,15,110) = +0.50600*TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(ALKE,K110) = +0.24463*K110*<BIOP>*<CARBOP>
 PTERMS(:,19,110) = +0.24463*TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(HCHO,K110) = +0.34000*K110*<BIOP>*<CARBOP>
 PTERMS(:,22,110) = +0.34000*TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(ALD,K110) = +0.00000*K110*<BIOP>*<CARBOP>
 PTERMS(:,23,110) = +0.00000*TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(KET,K110) = +0.00000*K110*<BIOP>*<CARBOP>
 PTERMS(:,24,110) = +0.00000*TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(CARBO,K110) = +0.78591*K110*<BIOP>*<CARBOP>
 PTERMS(:,25,110) = +0.78591*TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(ORA2,K110) = +0.49400*K110*<BIOP>*<CARBOP>
 PTERMS(:,30,110) = +0.49400*TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(MO2,K110) = +0.50600*K110*<BIOP>*<CARBOP>
 PTERMS(:,31,110) = +0.50600*TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(BIOP,K110) = -K110*<BIOP>*<CARBOP>
 PTERMS(:,34,110) = -TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(CARBOP,K110) = -K110*<BIOP>*<CARBOP>
 PTERMS(:,38,110) = -TPK%K110(:)*PCONC(:,34)*PCONC(:,38)

!PTERMS(HO2,K111) = +K111*<AROP>*<CARBOP>
 PTERMS(:,15,111) = +TPK%K111(:)*PCONC(:,37)*PCONC(:,38)

!PTERMS(CARBO,K111) = +1.99455*K111*<AROP>*<CARBOP>
 PTERMS(:,25,111) = +1.99455*TPK%K111(:)*PCONC(:,37)*PCONC(:,38)

!PTERMS(MO2,K111) = +K111*<AROP>*<CARBOP>
 PTERMS(:,31,111) = +TPK%K111(:)*PCONC(:,37)*PCONC(:,38)

!PTERMS(AROP,K111) = -K111*<AROP>*<CARBOP>
 PTERMS(:,37,111) = -TPK%K111(:)*PCONC(:,37)*PCONC(:,38)

!PTERMS(CARBOP,K111) = -K111*<AROP>*<CARBOP>
 PTERMS(:,38,111) = -TPK%K111(:)*PCONC(:,37)*PCONC(:,38)

!PTERMS(HO2,K112) = +0.07566*K112*<CARBOP>*<CARBOP>
 PTERMS(:,15,112) = +0.07566*TPK%K112(:)*PCONC(:,38)*PCONC(:,38)

!PTERMS(HCHO,K112) = +0.03432*K112*<CARBOP>*<CARBOP>
 PTERMS(:,22,112) = +0.03432*TPK%K112(:)*PCONC(:,38)*PCONC(:,38)

!PTERMS(ALD,K112) = +0.06969*K112*<CARBOP>*<CARBOP>
 PTERMS(:,23,112) = +0.06969*TPK%K112(:)*PCONC(:,38)*PCONC(:,38)

!PTERMS(KET,K112) = +0.02190*K112*<CARBOP>*<CARBOP>
 PTERMS(:,24,112) = +0.02190*TPK%K112(:)*PCONC(:,38)*PCONC(:,38)

!PTERMS(CARBO,K112) = +0.10777*K112*<CARBOP>*<CARBOP>
 PTERMS(:,25,112) = +0.10777*TPK%K112(:)*PCONC(:,38)*PCONC(:,38)

!PTERMS(ORA2,K112) = +0.09955*K112*<CARBOP>*<CARBOP>
 PTERMS(:,30,112) = +0.09955*TPK%K112(:)*PCONC(:,38)*PCONC(:,38)

!PTERMS(MO2,K112) = +1.66702*K112*<CARBOP>*<CARBOP>
 PTERMS(:,31,112) = +1.66702*TPK%K112(:)*PCONC(:,38)*PCONC(:,38)

!PTERMS(CARBOP,K112) = -K112*<CARBOP>*<CARBOP>
 PTERMS(:,38,112) = -TPK%K112(:)*PCONC(:,38)*PCONC(:,38)

!PTERMS(XO2,K112) = +0.01593*K112*<CARBOP>*<CARBOP>
 PTERMS(:,40,112) = +0.01593*TPK%K112(:)*PCONC(:,38)*PCONC(:,38)

!PTERMS(NO2,K113) = +0.00000*K113*<OLN>*<CARBOP>
 PTERMS(:,4,113) = +0.00000*TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(HO2,K113) = +0.17599*K113*<OLN>*<CARBOP>
 PTERMS(:,15,113) = +0.17599*TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(HCHO,K113) = +0.13414*K113*<OLN>*<CARBOP>
 PTERMS(:,22,113) = +0.13414*TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(ALD,K113) = +0.42122*K113*<OLN>*<CARBOP>
 PTERMS(:,23,113) = +0.42122*TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(KET,K113) = +0.10822*K113*<OLN>*<CARBOP>
 PTERMS(:,24,113) = +0.10822*TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(ONIT,K113) = +0.66562*K113*<OLN>*<CARBOP>
 PTERMS(:,26,113) = +0.66562*TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(ORA2,K113) = +0.48963*K113*<OLN>*<CARBOP>
 PTERMS(:,30,113) = +0.48963*TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(MO2,K113) = +0.51037*K113*<OLN>*<CARBOP>
 PTERMS(:,31,113) = +0.51037*TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(CARBOP,K113) = -K113*<OLN>*<CARBOP>
 PTERMS(:,38,113) = -TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(OLN,K113) = -K113*<OLN>*<CARBOP>
 PTERMS(:,39,113) = -TPK%K113(:)*PCONC(:,39)*PCONC(:,38)

!PTERMS(HO2,K114) = +K114*<OLN>*<OLN>
 PTERMS(:,15,114) = +TPK%K114(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(ONIT,K114) = +2.00*K114*<OLN>*<OLN>
 PTERMS(:,26,114) = +2.00*TPK%K114(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(OLN,K114) = -K114*<OLN>*<OLN>
 PTERMS(:,39,114) = -TPK%K114(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(NO2,K115) = +0.00000*K115*<OLN>*<OLN>
 PTERMS(:,4,115) = +0.00000*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(HO2,K115) = +0.00000*K115*<OLN>*<OLN>
 PTERMS(:,15,115) = +0.00000*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(HCHO,K115) = +0.00000*K115*<OLN>*<OLN>
 PTERMS(:,22,115) = +0.00000*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(ALD,K115) = +0.00000*K115*<OLN>*<OLN>
 PTERMS(:,23,115) = +0.00000*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(KET,K115) = +0.00000*K115*<OLN>*<OLN>
 PTERMS(:,24,115) = +0.00000*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(ONIT,K115) = +0.00000*K115*<OLN>*<OLN>
 PTERMS(:,26,115) = +0.00000*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(OLN,K115) = -K115*<OLN>*<OLN>
 PTERMS(:,39,115) = -TPK%K115(:)*PCONC(:,39)*PCONC(:,39)

!PTERMS(NO2,K116) = +K116*<MO2>*<NO3>
 PTERMS(:,4,116) = +TPK%K116(:)*PCONC(:,31)*PCONC(:,5)

!PTERMS(NO3,K116) = -K116*<MO2>*<NO3>
 PTERMS(:,5,116) = -TPK%K116(:)*PCONC(:,31)*PCONC(:,5)

!PTERMS(HO2,K116) = +K116*<MO2>*<NO3>
 PTERMS(:,15,116) = +TPK%K116(:)*PCONC(:,31)*PCONC(:,5)

!PTERMS(HCHO,K116) = +K116*<MO2>*<NO3>
 PTERMS(:,22,116) = +TPK%K116(:)*PCONC(:,31)*PCONC(:,5)

!PTERMS(MO2,K116) = -K116*<MO2>*<NO3>
 PTERMS(:,31,116) = -TPK%K116(:)*PCONC(:,31)*PCONC(:,5)

!PTERMS(NO2,K117) = +K117*<ALKAP>*<NO3>
 PTERMS(:,4,117) = +TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(NO3,K117) = -K117*<ALKAP>*<NO3>
 PTERMS(:,5,117) = -TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(HO2,K117) = +0.81290*K117*<ALKAP>*<NO3>
 PTERMS(:,15,117) = +0.81290*TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(HCHO,K117) = +0.03142*K117*<ALKAP>*<NO3>
 PTERMS(:,22,117) = +0.03142*TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(ALD,K117) = +0.33743*K117*<ALKAP>*<NO3>
 PTERMS(:,23,117) = +0.33743*TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(KET,K117) = +0.62978*K117*<ALKAP>*<NO3>
 PTERMS(:,24,117) = +0.62978*TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(CARBO,K117) = +0.03531*K117*<ALKAP>*<NO3>
 PTERMS(:,25,117) = +0.03531*TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(MO2,K117) = +0.09731*K117*<ALKAP>*<NO3>
 PTERMS(:,31,117) = +0.09731*TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(ALKAP,K117) = -K117*<ALKAP>*<NO3>
 PTERMS(:,32,117) = -TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(XO2,K117) = +0.16271*K117*<ALKAP>*<NO3>
 PTERMS(:,40,117) = +0.16271*TPK%K117(:)*PCONC(:,32)*PCONC(:,5)

!PTERMS(NO2,K118) = +K118*<ALKEP>*<NO3>
 PTERMS(:,4,118) = +TPK%K118(:)*PCONC(:,33)*PCONC(:,5)

!PTERMS(NO3,K118) = -K118*<ALKEP>*<NO3>
 PTERMS(:,5,118) = -TPK%K118(:)*PCONC(:,33)*PCONC(:,5)

!PTERMS(HO2,K118) = +K118*<ALKEP>*<NO3>
 PTERMS(:,15,118) = +TPK%K118(:)*PCONC(:,33)*PCONC(:,5)

!PTERMS(HCHO,K118) = +1.40909*K118*<ALKEP>*<NO3>
 PTERMS(:,22,118) = +1.40909*TPK%K118(:)*PCONC(:,33)*PCONC(:,5)

!PTERMS(ALD,K118) = +0.43039*K118*<ALKEP>*<NO3>
 PTERMS(:,23,118) = +0.43039*TPK%K118(:)*PCONC(:,33)*PCONC(:,5)

!PTERMS(KET,K118) = +0.02051*K118*<ALKEP>*<NO3>
 PTERMS(:,24,118) = +0.02051*TPK%K118(:)*PCONC(:,33)*PCONC(:,5)

!PTERMS(ALKEP,K118) = -K118*<ALKEP>*<NO3>
 PTERMS(:,33,118) = -TPK%K118(:)*PCONC(:,33)*PCONC(:,5)

!PTERMS(NO2,K119) = +K119*<BIOP>*<NO3>
 PTERMS(:,4,119) = +TPK%K119(:)*PCONC(:,34)*PCONC(:,5)

!PTERMS(NO3,K119) = -K119*<BIOP>*<NO3>
 PTERMS(:,5,119) = -TPK%K119(:)*PCONC(:,34)*PCONC(:,5)

!PTERMS(HO2,K119) = +K119*<BIOP>*<NO3>
 PTERMS(:,15,119) = +TPK%K119(:)*PCONC(:,34)*PCONC(:,5)

!PTERMS(ALKE,K119) = +0.42729*K119*<BIOP>*<NO3>
 PTERMS(:,19,119) = +0.42729*TPK%K119(:)*PCONC(:,34)*PCONC(:,5)

!PTERMS(HCHO,K119) = +0.68600*K119*<BIOP>*<NO3>
 PTERMS(:,22,119) = +0.68600*TPK%K119(:)*PCONC(:,34)*PCONC(:,5)

!PTERMS(ALD,K119) = +0.00000*K119*<BIOP>*<NO3>
 PTERMS(:,23,119) = +0.00000*TPK%K119(:)*PCONC(:,34)*PCONC(:,5)

!PTERMS(KET,K119) = +0.00000*K119*<BIOP>*<NO3>
 PTERMS(:,24,119) = +0.00000*TPK%K119(:)*PCONC(:,34)*PCONC(:,5)

!PTERMS(CARBO,K119) = +0.61160*K119*<BIOP>*<NO3>
 PTERMS(:,25,119) = +0.61160*TPK%K119(:)*PCONC(:,34)*PCONC(:,5)

!PTERMS(BIOP,K119) = -K119*<BIOP>*<NO3>
 PTERMS(:,34,119) = -TPK%K119(:)*PCONC(:,34)*PCONC(:,5)

!PTERMS(NO2,K120) = +K120*<AROP>*<NO3>
 PTERMS(:,4,120) = +TPK%K120(:)*PCONC(:,37)*PCONC(:,5)

!PTERMS(NO3,K120) = -K120*<AROP>*<NO3>
 PTERMS(:,5,120) = -TPK%K120(:)*PCONC(:,37)*PCONC(:,5)

!PTERMS(HO2,K120) = +K120*<AROP>*<NO3>
 PTERMS(:,15,120) = +TPK%K120(:)*PCONC(:,37)*PCONC(:,5)

!PTERMS(CARBO,K120) = +2.81904*K120*<AROP>*<NO3>
 PTERMS(:,25,120) = +2.81904*TPK%K120(:)*PCONC(:,37)*PCONC(:,5)

!PTERMS(AROP,K120) = -K120*<AROP>*<NO3>
 PTERMS(:,37,120) = -TPK%K120(:)*PCONC(:,37)*PCONC(:,5)

!PTERMS(NO2,K121) = +K121*<CARBOP>*<NO3>
 PTERMS(:,4,121) = +TPK%K121(:)*PCONC(:,38)*PCONC(:,5)

!PTERMS(NO3,K121) = -K121*<CARBOP>*<NO3>
 PTERMS(:,5,121) = -TPK%K121(:)*PCONC(:,38)*PCONC(:,5)

!PTERMS(HO2,K121) = +0.04915*K121*<CARBOP>*<NO3>
 PTERMS(:,15,121) = +0.04915*TPK%K121(:)*PCONC(:,38)*PCONC(:,5)

!PTERMS(HCHO,K121) = +0.03175*K121*<CARBOP>*<NO3>
 PTERMS(:,22,121) = +0.03175*TPK%K121(:)*PCONC(:,38)*PCONC(:,5)

!PTERMS(ALD,K121) = +0.02936*K121*<CARBOP>*<NO3>
 PTERMS(:,23,121) = +0.02936*TPK%K121(:)*PCONC(:,38)*PCONC(:,5)

!PTERMS(CARBO,K121) = +0.03455*K121*<CARBOP>*<NO3>
 PTERMS(:,25,121) = +0.03455*TPK%K121(:)*PCONC(:,38)*PCONC(:,5)

!PTERMS(MO2,K121) = +0.91910*K121*<CARBOP>*<NO3>
 PTERMS(:,31,121) = +0.91910*TPK%K121(:)*PCONC(:,38)*PCONC(:,5)

!PTERMS(CARBOP,K121) = -K121*<CARBOP>*<NO3>
 PTERMS(:,38,121) = -TPK%K121(:)*PCONC(:,38)*PCONC(:,5)

!PTERMS(XO2,K121) = +0.01021*K121*<CARBOP>*<NO3>
 PTERMS(:,40,121) = +0.01021*TPK%K121(:)*PCONC(:,38)*PCONC(:,5)

!PTERMS(NO2,K122) = +1.74072*K122*<OLN>*<NO3>
 PTERMS(:,4,122) = +1.74072*TPK%K122(:)*PCONC(:,39)*PCONC(:,5)

!PTERMS(NO3,K122) = -K122*<OLN>*<NO3>
 PTERMS(:,5,122) = -TPK%K122(:)*PCONC(:,39)*PCONC(:,5)

!PTERMS(HO2,K122) = +0.25928*K122*<OLN>*<NO3>
 PTERMS(:,15,122) = +0.25928*TPK%K122(:)*PCONC(:,39)*PCONC(:,5)

!PTERMS(HCHO,K122) = +0.20740*K122*<OLN>*<NO3>
 PTERMS(:,22,122) = +0.20740*TPK%K122(:)*PCONC(:,39)*PCONC(:,5)

!PTERMS(ALD,K122) = +0.91850*K122*<OLN>*<NO3>
 PTERMS(:,23,122) = +0.91850*TPK%K122(:)*PCONC(:,39)*PCONC(:,5)

!PTERMS(KET,K122) = +0.34740*K122*<OLN>*<NO3>
 PTERMS(:,24,122) = +0.34740*TPK%K122(:)*PCONC(:,39)*PCONC(:,5)

!PTERMS(ONIT,K122) = +0.25928*K122*<OLN>*<NO3>
 PTERMS(:,26,122) = +0.25928*TPK%K122(:)*PCONC(:,39)*PCONC(:,5)

!PTERMS(OLN,K122) = -K122*<OLN>*<NO3>
 PTERMS(:,39,122) = -TPK%K122(:)*PCONC(:,39)*PCONC(:,5)

!PTERMS(HO2,K123) = -K123*<XO2>*<HO2>
 PTERMS(:,15,123) = -TPK%K123(:)*PCONC(:,40)*PCONC(:,15)

!PTERMS(OP2,K123) = +1.00524*K123*<XO2>*<HO2>
 PTERMS(:,29,123) = +1.00524*TPK%K123(:)*PCONC(:,40)*PCONC(:,15)

!PTERMS(XO2,K123) = -K123*<XO2>*<HO2>
 PTERMS(:,40,123) = -TPK%K123(:)*PCONC(:,40)*PCONC(:,15)

!PTERMS(HO2,K124) = +K124*<XO2>*<MO2>
 PTERMS(:,15,124) = +TPK%K124(:)*PCONC(:,40)*PCONC(:,31)

!PTERMS(HCHO,K124) = +K124*<XO2>*<MO2>
 PTERMS(:,22,124) = +TPK%K124(:)*PCONC(:,40)*PCONC(:,31)

!PTERMS(MO2,K124) = -K124*<XO2>*<MO2>
 PTERMS(:,31,124) = -TPK%K124(:)*PCONC(:,40)*PCONC(:,31)

!PTERMS(XO2,K124) = -K124*<XO2>*<MO2>
 PTERMS(:,40,124) = -TPK%K124(:)*PCONC(:,40)*PCONC(:,31)

!PTERMS(MO2,K125) = +K125*<XO2>*<CARBOP>
 PTERMS(:,31,125) = +TPK%K125(:)*PCONC(:,40)*PCONC(:,38)

!PTERMS(CARBOP,K125) = -K125*<XO2>*<CARBOP>
 PTERMS(:,38,125) = -TPK%K125(:)*PCONC(:,40)*PCONC(:,38)

!PTERMS(XO2,K125) = -K125*<XO2>*<CARBOP>
 PTERMS(:,40,125) = -TPK%K125(:)*PCONC(:,40)*PCONC(:,38)

!PTERMS(XO2,K126) = -K126*<XO2>*<XO2>
 PTERMS(:,40,126) = -TPK%K126(:)*PCONC(:,40)*PCONC(:,40)

!PTERMS(NO,K127) = -K127*<XO2>*<NO>
 PTERMS(:,3,127) = -TPK%K127(:)*PCONC(:,40)*PCONC(:,3)

!PTERMS(NO2,K127) = +K127*<XO2>*<NO>
 PTERMS(:,4,127) = +TPK%K127(:)*PCONC(:,40)*PCONC(:,3)

!PTERMS(XO2,K127) = -K127*<XO2>*<NO>
 PTERMS(:,40,127) = -TPK%K127(:)*PCONC(:,40)*PCONC(:,3)

!PTERMS(NO2,K128) = +K128*<XO2>*<NO3>
 PTERMS(:,4,128) = +TPK%K128(:)*PCONC(:,40)*PCONC(:,5)

!PTERMS(NO3,K128) = -K128*<XO2>*<NO3>
 PTERMS(:,5,128) = -TPK%K128(:)*PCONC(:,40)*PCONC(:,5)

!PTERMS(XO2,K128) = -K128*<XO2>*<NO3>
 PTERMS(:,40,128) = -TPK%K128(:)*PCONC(:,40)*PCONC(:,5)

IF (LHOOK) CALL DR_HOOK('CH_TERMS',1,ZHOOK_HANDLE)
RETURN
END SUBROUTINE CH_TERMS
