!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$
! MASDEV4_7 init 2006/05/18 13:07:25
!-----------------------------------------------------------------
!     ###########################
      MODULE MODI_LIMA_READ_XKER_RDRYG
!     ###########################
!
INTERFACE
      SUBROUTINE LIMA_READ_XKER_RDRYG (KDRYLBDAG,KDRYLBDAR,KND,                   &
                    PALPHAG,PNUG,PALPHAR,PNUR,PEGR,PBR,PCG,PDG,PCR,PDR,      &
                    PDRYLBDAG_MAX,PDRYLBDAR_MAX,PDRYLBDAG_MIN,PDRYLBDAR_MIN, &
                    PFDINFTY,PKER_RDRYG                                      )
!
INTEGER, INTENT(OUT) :: KND,KDRYLBDAG,KDRYLBDAR
REAL,    INTENT(OUT) :: PALPHAG
REAL,    INTENT(OUT) :: PNUG
REAL,    INTENT(OUT) :: PALPHAR
REAL,    INTENT(OUT) :: PNUR
REAL,    INTENT(OUT) :: PEGR
REAL,    INTENT(OUT) :: PBR
REAL,    INTENT(OUT) :: PCG
REAL,    INTENT(OUT) :: PDG
REAL,    INTENT(OUT) :: PCR
REAL,    INTENT(OUT) :: PDR
REAL,    INTENT(OUT) :: PDRYLBDAG_MAX
REAL,    INTENT(OUT) :: PDRYLBDAR_MAX
REAL,    INTENT(OUT) :: PDRYLBDAG_MIN
REAL,    INTENT(OUT) :: PDRYLBDAR_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RDRYG 
!
END SUBROUTINE LIMA_READ_XKER_RDRYG
!
END INTERFACE
!
END MODULE MODI_LIMA_READ_XKER_RDRYG
!     ########################################################################
      SUBROUTINE LIMA_READ_XKER_RDRYG (KDRYLBDAG,KDRYLBDAR,KND,                   &
                    PALPHAG,PNUG,PALPHAR,PNUR,PEGR,PBR,PCG,PDG,PCR,PDR,      &
                    PDRYLBDAG_MAX,PDRYLBDAR_MAX,PDRYLBDAG_MIN,PDRYLBDAR_MIN, &
                    PFDINFTY,PKER_RDRYG                                      )
!     ########################################################################
!
!!****  * * - initialize the kernels for the snow-graupel dry growth process
!!
!!    PURPOSE
!!    -------
!!      The purpose of this routine is to initialize the kernels PKER_RDRYG
!!    prepared from a previous run of the routine INI_RAIN_ICE. The reading of
!!    the kernels is optional after checking for the dimensions of the arrays.
!!
!!**  METHOD
!!    ------
!!      
!!
!!    EXTERNAL
!!    --------
!!      None
!!     
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      None
!!
!!    REFERENCE
!!    ---------
!!      Book2 of documentation ( routine READ_XKER_RDRYG )
!!
!!    AUTHOR
!!    ------
!!      J.-P. Pinty      * Laboratoire d'Aerologie*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    09/04/96
!!
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!*       0.2   Declarations of local variables :
!
!  
INTEGER, INTENT(OUT) :: KND,KDRYLBDAG,KDRYLBDAR
REAL,    INTENT(OUT) :: PALPHAG
REAL,    INTENT(OUT) :: PNUG
REAL,    INTENT(OUT) :: PALPHAR
REAL,    INTENT(OUT) :: PNUR
REAL,    INTENT(OUT) :: PEGR
REAL,    INTENT(OUT) :: PBR
REAL,    INTENT(OUT) :: PCG
REAL,    INTENT(OUT) :: PDG
REAL,    INTENT(OUT) :: PCR
REAL,    INTENT(OUT) :: PDR
REAL,    INTENT(OUT) :: PDRYLBDAG_MAX
REAL,    INTENT(OUT) :: PDRYLBDAR_MAX
REAL,    INTENT(OUT) :: PDRYLBDAG_MIN
REAL,    INTENT(OUT) :: PDRYLBDAR_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RDRYG 
!
! ###################################################################
! #INSERT HERE THE OUTPUT OF INI_RAIN_ICE IF THE KERNELS ARE UPDATED#
! ###################################################################
!
KND= 50
KDRYLBDAG= 40
KDRYLBDAR= 40
PALPHAG= 0.100000E+01
PNUG= 0.100000E+01
PALPHAR= 0.100000E+01
PNUR= 0.200000E+01
PEGR= 0.100000E+01
PBR= 0.300000E+01
PCG= 0.122000E+03
PDG= 0.660000E+00
PCR= 0.842000E+03
PDR= 0.800000E+00
PDRYLBDAG_MAX= 0.100000E+08
PDRYLBDAR_MAX= 0.100000E+08
PDRYLBDAG_MIN= 0.100000E+04
PDRYLBDAR_MIN= 0.100000E+04
PFDINFTY= 0.200000E+02
!
IF( PRESENT(PKER_RDRYG) ) THEN
PKER_RDRYG(  1,  1) =  0.134210E+02
PKER_RDRYG(  1,  2) =  0.106490E+02
PKER_RDRYG(  1,  3) =  0.834292E+01
PKER_RDRYG(  1,  4) =  0.642847E+01
PKER_RDRYG(  1,  5) =  0.484974E+01
PKER_RDRYG(  1,  6) =  0.356945E+01
PKER_RDRYG(  1,  7) =  0.256678E+01
PKER_RDRYG(  1,  8) =  0.183093E+01
PKER_RDRYG(  1,  9) =  0.135156E+01
PKER_RDRYG(  1, 10) =  0.110260E+01
PKER_RDRYG(  1, 11) =  0.104070E+01
PKER_RDRYG(  1, 12) =  0.110897E+01
PKER_RDRYG(  1, 13) =  0.125122E+01
PKER_RDRYG(  1, 14) =  0.142283E+01
PKER_RDRYG(  1, 15) =  0.159456E+01
PKER_RDRYG(  1, 16) =  0.175135E+01
PKER_RDRYG(  1, 17) =  0.188742E+01
PKER_RDRYG(  1, 18) =  0.200233E+01
PKER_RDRYG(  1, 19) =  0.209795E+01
PKER_RDRYG(  1, 20) =  0.217687E+01
PKER_RDRYG(  1, 21) =  0.224175E+01
PKER_RDRYG(  1, 22) =  0.229504E+01
PKER_RDRYG(  1, 23) =  0.233883E+01
PKER_RDRYG(  1, 24) =  0.237485E+01
PKER_RDRYG(  1, 25) =  0.240449E+01
PKER_RDRYG(  1, 26) =  0.242888E+01
PKER_RDRYG(  1, 27) =  0.244897E+01
PKER_RDRYG(  1, 28) =  0.246553E+01
PKER_RDRYG(  1, 29) =  0.247917E+01
PKER_RDRYG(  1, 30) =  0.249042E+01
PKER_RDRYG(  1, 31) =  0.249970E+01
PKER_RDRYG(  1, 32) =  0.250735E+01
PKER_RDRYG(  1, 33) =  0.251366E+01
PKER_RDRYG(  1, 34) =  0.251887E+01
PKER_RDRYG(  1, 35) =  0.252317E+01
PKER_RDRYG(  1, 36) =  0.252671E+01
PKER_RDRYG(  1, 37) =  0.252964E+01
PKER_RDRYG(  1, 38) =  0.253206E+01
PKER_RDRYG(  1, 39) =  0.253406E+01
PKER_RDRYG(  1, 40) =  0.253571E+01
PKER_RDRYG(  2,  1) =  0.138258E+02
PKER_RDRYG(  2,  2) =  0.110664E+02
PKER_RDRYG(  2,  3) =  0.877034E+01
PKER_RDRYG(  2,  4) =  0.686001E+01
PKER_RDRYG(  2,  5) =  0.527438E+01
PKER_RDRYG(  2,  6) =  0.396820E+01
PKER_RDRYG(  2,  7) =  0.291168E+01
PKER_RDRYG(  2,  8) =  0.208952E+01
PKER_RDRYG(  2,  9) =  0.149350E+01
PKER_RDRYG(  2, 10) =  0.111353E+01
PKER_RDRYG(  2, 11) =  0.926786E+00
PKER_RDRYG(  2, 12) =  0.892818E+00
PKER_RDRYG(  2, 13) =  0.963446E+00
PKER_RDRYG(  2, 14) =  0.109105E+01
PKER_RDRYG(  2, 15) =  0.123930E+01
PKER_RDRYG(  2, 16) =  0.138520E+01
PKER_RDRYG(  2, 17) =  0.151708E+01
PKER_RDRYG(  2, 18) =  0.163089E+01
PKER_RDRYG(  2, 19) =  0.172673E+01
PKER_RDRYG(  2, 20) =  0.180633E+01
PKER_RDRYG(  2, 21) =  0.187195E+01
PKER_RDRYG(  2, 22) =  0.192586E+01
PKER_RDRYG(  2, 23) =  0.197013E+01
PKER_RDRYG(  2, 24) =  0.200651E+01
PKER_RDRYG(  2, 25) =  0.203642E+01
PKER_RDRYG(  2, 26) =  0.206103E+01
PKER_RDRYG(  2, 27) =  0.208129E+01
PKER_RDRYG(  2, 28) =  0.209797E+01
PKER_RDRYG(  2, 29) =  0.211172E+01
PKER_RDRYG(  2, 30) =  0.212304E+01
PKER_RDRYG(  2, 31) =  0.213238E+01
PKER_RDRYG(  2, 32) =  0.214007E+01
PKER_RDRYG(  2, 33) =  0.214642E+01
PKER_RDRYG(  2, 34) =  0.215166E+01
PKER_RDRYG(  2, 35) =  0.215598E+01
PKER_RDRYG(  2, 36) =  0.215954E+01
PKER_RDRYG(  2, 37) =  0.216249E+01
PKER_RDRYG(  2, 38) =  0.216492E+01
PKER_RDRYG(  2, 39) =  0.216692E+01
PKER_RDRYG(  2, 40) =  0.216858E+01
PKER_RDRYG(  3,  1) =  0.141567E+02
PKER_RDRYG(  3,  2) =  0.114089E+02
PKER_RDRYG(  3,  3) =  0.912360E+01
PKER_RDRYG(  3,  4) =  0.722169E+01
PKER_RDRYG(  3,  5) =  0.563921E+01
PKER_RDRYG(  3,  6) =  0.432602E+01
PKER_RDRYG(  3,  7) =  0.324547E+01
PKER_RDRYG(  3,  8) =  0.237429E+01
PKER_RDRYG(  3,  9) =  0.170066E+01
PKER_RDRYG(  3, 10) =  0.121912E+01
PKER_RDRYG(  3, 11) =  0.919677E+00
PKER_RDRYG(  3, 12) =  0.780708E+00
PKER_RDRYG(  3, 13) =  0.767737E+00
PKER_RDRYG(  3, 14) =  0.837693E+00
PKER_RDRYG(  3, 15) =  0.951377E+00
PKER_RDRYG(  3, 16) =  0.107910E+01
PKER_RDRYG(  3, 17) =  0.120275E+01
PKER_RDRYG(  3, 18) =  0.131354E+01
PKER_RDRYG(  3, 19) =  0.140872E+01
PKER_RDRYG(  3, 20) =  0.148863E+01
PKER_RDRYG(  3, 21) =  0.155489E+01
PKER_RDRYG(  3, 22) =  0.160944E+01
PKER_RDRYG(  3, 23) =  0.165424E+01
PKER_RDRYG(  3, 24) =  0.169103E+01
PKER_RDRYG(  3, 25) =  0.172125E+01
PKER_RDRYG(  3, 26) =  0.174610E+01
PKER_RDRYG(  3, 27) =  0.176654E+01
PKER_RDRYG(  3, 28) =  0.178336E+01
PKER_RDRYG(  3, 29) =  0.179721E+01
PKER_RDRYG(  3, 30) =  0.180862E+01
PKER_RDRYG(  3, 31) =  0.181802E+01
PKER_RDRYG(  3, 32) =  0.182577E+01
PKER_RDRYG(  3, 33) =  0.183215E+01
PKER_RDRYG(  3, 34) =  0.183742E+01
PKER_RDRYG(  3, 35) =  0.184177E+01
PKER_RDRYG(  3, 36) =  0.184535E+01
PKER_RDRYG(  3, 37) =  0.184831E+01
PKER_RDRYG(  3, 38) =  0.185075E+01
PKER_RDRYG(  3, 39) =  0.185277E+01
PKER_RDRYG(  3, 40) =  0.185443E+01
PKER_RDRYG(  4,  1) =  0.144269E+02
PKER_RDRYG(  4,  2) =  0.116888E+02
PKER_RDRYG(  4,  3) =  0.941339E+01
PKER_RDRYG(  4,  4) =  0.752068E+01
PKER_RDRYG(  4,  5) =  0.594528E+01
PKER_RDRYG(  4,  6) =  0.463440E+01
PKER_RDRYG(  4,  7) =  0.354694E+01
PKER_RDRYG(  4,  8) =  0.265338E+01
PKER_RDRYG(  4,  9) =  0.193548E+01
PKER_RDRYG(  4, 10) =  0.138447E+01
PKER_RDRYG(  4, 11) =  0.996309E+00
PKER_RDRYG(  4, 12) =  0.761568E+00
PKER_RDRYG(  4, 13) =  0.660627E+00
PKER_RDRYG(  4, 14) =  0.661754E+00
PKER_RDRYG(  4, 15) =  0.729010E+00
PKER_RDRYG(  4, 16) =  0.829397E+00
PKER_RDRYG(  4, 17) =  0.939122E+00
PKER_RDRYG(  4, 18) =  0.104378E+01
PKER_RDRYG(  4, 19) =  0.113682E+01
PKER_RDRYG(  4, 20) =  0.121638E+01
PKER_RDRYG(  4, 21) =  0.128300E+01
PKER_RDRYG(  4, 22) =  0.133814E+01
PKER_RDRYG(  4, 23) =  0.138351E+01
PKER_RDRYG(  4, 24) =  0.142074E+01
PKER_RDRYG(  4, 25) =  0.145131E+01
PKER_RDRYG(  4, 26) =  0.147642E+01
PKER_RDRYG(  4, 27) =  0.149706E+01
PKER_RDRYG(  4, 28) =  0.151403E+01
PKER_RDRYG(  4, 29) =  0.152800E+01
PKER_RDRYG(  4, 30) =  0.153950E+01
PKER_RDRYG(  4, 31) =  0.154897E+01
PKER_RDRYG(  4, 32) =  0.155678E+01
PKER_RDRYG(  4, 33) =  0.156321E+01
PKER_RDRYG(  4, 34) =  0.156851E+01
PKER_RDRYG(  4, 35) =  0.157288E+01
PKER_RDRYG(  4, 36) =  0.157649E+01
PKER_RDRYG(  4, 37) =  0.157946E+01
PKER_RDRYG(  4, 38) =  0.158192E+01
PKER_RDRYG(  4, 39) =  0.158394E+01
PKER_RDRYG(  4, 40) =  0.158562E+01
PKER_RDRYG(  5,  1) =  0.146477E+02
PKER_RDRYG(  5,  2) =  0.119175E+02
PKER_RDRYG(  5,  3) =  0.965028E+01
PKER_RDRYG(  5,  4) =  0.776596E+01
PKER_RDRYG(  5,  5) =  0.619837E+01
PKER_RDRYG(  5,  6) =  0.489342E+01
PKER_RDRYG(  5,  7) =  0.380757E+01
PKER_RDRYG(  5,  8) =  0.290717E+01
PKER_RDRYG(  5,  9) =  0.216844E+01
PKER_RDRYG(  5, 10) =  0.157730E+01
PKER_RDRYG(  5, 11) =  0.112773E+01
PKER_RDRYG(  5, 12) =  0.815273E+00
PKER_RDRYG(  5, 13) =  0.632305E+00
PKER_RDRYG(  5, 14) =  0.560193E+00
PKER_RDRYG(  5, 15) =  0.571354E+00
PKER_RDRYG(  5, 16) =  0.634685E+00
PKER_RDRYG(  5, 17) =  0.723003E+00
PKER_RDRYG(  5, 18) =  0.816915E+00
PKER_RDRYG(  5, 19) =  0.905398E+00
PKER_RDRYG(  5, 20) =  0.983467E+00
PKER_RDRYG(  5, 21) =  0.104994E+01
PKER_RDRYG(  5, 22) =  0.110547E+01
PKER_RDRYG(  5, 23) =  0.115137E+01
PKER_RDRYG(  5, 24) =  0.118909E+01
PKER_RDRYG(  5, 25) =  0.122003E+01
PKER_RDRYG(  5, 26) =  0.124544E+01
PKER_RDRYG(  5, 27) =  0.126630E+01
PKER_RDRYG(  5, 28) =  0.128345E+01
PKER_RDRYG(  5, 29) =  0.129755E+01
PKER_RDRYG(  5, 30) =  0.130915E+01
PKER_RDRYG(  5, 31) =  0.131870E+01
PKER_RDRYG(  5, 32) =  0.132657E+01
PKER_RDRYG(  5, 33) =  0.133305E+01
PKER_RDRYG(  5, 34) =  0.133839E+01
PKER_RDRYG(  5, 35) =  0.134279E+01
PKER_RDRYG(  5, 36) =  0.134641E+01
PKER_RDRYG(  5, 37) =  0.134941E+01
PKER_RDRYG(  5, 38) =  0.135188E+01
PKER_RDRYG(  5, 39) =  0.135391E+01
PKER_RDRYG(  5, 40) =  0.135559E+01
PKER_RDRYG(  6,  1) =  0.148285E+02
PKER_RDRYG(  6,  2) =  0.121043E+02
PKER_RDRYG(  6,  3) =  0.984376E+01
PKER_RDRYG(  6,  4) =  0.796646E+01
PKER_RDRYG(  6,  5) =  0.640602E+01
PKER_RDRYG(  6,  6) =  0.510770E+01
PKER_RDRYG(  6,  7) =  0.402676E+01
PKER_RDRYG(  6,  8) =  0.312733E+01
PKER_RDRYG(  6,  9) =  0.238192E+01
PKER_RDRYG(  6, 10) =  0.177145E+01
PKER_RDRYG(  6, 11) =  0.128511E+01
PKER_RDRYG(  6, 12) =  0.918271E+00
PKER_RDRYG(  6, 13) =  0.668096E+00
PKER_RDRYG(  6, 14) =  0.526360E+00
PKER_RDRYG(  6, 15) =  0.476580E+00
PKER_RDRYG(  6, 16) =  0.494226E+00
PKER_RDRYG(  6, 17) =  0.552847E+00
PKER_RDRYG(  6, 18) =  0.630007E+00
PKER_RDRYG(  6, 19) =  0.710312E+00
PKER_RDRYG(  6, 20) =  0.784988E+00
PKER_RDRYG(  6, 21) =  0.850444E+00
PKER_RDRYG(  6, 22) =  0.905977E+00
PKER_RDRYG(  6, 23) =  0.952261E+00
PKER_RDRYG(  6, 24) =  0.990455E+00
PKER_RDRYG(  6, 25) =  0.102182E+01
PKER_RDRYG(  6, 26) =  0.104755E+01
PKER_RDRYG(  6, 27) =  0.106866E+01
PKER_RDRYG(  6, 28) =  0.108600E+01
PKER_RDRYG(  6, 29) =  0.110024E+01
PKER_RDRYG(  6, 30) =  0.111196E+01
PKER_RDRYG(  6, 31) =  0.112160E+01
PKER_RDRYG(  6, 32) =  0.112953E+01
PKER_RDRYG(  6, 33) =  0.113606E+01
PKER_RDRYG(  6, 34) =  0.114144E+01
PKER_RDRYG(  6, 35) =  0.114587E+01
PKER_RDRYG(  6, 36) =  0.114953E+01
PKER_RDRYG(  6, 37) =  0.115254E+01
PKER_RDRYG(  6, 38) =  0.115502E+01
PKER_RDRYG(  6, 39) =  0.115707E+01
PKER_RDRYG(  6, 40) =  0.115876E+01
PKER_RDRYG(  7,  1) =  0.149770E+02
PKER_RDRYG(  7,  2) =  0.122574E+02
PKER_RDRYG(  7,  3) =  0.100019E+02
PKER_RDRYG(  7,  4) =  0.813025E+01
PKER_RDRYG(  7,  5) =  0.657577E+01
PKER_RDRYG(  7,  6) =  0.528352E+01
PKER_RDRYG(  7,  7) =  0.420821E+01
PKER_RDRYG(  7,  8) =  0.331283E+01
PKER_RDRYG(  7,  9) =  0.256784E+01
PKER_RDRYG(  7, 10) =  0.195082E+01
PKER_RDRYG(  7, 11) =  0.144657E+01
PKER_RDRYG(  7, 12) =  0.104687E+01
PKER_RDRYG(  7, 13) =  0.748356E+00
PKER_RDRYG(  7, 14) =  0.548446E+00
PKER_RDRYG(  7, 15) =  0.439652E+00
PKER_RDRYG(  7, 16) =  0.406642E+00
PKER_RDRYG(  7, 17) =  0.428019E+00
PKER_RDRYG(  7, 18) =  0.481606E+00
PKER_RDRYG(  7, 19) =  0.548855E+00
PKER_RDRYG(  7, 20) =  0.617296E+00
PKER_RDRYG(  7, 21) =  0.680279E+00
PKER_RDRYG(  7, 22) =  0.735137E+00
PKER_RDRYG(  7, 23) =  0.781510E+00
PKER_RDRYG(  7, 24) =  0.820079E+00
PKER_RDRYG(  7, 25) =  0.851863E+00
PKER_RDRYG(  7, 26) =  0.877947E+00
PKER_RDRYG(  7, 27) =  0.899335E+00
PKER_RDRYG(  7, 28) =  0.916884E+00
PKER_RDRYG(  7, 29) =  0.931293E+00
PKER_RDRYG(  7, 30) =  0.943132E+00
PKER_RDRYG(  7, 31) =  0.952865E+00
PKER_RDRYG(  7, 32) =  0.960872E+00
PKER_RDRYG(  7, 33) =  0.967460E+00
PKER_RDRYG(  7, 34) =  0.972885E+00
PKER_RDRYG(  7, 35) =  0.977352E+00
PKER_RDRYG(  7, 36) =  0.981033E+00
PKER_RDRYG(  7, 37) =  0.984066E+00
PKER_RDRYG(  7, 38) =  0.986565E+00
PKER_RDRYG(  7, 39) =  0.988627E+00
PKER_RDRYG(  7, 40) =  0.990326E+00
PKER_RDRYG(  8,  1) =  0.150992E+02
PKER_RDRYG(  8,  2) =  0.123831E+02
PKER_RDRYG(  8,  3) =  0.101315E+02
PKER_RDRYG(  8,  4) =  0.826417E+01
PKER_RDRYG(  8,  5) =  0.671445E+01
PKER_RDRYG(  8,  6) =  0.542727E+01
PKER_RDRYG(  8,  7) =  0.435711E+01
PKER_RDRYG(  8,  8) =  0.346649E+01
PKER_RDRYG(  8,  9) =  0.272482E+01
PKER_RDRYG(  8, 10) =  0.210780E+01
PKER_RDRYG(  8, 11) =  0.159717E+01
PKER_RDRYG(  8, 12) =  0.118083E+01
PKER_RDRYG(  8, 13) =  0.852650E+00
PKER_RDRYG(  8, 14) =  0.610124E+00
PKER_RDRYG(  8, 15) =  0.451060E+00
PKER_RDRYG(  8, 16) =  0.368291E+00
PKER_RDRYG(  8, 17) =  0.347823E+00
PKER_RDRYG(  8, 18) =  0.371281E+00
PKER_RDRYG(  8, 19) =  0.419706E+00
PKER_RDRYG(  8, 20) =  0.477953E+00
PKER_RDRYG(  8, 21) =  0.536200E+00
PKER_RDRYG(  8, 22) =  0.589265E+00
PKER_RDRYG(  8, 23) =  0.635216E+00
PKER_RDRYG(  8, 24) =  0.673937E+00
PKER_RDRYG(  8, 25) =  0.706074E+00
PKER_RDRYG(  8, 26) =  0.732525E+00
PKER_RDRYG(  8, 27) =  0.754218E+00
PKER_RDRYG(  8, 28) =  0.772002E+00
PKER_RDRYG(  8, 29) =  0.786590E+00
PKER_RDRYG(  8, 30) =  0.798567E+00
PKER_RDRYG(  8, 31) =  0.808406E+00
PKER_RDRYG(  8, 32) =  0.816494E+00
PKER_RDRYG(  8, 33) =  0.823145E+00
PKER_RDRYG(  8, 34) =  0.828619E+00
PKER_RDRYG(  8, 35) =  0.833124E+00
PKER_RDRYG(  8, 36) =  0.836834E+00
PKER_RDRYG(  8, 37) =  0.839890E+00
PKER_RDRYG(  8, 38) =  0.842408E+00
PKER_RDRYG(  8, 39) =  0.844484E+00
PKER_RDRYG(  8, 40) =  0.846195E+00
PKER_RDRYG(  9,  1) =  0.152001E+02
PKER_RDRYG(  9,  2) =  0.124866E+02
PKER_RDRYG(  9,  3) =  0.102380E+02
PKER_RDRYG(  9,  4) =  0.837392E+01
PKER_RDRYG(  9,  5) =  0.682786E+01
PKER_RDRYG(  9,  6) =  0.554471E+01
PKER_RDRYG(  9,  7) =  0.447886E+01
PKER_RDRYG(  9,  8) =  0.359262E+01
PKER_RDRYG(  9,  9) =  0.285496E+01
PKER_RDRYG(  9, 10) =  0.224062E+01
PKER_RDRYG(  9, 11) =  0.172961E+01
PKER_RDRYG(  9, 12) =  0.130712E+01
PKER_RDRYG(  9, 13) =  0.963568E+00
PKER_RDRYG(  9, 14) =  0.694236E+00
PKER_RDRYG(  9, 15) =  0.497828E+00
PKER_RDRYG(  9, 16) =  0.371725E+00
PKER_RDRYG(  9, 17) =  0.309284E+00
PKER_RDRYG(  9, 18) =  0.298254E+00
PKER_RDRYG(  9, 19) =  0.322338E+00
PKER_RDRYG(  9, 20) =  0.365743E+00
PKER_RDRYG(  9, 21) =  0.416082E+00
PKER_RDRYG(  9, 22) =  0.465554E+00
PKER_RDRYG(  9, 23) =  0.510205E+00
PKER_RDRYG(  9, 24) =  0.548676E+00
PKER_RDRYG(  9, 25) =  0.581002E+00
PKER_RDRYG(  9, 26) =  0.607778E+00
PKER_RDRYG(  9, 27) =  0.629790E+00
PKER_RDRYG(  9, 28) =  0.647834E+00
PKER_RDRYG(  9, 29) =  0.662622E+00
PKER_RDRYG(  9, 30) =  0.674751E+00
PKER_RDRYG(  9, 31) =  0.684707E+00
PKER_RDRYG(  9, 32) =  0.692884E+00
PKER_RDRYG(  9, 33) =  0.699606E+00
PKER_RDRYG(  9, 34) =  0.705133E+00
PKER_RDRYG(  9, 35) =  0.709680E+00
PKER_RDRYG(  9, 36) =  0.713422E+00
PKER_RDRYG(  9, 37) =  0.716504E+00
PKER_RDRYG(  9, 38) =  0.719042E+00
PKER_RDRYG(  9, 39) =  0.721132E+00
PKER_RDRYG(  9, 40) =  0.722855E+00
PKER_RDRYG( 10,  1) =  0.152836E+02
PKER_RDRYG( 10,  2) =  0.125721E+02
PKER_RDRYG( 10,  3) =  0.103257E+02
PKER_RDRYG( 10,  4) =  0.846410E+01
PKER_RDRYG( 10,  5) =  0.692082E+01
PKER_RDRYG( 10,  6) =  0.564078E+01
PKER_RDRYG( 10,  7) =  0.457835E+01
PKER_RDRYG( 10,  8) =  0.369576E+01
PKER_RDRYG( 10,  9) =  0.296182E+01
PKER_RDRYG( 10, 10) =  0.235084E+01
PKER_RDRYG( 10, 11) =  0.184198E+01
PKER_RDRYG( 10, 12) =  0.141881E+01
PKER_RDRYG( 10, 13) =  0.106933E+01
PKER_RDRYG( 10, 14) =  0.786016E+00
PKER_RDRYG( 10, 15) =  0.565474E+00
PKER_RDRYG( 10, 16) =  0.406543E+00
PKER_RDRYG( 10, 17) =  0.307053E+00
PKER_RDRYG( 10, 18) =  0.260725E+00
PKER_RDRYG( 10, 19) =  0.256389E+00
PKER_RDRYG( 10, 20) =  0.280106E+00
PKER_RDRYG( 10, 21) =  0.318661E+00
PKER_RDRYG( 10, 22) =  0.362054E+00
PKER_RDRYG( 10, 23) =  0.404004E+00
PKER_RDRYG( 10, 24) =  0.441559E+00
PKER_RDRYG( 10, 25) =  0.473763E+00
PKER_RDRYG( 10, 26) =  0.500741E+00
PKER_RDRYG( 10, 27) =  0.523049E+00
PKER_RDRYG( 10, 28) =  0.541369E+00
PKER_RDRYG( 10, 29) =  0.556378E+00
PKER_RDRYG( 10, 30) =  0.568677E+00
PKER_RDRYG( 10, 31) =  0.578762E+00
PKER_RDRYG( 10, 32) =  0.587040E+00
PKER_RDRYG( 10, 33) =  0.593837E+00
PKER_RDRYG( 10, 34) =  0.599424E+00
PKER_RDRYG( 10, 35) =  0.604017E+00
PKER_RDRYG( 10, 36) =  0.607795E+00
PKER_RDRYG( 10, 37) =  0.610904E+00
PKER_RDRYG( 10, 38) =  0.613463E+00
PKER_RDRYG( 10, 39) =  0.615571E+00
PKER_RDRYG( 10, 40) =  0.617307E+00
PKER_RDRYG( 11,  1) =  0.153530E+02
PKER_RDRYG( 11,  2) =  0.126429E+02
PKER_RDRYG( 11,  3) =  0.103982E+02
PKER_RDRYG( 11,  4) =  0.853842E+01
PKER_RDRYG( 11,  5) =  0.699724E+01
PKER_RDRYG( 11,  6) =  0.571954E+01
PKER_RDRYG( 11,  7) =  0.465974E+01
PKER_RDRYG( 11,  8) =  0.378005E+01
PKER_RDRYG( 11,  9) =  0.304921E+01
PKER_RDRYG( 11, 10) =  0.244139E+01
PKER_RDRYG( 11, 11) =  0.193535E+01
PKER_RDRYG( 11, 12) =  0.151386E+01
PKER_RDRYG( 11, 13) =  0.116347E+01
PKER_RDRYG( 11, 14) =  0.874451E+00
PKER_RDRYG( 11, 15) =  0.640975E+00
PKER_RDRYG( 11, 16) =  0.460649E+00
PKER_RDRYG( 11, 17) =  0.332340E+00
PKER_RDRYG( 11, 18) =  0.254216E+00
PKER_RDRYG( 11, 19) =  0.220358E+00
PKER_RDRYG( 11, 20) =  0.220732E+00
PKER_RDRYG( 11, 21) =  0.243530E+00
PKER_RDRYG( 11, 22) =  0.277653E+00
PKER_RDRYG( 11, 23) =  0.314885E+00
PKER_RDRYG( 11, 24) =  0.350439E+00
PKER_RDRYG( 11, 25) =  0.381996E+00
PKER_RDRYG( 11, 26) =  0.408939E+00
PKER_RDRYG( 11, 27) =  0.431452E+00
PKER_RDRYG( 11, 28) =  0.450036E+00
PKER_RDRYG( 11, 29) =  0.465283E+00
PKER_RDRYG( 11, 30) =  0.477770E+00
PKER_RDRYG( 11, 31) =  0.488000E+00
PKER_RDRYG( 11, 32) =  0.496387E+00
PKER_RDRYG( 11, 33) =  0.503270E+00
PKER_RDRYG( 11, 34) =  0.508921E+00
PKER_RDRYG( 11, 35) =  0.513565E+00
PKER_RDRYG( 11, 36) =  0.517382E+00
PKER_RDRYG( 11, 37) =  0.520521E+00
PKER_RDRYG( 11, 38) =  0.523104E+00
PKER_RDRYG( 11, 39) =  0.525230E+00
PKER_RDRYG( 11, 40) =  0.526981E+00
PKER_RDRYG( 12,  1) =  0.154107E+02
PKER_RDRYG( 12,  2) =  0.127017E+02
PKER_RDRYG( 12,  3) =  0.104582E+02
PKER_RDRYG( 12,  4) =  0.859986E+01
PKER_RDRYG( 12,  5) =  0.706024E+01
PKER_RDRYG( 12,  6) =  0.578430E+01
PKER_RDRYG( 12,  7) =  0.472649E+01
PKER_RDRYG( 12,  8) =  0.384903E+01
PKER_RDRYG( 12,  9) =  0.312065E+01
PKER_RDRYG( 12, 10) =  0.251546E+01
PKER_RDRYG( 12, 11) =  0.201208E+01
PKER_RDRYG( 12, 12) =  0.159294E+01
PKER_RDRYG( 12, 13) =  0.124384E+01
PKER_RDRYG( 12, 14) =  0.953734E+00
PKER_RDRYG( 12, 15) =  0.714822E+00
PKER_RDRYG( 12, 16) =  0.522561E+00
PKER_RDRYG( 12, 17) =  0.375074E+00
PKER_RDRYG( 12, 18) =  0.271992E+00
PKER_RDRYG( 12, 19) =  0.210994E+00
PKER_RDRYG( 12, 20) =  0.186793E+00
PKER_RDRYG( 12, 21) =  0.190524E+00
PKER_RDRYG( 12, 22) =  0.211914E+00
PKER_RDRYG( 12, 23) =  0.241853E+00
PKER_RDRYG( 12, 24) =  0.273771E+00
PKER_RDRYG( 12, 25) =  0.303824E+00
PKER_RDRYG( 12, 26) =  0.330330E+00
PKER_RDRYG( 12, 27) =  0.352868E+00
PKER_RDRYG( 12, 28) =  0.371654E+00
PKER_RDRYG( 12, 29) =  0.387136E+00
PKER_RDRYG( 12, 30) =  0.399827E+00
PKER_RDRYG( 12, 31) =  0.410216E+00
PKER_RDRYG( 12, 32) =  0.418726E+00
PKER_RDRYG( 12, 33) =  0.425702E+00
PKER_RDRYG( 12, 34) =  0.431426E+00
PKER_RDRYG( 12, 35) =  0.436125E+00
PKER_RDRYG( 12, 36) =  0.439985E+00
PKER_RDRYG( 12, 37) =  0.443157E+00
PKER_RDRYG( 12, 38) =  0.445766E+00
PKER_RDRYG( 12, 39) =  0.447913E+00
PKER_RDRYG( 12, 40) =  0.449679E+00
PKER_RDRYG( 13,  1) =  0.154588E+02
PKER_RDRYG( 13,  2) =  0.127507E+02
PKER_RDRYG( 13,  3) =  0.105081E+02
PKER_RDRYG( 13,  4) =  0.865080E+01
PKER_RDRYG( 13,  5) =  0.711233E+01
PKER_RDRYG( 13,  6) =  0.583772E+01
PKER_RDRYG( 13,  7) =  0.478139E+01
PKER_RDRYG( 13,  8) =  0.390560E+01
PKER_RDRYG( 13,  9) =  0.317911E+01
PKER_RDRYG( 13, 10) =  0.257601E+01
PKER_RDRYG( 13, 11) =  0.207487E+01
PKER_RDRYG( 13, 12) =  0.165798E+01
PKER_RDRYG( 13, 13) =  0.131083E+01
PKER_RDRYG( 13, 14) =  0.102169E+01
PKER_RDRYG( 13, 15) =  0.781536E+00
PKER_RDRYG( 13, 16) =  0.584105E+00
PKER_RDRYG( 13, 17) =  0.425921E+00
PKER_RDRYG( 13, 18) =  0.305717E+00
PKER_RDRYG( 13, 19) =  0.222926E+00
PKER_RDRYG( 13, 20) =  0.175670E+00
PKER_RDRYG( 13, 21) =  0.158795E+00
PKER_RDRYG( 13, 22) =  0.164617E+00
PKER_RDRYG( 13, 23) =  0.184416E+00
PKER_RDRYG( 13, 24) =  0.210615E+00
PKER_RDRYG( 13, 25) =  0.237900E+00
PKER_RDRYG( 13, 26) =  0.263298E+00
PKER_RDRYG( 13, 27) =  0.285545E+00
PKER_RDRYG( 13, 28) =  0.304391E+00
PKER_RDRYG( 13, 29) =  0.320063E+00
PKER_RDRYG( 13, 30) =  0.332961E+00
PKER_RDRYG( 13, 31) =  0.343525E+00
PKER_RDRYG( 13, 32) =  0.352171E+00
PKER_RDRYG( 13, 33) =  0.359251E+00
PKER_RDRYG( 13, 34) =  0.365054E+00
PKER_RDRYG( 13, 35) =  0.369814E+00
PKER_RDRYG( 13, 36) =  0.373722E+00
PKER_RDRYG( 13, 37) =  0.376931E+00
PKER_RDRYG( 13, 38) =  0.379569E+00
PKER_RDRYG( 13, 39) =  0.381737E+00
PKER_RDRYG( 13, 40) =  0.383521E+00
PKER_RDRYG( 14,  1) =  0.154991E+02
PKER_RDRYG( 14,  2) =  0.127916E+02
PKER_RDRYG( 14,  3) =  0.105497E+02
PKER_RDRYG( 14,  4) =  0.869314E+01
PKER_RDRYG( 14,  5) =  0.715554E+01
PKER_RDRYG( 14,  6) =  0.588191E+01
PKER_RDRYG( 14,  7) =  0.482668E+01
PKER_RDRYG( 14,  8) =  0.395215E+01
PKER_RDRYG( 14,  9) =  0.322708E+01
PKER_RDRYG( 14, 10) =  0.262557E+01
PKER_RDRYG( 14, 11) =  0.212620E+01
PKER_RDRYG( 14, 12) =  0.171122E+01
PKER_RDRYG( 14, 13) =  0.136596E+01
PKER_RDRYG( 14, 14) =  0.107842E+01
PKER_RDRYG( 14, 15) =  0.838958E+00
PKER_RDRYG( 14, 16) =  0.640183E+00
PKER_RDRYG( 14, 17) =  0.477107E+00
PKER_RDRYG( 14, 18) =  0.347057E+00
PKER_RDRYG( 14, 19) =  0.249165E+00
PKER_RDRYG( 14, 20) =  0.183013E+00
PKER_RDRYG( 14, 21) =  0.146601E+00
PKER_RDRYG( 14, 22) =  0.135353E+00
PKER_RDRYG( 14, 23) =  0.142468E+00
PKER_RDRYG( 14, 24) =  0.160555E+00
PKER_RDRYG( 14, 25) =  0.183354E+00
PKER_RDRYG( 14, 26) =  0.206635E+00
PKER_RDRYG( 14, 27) =  0.228070E+00
PKER_RDRYG( 14, 28) =  0.246738E+00
PKER_RDRYG( 14, 29) =  0.262495E+00
PKER_RDRYG( 14, 30) =  0.275569E+00
PKER_RDRYG( 14, 31) =  0.286313E+00
PKER_RDRYG( 14, 32) =  0.295107E+00
PKER_RDRYG( 14, 33) =  0.302303E+00
PKER_RDRYG( 14, 34) =  0.308195E+00
PKER_RDRYG( 14, 35) =  0.313023E+00
PKER_RDRYG( 14, 36) =  0.316982E+00
PKER_RDRYG( 14, 37) =  0.320232E+00
PKER_RDRYG( 14, 38) =  0.322901E+00
PKER_RDRYG( 14, 39) =  0.325094E+00
PKER_RDRYG( 14, 40) =  0.326896E+00
PKER_RDRYG( 15,  1) =  0.155328E+02
PKER_RDRYG( 15,  2) =  0.128258E+02
PKER_RDRYG( 15,  3) =  0.105844E+02
PKER_RDRYG( 15,  4) =  0.872843E+01
PKER_RDRYG( 15,  5) =  0.719148E+01
PKER_RDRYG( 15,  6) =  0.591857E+01
PKER_RDRYG( 15,  7) =  0.486417E+01
PKER_RDRYG( 15,  8) =  0.399057E+01
PKER_RDRYG( 15,  9) =  0.326656E+01
PKER_RDRYG( 15, 10) =  0.266625E+01
PKER_RDRYG( 15, 11) =  0.216823E+01
PKER_RDRYG( 15, 12) =  0.175475E+01
PKER_RDRYG( 15, 13) =  0.141110E+01
PKER_RDRYG( 15, 14) =  0.112517E+01
PKER_RDRYG( 15, 15) =  0.887014E+00
PKER_RDRYG( 15, 16) =  0.688694E+00
PKER_RDRYG( 15, 17) =  0.524210E+00
PKER_RDRYG( 15, 18) =  0.389564E+00
PKER_RDRYG( 15, 19) =  0.282710E+00
PKER_RDRYG( 15, 20) =  0.203209E+00
PKER_RDRYG( 15, 21) =  0.150500E+00
PKER_RDRYG( 15, 22) =  0.122720E+00
PKER_RDRYG( 15, 23) =  0.115684E+00
PKER_RDRYG( 15, 24) =  0.123454E+00
PKER_RDRYG( 15, 25) =  0.139800E+00
PKER_RDRYG( 15, 26) =  0.159573E+00
PKER_RDRYG( 15, 27) =  0.179400E+00
PKER_RDRYG( 15, 28) =  0.197477E+00
PKER_RDRYG( 15, 29) =  0.213128E+00
PKER_RDRYG( 15, 30) =  0.226299E+00
PKER_RDRYG( 15, 31) =  0.237204E+00
PKER_RDRYG( 15, 32) =  0.246155E+00
PKER_RDRYG( 15, 33) =  0.253478E+00
PKER_RDRYG( 15, 34) =  0.259467E+00
PKER_RDRYG( 15, 35) =  0.264371E+00
PKER_RDRYG( 15, 36) =  0.268388E+00
PKER_RDRYG( 15, 37) =  0.271682E+00
PKER_RDRYG( 15, 38) =  0.274385E+00
PKER_RDRYG( 15, 39) =  0.276605E+00
PKER_RDRYG( 15, 40) =  0.278428E+00
PKER_RDRYG( 16,  1) =  0.155611E+02
PKER_RDRYG( 16,  2) =  0.128544E+02
PKER_RDRYG( 16,  3) =  0.106134E+02
PKER_RDRYG( 16,  4) =  0.875790E+01
PKER_RDRYG( 16,  5) =  0.722144E+01
PKER_RDRYG( 16,  6) =  0.594908E+01
PKER_RDRYG( 16,  7) =  0.489528E+01
PKER_RDRYG( 16,  8) =  0.402238E+01
PKER_RDRYG( 16,  9) =  0.329915E+01
PKER_RDRYG( 16, 10) =  0.269974E+01
PKER_RDRYG( 16, 11) =  0.220274E+01
PKER_RDRYG( 16, 12) =  0.179040E+01
PKER_RDRYG( 16, 13) =  0.144802E+01
PKER_RDRYG( 16, 14) =  0.116345E+01
PKER_RDRYG( 16, 15) =  0.926641E+00
PKER_RDRYG( 16, 16) =  0.729392E+00
PKER_RDRYG( 16, 17) =  0.565165E+00
PKER_RDRYG( 16, 18) =  0.429078E+00
PKER_RDRYG( 16, 19) =  0.317968E+00
PKER_RDRYG( 16, 20) =  0.230366E+00
PKER_RDRYG( 16, 21) =  0.165832E+00
PKER_RDRYG( 16, 22) =  0.123999E+00
PKER_RDRYG( 16, 23) =  0.102998E+00
PKER_RDRYG( 16, 24) =  0.991169E-01
PKER_RDRYG( 16, 25) =  0.107099E+00
PKER_RDRYG( 16, 26) =  0.121727E+00
PKER_RDRYG( 16, 27) =  0.138829E+00
PKER_RDRYG( 16, 28) =  0.155681E+00
PKER_RDRYG( 16, 29) =  0.170911E+00
PKER_RDRYG( 16, 30) =  0.184033E+00
PKER_RDRYG( 16, 31) =  0.195040E+00
PKER_RDRYG( 16, 32) =  0.204136E+00
PKER_RDRYG( 16, 33) =  0.211593E+00
PKER_RDRYG( 16, 34) =  0.217691E+00
PKER_RDRYG( 16, 35) =  0.222677E+00
PKER_RDRYG( 16, 36) =  0.226759E+00
PKER_RDRYG( 16, 37) =  0.230102E+00
PKER_RDRYG( 16, 38) =  0.232843E+00
PKER_RDRYG( 16, 39) =  0.235091E+00
PKER_RDRYG( 16, 40) =  0.236937E+00
PKER_RDRYG( 17,  1) =  0.155848E+02
PKER_RDRYG( 17,  2) =  0.128785E+02
PKER_RDRYG( 17,  3) =  0.106378E+02
PKER_RDRYG( 17,  4) =  0.878258E+01
PKER_RDRYG( 17,  5) =  0.724648E+01
PKER_RDRYG( 17,  6) =  0.597452E+01
PKER_RDRYG( 17,  7) =  0.492118E+01
PKER_RDRYG( 17,  8) =  0.404879E+01
PKER_RDRYG( 17,  9) =  0.332615E+01
PKER_RDRYG( 17, 10) =  0.272740E+01
PKER_RDRYG( 17, 11) =  0.223115E+01
PKER_RDRYG( 17, 12) =  0.181967E+01
PKER_RDRYG( 17, 13) =  0.147827E+01
PKER_RDRYG( 17, 14) =  0.119477E+01
PKER_RDRYG( 17, 15) =  0.959115E+00
PKER_RDRYG( 17, 16) =  0.762992E+00
PKER_RDRYG( 17, 17) =  0.599624E+00
PKER_RDRYG( 17, 18) =  0.463642E+00
PKER_RDRYG( 17, 19) =  0.351078E+00
PKER_RDRYG( 17, 20) =  0.259445E+00
PKER_RDRYG( 17, 21) =  0.187672E+00
PKER_RDRYG( 17, 22) =  0.135435E+00
PKER_RDRYG( 17, 23) =  0.102368E+00
PKER_RDRYG( 17, 24) =  0.867396E-01
PKER_RDRYG( 17, 25) =  0.850688E-01
PKER_RDRYG( 17, 26) =  0.929638E-01
PKER_RDRYG( 17, 27) =  0.105991E+00
PKER_RDRYG( 17, 28) =  0.120728E+00
PKER_RDRYG( 17, 29) =  0.135039E+00
PKER_RDRYG( 17, 30) =  0.147861E+00
PKER_RDRYG( 17, 31) =  0.158856E+00
PKER_RDRYG( 17, 32) =  0.168054E+00
PKER_RDRYG( 17, 33) =  0.175640E+00
PKER_RDRYG( 17, 34) =  0.181854E+00
PKER_RDRYG( 17, 35) =  0.186932E+00
PKER_RDRYG( 17, 36) =  0.191084E+00
PKER_RDRYG( 17, 37) =  0.194481E+00
PKER_RDRYG( 17, 38) =  0.197264E+00
PKER_RDRYG( 17, 39) =  0.199545E+00
PKER_RDRYG( 17, 40) =  0.201416E+00
PKER_RDRYG( 18,  1) =  0.156048E+02
PKER_RDRYG( 18,  2) =  0.128987E+02
PKER_RDRYG( 18,  3) =  0.106582E+02
PKER_RDRYG( 18,  4) =  0.880327E+01
PKER_RDRYG( 18,  5) =  0.726745E+01
PKER_RDRYG( 18,  6) =  0.599579E+01
PKER_RDRYG( 18,  7) =  0.494280E+01
PKER_RDRYG( 18,  8) =  0.407079E+01
PKER_RDRYG( 18,  9) =  0.334857E+01
PKER_RDRYG( 18, 10) =  0.275031E+01
PKER_RDRYG( 18, 11) =  0.225462E+01
PKER_RDRYG( 18, 12) =  0.184378E+01
PKER_RDRYG( 18, 13) =  0.150310E+01
PKER_RDRYG( 18, 14) =  0.122043E+01
PKER_RDRYG( 18, 15) =  0.985691E+00
PKER_RDRYG( 18, 16) =  0.790542E+00
PKER_RDRYG( 18, 17) =  0.628114E+00
PKER_RDRYG( 18, 18) =  0.492811E+00
PKER_RDRYG( 18, 19) =  0.380219E+00
PKER_RDRYG( 18, 20) =  0.287142E+00
PKER_RDRYG( 18, 21) =  0.211629E+00
PKER_RDRYG( 18, 22) =  0.152851E+00
PKER_RDRYG( 18, 23) =  0.110724E+00
PKER_RDRYG( 18, 24) =  0.847137E-01
PKER_RDRYG( 18, 25) =  0.732323E-01
PKER_RDRYG( 18, 26) =  0.732076E-01
PKER_RDRYG( 18, 27) =  0.807748E-01
PKER_RDRYG( 18, 28) =  0.922834E-01
PKER_RDRYG( 18, 29) =  0.104948E+00
PKER_RDRYG( 18, 30) =  0.117078E+00
PKER_RDRYG( 18, 31) =  0.127868E+00
PKER_RDRYG( 18, 32) =  0.137079E+00
PKER_RDRYG( 18, 33) =  0.144764E+00
PKER_RDRYG( 18, 34) =  0.151091E+00
PKER_RDRYG( 18, 35) =  0.156269E+00
PKER_RDRYG( 18, 36) =  0.160499E+00
PKER_RDRYG( 18, 37) =  0.163956E+00
PKER_RDRYG( 18, 38) =  0.166785E+00
PKER_RDRYG( 18, 39) =  0.169102E+00
PKER_RDRYG( 18, 40) =  0.171000E+00
PKER_RDRYG( 19,  1) =  0.156217E+02
PKER_RDRYG( 19,  2) =  0.129157E+02
PKER_RDRYG( 19,  3) =  0.106754E+02
PKER_RDRYG( 19,  4) =  0.882064E+01
PKER_RDRYG( 19,  5) =  0.728503E+01
PKER_RDRYG( 19,  6) =  0.601361E+01
PKER_RDRYG( 19,  7) =  0.496087E+01
PKER_RDRYG( 19,  8) =  0.408915E+01
PKER_RDRYG( 19,  9) =  0.336725E+01
PKER_RDRYG( 19, 10) =  0.276936E+01
PKER_RDRYG( 19, 11) =  0.227408E+01
PKER_RDRYG( 19, 12) =  0.186371E+01
PKER_RDRYG( 19, 13) =  0.152357E+01
PKER_RDRYG( 19, 14) =  0.124151E+01
PKER_RDRYG( 19, 15) =  0.100747E+01
PKER_RDRYG( 19, 16) =  0.813095E+00
PKER_RDRYG( 19, 17) =  0.651490E+00
PKER_RDRYG( 19, 18) =  0.516968E+00
PKER_RDRYG( 19, 19) =  0.404911E+00
PKER_RDRYG( 19, 20) =  0.311706E+00
PKER_RDRYG( 19, 21) =  0.234763E+00
PKER_RDRYG( 19, 22) =  0.172575E+00
PKER_RDRYG( 19, 23) =  0.124563E+00
PKER_RDRYG( 19, 24) =  0.906076E-01
PKER_RDRYG( 19, 25) =  0.702940E-01
PKER_RDRYG( 19, 26) =  0.620081E-01
PKER_RDRYG( 19, 27) =  0.630865E-01
PKER_RDRYG( 19, 28) =  0.702057E-01
PKER_RDRYG( 19, 29) =  0.803254E-01
PKER_RDRYG( 19, 30) =  0.911904E-01
PKER_RDRYG( 19, 31) =  0.101465E+00
PKER_RDRYG( 19, 32) =  0.110536E+00
PKER_RDRYG( 19, 33) =  0.118251E+00
PKER_RDRYG( 19, 34) =  0.124670E+00
PKER_RDRYG( 19, 35) =  0.129948E+00
PKER_RDRYG( 19, 36) =  0.134262E+00
PKER_RDRYG( 19, 37) =  0.137786E+00
PKER_RDRYG( 19, 38) =  0.140666E+00
PKER_RDRYG( 19, 39) =  0.143022E+00
PKER_RDRYG( 19, 40) =  0.144951E+00
PKER_RDRYG( 20,  1) =  0.156359E+02
PKER_RDRYG( 20,  2) =  0.129300E+02
PKER_RDRYG( 20,  3) =  0.106899E+02
PKER_RDRYG( 20,  4) =  0.883526E+01
PKER_RDRYG( 20,  5) =  0.729981E+01
PKER_RDRYG( 20,  6) =  0.602856E+01
PKER_RDRYG( 20,  7) =  0.497602E+01
PKER_RDRYG( 20,  8) =  0.410451E+01
PKER_RDRYG( 20,  9) =  0.338285E+01
PKER_RDRYG( 20, 10) =  0.278523E+01
PKER_RDRYG( 20, 11) =  0.229026E+01
PKER_RDRYG( 20, 12) =  0.188023E+01
PKER_RDRYG( 20, 13) =  0.154049E+01
PKER_RDRYG( 20, 14) =  0.125889E+01
PKER_RDRYG( 20, 15) =  0.102536E+01
PKER_RDRYG( 20, 16) =  0.831581E+00
PKER_RDRYG( 20, 17) =  0.670632E+00
PKER_RDRYG( 20, 18) =  0.536803E+00
PKER_RDRYG( 20, 19) =  0.425393E+00
PKER_RDRYG( 20, 20) =  0.332592E+00
PKER_RDRYG( 20, 21) =  0.255441E+00
PKER_RDRYG( 20, 22) =  0.191863E+00
PKER_RDRYG( 20, 23) =  0.140678E+00
PKER_RDRYG( 20, 24) =  0.101505E+00
PKER_RDRYG( 20, 25) =  0.742493E-01
PKER_RDRYG( 20, 26) =  0.584264E-01
PKER_RDRYG( 20, 27) =  0.526432E-01
PKER_RDRYG( 20, 28) =  0.544495E-01
PKER_RDRYG( 20, 29) =  0.610513E-01
PKER_RDRYG( 20, 30) =  0.699078E-01
PKER_RDRYG( 20, 31) =  0.792045E-01
PKER_RDRYG( 20, 32) =  0.878929E-01
PKER_RDRYG( 20, 33) =  0.955190E-01
PKER_RDRYG( 20, 34) =  0.101978E+00
PKER_RDRYG( 20, 35) =  0.107340E+00
PKER_RDRYG( 20, 36) =  0.111742E+00
PKER_RDRYG( 20, 37) =  0.115338E+00
PKER_RDRYG( 20, 38) =  0.118274E+00
PKER_RDRYG( 20, 39) =  0.120673E+00
PKER_RDRYG( 20, 40) =  0.122635E+00
PKER_RDRYG( 21,  1) =  0.156479E+02
PKER_RDRYG( 21,  2) =  0.129421E+02
PKER_RDRYG( 21,  3) =  0.107021E+02
PKER_RDRYG( 21,  4) =  0.884758E+01
PKER_RDRYG( 21,  5) =  0.731225E+01
PKER_RDRYG( 21,  6) =  0.604114E+01
PKER_RDRYG( 21,  7) =  0.498874E+01
PKER_RDRYG( 21,  8) =  0.411739E+01
PKER_RDRYG( 21,  9) =  0.339591E+01
PKER_RDRYG( 21, 10) =  0.279849E+01
PKER_RDRYG( 21, 11) =  0.230374E+01
PKER_RDRYG( 21, 12) =  0.189397E+01
PKER_RDRYG( 21, 13) =  0.155452E+01
PKER_RDRYG( 21, 14) =  0.127326E+01
PKER_RDRYG( 21, 15) =  0.104012E+01
PKER_RDRYG( 21, 16) =  0.846776E+00
PKER_RDRYG( 21, 17) =  0.686327E+00
PKER_RDRYG( 21, 18) =  0.553054E+00
PKER_RDRYG( 21, 19) =  0.442227E+00
PKER_RDRYG( 21, 20) =  0.349958E+00
PKER_RDRYG( 21, 21) =  0.273107E+00
PKER_RDRYG( 21, 22) =  0.209258E+00
PKER_RDRYG( 21, 23) =  0.156741E+00
PKER_RDRYG( 21, 24) =  0.114650E+00
PKER_RDRYG( 21, 25) =  0.827499E-01
PKER_RDRYG( 21, 26) =  0.609346E-01
PKER_RDRYG( 21, 27) =  0.487447E-01
PKER_RDRYG( 21, 28) =  0.448236E-01
PKER_RDRYG( 21, 29) =  0.470754E-01
PKER_RDRYG( 21, 30) =  0.531032E-01
PKER_RDRYG( 21, 31) =  0.608204E-01
PKER_RDRYG( 21, 32) =  0.687615E-01
PKER_RDRYG( 21, 33) =  0.761062E-01
PKER_RDRYG( 21, 34) =  0.825119E-01
PKER_RDRYG( 21, 35) =  0.879190E-01
PKER_RDRYG( 21, 36) =  0.923978E-01
PKER_RDRYG( 21, 37) =  0.960692E-01
PKER_RDRYG( 21, 38) =  0.990669E-01
PKER_RDRYG( 21, 39) =  0.101514E+00
PKER_RDRYG( 21, 40) =  0.103513E+00
PKER_RDRYG( 22,  1) =  0.156580E+02
PKER_RDRYG( 22,  2) =  0.129523E+02
PKER_RDRYG( 22,  3) =  0.107124E+02
PKER_RDRYG( 22,  4) =  0.885797E+01
PKER_RDRYG( 22,  5) =  0.732273E+01
PKER_RDRYG( 22,  6) =  0.605172E+01
PKER_RDRYG( 22,  7) =  0.499943E+01
PKER_RDRYG( 22,  8) =  0.412821E+01
PKER_RDRYG( 22,  9) =  0.340686E+01
PKER_RDRYG( 22, 10) =  0.280959E+01
PKER_RDRYG( 22, 11) =  0.231501E+01
PKER_RDRYG( 22, 12) =  0.190543E+01
PKER_RDRYG( 22, 13) =  0.156620E+01
PKER_RDRYG( 22, 14) =  0.128518E+01
PKER_RDRYG( 22, 15) =  0.105232E+01
PKER_RDRYG( 22, 16) =  0.859305E+00
PKER_RDRYG( 22, 17) =  0.699230E+00
PKER_RDRYG( 22, 18) =  0.566381E+00
PKER_RDRYG( 22, 19) =  0.456024E+00
PKER_RDRYG( 22, 20) =  0.364245E+00
PKER_RDRYG( 22, 21) =  0.287830E+00
PKER_RDRYG( 22, 22) =  0.224192E+00
PKER_RDRYG( 22, 23) =  0.171359E+00
PKER_RDRYG( 22, 24) =  0.128001E+00
PKER_RDRYG( 22, 25) =  0.934489E-01
PKER_RDRYG( 22, 26) =  0.674901E-01
PKER_RDRYG( 22, 27) =  0.500882E-01
PKER_RDRYG( 22, 28) =  0.407416E-01
PKER_RDRYG( 22, 29) =  0.382527E-01
PKER_RDRYG( 22, 30) =  0.407450E-01
PKER_RDRYG( 22, 31) =  0.462007E-01
PKER_RDRYG( 22, 32) =  0.529000E-01
PKER_RDRYG( 22, 33) =  0.596709E-01
PKER_RDRYG( 22, 34) =  0.658722E-01
PKER_RDRYG( 22, 35) =  0.712512E-01
PKER_RDRYG( 22, 36) =  0.757772E-01
PKER_RDRYG( 22, 37) =  0.795178E-01
PKER_RDRYG( 22, 38) =  0.825803E-01
PKER_RDRYG( 22, 39) =  0.850795E-01
PKER_RDRYG( 22, 40) =  0.871191E-01
PKER_RDRYG( 23,  1) =  0.156666E+02
PKER_RDRYG( 23,  2) =  0.129610E+02
PKER_RDRYG( 23,  3) =  0.107211E+02
PKER_RDRYG( 23,  4) =  0.886674E+01
PKER_RDRYG( 23,  5) =  0.733158E+01
PKER_RDRYG( 23,  6) =  0.606064E+01
PKER_RDRYG( 23,  7) =  0.500844E+01
PKER_RDRYG( 23,  8) =  0.413730E+01
PKER_RDRYG( 23,  9) =  0.341606E+01
PKER_RDRYG( 23, 10) =  0.281890E+01
PKER_RDRYG( 23, 11) =  0.232445E+01
PKER_RDRYG( 23, 12) =  0.191501E+01
PKER_RDRYG( 23, 13) =  0.157594E+01
PKER_RDRYG( 23, 14) =  0.129510E+01
PKER_RDRYG( 23, 15) =  0.106245E+01
PKER_RDRYG( 23, 16) =  0.869674E+00
PKER_RDRYG( 23, 17) =  0.709873E+00
PKER_RDRYG( 23, 18) =  0.577340E+00
PKER_RDRYG( 23, 19) =  0.467343E+00
PKER_RDRYG( 23, 20) =  0.375961E+00
PKER_RDRYG( 23, 21) =  0.299956E+00
PKER_RDRYG( 23, 22) =  0.236671E+00
PKER_RDRYG( 23, 23) =  0.183979E+00
PKER_RDRYG( 23, 24) =  0.140272E+00
PKER_RDRYG( 23, 25) =  0.104494E+00
PKER_RDRYG( 23, 26) =  0.761340E-01
PKER_RDRYG( 23, 27) =  0.550738E-01
PKER_RDRYG( 23, 28) =  0.412380E-01
PKER_RDRYG( 23, 29) =  0.341626E-01
PKER_RDRYG( 23, 30) =  0.327198E-01
PKER_RDRYG( 23, 31) =  0.353014E-01
PKER_RDRYG( 23, 32) =  0.401947E-01
PKER_RDRYG( 23, 33) =  0.459971E-01
PKER_RDRYG( 23, 34) =  0.517601E-01
PKER_RDRYG( 23, 35) =  0.569916E-01
PKER_RDRYG( 23, 36) =  0.615074E-01
PKER_RDRYG( 23, 37) =  0.652947E-01
PKER_RDRYG( 23, 38) =  0.684187E-01
PKER_RDRYG( 23, 39) =  0.709735E-01
PKER_RDRYG( 23, 40) =  0.730575E-01
PKER_RDRYG( 24,  1) =  0.156739E+02
PKER_RDRYG( 24,  2) =  0.129683E+02
PKER_RDRYG( 24,  3) =  0.107284E+02
PKER_RDRYG( 24,  4) =  0.887415E+01
PKER_RDRYG( 24,  5) =  0.733905E+01
PKER_RDRYG( 24,  6) =  0.606817E+01
PKER_RDRYG( 24,  7) =  0.501603E+01
PKER_RDRYG( 24,  8) =  0.414497E+01
PKER_RDRYG( 24,  9) =  0.342381E+01
PKER_RDRYG( 24, 10) =  0.282673E+01
PKER_RDRYG( 24, 11) =  0.233237E+01
PKER_RDRYG( 24, 12) =  0.192304E+01
PKER_RDRYG( 24, 13) =  0.158408E+01
PKER_RDRYG( 24, 14) =  0.130338E+01
PKER_RDRYG( 24, 15) =  0.107089E+01
PKER_RDRYG( 24, 16) =  0.878282E+00
PKER_RDRYG( 24, 17) =  0.718684E+00
PKER_RDRYG( 24, 18) =  0.586383E+00
PKER_RDRYG( 24, 19) =  0.476653E+00
PKER_RDRYG( 24, 20) =  0.385576E+00
PKER_RDRYG( 24, 21) =  0.309906E+00
PKER_RDRYG( 24, 22) =  0.246964E+00
PKER_RDRYG( 24, 23) =  0.194554E+00
PKER_RDRYG( 24, 24) =  0.150927E+00
PKER_RDRYG( 24, 25) =  0.114779E+00
PKER_RDRYG( 24, 26) =  0.852750E-01
PKER_RDRYG( 24, 27) =  0.620279E-01
PKER_RDRYG( 24, 28) =  0.449765E-01
PKER_RDRYG( 24, 29) =  0.340278E-01
PKER_RDRYG( 24, 30) =  0.287248E-01
PKER_RDRYG( 24, 31) =  0.280506E-01
PKER_RDRYG( 24, 32) =  0.306122E-01
PKER_RDRYG( 24, 33) =  0.349754E-01
PKER_RDRYG( 24, 34) =  0.399788E-01
PKER_RDRYG( 24, 35) =  0.448785E-01
PKER_RDRYG( 24, 36) =  0.492896E-01
PKER_RDRYG( 24, 37) =  0.530789E-01
PKER_RDRYG( 24, 38) =  0.562478E-01
PKER_RDRYG( 24, 39) =  0.588567E-01
PKER_RDRYG( 24, 40) =  0.609882E-01
PKER_RDRYG( 25,  1) =  0.156801E+02
PKER_RDRYG( 25,  2) =  0.129745E+02
PKER_RDRYG( 25,  3) =  0.107347E+02
PKER_RDRYG( 25,  4) =  0.888043E+01
PKER_RDRYG( 25,  5) =  0.734536E+01
PKER_RDRYG( 25,  6) =  0.607453E+01
PKER_RDRYG( 25,  7) =  0.502245E+01
PKER_RDRYG( 25,  8) =  0.415144E+01
PKER_RDRYG( 25,  9) =  0.343033E+01
PKER_RDRYG( 25, 10) =  0.283332E+01
PKER_RDRYG( 25, 11) =  0.233903E+01
PKER_RDRYG( 25, 12) =  0.192978E+01
PKER_RDRYG( 25, 13) =  0.159091E+01
PKER_RDRYG( 25, 14) =  0.131031E+01
PKER_RDRYG( 25, 15) =  0.107793E+01
PKER_RDRYG( 25, 16) =  0.885452E+00
PKER_RDRYG( 25, 17) =  0.726001E+00
PKER_RDRYG( 25, 18) =  0.593871E+00
PKER_RDRYG( 25, 19) =  0.484338E+00
PKER_RDRYG( 25, 20) =  0.393487E+00
PKER_RDRYG( 25, 21) =  0.318075E+00
PKER_RDRYG( 25, 22) =  0.255416E+00
PKER_RDRYG( 25, 23) =  0.203291E+00
PKER_RDRYG( 25, 24) =  0.159889E+00
PKER_RDRYG( 25, 25) =  0.123773E+00
PKER_RDRYG( 25, 26) =  0.938825E-01
PKER_RDRYG( 25, 27) =  0.695667E-01
PKER_RDRYG( 25, 28) =  0.505383E-01
PKER_RDRYG( 25, 29) =  0.367602E-01
PKER_RDRYG( 25, 30) =  0.281404E-01
PKER_RDRYG( 25, 31) =  0.242165E-01
PKER_RDRYG( 25, 32) =  0.240985E-01
PKER_RDRYG( 25, 33) =  0.265682E-01
PKER_RDRYG( 25, 34) =  0.304264E-01
PKER_RDRYG( 25, 35) =  0.347350E-01
PKER_RDRYG( 25, 36) =  0.388954E-01
PKER_RDRYG( 25, 37) =  0.426118E-01
PKER_RDRYG( 25, 38) =  0.457911E-01
PKER_RDRYG( 25, 39) =  0.484422E-01
PKER_RDRYG( 25, 40) =  0.506210E-01
PKER_RDRYG( 26,  1) =  0.156853E+02
PKER_RDRYG( 26,  2) =  0.129797E+02
PKER_RDRYG( 26,  3) =  0.107400E+02
PKER_RDRYG( 26,  4) =  0.888574E+01
PKER_RDRYG( 26,  5) =  0.735071E+01
PKER_RDRYG( 26,  6) =  0.607992E+01
PKER_RDRYG( 26,  7) =  0.502787E+01
PKER_RDRYG( 26,  8) =  0.415690E+01
PKER_RDRYG( 26,  9) =  0.343584E+01
PKER_RDRYG( 26, 10) =  0.283888E+01
PKER_RDRYG( 26, 11) =  0.234464E+01
PKER_RDRYG( 26, 12) =  0.193545E+01
PKER_RDRYG( 26, 13) =  0.159665E+01
PKER_RDRYG( 26, 14) =  0.131612E+01
PKER_RDRYG( 26, 15) =  0.108382E+01
PKER_RDRYG( 26, 16) =  0.891439E+00
PKER_RDRYG( 26, 17) =  0.732097E+00
PKER_RDRYG( 26, 18) =  0.600091E+00
PKER_RDRYG( 26, 19) =  0.490702E+00
PKER_RDRYG( 26, 20) =  0.400018E+00
PKER_RDRYG( 26, 21) =  0.324798E+00
PKER_RDRYG( 26, 22) =  0.262357E+00
PKER_RDRYG( 26, 23) =  0.210471E+00
PKER_RDRYG( 26, 24) =  0.167304E+00
PKER_RDRYG( 26, 25) =  0.131363E+00
PKER_RDRYG( 26, 26) =  0.101467E+00
PKER_RDRYG( 26, 27) =  0.767609E-01
PKER_RDRYG( 26, 28) =  0.567283E-01
PKER_RDRYG( 26, 29) =  0.411794E-01
PKER_RDRYG( 26, 30) =  0.300747E-01
PKER_RDRYG( 26, 31) =  0.233080E-01
PKER_RDRYG( 26, 32) =  0.204716E-01
PKER_RDRYG( 26, 33) =  0.207372E-01
PKER_RDRYG( 26, 34) =  0.230713E-01
PKER_RDRYG( 26, 35) =  0.264699E-01
PKER_RDRYG( 26, 36) =  0.301689E-01
PKER_RDRYG( 26, 37) =  0.336958E-01
PKER_RDRYG( 26, 38) =  0.368256E-01
PKER_RDRYG( 26, 39) =  0.394921E-01
PKER_RDRYG( 26, 40) =  0.417098E-01
PKER_RDRYG( 27,  1) =  0.156897E+02
PKER_RDRYG( 27,  2) =  0.129842E+02
PKER_RDRYG( 27,  3) =  0.107444E+02
PKER_RDRYG( 27,  4) =  0.889024E+01
PKER_RDRYG( 27,  5) =  0.735524E+01
PKER_RDRYG( 27,  6) =  0.608447E+01
PKER_RDRYG( 27,  7) =  0.503245E+01
PKER_RDRYG( 27,  8) =  0.416152E+01
PKER_RDRYG( 27,  9) =  0.344049E+01
PKER_RDRYG( 27, 10) =  0.284357E+01
PKER_RDRYG( 27, 11) =  0.234937E+01
PKER_RDRYG( 27, 12) =  0.194022E+01
PKER_RDRYG( 27, 13) =  0.160147E+01
PKER_RDRYG( 27, 14) =  0.132100E+01
PKER_RDRYG( 27, 15) =  0.108876E+01
PKER_RDRYG( 27, 16) =  0.896452E+00
PKER_RDRYG( 27, 17) =  0.737189E+00
PKER_RDRYG( 27, 18) =  0.605275E+00
PKER_RDRYG( 27, 19) =  0.495991E+00
PKER_RDRYG( 27, 20) =  0.405429E+00
PKER_RDRYG( 27, 21) =  0.330350E+00
PKER_RDRYG( 27, 22) =  0.268071E+00
PKER_RDRYG( 27, 23) =  0.216369E+00
PKER_RDRYG( 27, 24) =  0.173404E+00
PKER_RDRYG( 27, 25) =  0.137657E+00
PKER_RDRYG( 27, 26) =  0.107894E+00
PKER_RDRYG( 27, 27) =  0.831508E-01
PKER_RDRYG( 27, 28) =  0.627371E-01
PKER_RDRYG( 27, 29) =  0.462532E-01
PKER_RDRYG( 27, 30) =  0.335602E-01
PKER_RDRYG( 27, 31) =  0.246352E-01
PKER_RDRYG( 27, 32) =  0.193701E-01
PKER_RDRYG( 27, 33) =  0.173556E-01
PKER_RDRYG( 27, 34) =  0.178767E-01
PKER_RDRYG( 27, 35) =  0.200407E-01
PKER_RDRYG( 27, 36) =  0.230216E-01
PKER_RDRYG( 27, 37) =  0.261908E-01
PKER_RDRYG( 27, 38) =  0.291792E-01
PKER_RDRYG( 27, 39) =  0.318140E-01
PKER_RDRYG( 27, 40) =  0.340498E-01
PKER_RDRYG( 28,  1) =  0.156935E+02
PKER_RDRYG( 28,  2) =  0.129880E+02
PKER_RDRYG( 28,  3) =  0.107482E+02
PKER_RDRYG( 28,  4) =  0.889406E+01
PKER_RDRYG( 28,  5) =  0.735908E+01
PKER_RDRYG( 28,  6) =  0.608833E+01
PKER_RDRYG( 28,  7) =  0.503634E+01
PKER_RDRYG( 28,  8) =  0.416543E+01
PKER_RDRYG( 28,  9) =  0.344443E+01
PKER_RDRYG( 28, 10) =  0.284753E+01
PKER_RDRYG( 28, 11) =  0.235337E+01
PKER_RDRYG( 28, 12) =  0.194425E+01
PKER_RDRYG( 28, 13) =  0.160554E+01
PKER_RDRYG( 28, 14) =  0.132511E+01
PKER_RDRYG( 28, 15) =  0.109292E+01
PKER_RDRYG( 28, 16) =  0.900659E+00
PKER_RDRYG( 28, 17) =  0.741455E+00
PKER_RDRYG( 28, 18) =  0.609608E+00
PKER_RDRYG( 28, 19) =  0.500400E+00
PKER_RDRYG( 28, 20) =  0.409927E+00
PKER_RDRYG( 28, 21) =  0.334951E+00
PKER_RDRYG( 28, 22) =  0.272791E+00
PKER_RDRYG( 28, 23) =  0.221227E+00
PKER_RDRYG( 28, 24) =  0.178418E+00
PKER_RDRYG( 28, 25) =  0.142839E+00
PKER_RDRYG( 28, 26) =  0.113236E+00
PKER_RDRYG( 28, 27) =  0.885917E-01
PKER_RDRYG( 28, 28) =  0.681158E-01
PKER_RDRYG( 28, 29) =  0.512555E-01
PKER_RDRYG( 28, 30) =  0.377074E-01
PKER_RDRYG( 28, 31) =  0.273581E-01
PKER_RDRYG( 28, 32) =  0.202058E-01
PKER_RDRYG( 28, 33) =  0.161272E-01
PKER_RDRYG( 28, 34) =  0.147463E-01
PKER_RDRYG( 28, 35) =  0.154299E-01
PKER_RDRYG( 28, 36) =  0.174181E-01
PKER_RDRYG( 28, 37) =  0.200165E-01
PKER_RDRYG( 28, 38) =  0.227292E-01
PKER_RDRYG( 28, 39) =  0.252583E-01
PKER_RDRYG( 28, 40) =  0.274748E-01
PKER_RDRYG( 29,  1) =  0.156967E+02
PKER_RDRYG( 29,  2) =  0.129912E+02
PKER_RDRYG( 29,  3) =  0.107515E+02
PKER_RDRYG( 29,  4) =  0.889730E+01
PKER_RDRYG( 29,  5) =  0.736233E+01
PKER_RDRYG( 29,  6) =  0.609161E+01
PKER_RDRYG( 29,  7) =  0.503963E+01
PKER_RDRYG( 29,  8) =  0.416874E+01
PKER_RDRYG( 29,  9) =  0.344776E+01
PKER_RDRYG( 29, 10) =  0.285088E+01
PKER_RDRYG( 29, 11) =  0.235675E+01
PKER_RDRYG( 29, 12) =  0.194766E+01
PKER_RDRYG( 29, 13) =  0.160897E+01
PKER_RDRYG( 29, 14) =  0.132857E+01
PKER_RDRYG( 29, 15) =  0.109641E+01
PKER_RDRYG( 29, 16) =  0.904196E+00
PKER_RDRYG( 29, 17) =  0.745035E+00
PKER_RDRYG( 29, 18) =  0.613237E+00
PKER_RDRYG( 29, 19) =  0.504086E+00
PKER_RDRYG( 29, 20) =  0.413678E+00
PKER_RDRYG( 29, 21) =  0.338776E+00
PKER_RDRYG( 29, 22) =  0.276704E+00
PKER_RDRYG( 29, 23) =  0.225241E+00
PKER_RDRYG( 29, 24) =  0.182548E+00
PKER_RDRYG( 29, 25) =  0.147101E+00
PKER_RDRYG( 29, 26) =  0.117639E+00
PKER_RDRYG( 29, 27) =  0.931243E-01
PKER_RDRYG( 29, 28) =  0.727192E-01
PKER_RDRYG( 29, 29) =  0.557785E-01
PKER_RDRYG( 29, 30) =  0.418595E-01
PKER_RDRYG( 29, 31) =  0.307224E-01
PKER_RDRYG( 29, 32) =  0.223096E-01
PKER_RDRYG( 29, 33) =  0.165947E-01
PKER_RDRYG( 29, 34) =  0.134638E-01
PKER_RDRYG( 29, 35) =  0.125669E-01
PKER_RDRYG( 29, 36) =  0.133388E-01
PKER_RDRYG( 29, 37) =  0.151398E-01
PKER_RDRYG( 29, 38) =  0.174018E-01
PKER_RDRYG( 29, 39) =  0.197163E-01
PKER_RDRYG( 29, 40) =  0.218551E-01
PKER_RDRYG( 30,  1) =  0.156994E+02
PKER_RDRYG( 30,  2) =  0.129939E+02
PKER_RDRYG( 30,  3) =  0.107542E+02
PKER_RDRYG( 30,  4) =  0.890005E+01
PKER_RDRYG( 30,  5) =  0.736510E+01
PKER_RDRYG( 30,  6) =  0.609438E+01
PKER_RDRYG( 30,  7) =  0.504242E+01
PKER_RDRYG( 30,  8) =  0.417154E+01
PKER_RDRYG( 30,  9) =  0.345058E+01
PKER_RDRYG( 30, 10) =  0.285372E+01
PKER_RDRYG( 30, 11) =  0.235960E+01
PKER_RDRYG( 30, 12) =  0.195054E+01
PKER_RDRYG( 30, 13) =  0.161187E+01
PKER_RDRYG( 30, 14) =  0.133149E+01
PKER_RDRYG( 30, 15) =  0.109936E+01
PKER_RDRYG( 30, 16) =  0.907174E+00
PKER_RDRYG( 30, 17) =  0.748046E+00
PKER_RDRYG( 30, 18) =  0.616285E+00
PKER_RDRYG( 30, 19) =  0.507176E+00
PKER_RDRYG( 30, 20) =  0.416814E+00
PKER_RDRYG( 30, 21) =  0.341968E+00
PKER_RDRYG( 30, 22) =  0.279958E+00
PKER_RDRYG( 30, 23) =  0.228569E+00
PKER_RDRYG( 30, 24) =  0.185961E+00
PKER_RDRYG( 30, 25) =  0.150613E+00
PKER_RDRYG( 30, 26) =  0.121262E+00
PKER_RDRYG( 30, 27) =  0.968655E-01
PKER_RDRYG( 30, 28) =  0.765650E-01
PKER_RDRYG( 30, 29) =  0.596711E-01
PKER_RDRYG( 30, 30) =  0.456581E-01
PKER_RDRYG( 30, 31) =  0.341736E-01
PKER_RDRYG( 30, 32) =  0.250373E-01
PKER_RDRYG( 30, 33) =  0.182029E-01
PKER_RDRYG( 30, 34) =  0.136572E-01
PKER_RDRYG( 30, 35) =  0.112718E-01
PKER_RDRYG( 30, 36) =  0.107288E-01
PKER_RDRYG( 30, 37) =  0.115403E-01
PKER_RDRYG( 30, 38) =  0.131623E-01
PKER_RDRYG( 30, 39) =  0.151226E-01
PKER_RDRYG( 30, 40) =  0.170966E-01
PKER_RDRYG( 31,  1) =  0.157017E+02
PKER_RDRYG( 31,  2) =  0.129962E+02
PKER_RDRYG( 31,  3) =  0.107565E+02
PKER_RDRYG( 31,  4) =  0.890239E+01
PKER_RDRYG( 31,  5) =  0.736744E+01
PKER_RDRYG( 31,  6) =  0.609674E+01
PKER_RDRYG( 31,  7) =  0.504479E+01
PKER_RDRYG( 31,  8) =  0.417392E+01
PKER_RDRYG( 31,  9) =  0.345297E+01
PKER_RDRYG( 31, 10) =  0.285613E+01
PKER_RDRYG( 31, 11) =  0.236203E+01
PKER_RDRYG( 31, 12) =  0.195297E+01
PKER_RDRYG( 31, 13) =  0.161433E+01
PKER_RDRYG( 31, 14) =  0.133396E+01
PKER_RDRYG( 31, 15) =  0.110185E+01
PKER_RDRYG( 31, 16) =  0.909687E+00
PKER_RDRYG( 31, 17) =  0.750583E+00
PKER_RDRYG( 31, 18) =  0.618849E+00
PKER_RDRYG( 31, 19) =  0.509771E+00
PKER_RDRYG( 31, 20) =  0.419444E+00
PKER_RDRYG( 31, 21) =  0.344637E+00
PKER_RDRYG( 31, 22) =  0.282674E+00
PKER_RDRYG( 31, 23) =  0.231338E+00
PKER_RDRYG( 31, 24) =  0.188793E+00
PKER_RDRYG( 31, 25) =  0.153517E+00
PKER_RDRYG( 31, 26) =  0.124249E+00
PKER_RDRYG( 31, 27) =  0.999464E-01
PKER_RDRYG( 31, 28) =  0.797438E-01
PKER_RDRYG( 31, 29) =  0.629334E-01
PKER_RDRYG( 31, 30) =  0.489476E-01
PKER_RDRYG( 31, 31) =  0.373591E-01
PKER_RDRYG( 31, 32) =  0.278881E-01
PKER_RDRYG( 31, 33) =  0.203979E-01
PKER_RDRYG( 31, 34) =  0.148616E-01
PKER_RDRYG( 31, 35) =  0.112574E-01
PKER_RDRYG( 31, 36) =  0.946007E-02
PKER_RDRYG( 31, 37) =  0.918277E-02
PKER_RDRYG( 31, 38) =  0.999683E-02
PKER_RDRYG( 31, 39) =  0.114431E-01
PKER_RDRYG( 31, 40) =  0.131376E-01
PKER_RDRYG( 32,  1) =  0.157037E+02
PKER_RDRYG( 32,  2) =  0.129982E+02
PKER_RDRYG( 32,  3) =  0.107585E+02
PKER_RDRYG( 32,  4) =  0.890438E+01
PKER_RDRYG( 32,  5) =  0.736944E+01
PKER_RDRYG( 32,  6) =  0.609874E+01
PKER_RDRYG( 32,  7) =  0.504680E+01
PKER_RDRYG( 32,  8) =  0.417594E+01
PKER_RDRYG( 32,  9) =  0.345501E+01
PKER_RDRYG( 32, 10) =  0.285817E+01
PKER_RDRYG( 32, 11) =  0.236408E+01
PKER_RDRYG( 32, 12) =  0.195504E+01
PKER_RDRYG( 32, 13) =  0.161640E+01
PKER_RDRYG( 32, 14) =  0.133606E+01
PKER_RDRYG( 32, 15) =  0.110396E+01
PKER_RDRYG( 32, 16) =  0.911809E+00
PKER_RDRYG( 32, 17) =  0.752724E+00
PKER_RDRYG( 32, 18) =  0.621010E+00
PKER_RDRYG( 32, 19) =  0.511954E+00
PKER_RDRYG( 32, 20) =  0.421653E+00
PKER_RDRYG( 32, 21) =  0.346876E+00
PKER_RDRYG( 32, 22) =  0.284947E+00
PKER_RDRYG( 32, 23) =  0.233649E+00
PKER_RDRYG( 32, 24) =  0.191149E+00
PKER_RDRYG( 32, 25) =  0.155926E+00
PKER_RDRYG( 32, 26) =  0.126720E+00
PKER_RDRYG( 32, 27) =  0.102487E+00
PKER_RDRYG( 32, 28) =  0.823637E-01
PKER_RDRYG( 32, 29) =  0.656344E-01
PKER_RDRYG( 32, 30) =  0.517143E-01
PKER_RDRYG( 32, 31) =  0.401375E-01
PKER_RDRYG( 32, 32) =  0.305566E-01
PKER_RDRYG( 32, 33) =  0.227484E-01
PKER_RDRYG( 32, 34) =  0.166190E-01
PKER_RDRYG( 32, 35) =  0.121425E-01
PKER_RDRYG( 32, 36) =  0.929636E-02
PKER_RDRYG( 32, 37) =  0.796211E-02
PKER_RDRYG( 32, 38) =  0.787497E-02
PKER_RDRYG( 32, 39) =  0.866604E-02
PKER_RDRYG( 32, 40) =  0.994926E-02
PKER_RDRYG( 33,  1) =  0.157053E+02
PKER_RDRYG( 33,  2) =  0.129999E+02
PKER_RDRYG( 33,  3) =  0.107602E+02
PKER_RDRYG( 33,  4) =  0.890607E+01
PKER_RDRYG( 33,  5) =  0.737114E+01
PKER_RDRYG( 33,  6) =  0.610045E+01
PKER_RDRYG( 33,  7) =  0.504851E+01
PKER_RDRYG( 33,  8) =  0.417766E+01
PKER_RDRYG( 33,  9) =  0.345673E+01
PKER_RDRYG( 33, 10) =  0.285990E+01
PKER_RDRYG( 33, 11) =  0.236582E+01
PKER_RDRYG( 33, 12) =  0.195679E+01
PKER_RDRYG( 33, 13) =  0.161816E+01
PKER_RDRYG( 33, 14) =  0.133783E+01
PKER_RDRYG( 33, 15) =  0.110574E+01
PKER_RDRYG( 33, 16) =  0.913604E+00
PKER_RDRYG( 33, 17) =  0.754532E+00
PKER_RDRYG( 33, 18) =  0.622834E+00
PKER_RDRYG( 33, 19) =  0.513795E+00
PKER_RDRYG( 33, 20) =  0.423513E+00
PKER_RDRYG( 33, 21) =  0.348758E+00
PKER_RDRYG( 33, 22) =  0.286853E+00
PKER_RDRYG( 33, 23) =  0.235584E+00
PKER_RDRYG( 33, 24) =  0.193116E+00
PKER_RDRYG( 33, 25) =  0.157931E+00
PKER_RDRYG( 33, 26) =  0.128770E+00
PKER_RDRYG( 33, 27) =  0.104589E+00
PKER_RDRYG( 33, 28) =  0.845253E-01
PKER_RDRYG( 33, 29) =  0.678623E-01
PKER_RDRYG( 33, 30) =  0.540092E-01
PKER_RDRYG( 33, 31) =  0.424830E-01
PKER_RDRYG( 33, 32) =  0.329012E-01
PKER_RDRYG( 33, 33) =  0.249827E-01
PKER_RDRYG( 33, 34) =  0.185543E-01
PKER_RDRYG( 33, 35) =  0.135404E-01
PKER_RDRYG( 33, 36) =  0.993014E-02
PKER_RDRYG( 33, 37) =  0.769477E-02
PKER_RDRYG( 33, 38) =  0.672045E-02
PKER_RDRYG( 33, 39) =  0.676668E-02
PKER_RDRYG( 33, 40) =  0.751623E-02
PKER_RDRYG( 34,  1) =  0.157068E+02
PKER_RDRYG( 34,  2) =  0.130013E+02
PKER_RDRYG( 34,  3) =  0.107616E+02
PKER_RDRYG( 34,  4) =  0.890751E+01
PKER_RDRYG( 34,  5) =  0.737258E+01
PKER_RDRYG( 34,  6) =  0.610189E+01
PKER_RDRYG( 34,  7) =  0.504996E+01
PKER_RDRYG( 34,  8) =  0.417912E+01
PKER_RDRYG( 34,  9) =  0.345819E+01
PKER_RDRYG( 34, 10) =  0.286137E+01
PKER_RDRYG( 34, 11) =  0.236730E+01
PKER_RDRYG( 34, 12) =  0.195827E+01
PKER_RDRYG( 34, 13) =  0.161965E+01
PKER_RDRYG( 34, 14) =  0.133933E+01
PKER_RDRYG( 34, 15) =  0.110725E+01
PKER_RDRYG( 34, 16) =  0.915123E+00
PKER_RDRYG( 34, 17) =  0.756062E+00
PKER_RDRYG( 34, 18) =  0.624375E+00
PKER_RDRYG( 34, 19) =  0.515349E+00
PKER_RDRYG( 34, 20) =  0.425082E+00
PKER_RDRYG( 34, 21) =  0.350342E+00
PKER_RDRYG( 34, 22) =  0.288455E+00
PKER_RDRYG( 34, 23) =  0.237207E+00
PKER_RDRYG( 34, 24) =  0.194764E+00
PKER_RDRYG( 34, 25) =  0.159606E+00
PKER_RDRYG( 34, 26) =  0.130477E+00
PKER_RDRYG( 34, 27) =  0.106334E+00
PKER_RDRYG( 34, 28) =  0.863139E-01
PKER_RDRYG( 34, 29) =  0.697015E-01
PKER_RDRYG( 34, 30) =  0.559040E-01
PKER_RDRYG( 34, 31) =  0.444327E-01
PKER_RDRYG( 34, 32) =  0.348892E-01
PKER_RDRYG( 34, 33) =  0.269596E-01
PKER_RDRYG( 34, 34) =  0.204175E-01
PKER_RDRYG( 34, 35) =  0.151283E-01
PKER_RDRYG( 34, 36) =  0.110336E-01
PKER_RDRYG( 34, 37) =  0.812881E-02
PKER_RDRYG( 34, 38) =  0.638384E-02
PKER_RDRYG( 34, 39) =  0.568390E-02
PKER_RDRYG( 34, 40) =  0.582227E-02
PKER_RDRYG( 35,  1) =  0.157080E+02
PKER_RDRYG( 35,  2) =  0.130025E+02
PKER_RDRYG( 35,  3) =  0.107628E+02
PKER_RDRYG( 35,  4) =  0.890873E+01
PKER_RDRYG( 35,  5) =  0.737381E+01
PKER_RDRYG( 35,  6) =  0.610313E+01
PKER_RDRYG( 35,  7) =  0.505120E+01
PKER_RDRYG( 35,  8) =  0.418036E+01
PKER_RDRYG( 35,  9) =  0.345944E+01
PKER_RDRYG( 35, 10) =  0.286262E+01
PKER_RDRYG( 35, 11) =  0.236855E+01
PKER_RDRYG( 35, 12) =  0.195953E+01
PKER_RDRYG( 35, 13) =  0.162092E+01
PKER_RDRYG( 35, 14) =  0.134060E+01
PKER_RDRYG( 35, 15) =  0.110853E+01
PKER_RDRYG( 35, 16) =  0.916411E+00
PKER_RDRYG( 35, 17) =  0.757357E+00
PKER_RDRYG( 35, 18) =  0.625679E+00
PKER_RDRYG( 35, 19) =  0.516663E+00
PKER_RDRYG( 35, 20) =  0.426406E+00
PKER_RDRYG( 35, 21) =  0.351679E+00
PKER_RDRYG( 35, 22) =  0.289805E+00
PKER_RDRYG( 35, 23) =  0.238572E+00
PKER_RDRYG( 35, 24) =  0.196146E+00
PKER_RDRYG( 35, 25) =  0.161009E+00
PKER_RDRYG( 35, 26) =  0.131903E+00
PKER_RDRYG( 35, 27) =  0.107787E+00
PKER_RDRYG( 35, 28) =  0.877991E-01
PKER_RDRYG( 35, 29) =  0.712238E-01
PKER_RDRYG( 35, 30) =  0.574690E-01
PKER_RDRYG( 35, 31) =  0.460443E-01
PKER_RDRYG( 35, 32) =  0.365454E-01
PKER_RDRYG( 35, 33) =  0.286436E-01
PKER_RDRYG( 35, 34) =  0.220827E-01
PKER_RDRYG( 35, 35) =  0.166801E-01
PKER_RDRYG( 35, 36) =  0.123284E-01
PKER_RDRYG( 35, 37) =  0.899312E-02
PKER_RDRYG( 35, 38) =  0.666232E-02
PKER_RDRYG( 35, 39) =  0.530804E-02
PKER_RDRYG( 35, 40) =  0.482355E-02
PKER_RDRYG( 36,  1) =  0.157090E+02
PKER_RDRYG( 36,  2) =  0.130036E+02
PKER_RDRYG( 36,  3) =  0.107639E+02
PKER_RDRYG( 36,  4) =  0.890977E+01
PKER_RDRYG( 36,  5) =  0.737485E+01
PKER_RDRYG( 36,  6) =  0.610418E+01
PKER_RDRYG( 36,  7) =  0.505225E+01
PKER_RDRYG( 36,  8) =  0.418142E+01
PKER_RDRYG( 36,  9) =  0.346050E+01
PKER_RDRYG( 36, 10) =  0.286369E+01
PKER_RDRYG( 36, 11) =  0.236962E+01
PKER_RDRYG( 36, 12) =  0.196060E+01
PKER_RDRYG( 36, 13) =  0.162200E+01
PKER_RDRYG( 36, 14) =  0.134168E+01
PKER_RDRYG( 36, 15) =  0.110962E+01
PKER_RDRYG( 36, 16) =  0.917502E+00
PKER_RDRYG( 36, 17) =  0.758455E+00
PKER_RDRYG( 36, 18) =  0.626784E+00
PKER_RDRYG( 36, 19) =  0.517775E+00
PKER_RDRYG( 36, 20) =  0.427526E+00
PKER_RDRYG( 36, 21) =  0.352807E+00
PKER_RDRYG( 36, 22) =  0.290944E+00
PKER_RDRYG( 36, 23) =  0.239723E+00
PKER_RDRYG( 36, 24) =  0.197309E+00
PKER_RDRYG( 36, 25) =  0.162187E+00
PKER_RDRYG( 36, 26) =  0.133098E+00
PKER_RDRYG( 36, 27) =  0.109002E+00
PKER_RDRYG( 36, 28) =  0.890365E-01
PKER_RDRYG( 36, 29) =  0.724882E-01
PKER_RDRYG( 36, 30) =  0.587648E-01
PKER_RDRYG( 36, 31) =  0.473761E-01
PKER_RDRYG( 36, 32) =  0.379160E-01
PKER_RDRYG( 36, 33) =  0.300505E-01
PKER_RDRYG( 36, 34) =  0.235088E-01
PKER_RDRYG( 36, 35) =  0.180811E-01
PKER_RDRYG( 36, 36) =  0.136215E-01
PKER_RDRYG( 36, 37) =  0.100480E-01
PKER_RDRYG( 36, 38) =  0.733183E-02
PKER_RDRYG( 36, 39) =  0.546978E-02
PKER_RDRYG( 36, 40) =  0.442459E-02
PKER_RDRYG( 37,  1) =  0.157099E+02
PKER_RDRYG( 37,  2) =  0.130045E+02
PKER_RDRYG( 37,  3) =  0.107648E+02
PKER_RDRYG( 37,  4) =  0.891066E+01
PKER_RDRYG( 37,  5) =  0.737574E+01
PKER_RDRYG( 37,  6) =  0.610507E+01
PKER_RDRYG( 37,  7) =  0.505315E+01
PKER_RDRYG( 37,  8) =  0.418231E+01
PKER_RDRYG( 37,  9) =  0.346140E+01
PKER_RDRYG( 37, 10) =  0.286459E+01
PKER_RDRYG( 37, 11) =  0.237053E+01
PKER_RDRYG( 37, 12) =  0.196151E+01
PKER_RDRYG( 37, 13) =  0.162291E+01
PKER_RDRYG( 37, 14) =  0.134260E+01
PKER_RDRYG( 37, 15) =  0.111054E+01
PKER_RDRYG( 37, 16) =  0.918429E+00
PKER_RDRYG( 37, 17) =  0.759387E+00
PKER_RDRYG( 37, 18) =  0.627720E+00
PKER_RDRYG( 37, 19) =  0.518717E+00
PKER_RDRYG( 37, 20) =  0.428474E+00
PKER_RDRYG( 37, 21) =  0.353762E+00
PKER_RDRYG( 37, 22) =  0.291907E+00
PKER_RDRYG( 37, 23) =  0.240693E+00
PKER_RDRYG( 37, 24) =  0.198289E+00
PKER_RDRYG( 37, 25) =  0.163177E+00
PKER_RDRYG( 37, 26) =  0.134101E+00
PKER_RDRYG( 37, 27) =  0.110019E+00
PKER_RDRYG( 37, 28) =  0.900708E-01
PKER_RDRYG( 37, 29) =  0.735419E-01
PKER_RDRYG( 37, 30) =  0.598414E-01
PKER_RDRYG( 37, 31) =  0.484792E-01
PKER_RDRYG( 37, 32) =  0.390495E-01
PKER_RDRYG( 37, 33) =  0.312163E-01
PKER_RDRYG( 37, 34) =  0.247033E-01
PKER_RDRYG( 37, 35) =  0.192878E-01
PKER_RDRYG( 37, 36) =  0.147988E-01
PKER_RDRYG( 37, 37) =  0.111191E-01
PKER_RDRYG( 37, 38) =  0.818617E-02
PKER_RDRYG( 37, 39) =  0.598058E-02
PKER_RDRYG( 37, 40) =  0.449521E-02
PKER_RDRYG( 38,  1) =  0.157107E+02
PKER_RDRYG( 38,  2) =  0.130052E+02
PKER_RDRYG( 38,  3) =  0.107655E+02
PKER_RDRYG( 38,  4) =  0.891142E+01
PKER_RDRYG( 38,  5) =  0.737650E+01
PKER_RDRYG( 38,  6) =  0.610583E+01
PKER_RDRYG( 38,  7) =  0.505391E+01
PKER_RDRYG( 38,  8) =  0.418308E+01
PKER_RDRYG( 38,  9) =  0.346217E+01
PKER_RDRYG( 38, 10) =  0.286536E+01
PKER_RDRYG( 38, 11) =  0.237130E+01
PKER_RDRYG( 38, 12) =  0.196229E+01
PKER_RDRYG( 38, 13) =  0.162369E+01
PKER_RDRYG( 38, 14) =  0.134338E+01
PKER_RDRYG( 38, 15) =  0.111132E+01
PKER_RDRYG( 38, 16) =  0.919216E+00
PKER_RDRYG( 38, 17) =  0.760177E+00
PKER_RDRYG( 38, 18) =  0.628515E+00
PKER_RDRYG( 38, 19) =  0.519516E+00
PKER_RDRYG( 38, 20) =  0.429278E+00
PKER_RDRYG( 38, 21) =  0.354571E+00
PKER_RDRYG( 38, 22) =  0.292721E+00
PKER_RDRYG( 38, 23) =  0.241514E+00
PKER_RDRYG( 38, 24) =  0.199117E+00
PKER_RDRYG( 38, 25) =  0.164013E+00
PKER_RDRYG( 38, 26) =  0.134945E+00
PKER_RDRYG( 38, 27) =  0.110874E+00
PKER_RDRYG( 38, 28) =  0.909377E-01
PKER_RDRYG( 38, 29) =  0.744229E-01
PKER_RDRYG( 38, 30) =  0.607388E-01
PKER_RDRYG( 38, 31) =  0.493960E-01
PKER_RDRYG( 38, 32) =  0.399888E-01
PKER_RDRYG( 38, 33) =  0.321810E-01
PKER_RDRYG( 38, 34) =  0.256949E-01
PKER_RDRYG( 38, 35) =  0.203021E-01
PKER_RDRYG( 38, 36) =  0.158193E-01
PKER_RDRYG( 38, 37) =  0.121074E-01
PKER_RDRYG( 38, 38) =  0.907255E-02
PKER_RDRYG( 38, 39) =  0.666890E-02
PKER_RDRYG( 38, 40) =  0.488099E-02
PKER_RDRYG( 39,  1) =  0.157113E+02
PKER_RDRYG( 39,  2) =  0.130059E+02
PKER_RDRYG( 39,  3) =  0.107662E+02
PKER_RDRYG( 39,  4) =  0.891206E+01
PKER_RDRYG( 39,  5) =  0.737715E+01
PKER_RDRYG( 39,  6) =  0.610648E+01
PKER_RDRYG( 39,  7) =  0.505456E+01
PKER_RDRYG( 39,  8) =  0.418373E+01
PKER_RDRYG( 39,  9) =  0.346282E+01
PKER_RDRYG( 39, 10) =  0.286602E+01
PKER_RDRYG( 39, 11) =  0.237195E+01
PKER_RDRYG( 39, 12) =  0.196295E+01
PKER_RDRYG( 39, 13) =  0.162435E+01
PKER_RDRYG( 39, 14) =  0.134404E+01
PKER_RDRYG( 39, 15) =  0.111199E+01
PKER_RDRYG( 39, 16) =  0.919884E+00
PKER_RDRYG( 39, 17) =  0.760849E+00
PKER_RDRYG( 39, 18) =  0.629189E+00
PKER_RDRYG( 39, 19) =  0.520193E+00
PKER_RDRYG( 39, 20) =  0.429959E+00
PKER_RDRYG( 39, 21) =  0.355256E+00
PKER_RDRYG( 39, 22) =  0.293410E+00
PKER_RDRYG( 39, 23) =  0.242208E+00
PKER_RDRYG( 39, 24) =  0.199816E+00
PKER_RDRYG( 39, 25) =  0.164718E+00
PKER_RDRYG( 39, 26) =  0.135657E+00
PKER_RDRYG( 39, 27) =  0.111594E+00
PKER_RDRYG( 39, 28) =  0.916661E-01
PKER_RDRYG( 39, 29) =  0.751615E-01
PKER_RDRYG( 39, 30) =  0.614894E-01
PKER_RDRYG( 39, 31) =  0.501605E-01
PKER_RDRYG( 39, 32) =  0.407696E-01
PKER_RDRYG( 39, 33) =  0.329808E-01
PKER_RDRYG( 39, 34) =  0.265161E-01
PKER_RDRYG( 39, 35) =  0.211454E-01
PKER_RDRYG( 39, 36) =  0.166802E-01
PKER_RDRYG( 39, 37) =  0.129700E-01
PKER_RDRYG( 39, 38) =  0.990158E-02
PKER_RDRYG( 39, 39) =  0.740159E-02
PKER_RDRYG( 39, 40) =  0.543265E-02
PKER_RDRYG( 40,  1) =  0.157118E+02
PKER_RDRYG( 40,  2) =  0.130064E+02
PKER_RDRYG( 40,  3) =  0.107667E+02
PKER_RDRYG( 40,  4) =  0.891261E+01
PKER_RDRYG( 40,  5) =  0.737770E+01
PKER_RDRYG( 40,  6) =  0.610703E+01
PKER_RDRYG( 40,  7) =  0.505511E+01
PKER_RDRYG( 40,  8) =  0.418429E+01
PKER_RDRYG( 40,  9) =  0.346338E+01
PKER_RDRYG( 40, 10) =  0.286657E+01
PKER_RDRYG( 40, 11) =  0.237251E+01
PKER_RDRYG( 40, 12) =  0.196351E+01
PKER_RDRYG( 40, 13) =  0.162491E+01
PKER_RDRYG( 40, 14) =  0.134461E+01
PKER_RDRYG( 40, 15) =  0.111256E+01
PKER_RDRYG( 40, 16) =  0.920453E+00
PKER_RDRYG( 40, 17) =  0.761419E+00
PKER_RDRYG( 40, 18) =  0.629762E+00
PKER_RDRYG( 40, 19) =  0.520769E+00
PKER_RDRYG( 40, 20) =  0.430537E+00
PKER_RDRYG( 40, 21) =  0.355837E+00
PKER_RDRYG( 40, 22) =  0.293995E+00
PKER_RDRYG( 40, 23) =  0.242796E+00
PKER_RDRYG( 40, 24) =  0.200408E+00
PKER_RDRYG( 40, 25) =  0.165315E+00
PKER_RDRYG( 40, 26) =  0.136259E+00
PKER_RDRYG( 40, 27) =  0.112201E+00
PKER_RDRYG( 40, 28) =  0.922796E-01
PKER_RDRYG( 40, 29) =  0.757823E-01
PKER_RDRYG( 40, 30) =  0.621188E-01
PKER_RDRYG( 40, 31) =  0.507999E-01
PKER_RDRYG( 40, 32) =  0.414208E-01
PKER_RDRYG( 40, 33) =  0.336459E-01
PKER_RDRYG( 40, 34) =  0.271972E-01
PKER_RDRYG( 40, 35) =  0.218444E-01
PKER_RDRYG( 40, 36) =  0.173974E-01
PKER_RDRYG( 40, 37) =  0.137005E-01
PKER_RDRYG( 40, 38) =  0.106300E-01
PKER_RDRYG( 40, 39) =  0.809434E-02
PKER_RDRYG( 40, 40) =  0.603544E-02
END IF
!
END SUBROUTINE LIMA_READ_XKER_RDRYG
