!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!     ###########################
      MODULE MODE_READ_XKER_RACCS 
!     ###########################
IMPLICIT NONE
CONTAINS
      SUBROUTINE READ_XKER_RACCS (KACCLBDAS,KACCLBDAR,KND,                     &
                      PALPHAS,PNUS,PALPHAR,PNUR,PESR,PBS,PBR,PCS,PDS,PCR,PDR,  &
                      PACCLBDAS_MAX,PACCLBDAR_MAX,PACCLBDAS_MIN,PACCLBDAR_MIN, &
                      PFDINFTY,PKER_RACCSS,PKER_RACCS,PKER_SACCRG              )
!DEC$ OPTIMIZE:0
      USE PARKIND1, ONLY : JPRB
      USE YOMHOOK , ONLY : LHOOK, DR_HOOK
!     ##########################################################################
!
!!****  * * - initialize the kernels for the rain-snow accretion process
!!
!!    PURPOSE
!!    -------
!!      The purpose of this routine is to initialize the kernels PKER_RACCSS,
!!    PKER_RACCS and PKER_SACCRG prepared from a previous run of the routine
!!    INI_RAIN_ICE. The reading of the kernels is optional after checking for
!!    the dimensions of the arrays.
!!
!!**  METHOD
!!    ------
!!      
!!
!!    EXTERNAL
!!    --------
!!      None
!!     
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      None
!!
!!    REFERENCE
!!    ---------
!!      Book2 of documentation ( routine READ_XKER_RACCS )
!!
!!    AUTHOR
!!    ------
!!      J.-P. Pinty      * Laboratoire d'Aerologie*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    09/04/96
!!      14-Feb-2014 R. El Khatib optimise for compile time on Intel
!!
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!*       0.2   Declarations of local variables :
!
!  
INTEGER, INTENT(OUT) :: KND,KACCLBDAS,KACCLBDAR
REAL,    INTENT(OUT) :: PALPHAS
REAL,    INTENT(OUT) :: PNUS
REAL,    INTENT(OUT) :: PALPHAR
REAL,    INTENT(OUT) :: PNUR
REAL,    INTENT(OUT) :: PESR
REAL,    INTENT(OUT) :: PBS
REAL,    INTENT(OUT) :: PBR
REAL,    INTENT(OUT) :: PCS
REAL,    INTENT(OUT) :: PDS
REAL,    INTENT(OUT) :: PCR
REAL,    INTENT(OUT) :: PDR
REAL,    INTENT(OUT) :: PACCLBDAS_MAX
REAL,    INTENT(OUT) :: PACCLBDAR_MAX
REAL,    INTENT(OUT) :: PACCLBDAS_MIN
REAL,    INTENT(OUT) :: PACCLBDAR_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RACCSS
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RACCS 
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_SACCRG
!
! ###################################################################
! #INSERT HERE THE OUTPUT OF INI_RAIN_ICE IF THE KERNELS ARE UPDATED#
! ###################################################################
!
REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('READ_XKER_RACCS',0,ZHOOK_HANDLE)
KND= 50
KACCLBDAS= 40
KACCLBDAR= 40
PALPHAS= 0.100000E+01
PNUS= 0.100000E+01
PALPHAR= 0.100000E+01
PNUR= 0.100000E+01
PESR= 0.100000E+01
PBS= 0.190000E+01
PBR= 0.300000E+01
PCS= 0.510000E+01
PDS= 0.270000E+00
PCR= 0.842000E+03
PDR= 0.800000E+00
PACCLBDAS_MAX= 0.500000E+06
PACCLBDAR_MAX= 0.100000E+08
PACCLBDAS_MIN= 0.500000E+02
PACCLBDAR_MIN= 0.100000E+04
PFDINFTY= 0.200000E+02
!
IF( PRESENT(PKER_RACCSS) ) THEN
  PKER_RACCSS(  1,  1) =  0.778513E+01
  PKER_RACCSS(  1,  2) =  0.611693E+01
  PKER_RACCSS(  1,  3) =  0.469673E+01
  PKER_RACCSS(  1,  4) =  0.351291E+01
  PKER_RACCSS(  1,  5) =  0.255165E+01
  PKER_RACCSS(  1,  6) =  0.180370E+01
  PKER_RACCSS(  1,  7) =  0.126294E+01
  PKER_RACCSS(  1,  8) =  0.924202E+00
  PKER_RACCSS(  1,  9) =  0.775231E+00
  PKER_RACCSS(  1, 10) =  0.787292E+00
  PKER_RACCSS(  1, 11) =  0.911536E+00
  PKER_RACCSS(  1, 12) =  0.109094E+01
  PKER_RACCSS(  1, 13) =  0.127926E+01
  PKER_RACCSS(  1, 14) =  0.145083E+01
  PKER_RACCSS(  1, 15) =  0.159745E+01
  PKER_RACCSS(  1, 16) =  0.171978E+01
  PKER_RACCSS(  1, 17) =  0.182114E+01
  PKER_RACCSS(  1, 18) =  0.190501E+01
  PKER_RACCSS(  1, 19) =  0.197441E+01
  PKER_RACCSS(  1, 20) =  0.203184E+01
  PKER_RACCSS(  1, 21) =  0.207937E+01
  PKER_RACCSS(  1, 22) =  0.211870E+01
  PKER_RACCSS(  1, 23) =  0.215125E+01
  PKER_RACCSS(  1, 24) =  0.217819E+01
  PKER_RACCSS(  1, 25) =  0.220049E+01
  PKER_RACCSS(  1, 26) =  0.221895E+01
  PKER_RACCSS(  1, 27) =  0.223423E+01
  PKER_RACCSS(  1, 28) =  0.224687E+01
  PKER_RACCSS(  1, 29) =  0.225734E+01
  PKER_RACCSS(  1, 30) =  0.226601E+01
  PKER_RACCSS(  1, 31) =  0.227318E+01
  PKER_RACCSS(  1, 32) =  0.227911E+01
  PKER_RACCSS(  1, 33) =  0.228403E+01
  PKER_RACCSS(  1, 34) =  0.228810E+01
  PKER_RACCSS(  1, 35) =  0.229146E+01
  PKER_RACCSS(  1, 36) =  0.229425E+01
  PKER_RACCSS(  1, 37) =  0.229656E+01
  PKER_RACCSS(  1, 38) =  0.229847E+01
  PKER_RACCSS(  1, 39) =  0.230005E+01
  PKER_RACCSS(  1, 40) =  0.230136E+01
  PKER_RACCSS(  2,  1) =  0.777519E+01
  PKER_RACCSS(  2,  2) =  0.620120E+01
  PKER_RACCSS(  2,  3) =  0.482130E+01
  PKER_RACCSS(  2,  4) =  0.365151E+01
  PKER_RACCSS(  2,  5) =  0.268556E+01
  PKER_RACCSS(  2,  6) =  0.191605E+01
  PKER_RACCSS(  2,  7) =  0.134047E+01
  PKER_RACCSS(  2,  8) =  0.956677E+00
  PKER_RACCSS(  2,  9) =  0.757265E+00
  PKER_RACCSS(  2, 10) =  0.720633E+00
  PKER_RACCSS(  2, 11) =  0.806882E+00
  PKER_RACCSS(  2, 12) =  0.963181E+00
  PKER_RACCSS(  2, 13) =  0.114076E+01
  PKER_RACCSS(  2, 14) =  0.130870E+01
  PKER_RACCSS(  2, 15) =  0.145451E+01
  PKER_RACCSS(  2, 16) =  0.157680E+01
  PKER_RACCSS(  2, 17) =  0.167825E+01
  PKER_RACCSS(  2, 18) =  0.176221E+01
  PKER_RACCSS(  2, 19) =  0.183168E+01
  PKER_RACCSS(  2, 20) =  0.188915E+01
  PKER_RACCSS(  2, 21) =  0.193671E+01
  PKER_RACCSS(  2, 22) =  0.197607E+01
  PKER_RACCSS(  2, 23) =  0.200864E+01
  PKER_RACCSS(  2, 24) =  0.203559E+01
  PKER_RACCSS(  2, 25) =  0.205790E+01
  PKER_RACCSS(  2, 26) =  0.207637E+01
  PKER_RACCSS(  2, 27) =  0.209165E+01
  PKER_RACCSS(  2, 28) =  0.210430E+01
  PKER_RACCSS(  2, 29) =  0.211478E+01
  PKER_RACCSS(  2, 30) =  0.212344E+01
  PKER_RACCSS(  2, 31) =  0.213062E+01
  PKER_RACCSS(  2, 32) =  0.213656E+01
  PKER_RACCSS(  2, 33) =  0.214147E+01
  PKER_RACCSS(  2, 34) =  0.214554E+01
  PKER_RACCSS(  2, 35) =  0.214891E+01
  PKER_RACCSS(  2, 36) =  0.215170E+01
  PKER_RACCSS(  2, 37) =  0.215401E+01
  PKER_RACCSS(  2, 38) =  0.215592E+01
  PKER_RACCSS(  2, 39) =  0.215750E+01
  PKER_RACCSS(  2, 40) =  0.215881E+01
  PKER_RACCSS(  3,  1) =  0.762215E+01
  PKER_RACCSS(  3,  2) =  0.621106E+01
  PKER_RACCSS(  3,  3) =  0.490698E+01
  PKER_RACCSS(  3,  4) =  0.376761E+01
  PKER_RACCSS(  3,  5) =  0.280896E+01
  PKER_RACCSS(  3,  6) =  0.202903E+01
  PKER_RACCSS(  3,  7) =  0.142689E+01
  PKER_RACCSS(  3,  8) =  0.100388E+01
  PKER_RACCSS(  3,  9) =  0.757013E+00
  PKER_RACCSS(  3, 10) =  0.673206E+00
  PKER_RACCSS(  3, 11) =  0.719335E+00
  PKER_RACCSS(  3, 12) =  0.849040E+00
  PKER_RACCSS(  3, 13) =  0.101307E+01
  PKER_RACCSS(  3, 14) =  0.117592E+01
  PKER_RACCSS(  3, 15) =  0.132041E+01
  PKER_RACCSS(  3, 16) =  0.144256E+01
  PKER_RACCSS(  3, 17) =  0.154410E+01
  PKER_RACCSS(  3, 18) =  0.162816E+01
  PKER_RACCSS(  3, 19) =  0.169770E+01
  PKER_RACCSS(  3, 20) =  0.175523E+01
  PKER_RACCSS(  3, 21) =  0.180284E+01
  PKER_RACCSS(  3, 22) =  0.184222E+01
  PKER_RACCSS(  3, 23) =  0.187482E+01
  PKER_RACCSS(  3, 24) =  0.190179E+01
  PKER_RACCSS(  3, 25) =  0.192411E+01
  PKER_RACCSS(  3, 26) =  0.194259E+01
  PKER_RACCSS(  3, 27) =  0.195788E+01
  PKER_RACCSS(  3, 28) =  0.197054E+01
  PKER_RACCSS(  3, 29) =  0.198101E+01
  PKER_RACCSS(  3, 30) =  0.198968E+01
  PKER_RACCSS(  3, 31) =  0.199686E+01
  PKER_RACCSS(  3, 32) =  0.200280E+01
  PKER_RACCSS(  3, 33) =  0.200772E+01
  PKER_RACCSS(  3, 34) =  0.201179E+01
  PKER_RACCSS(  3, 35) =  0.201516E+01
  PKER_RACCSS(  3, 36) =  0.201795E+01
  PKER_RACCSS(  3, 37) =  0.202026E+01
  PKER_RACCSS(  3, 38) =  0.202217E+01
  PKER_RACCSS(  3, 39) =  0.202375E+01
  PKER_RACCSS(  3, 40) =  0.202506E+01
  PKER_RACCSS(  4,  1) =  0.726688E+01
  PKER_RACCSS(  4,  2) =  0.610352E+01
  PKER_RACCSS(  4,  3) =  0.493154E+01
  PKER_RACCSS(  4,  4) =  0.385226E+01
  PKER_RACCSS(  4,  5) =  0.291497E+01
  PKER_RACCSS(  4,  6) =  0.213576E+01
  PKER_RACCSS(  4,  7) =  0.151726E+01
  PKER_RACCSS(  4,  8) =  0.106239E+01
  PKER_RACCSS(  4,  9) =  0.773458E+00
  PKER_RACCSS(  4, 10) =  0.643197E+00
  PKER_RACCSS(  4, 11) =  0.648455E+00
  PKER_RACCSS(  4, 12) =  0.748702E+00
  PKER_RACCSS(  4, 13) =  0.896286E+00
  PKER_RACCSS(  4, 14) =  0.105225E+01
  PKER_RACCSS(  4, 15) =  0.119469E+01
  PKER_RACCSS(  4, 16) =  0.131651E+01
  PKER_RACCSS(  4, 17) =  0.141813E+01
  PKER_RACCSS(  4, 18) =  0.150231E+01
  PKER_RACCSS(  4, 19) =  0.157195E+01
  PKER_RACCSS(  4, 20) =  0.162955E+01
  PKER_RACCSS(  4, 21) =  0.167720E+01
  PKER_RACCSS(  4, 22) =  0.171662E+01
  PKER_RACCSS(  4, 23) =  0.174924E+01
  PKER_RACCSS(  4, 24) =  0.177624E+01
  PKER_RACCSS(  4, 25) =  0.179858E+01
  PKER_RACCSS(  4, 26) =  0.181706E+01
  PKER_RACCSS(  4, 27) =  0.183237E+01
  PKER_RACCSS(  4, 28) =  0.184503E+01
  PKER_RACCSS(  4, 29) =  0.185551E+01
  PKER_RACCSS(  4, 30) =  0.186419E+01
  PKER_RACCSS(  4, 31) =  0.187137E+01
  PKER_RACCSS(  4, 32) =  0.187731E+01
  PKER_RACCSS(  4, 33) =  0.188223E+01
  PKER_RACCSS(  4, 34) =  0.188630E+01
  PKER_RACCSS(  4, 35) =  0.188967E+01
  PKER_RACCSS(  4, 36) =  0.189246E+01
  PKER_RACCSS(  4, 37) =  0.189477E+01
  PKER_RACCSS(  4, 38) =  0.189668E+01
  PKER_RACCSS(  4, 39) =  0.189826E+01
  PKER_RACCSS(  4, 40) =  0.189957E+01
  PKER_RACCSS(  5,  1) =  0.666156E+01
  PKER_RACCSS(  5,  2) =  0.583010E+01
  PKER_RACCSS(  5,  3) =  0.485991E+01
  PKER_RACCSS(  5,  4) =  0.388726E+01
  PKER_RACCSS(  5,  5) =  0.299622E+01
  PKER_RACCSS(  5,  6) =  0.223002E+01
  PKER_RACCSS(  5,  7) =  0.160523E+01
  PKER_RACCSS(  5,  8) =  0.112806E+01
  PKER_RACCSS(  5,  9) =  0.803444E+00
  PKER_RACCSS(  5, 10) =  0.630781E+00
  PKER_RACCSS(  5, 11) =  0.594728E+00
  PKER_RACCSS(  5, 12) =  0.662791E+00
  PKER_RACCSS(  5, 13) =  0.790719E+00
  PKER_RACCSS(  5, 14) =  0.937530E+00
  PKER_RACCSS(  5, 15) =  0.107695E+01
  PKER_RACCSS(  5, 16) =  0.119816E+01
  PKER_RACCSS(  5, 17) =  0.129982E+01
  PKER_RACCSS(  5, 18) =  0.138414E+01
  PKER_RACCSS(  5, 19) =  0.145388E+01
  PKER_RACCSS(  5, 20) =  0.151157E+01
  PKER_RACCSS(  5, 21) =  0.155928E+01
  PKER_RACCSS(  5, 22) =  0.159875E+01
  PKER_RACCSS(  5, 23) =  0.163140E+01
  PKER_RACCSS(  5, 24) =  0.165842E+01
  PKER_RACCSS(  5, 25) =  0.168078E+01
  PKER_RACCSS(  5, 26) =  0.169928E+01
  PKER_RACCSS(  5, 27) =  0.171459E+01
  PKER_RACCSS(  5, 28) =  0.172727E+01
  PKER_RACCSS(  5, 29) =  0.173775E+01
  PKER_RACCSS(  5, 30) =  0.174643E+01
  PKER_RACCSS(  5, 31) =  0.175362E+01
  PKER_RACCSS(  5, 32) =  0.175957E+01
  PKER_RACCSS(  5, 33) =  0.176449E+01
  PKER_RACCSS(  5, 34) =  0.176856E+01
  PKER_RACCSS(  5, 35) =  0.177193E+01
  PKER_RACCSS(  5, 36) =  0.177472E+01
  PKER_RACCSS(  5, 37) =  0.177703E+01
  PKER_RACCSS(  5, 38) =  0.177895E+01
  PKER_RACCSS(  5, 39) =  0.178053E+01
  PKER_RACCSS(  5, 40) =  0.178184E+01
  PKER_RACCSS(  6,  1) =  0.579411E+01
  PKER_RACCSS(  6,  2) =  0.535171E+01
  PKER_RACCSS(  6,  3) =  0.465234E+01
  PKER_RACCSS(  6,  4) =  0.384358E+01
  PKER_RACCSS(  6,  5) =  0.303756E+01
  PKER_RACCSS(  6,  6) =  0.230559E+01
  PKER_RACCSS(  6,  7) =  0.168583E+01
  PKER_RACCSS(  6,  8) =  0.119580E+01
  PKER_RACCSS(  6,  9) =  0.843934E+00
  PKER_RACCSS(  6, 10) =  0.633155E+00
  PKER_RACCSS(  6, 11) =  0.557339E+00
  PKER_RACCSS(  6, 12) =  0.591240E+00
  PKER_RACCSS(  6, 13) =  0.696457E+00
  PKER_RACCSS(  6, 14) =  0.831746E+00
  PKER_RACCSS(  6, 15) =  0.966879E+00
  PKER_RACCSS(  6, 16) =  0.108705E+01
  PKER_RACCSS(  6, 17) =  0.118868E+01
  PKER_RACCSS(  6, 18) =  0.127314E+01
  PKER_RACCSS(  6, 19) =  0.134302E+01
  PKER_RACCSS(  6, 20) =  0.140081E+01
  PKER_RACCSS(  6, 21) =  0.144859E+01
  PKER_RACCSS(  6, 22) =  0.148812E+01
  PKER_RACCSS(  6, 23) =  0.152081E+01
  PKER_RACCSS(  6, 24) =  0.154786E+01
  PKER_RACCSS(  6, 25) =  0.157025E+01
  PKER_RACCSS(  6, 26) =  0.158876E+01
  PKER_RACCSS(  6, 27) =  0.160409E+01
  PKER_RACCSS(  6, 28) =  0.161677E+01
  PKER_RACCSS(  6, 29) =  0.162727E+01
  PKER_RACCSS(  6, 30) =  0.163595E+01
  PKER_RACCSS(  6, 31) =  0.164314E+01
  PKER_RACCSS(  6, 32) =  0.164909E+01
  PKER_RACCSS(  6, 33) =  0.165402E+01
  PKER_RACCSS(  6, 34) =  0.165809E+01
  PKER_RACCSS(  6, 35) =  0.166147E+01
  PKER_RACCSS(  6, 36) =  0.166426E+01
  PKER_RACCSS(  6, 37) =  0.166657E+01
  PKER_RACCSS(  6, 38) =  0.166848E+01
  PKER_RACCSS(  6, 39) =  0.167007E+01
  PKER_RACCSS(  6, 40) =  0.167138E+01
  PKER_RACCSS(  7,  1) =  0.471256E+01
  PKER_RACCSS(  7,  2) =  0.465839E+01
  PKER_RACCSS(  7,  3) =  0.427722E+01
  PKER_RACCSS(  7,  4) =  0.368892E+01
  PKER_RACCSS(  7,  5) =  0.301520E+01
  PKER_RACCSS(  7,  6) =  0.234970E+01
  PKER_RACCSS(  7,  7) =  0.175327E+01
  PKER_RACCSS(  7,  8) =  0.126056E+01
  PKER_RACCSS(  7,  9) =  0.889610E+00
  PKER_RACCSS(  7, 10) =  0.648011E+00
  PKER_RACCSS(  7, 11) =  0.534534E+00
  PKER_RACCSS(  7, 12) =  0.533743E+00
  PKER_RACCSS(  7, 13) =  0.613806E+00
  PKER_RACCSS(  7, 14) =  0.735010E+00
  PKER_RACCSS(  7, 15) =  0.864301E+00
  PKER_RACCSS(  7, 16) =  0.982807E+00
  PKER_RACCSS(  7, 17) =  0.108425E+01
  PKER_RACCSS(  7, 18) =  0.116886E+01
  PKER_RACCSS(  7, 19) =  0.123890E+01
  PKER_RACCSS(  7, 20) =  0.129681E+01
  PKER_RACCSS(  7, 21) =  0.134469E+01
  PKER_RACCSS(  7, 22) =  0.138428E+01
  PKER_RACCSS(  7, 23) =  0.141702E+01
  PKER_RACCSS(  7, 24) =  0.144411E+01
  PKER_RACCSS(  7, 25) =  0.146652E+01
  PKER_RACCSS(  7, 26) =  0.148506E+01
  PKER_RACCSS(  7, 27) =  0.150040E+01
  PKER_RACCSS(  7, 28) =  0.151309E+01
  PKER_RACCSS(  7, 29) =  0.152360E+01
  PKER_RACCSS(  7, 30) =  0.153229E+01
  PKER_RACCSS(  7, 31) =  0.153949E+01
  PKER_RACCSS(  7, 32) =  0.154544E+01
  PKER_RACCSS(  7, 33) =  0.155037E+01
  PKER_RACCSS(  7, 34) =  0.155445E+01
  PKER_RACCSS(  7, 35) =  0.155782E+01
  PKER_RACCSS(  7, 36) =  0.156062E+01
  PKER_RACCSS(  7, 37) =  0.156293E+01
  PKER_RACCSS(  7, 38) =  0.156484E+01
  PKER_RACCSS(  7, 39) =  0.156643E+01
  PKER_RACCSS(  7, 40) =  0.156774E+01
  PKER_RACCSS(  8,  1) =  0.353255E+01
  PKER_RACCSS(  8,  2) =  0.378953E+01
  PKER_RACCSS(  8,  3) =  0.372636E+01
  PKER_RACCSS(  8,  4) =  0.339746E+01
  PKER_RACCSS(  8,  5) =  0.290255E+01
  PKER_RACCSS(  8,  6) =  0.234259E+01
  PKER_RACCSS(  8,  7) =  0.179670E+01
  PKER_RACCSS(  8,  8) =  0.131725E+01
  PKER_RACCSS(  8,  9) =  0.936217E+00
  PKER_RACCSS(  8, 10) =  0.670685E+00
  PKER_RACCSS(  8, 11) =  0.525055E+00
  PKER_RACCSS(  8, 12) =  0.490553E+00
  PKER_RACCSS(  8, 13) =  0.543364E+00
  PKER_RACCSS(  8, 14) =  0.647682E+00
  PKER_RACCSS(  8, 15) =  0.769109E+00
  PKER_RACCSS(  8, 16) =  0.885089E+00
  PKER_RACCSS(  8, 17) =  0.986107E+00
  PKER_RACCSS(  8, 18) =  0.107085E+01
  PKER_RACCSS(  8, 19) =  0.114108E+01
  PKER_RACCSS(  8, 20) =  0.119914E+01
  PKER_RACCSS(  8, 21) =  0.124712E+01
  PKER_RACCSS(  8, 22) =  0.128680E+01
  PKER_RACCSS(  8, 23) =  0.131960E+01
  PKER_RACCSS(  8, 24) =  0.134673E+01
  PKER_RACCSS(  8, 25) =  0.136917E+01
  PKER_RACCSS(  8, 26) =  0.138774E+01
  PKER_RACCSS(  8, 27) =  0.140310E+01
  PKER_RACCSS(  8, 28) =  0.141581E+01
  PKER_RACCSS(  8, 29) =  0.142633E+01
  PKER_RACCSS(  8, 30) =  0.143503E+01
  PKER_RACCSS(  8, 31) =  0.144223E+01
  PKER_RACCSS(  8, 32) =  0.144819E+01
  PKER_RACCSS(  8, 33) =  0.145312E+01
  PKER_RACCSS(  8, 34) =  0.145720E+01
  PKER_RACCSS(  8, 35) =  0.146058E+01
  PKER_RACCSS(  8, 36) =  0.146338E+01
  PKER_RACCSS(  8, 37) =  0.146569E+01
  PKER_RACCSS(  8, 38) =  0.146761E+01
  PKER_RACCSS(  8, 39) =  0.146919E+01
  PKER_RACCSS(  8, 40) =  0.147050E+01
  PKER_RACCSS(  9,  1) =  0.240807E+01
  PKER_RACCSS(  9,  2) =  0.283932E+01
  PKER_RACCSS(  9,  3) =  0.303178E+01
  PKER_RACCSS(  9,  4) =  0.296265E+01
  PKER_RACCSS(  9,  5) =  0.267871E+01
  PKER_RACCSS(  9,  6) =  0.226276E+01
  PKER_RACCSS(  9,  7) =  0.179979E+01
  PKER_RACCSS(  9,  8) =  0.135674E+01
  PKER_RACCSS(  9,  9) =  0.979933E+00
  PKER_RACCSS(  9, 10) =  0.698320E+00
  PKER_RACCSS(  9, 11) =  0.525242E+00
  PKER_RACCSS(  9, 12) =  0.460033E+00
  PKER_RACCSS(  9, 13) =  0.484763E+00
  PKER_RACCSS(  9, 14) =  0.569735E+00
  PKER_RACCSS(  9, 15) =  0.681283E+00
  PKER_RACCSS(  9, 16) =  0.793641E+00
  PKER_RACCSS(  9, 17) =  0.893878E+00
  PKER_RACCSS(  9, 18) =  0.978690E+00
  PKER_RACCSS(  9, 19) =  0.104914E+01
  PKER_RACCSS(  9, 20) =  0.110738E+01
  PKER_RACCSS(  9, 21) =  0.115550E+01
  PKER_RACCSS(  9, 22) =  0.119527E+01
  PKER_RACCSS(  9, 23) =  0.122815E+01
  PKER_RACCSS(  9, 24) =  0.125533E+01
  PKER_RACCSS(  9, 25) =  0.127782E+01
  PKER_RACCSS(  9, 26) =  0.129641E+01
  PKER_RACCSS(  9, 27) =  0.131179E+01
  PKER_RACCSS(  9, 28) =  0.132452E+01
  PKER_RACCSS(  9, 29) =  0.133505E+01
  PKER_RACCSS(  9, 30) =  0.134376E+01
  PKER_RACCSS(  9, 31) =  0.135097E+01
  PKER_RACCSS(  9, 32) =  0.135694E+01
  PKER_RACCSS(  9, 33) =  0.136188E+01
  PKER_RACCSS(  9, 34) =  0.136596E+01
  PKER_RACCSS(  9, 35) =  0.136934E+01
  PKER_RACCSS(  9, 36) =  0.137214E+01
  PKER_RACCSS(  9, 37) =  0.137446E+01
  PKER_RACCSS(  9, 38) =  0.137637E+01
  PKER_RACCSS(  9, 39) =  0.137796E+01
  PKER_RACCSS(  9, 40) =  0.137927E+01
  PKER_RACCSS( 10,  1) =  0.147671E+01
  PKER_RACCSS( 10,  2) =  0.193328E+01
  PKER_RACCSS( 10,  3) =  0.227014E+01
  PKER_RACCSS( 10,  4) =  0.241054E+01
  PKER_RACCSS( 10,  5) =  0.233821E+01
  PKER_RACCSS( 10,  6) =  0.209295E+01
  PKER_RACCSS( 10,  7) =  0.174482E+01
  PKER_RACCSS( 10,  8) =  0.136525E+01
  PKER_RACCSS( 10,  9) =  0.101239E+01
  PKER_RACCSS( 10, 10) =  0.726741E+00
  PKER_RACCSS( 10, 11) =  0.533079E+00
  PKER_RACCSS( 10, 12) =  0.439515E+00
  PKER_RACCSS( 10, 13) =  0.437071E+00
  PKER_RACCSS( 10, 14) =  0.501385E+00
  PKER_RACCSS( 10, 15) =  0.600980E+00
  PKER_RACCSS( 10, 16) =  0.708337E+00
  PKER_RACCSS( 10, 17) =  0.807233E+00
  PKER_RACCSS( 10, 18) =  0.892004E+00
  PKER_RACCSS( 10, 19) =  0.962681E+00
  PKER_RACCSS( 10, 20) =  0.102114E+01
  PKER_RACCSS( 10, 21) =  0.106943E+01
  PKER_RACCSS( 10, 22) =  0.110932E+01
  PKER_RACCSS( 10, 23) =  0.114228E+01
  PKER_RACCSS( 10, 24) =  0.116953E+01
  PKER_RACCSS( 10, 25) =  0.119207E+01
  PKER_RACCSS( 10, 26) =  0.121070E+01
  PKER_RACCSS( 10, 27) =  0.122611E+01
  PKER_RACCSS( 10, 28) =  0.123886E+01
  PKER_RACCSS( 10, 29) =  0.124940E+01
  PKER_RACCSS( 10, 30) =  0.125813E+01
  PKER_RACCSS( 10, 31) =  0.126535E+01
  PKER_RACCSS( 10, 32) =  0.127132E+01
  PKER_RACCSS( 10, 33) =  0.127626E+01
  PKER_RACCSS( 10, 34) =  0.128035E+01
  PKER_RACCSS( 10, 35) =  0.128374E+01
  PKER_RACCSS( 10, 36) =  0.128654E+01
  PKER_RACCSS( 10, 37) =  0.128886E+01
  PKER_RACCSS( 10, 38) =  0.129077E+01
  PKER_RACCSS( 10, 39) =  0.129236E+01
  PKER_RACCSS( 10, 40) =  0.129368E+01
  PKER_RACCSS( 11,  1) =  0.808661E+00
  PKER_RACCSS( 11,  2) =  0.118349E+01
  PKER_RACCSS( 11,  3) =  0.154344E+01
  PKER_RACCSS( 11,  4) =  0.180338E+01
  PKER_RACCSS( 11,  5) =  0.190224E+01
  PKER_RACCSS( 11,  6) =  0.182880E+01
  PKER_RACCSS( 11,  7) =  0.161765E+01
  PKER_RACCSS( 11,  8) =  0.132833E+01
  PKER_RACCSS( 11,  9) =  0.102209E+01
  PKER_RACCSS( 11, 10) =  0.749176E+00
  PKER_RACCSS( 11, 11) =  0.544780E+00
  PKER_RACCSS( 11, 12) =  0.428018E+00
  PKER_RACCSS( 11, 13) =  0.399615E+00
  PKER_RACCSS( 11, 14) =  0.442486E+00
  PKER_RACCSS( 11, 15) =  0.528291E+00
  PKER_RACCSS( 11, 16) =  0.629068E+00
  PKER_RACCSS( 11, 17) =  0.725892E+00
  PKER_RACCSS( 11, 18) =  0.810425E+00
  PKER_RACCSS( 11, 19) =  0.881336E+00
  PKER_RACCSS( 11, 20) =  0.940053E+00
  PKER_RACCSS( 11, 21) =  0.988540E+00
  PKER_RACCSS( 11, 22) =  0.102858E+01
  PKER_RACCSS( 11, 23) =  0.106165E+01
  PKER_RACCSS( 11, 24) =  0.108898E+01
  PKER_RACCSS( 11, 25) =  0.111157E+01
  PKER_RACCSS( 11, 26) =  0.113025E+01
  PKER_RACCSS( 11, 27) =  0.114569E+01
  PKER_RACCSS( 11, 28) =  0.115847E+01
  PKER_RACCSS( 11, 29) =  0.116903E+01
  PKER_RACCSS( 11, 30) =  0.117777E+01
  PKER_RACCSS( 11, 31) =  0.118500E+01
  PKER_RACCSS( 11, 32) =  0.119098E+01
  PKER_RACCSS( 11, 33) =  0.119593E+01
  PKER_RACCSS( 11, 34) =  0.120003E+01
  PKER_RACCSS( 11, 35) =  0.120342E+01
  PKER_RACCSS( 11, 36) =  0.120622E+01
  PKER_RACCSS( 11, 37) =  0.120854E+01
  PKER_RACCSS( 11, 38) =  0.121046E+01
  PKER_RACCSS( 11, 39) =  0.121205E+01
  PKER_RACCSS( 11, 40) =  0.121337E+01
  PKER_RACCSS( 12,  1) =  0.394253E+00
  PKER_RACCSS( 12,  2) =  0.646179E+00
  PKER_RACCSS( 12,  3) =  0.942558E+00
  PKER_RACCSS( 12,  4) =  0.122389E+01
  PKER_RACCSS( 12,  5) =  0.142127E+01
  PKER_RACCSS( 12,  6) =  0.148735E+01
  PKER_RACCSS( 12,  7) =  0.141473E+01
  PKER_RACCSS( 12,  8) =  0.123412E+01
  PKER_RACCSS( 12,  9) =  0.996999E+00
  PKER_RACCSS( 12, 10) =  0.756208E+00
  PKER_RACCSS( 12, 11) =  0.555253E+00
  PKER_RACCSS( 12, 12) =  0.422862E+00
  PKER_RACCSS( 12, 13) =  0.371247E+00
  PKER_RACCSS( 12, 14) =  0.392052E+00
  PKER_RACCSS( 12, 15) =  0.462634E+00
  PKER_RACCSS( 12, 16) =  0.555651E+00
  PKER_RACCSS( 12, 17) =  0.649618E+00
  PKER_RACCSS( 12, 18) =  0.733630E+00
  PKER_RACCSS( 12, 19) =  0.804744E+00
  PKER_RACCSS( 12, 20) =  0.863761E+00
  PKER_RACCSS( 12, 21) =  0.912491E+00
  PKER_RACCSS( 12, 22) =  0.952708E+00
  PKER_RACCSS( 12, 23) =  0.985912E+00
  PKER_RACCSS( 12, 24) =  0.101334E+01
  PKER_RACCSS( 12, 25) =  0.103600E+01
  PKER_RACCSS( 12, 26) =  0.105473E+01
  PKER_RACCSS( 12, 27) =  0.107022E+01
  PKER_RACCSS( 12, 28) =  0.108302E+01
  PKER_RACCSS( 12, 29) =  0.109361E+01
  PKER_RACCSS( 12, 30) =  0.110236E+01
  PKER_RACCSS( 12, 31) =  0.110961E+01
  PKER_RACCSS( 12, 32) =  0.111560E+01
  PKER_RACCSS( 12, 33) =  0.112056E+01
  PKER_RACCSS( 12, 34) =  0.112466E+01
  PKER_RACCSS( 12, 35) =  0.112805E+01
  PKER_RACCSS( 12, 36) =  0.113086E+01
  PKER_RACCSS( 12, 37) =  0.113319E+01
  PKER_RACCSS( 12, 38) =  0.113511E+01
  PKER_RACCSS( 12, 39) =  0.113670E+01
  PKER_RACCSS( 12, 40) =  0.113802E+01
  PKER_RACCSS( 13,  1) =  0.171360E+00
  PKER_RACCSS( 13,  2) =  0.313975E+00
  PKER_RACCSS( 13,  3) =  0.512870E+00
  PKER_RACCSS( 13,  4) =  0.744995E+00
  PKER_RACCSS( 13,  5) =  0.962081E+00
  PKER_RACCSS( 13,  6) =  0.110931E+01
  PKER_RACCSS( 13,  7) =  0.114976E+01
  PKER_RACCSS( 13,  8) =  0.107985E+01
  PKER_RACCSS( 13,  9) =  0.927521E+00
  PKER_RACCSS( 13, 10) =  0.737617E+00
  PKER_RACCSS( 13, 11) =  0.556237E+00
  PKER_RACCSS( 13, 12) =  0.420066E+00
  PKER_RACCSS( 13, 13) =  0.350230E+00
  PKER_RACCSS( 13, 14) =  0.349906E+00
  PKER_RACCSS( 13, 15) =  0.404063E+00
  PKER_RACCSS( 13, 16) =  0.487780E+00
  PKER_RACCSS( 13, 17) =  0.578111E+00
  PKER_RACCSS( 13, 18) =  0.661299E+00
  PKER_RACCSS( 13, 19) =  0.732568E+00
  PKER_RACCSS( 13, 20) =  0.791923E+00
  PKER_RACCSS( 13, 21) =  0.840945E+00
  PKER_RACCSS( 13, 22) =  0.881381E+00
  PKER_RACCSS( 13, 23) =  0.914745E+00
  PKER_RACCSS( 13, 24) =  0.942288E+00
  PKER_RACCSS( 13, 25) =  0.965037E+00
  PKER_RACCSS( 13, 26) =  0.983832E+00
  PKER_RACCSS( 13, 27) =  0.999365E+00
  PKER_RACCSS( 13, 28) =  0.101221E+01
  PKER_RACCSS( 13, 29) =  0.102282E+01
  PKER_RACCSS( 13, 30) =  0.103160E+01
  PKER_RACCSS( 13, 31) =  0.103886E+01
  PKER_RACCSS( 13, 32) =  0.104487E+01
  PKER_RACCSS( 13, 33) =  0.104983E+01
  PKER_RACCSS( 13, 34) =  0.105394E+01
  PKER_RACCSS( 13, 35) =  0.105734E+01
  PKER_RACCSS( 13, 36) =  0.106016E+01
  PKER_RACCSS( 13, 37) =  0.106248E+01
  PKER_RACCSS( 13, 38) =  0.106441E+01
  PKER_RACCSS( 13, 39) =  0.106600E+01
  PKER_RACCSS( 13, 40) =  0.106732E+01
  PKER_RACCSS( 14,  1) =  0.880495E-01
  PKER_RACCSS( 14,  2) =  0.175611E+00
  PKER_RACCSS( 14,  3) =  0.247975E+00
  PKER_RACCSS( 14,  4) =  0.403566E+00
  PKER_RACCSS( 14,  5) =  0.583307E+00
  PKER_RACCSS( 14,  6) =  0.748280E+00
  PKER_RACCSS( 14,  7) =  0.855344E+00
  PKER_RACCSS( 14,  8) =  0.876333E+00
  PKER_RACCSS( 14,  9) =  0.811263E+00
  PKER_RACCSS( 14, 10) =  0.685718E+00
  PKER_RACCSS( 14, 11) =  0.539707E+00
  PKER_RACCSS( 14, 12) =  0.412364E+00
  PKER_RACCSS( 14, 13) =  0.333785E+00
  PKER_RACCSS( 14, 14) =  0.315877E+00
  PKER_RACCSS( 14, 15) =  0.352939E+00
  PKER_RACCSS( 14, 16) =  0.425537E+00
  PKER_RACCSS( 14, 17) =  0.511002E+00
  PKER_RACCSS( 14, 18) =  0.593027E+00
  PKER_RACCSS( 14, 19) =  0.664451E+00
  PKER_RACCSS( 14, 20) =  0.724208E+00
  PKER_RACCSS( 14, 21) =  0.773584E+00
  PKER_RACCSS( 14, 22) =  0.814286E+00
  PKER_RACCSS( 14, 23) =  0.847845E+00
  PKER_RACCSS( 14, 24) =  0.875531E+00
  PKER_RACCSS( 14, 25) =  0.898385E+00
  PKER_RACCSS( 14, 26) =  0.917258E+00
  PKER_RACCSS( 14, 27) =  0.932850E+00
  PKER_RACCSS( 14, 28) =  0.945734E+00
  PKER_RACCSS( 14, 29) =  0.956384E+00
  PKER_RACCSS( 14, 30) =  0.965189E+00
  PKER_RACCSS( 14, 31) =  0.972469E+00
  PKER_RACCSS( 14, 32) =  0.978490E+00
  PKER_RACCSS( 14, 33) =  0.983469E+00
  PKER_RACCSS( 14, 34) =  0.987588E+00
  PKER_RACCSS( 14, 35) =  0.990995E+00
  PKER_RACCSS( 14, 36) =  0.993813E+00
  PKER_RACCSS( 14, 37) =  0.996145E+00
  PKER_RACCSS( 14, 38) =  0.998074E+00
  PKER_RACCSS( 14, 39) =  0.999670E+00
  PKER_RACCSS( 14, 40) =  0.100099E+01
  PKER_RACCSS( 15,  1) =  0.315291E-01
  PKER_RACCSS( 15,  2) =  0.693241E-01
  PKER_RACCSS( 15,  3) =  0.137798E+00
  PKER_RACCSS( 15,  4) =  0.193925E+00
  PKER_RACCSS( 15,  5) =  0.314161E+00
  PKER_RACCSS( 15,  6) =  0.451226E+00
  PKER_RACCSS( 15,  7) =  0.574319E+00
  PKER_RACCSS( 15,  8) =  0.649498E+00
  PKER_RACCSS( 15,  9) =  0.656529E+00
  PKER_RACCSS( 15, 10) =  0.598237E+00
  PKER_RACCSS( 15, 11) =  0.499202E+00
  PKER_RACCSS( 15, 12) =  0.394122E+00
  PKER_RACCSS( 15, 13) =  0.316374E+00
  PKER_RACCSS( 15, 14) =  0.287121E+00
  PKER_RACCSS( 15, 15) =  0.308960E+00
  PKER_RACCSS( 15, 16) =  0.369539E+00
  PKER_RACCSS( 15, 17) =  0.448627E+00
  PKER_RACCSS( 15, 18) =  0.528619E+00
  PKER_RACCSS( 15, 19) =  0.600043E+00
  PKER_RACCSS( 15, 20) =  0.660278E+00
  PKER_RACCSS( 15, 21) =  0.710095E+00
  PKER_RACCSS( 15, 22) =  0.751124E+00
  PKER_RACCSS( 15, 23) =  0.784920E+00
  PKER_RACCSS( 15, 24) =  0.812780E+00
  PKER_RACCSS( 15, 25) =  0.835762E+00
  PKER_RACCSS( 15, 26) =  0.854730E+00
  PKER_RACCSS( 15, 27) =  0.870393E+00
  PKER_RACCSS( 15, 28) =  0.883331E+00
  PKER_RACCSS( 15, 29) =  0.894022E+00
  PKER_RACCSS( 15, 30) =  0.902857E+00
  PKER_RACCSS( 15, 31) =  0.910161E+00
  PKER_RACCSS( 15, 32) =  0.916200E+00
  PKER_RACCSS( 15, 33) =  0.921193E+00
  PKER_RACCSS( 15, 34) =  0.925323E+00
  PKER_RACCSS( 15, 35) =  0.928738E+00
  PKER_RACCSS( 15, 36) =  0.931563E+00
  PKER_RACCSS( 15, 37) =  0.933900E+00
  PKER_RACCSS( 15, 38) =  0.935833E+00
  PKER_RACCSS( 15, 39) =  0.937432E+00
  PKER_RACCSS( 15, 40) =  0.938755E+00
  PKER_RACCSS( 16,  1) =  0.360358E+01
  PKER_RACCSS( 16,  2) =  0.281969E+01
  PKER_RACCSS( 16,  3) =  0.219170E+01
  PKER_RACCSS( 16,  4) =  0.170588E+01
  PKER_RACCSS( 16,  5) =  0.135069E+01
  PKER_RACCSS( 16,  6) =  0.110996E+01
  PKER_RACCSS( 16,  7) =  0.957328E+00
  PKER_RACCSS( 16,  8) =  0.855867E+00
  PKER_RACCSS( 16,  9) =  0.767727E+00
  PKER_RACCSS( 16, 10) =  0.667811E+00
  PKER_RACCSS( 16, 11) =  0.551774E+00
  PKER_RACCSS( 16, 12) =  0.434001E+00
  PKER_RACCSS( 16, 13) =  0.338225E+00
  PKER_RACCSS( 16, 14) =  0.285601E+00
  PKER_RACCSS( 16, 15) =  0.284136E+00
  PKER_RACCSS( 16, 16) =  0.326430E+00
  PKER_RACCSS( 16, 17) =  0.394397E+00
  PKER_RACCSS( 16, 18) =  0.469502E+00
  PKER_RACCSS( 16, 19) =  0.539605E+00
  PKER_RACCSS( 16, 20) =  0.599949E+00
  PKER_RACCSS( 16, 21) =  0.650193E+00
  PKER_RACCSS( 16, 22) =  0.691608E+00
  PKER_RACCSS( 16, 23) =  0.725693E+00
  PKER_RACCSS( 16, 24) =  0.753765E+00
  PKER_RACCSS( 16, 25) =  0.776902E+00
  PKER_RACCSS( 16, 26) =  0.795985E+00
  PKER_RACCSS( 16, 27) =  0.811734E+00
  PKER_RACCSS( 16, 28) =  0.824737E+00
  PKER_RACCSS( 16, 29) =  0.835476E+00
  PKER_RACCSS( 16, 30) =  0.844348E+00
  PKER_RACCSS( 16, 31) =  0.851681E+00
  PKER_RACCSS( 16, 32) =  0.857741E+00
  PKER_RACCSS( 16, 33) =  0.862751E+00
  PKER_RACCSS( 16, 34) =  0.866894E+00
  PKER_RACCSS( 16, 35) =  0.870319E+00
  PKER_RACCSS( 16, 36) =  0.873152E+00
  PKER_RACCSS( 16, 37) =  0.875495E+00
  PKER_RACCSS( 16, 38) =  0.877433E+00
  PKER_RACCSS( 16, 39) =  0.879036E+00
  PKER_RACCSS( 16, 40) =  0.880362E+00
  PKER_RACCSS( 17,  1) =  0.472676E+01
  PKER_RACCSS( 17,  2) =  0.370797E+01
  PKER_RACCSS( 17,  3) =  0.231793E+01
  PKER_RACCSS( 17,  4) =  0.179758E+01
  PKER_RACCSS( 17,  5) =  0.139358E+01
  PKER_RACCSS( 17,  6) =  0.109574E+01
  PKER_RACCSS( 17,  7) =  0.890250E+00
  PKER_RACCSS( 17,  8) =  0.755210E+00
  PKER_RACCSS( 17,  9) =  0.661386E+00
  PKER_RACCSS( 17, 10) =  0.579824E+00
  PKER_RACCSS( 17, 11) =  0.493157E+00
  PKER_RACCSS( 17, 12) =  0.401316E+00
  PKER_RACCSS( 17, 13) =  0.318099E+00
  PKER_RACCSS( 17, 14) =  0.264075E+00
  PKER_RACCSS( 17, 15) =  0.252206E+00
  PKER_RACCSS( 17, 16) =  0.282309E+00
  PKER_RACCSS( 17, 17) =  0.341880E+00
  PKER_RACCSS( 17, 18) =  0.413082E+00
  PKER_RACCSS( 17, 19) =  0.482222E+00
  PKER_RACCSS( 17, 20) =  0.542813E+00
  PKER_RACCSS( 17, 21) =  0.593576E+00
  PKER_RACCSS( 17, 22) =  0.635456E+00
  PKER_RACCSS( 17, 23) =  0.669894E+00
  PKER_RACCSS( 17, 24) =  0.698224E+00
  PKER_RACCSS( 17, 25) =  0.721550E+00
  PKER_RACCSS( 17, 26) =  0.740773E+00
  PKER_RACCSS( 17, 27) =  0.756626E+00
  PKER_RACCSS( 17, 28) =  0.769706E+00
  PKER_RACCSS( 17, 29) =  0.780504E+00
  PKER_RACCSS( 17, 30) =  0.789421E+00
  PKER_RACCSS( 17, 31) =  0.796788E+00
  PKER_RACCSS( 17, 32) =  0.802874E+00
  PKER_RACCSS( 17, 33) =  0.807905E+00
  PKER_RACCSS( 17, 34) =  0.812063E+00
  PKER_RACCSS( 17, 35) =  0.815500E+00
  PKER_RACCSS( 17, 36) =  0.818342E+00
  PKER_RACCSS( 17, 37) =  0.820693E+00
  PKER_RACCSS( 17, 38) =  0.822636E+00
  PKER_RACCSS( 17, 39) =  0.824244E+00
  PKER_RACCSS( 17, 40) =  0.825573E+00
  PKER_RACCSS( 18,  1) =  0.603863E+01
  PKER_RACCSS( 18,  2) =  0.389316E+01
  PKER_RACCSS( 18,  3) =  0.305031E+01
  PKER_RACCSS( 18,  4) =  0.236338E+01
  PKER_RACCSS( 18,  5) =  0.147231E+01
  PKER_RACCSS( 18,  6) =  0.113620E+01
  PKER_RACCSS( 18,  7) =  0.886115E+00
  PKER_RACCSS( 18,  8) =  0.710209E+00
  PKER_RACCSS( 18,  9) =  0.590674E+00
  PKER_RACCSS( 18, 10) =  0.504703E+00
  PKER_RACCSS( 18, 11) =  0.431038E+00
  PKER_RACCSS( 18, 12) =  0.358809E+00
  PKER_RACCSS( 18, 13) =  0.290844E+00
  PKER_RACCSS( 18, 14) =  0.240768E+00
  PKER_RACCSS( 18, 15) =  0.223220E+00
  PKER_RACCSS( 18, 16) =  0.243218E+00
  PKER_RACCSS( 18, 17) =  0.293836E+00
  PKER_RACCSS( 18, 18) =  0.360151E+00
  PKER_RACCSS( 18, 19) =  0.427795E+00
  PKER_RACCSS( 18, 20) =  0.488580E+00
  PKER_RACCSS( 18, 21) =  0.539954E+00
  PKER_RACCSS( 18, 22) =  0.582396E+00
  PKER_RACCSS( 18, 23) =  0.617263E+00
  PKER_RACCSS( 18, 24) =  0.645906E+00
  PKER_RACCSS( 18, 25) =  0.669463E+00
  PKER_RACCSS( 18, 26) =  0.688855E+00
  PKER_RACCSS( 18, 27) =  0.704834E+00
  PKER_RACCSS( 18, 28) =  0.718008E+00
  PKER_RACCSS( 18, 29) =  0.728877E+00
  PKER_RACCSS( 18, 30) =  0.737848E+00
  PKER_RACCSS( 18, 31) =  0.745255E+00
  PKER_RACCSS( 18, 32) =  0.751373E+00
  PKER_RACCSS( 18, 33) =  0.756428E+00
  PKER_RACCSS( 18, 34) =  0.760604E+00
  PKER_RACCSS( 18, 35) =  0.764056E+00
  PKER_RACCSS( 18, 36) =  0.766910E+00
  PKER_RACCSS( 18, 37) =  0.769269E+00
  PKER_RACCSS( 18, 38) =  0.771219E+00
  PKER_RACCSS( 18, 39) =  0.772832E+00
  PKER_RACCSS( 18, 40) =  0.774166E+00
  PKER_RACCSS( 19,  1) =  0.795385E+01
  PKER_RACCSS( 19,  2) =  0.638846E+01
  PKER_RACCSS( 19,  3) =  0.434595E+01
  PKER_RACCSS( 19,  4) =  0.343549E+01
  PKER_RACCSS( 19,  5) =  0.268818E+01
  PKER_RACCSS( 19,  6) =  0.208133E+01
  PKER_RACCSS( 19,  7) =  0.159740E+01
  PKER_RACCSS( 19,  8) =  0.122163E+01
  PKER_RACCSS( 19,  9) =  0.938335E+00
  PKER_RACCSS( 19, 10) =  0.728285E+00
  PKER_RACCSS( 19, 11) =  0.570145E+00
  PKER_RACCSS( 19, 12) =  0.445027E+00
  PKER_RACCSS( 19, 13) =  0.343893E+00
  PKER_RACCSS( 19, 14) =  0.268248E+00
  PKER_RACCSS( 19, 15) =  0.226350E+00
  PKER_RACCSS( 19, 16) =  0.224325E+00
  PKER_RACCSS( 19, 17) =  0.257856E+00
  PKER_RACCSS( 19, 18) =  0.313989E+00
  PKER_RACCSS( 19, 19) =  0.377472E+00
  PKER_RACCSS( 19, 20) =  0.437368E+00
  PKER_RACCSS( 19, 21) =  0.489118E+00
  PKER_RACCSS( 19, 22) =  0.532165E+00
  PKER_RACCSS( 19, 23) =  0.567544E+00
  PKER_RACCSS( 19, 24) =  0.596569E+00
  PKER_RACCSS( 19, 25) =  0.620406E+00
  PKER_RACCSS( 19, 26) =  0.640004E+00
  PKER_RACCSS( 19, 27) =  0.656135E+00
  PKER_RACCSS( 19, 28) =  0.669424E+00
  PKER_RACCSS( 19, 29) =  0.680378E+00
  PKER_RACCSS( 19, 30) =  0.689414E+00
  PKER_RACCSS( 19, 31) =  0.696870E+00
  PKER_RACCSS( 19, 32) =  0.703026E+00
  PKER_RACCSS( 19, 33) =  0.708109E+00
  PKER_RACCSS( 19, 34) =  0.712308E+00
  PKER_RACCSS( 19, 35) =  0.715777E+00
  PKER_RACCSS( 19, 36) =  0.718644E+00
  PKER_RACCSS( 19, 37) =  0.721014E+00
  PKER_RACCSS( 19, 38) =  0.722972E+00
  PKER_RACCSS( 19, 39) =  0.724592E+00
  PKER_RACCSS( 19, 40) =  0.725930E+00
  PKER_RACCSS( 20,  1) =  0.634781E+01
  PKER_RACCSS( 20,  2) =  0.508413E+01
  PKER_RACCSS( 20,  3) =  0.328893E+01
  PKER_RACCSS( 20,  4) =  0.259197E+01
  PKER_RACCSS( 20,  5) =  0.161527E+01
  PKER_RACCSS( 20,  6) =  0.125279E+01
  PKER_RACCSS( 20,  7) =  0.963381E+00
  PKER_RACCSS( 20,  8) =  0.738949E+00
  PKER_RACCSS( 20,  9) =  0.571583E+00
  PKER_RACCSS( 20, 10) =  0.451257E+00
  PKER_RACCSS( 20, 11) =  0.365125E+00
  PKER_RACCSS( 20, 12) =  0.299475E+00
  PKER_RACCSS( 20, 13) =  0.245596E+00
  PKER_RACCSS( 20, 14) =  0.203304E+00
  PKER_RACCSS( 20, 15) =  0.180537E+00
  PKER_RACCSS( 20, 16) =  0.185574E+00
  PKER_RACCSS( 20, 17) =  0.220030E+00
  PKER_RACCSS( 20, 18) =  0.275495E+00
  PKER_RACCSS( 20, 19) =  0.338734E+00
  PKER_RACCSS( 20, 20) =  0.398970E+00
  PKER_RACCSS( 20, 21) =  0.450959E+00
  PKER_RACCSS( 20, 22) =  0.493976E+00
  PKER_RACCSS( 20, 23) =  0.529200E+00
  PKER_RACCSS( 20, 24) =  0.558067E+00
  PKER_RACCSS( 20, 25) =  0.581769E+00
  PKER_RACCSS( 20, 26) =  0.601256E+00
  PKER_RACCSS( 20, 27) =  0.617297E+00
  PKER_RACCSS( 20, 28) =  0.630511E+00
  PKER_RACCSS( 20, 29) =  0.641405E+00
  PKER_RACCSS( 20, 30) =  0.650392E+00
  PKER_RACCSS( 20, 31) =  0.657810E+00
  PKER_RACCSS( 20, 32) =  0.663934E+00
  PKER_RACCSS( 20, 33) =  0.668992E+00
  PKER_RACCSS( 20, 34) =  0.673171E+00
  PKER_RACCSS( 20, 35) =  0.676624E+00
  PKER_RACCSS( 20, 36) =  0.679478E+00
  PKER_RACCSS( 20, 37) =  0.681837E+00
  PKER_RACCSS( 20, 38) =  0.683788E+00
  PKER_RACCSS( 20, 39) =  0.685401E+00
  PKER_RACCSS( 20, 40) =  0.686734E+00
  PKER_RACCSS( 21,  1) =  0.102443E+02
  PKER_RACCSS( 21,  2) =  0.752283E+01
  PKER_RACCSS( 21,  3) =  0.532770E+01
  PKER_RACCSS( 21,  4) =  0.425873E+01
  PKER_RACCSS( 21,  5) =  0.288056E+01
  PKER_RACCSS( 21,  6) =  0.226207E+01
  PKER_RACCSS( 21,  7) =  0.175652E+01
  PKER_RACCSS( 21,  8) =  0.134803E+01
  PKER_RACCSS( 21,  9) =  0.102375E+01
  PKER_RACCSS( 21, 10) =  0.771986E+00
  PKER_RACCSS( 21, 11) =  0.580680E+00
  PKER_RACCSS( 21, 12) =  0.436943E+00
  PKER_RACCSS( 21, 13) =  0.328804E+00
  PKER_RACCSS( 21, 14) =  0.249300E+00
  PKER_RACCSS( 21, 15) =  0.198560E+00
  PKER_RACCSS( 21, 16) =  0.180676E+00
  PKER_RACCSS( 21, 17) =  0.196350E+00
  PKER_RACCSS( 21, 18) =  0.238922E+00
  PKER_RACCSS( 21, 19) =  0.295536E+00
  PKER_RACCSS( 21, 20) =  0.353574E+00
  PKER_RACCSS( 21, 21) =  0.405455E+00
  PKER_RACCSS( 21, 22) =  0.448988E+00
  PKER_RACCSS( 21, 23) =  0.484753E+00
  PKER_RACCSS( 21, 24) =  0.514042E+00
  PKER_RACCSS( 21, 25) =  0.538053E+00
  PKER_RACCSS( 21, 26) =  0.557767E+00
  PKER_RACCSS( 21, 27) =  0.573974E+00
  PKER_RACCSS( 21, 28) =  0.587311E+00
  PKER_RACCSS( 21, 29) =  0.598297E+00
  PKER_RACCSS( 21, 30) =  0.607353E+00
  PKER_RACCSS( 21, 31) =  0.614822E+00
  PKER_RACCSS( 21, 32) =  0.620985E+00
  PKER_RACCSS( 21, 33) =  0.626073E+00
  PKER_RACCSS( 21, 34) =  0.630275E+00
  PKER_RACCSS( 21, 35) =  0.633746E+00
  PKER_RACCSS( 21, 36) =  0.636613E+00
  PKER_RACCSS( 21, 37) =  0.638983E+00
  PKER_RACCSS( 21, 38) =  0.640942E+00
  PKER_RACCSS( 21, 39) =  0.642561E+00
  PKER_RACCSS( 21, 40) =  0.643900E+00
  PKER_RACCSS( 22,  1) =  0.115320E+02
  PKER_RACCSS( 22,  2) =  0.885714E+01
  PKER_RACCSS( 22,  3) =  0.661944E+01
  PKER_RACCSS( 22,  4) =  0.533800E+01
  PKER_RACCSS( 22,  5) =  0.383246E+01
  PKER_RACCSS( 22,  6) =  0.304296E+01
  PKER_RACCSS( 22,  7) =  0.239235E+01
  PKER_RACCSS( 22,  8) =  0.185899E+01
  PKER_RACCSS( 22,  9) =  0.142556E+01
  PKER_RACCSS( 22, 10) =  0.107781E+01
  PKER_RACCSS( 22, 11) =  0.803526E+00
  PKER_RACCSS( 22, 12) =  0.590905E+00
  PKER_RACCSS( 22, 13) =  0.429091E+00
  PKER_RACCSS( 22, 14) =  0.309341E+00
  PKER_RACCSS( 22, 15) =  0.227914E+00
  PKER_RACCSS( 22, 16) =  0.184487E+00
  PKER_RACCSS( 22, 17) =  0.179339E+00
  PKER_RACCSS( 22, 18) =  0.207043E+00
  PKER_RACCSS( 22, 19) =  0.255369E+00
  PKER_RACCSS( 22, 20) =  0.310362E+00
  PKER_RACCSS( 22, 21) =  0.362024E+00
  PKER_RACCSS( 22, 22) =  0.406192E+00
  PKER_RACCSS( 22, 23) =  0.442617E+00
  PKER_RACCSS( 22, 24) =  0.472415E+00
  PKER_RACCSS( 22, 25) =  0.496799E+00
  PKER_RACCSS( 22, 26) =  0.516786E+00
  PKER_RACCSS( 22, 27) =  0.533194E+00
  PKER_RACCSS( 22, 28) =  0.546679E+00
  PKER_RACCSS( 22, 29) =  0.557776E+00
  PKER_RACCSS( 22, 30) =  0.566914E+00
  PKER_RACCSS( 22, 31) =  0.574445E+00
  PKER_RACCSS( 22, 32) =  0.580656E+00
  PKER_RACCSS( 22, 33) =  0.585779E+00
  PKER_RACCSS( 22, 34) =  0.590009E+00
  PKER_RACCSS( 22, 35) =  0.593501E+00
  PKER_RACCSS( 22, 36) =  0.596384E+00
  PKER_RACCSS( 22, 37) =  0.598767E+00
  PKER_RACCSS( 22, 38) =  0.600735E+00
  PKER_RACCSS( 22, 39) =  0.602362E+00
  PKER_RACCSS( 22, 40) =  0.603707E+00
  PKER_RACCSS( 23,  1) =  0.120552E+02
  PKER_RACCSS( 23,  2) =  0.943853E+01
  PKER_RACCSS( 23,  3) =  0.723099E+01
  PKER_RACCSS( 23,  4) =  0.538764E+01
  PKER_RACCSS( 23,  5) =  0.432828E+01
  PKER_RACCSS( 23,  6) =  0.309359E+01
  PKER_RACCSS( 23,  7) =  0.244279E+01
  PKER_RACCSS( 23,  8) =  0.190778E+01
  PKER_RACCSS( 23,  9) =  0.147059E+01
  PKER_RACCSS( 23, 10) =  0.111661E+01
  PKER_RACCSS( 23, 11) =  0.833900E+00
  PKER_RACCSS( 23, 12) =  0.611721E+00
  PKER_RACCSS( 23, 13) =  0.440899E+00
  PKER_RACCSS( 23, 14) =  0.313483E+00
  PKER_RACCSS( 23, 15) =  0.225201E+00
  PKER_RACCSS( 23, 16) =  0.175156E+00
  PKER_RACCSS( 23, 17) =  0.163153E+00
  PKER_RACCSS( 23, 18) =  0.185306E+00
  PKER_RACCSS( 23, 19) =  0.230283E+00
  PKER_RACCSS( 23, 20) =  0.284175E+00
  PKER_RACCSS( 23, 21) =  0.335712E+00
  PKER_RACCSS( 23, 22) =  0.379840E+00
  PKER_RACCSS( 23, 23) =  0.416119E+00
  PKER_RACCSS( 23, 24) =  0.445741E+00
  PKER_RACCSS( 23, 25) =  0.469966E+00
  PKER_RACCSS( 23, 26) =  0.489818E+00
  PKER_RACCSS( 23, 27) =  0.506111E+00
  PKER_RACCSS( 23, 28) =  0.519502E+00
  PKER_RACCSS( 23, 29) =  0.530519E+00
  PKER_RACCSS( 23, 30) =  0.539593E+00
  PKER_RACCSS( 23, 31) =  0.547072E+00
  PKER_RACCSS( 23, 32) =  0.553240E+00
  PKER_RACCSS( 23, 33) =  0.558330E+00
  PKER_RACCSS( 23, 34) =  0.562532E+00
  PKER_RACCSS( 23, 35) =  0.566002E+00
  PKER_RACCSS( 23, 36) =  0.568868E+00
  PKER_RACCSS( 23, 37) =  0.571236E+00
  PKER_RACCSS( 23, 38) =  0.573194E+00
  PKER_RACCSS( 23, 39) =  0.574812E+00
  PKER_RACCSS( 23, 40) =  0.576149E+00
  PKER_RACCSS( 24,  1) =  0.129576E+02
  PKER_RACCSS( 24,  2) =  0.102975E+02
  PKER_RACCSS( 24,  3) =  0.818920E+01
  PKER_RACCSS( 24,  4) =  0.640995E+01
  PKER_RACCSS( 24,  5) =  0.491149E+01
  PKER_RACCSS( 24,  6) =  0.394577E+01
  PKER_RACCSS( 24,  7) =  0.291637E+01
  PKER_RACCSS( 24,  8) =  0.230081E+01
  PKER_RACCSS( 24,  9) =  0.179410E+01
  PKER_RACCSS( 24, 10) =  0.137900E+01
  PKER_RACCSS( 24, 11) =  0.104163E+01
  PKER_RACCSS( 24, 12) =  0.770431E+00
  PKER_RACCSS( 24, 13) =  0.556107E+00
  PKER_RACCSS( 24, 14) =  0.391190E+00
  PKER_RACCSS( 24, 15) =  0.270786E+00
  PKER_RACCSS( 24, 16) =  0.192864E+00
  PKER_RACCSS( 24, 17) =  0.156677E+00
  PKER_RACCSS( 24, 18) =  0.159396E+00
  PKER_RACCSS( 24, 19) =  0.191937E+00
  PKER_RACCSS( 24, 20) =  0.240898E+00
  PKER_RACCSS( 24, 21) =  0.292797E+00
  PKER_RACCSS( 24, 22) =  0.339207E+00
  PKER_RACCSS( 24, 23) =  0.377404E+00
  PKER_RACCSS( 24, 24) =  0.408063E+00
  PKER_RACCSS( 24, 25) =  0.432806E+00
  PKER_RACCSS( 24, 26) =  0.452971E+00
  PKER_RACCSS( 24, 27) =  0.469485E+00
  PKER_RACCSS( 24, 28) =  0.483037E+00
  PKER_RACCSS( 24, 29) =  0.494174E+00
  PKER_RACCSS( 24, 30) =  0.503336E+00
  PKER_RACCSS( 24, 31) =  0.510880E+00
  PKER_RACCSS( 24, 32) =  0.517096E+00
  PKER_RACCSS( 24, 33) =  0.522223E+00
  PKER_RACCSS( 24, 34) =  0.526452E+00
  PKER_RACCSS( 24, 35) =  0.529943E+00
  PKER_RACCSS( 24, 36) =  0.532826E+00
  PKER_RACCSS( 24, 37) =  0.535207E+00
  PKER_RACCSS( 24, 38) =  0.537174E+00
  PKER_RACCSS( 24, 39) =  0.538799E+00
  PKER_RACCSS( 24, 40) =  0.540142E+00
  PKER_RACCSS( 25,  1) =  0.131514E+02
  PKER_RACCSS( 25,  2) =  0.106419E+02
  PKER_RACCSS( 25,  3) =  0.845868E+01
  PKER_RACCSS( 25,  4) =  0.672282E+01
  PKER_RACCSS( 25,  5) =  0.526076E+01
  PKER_RACCSS( 25,  6) =  0.423970E+01
  PKER_RACCSS( 25,  7) =  0.322433E+01
  PKER_RACCSS( 25,  8) =  0.255677E+01
  PKER_RACCSS( 25,  9) =  0.200589E+01
  PKER_RACCSS( 25, 10) =  0.155266E+01
  PKER_RACCSS( 25, 11) =  0.118171E+01
  PKER_RACCSS( 25, 12) =  0.880334E+00
  PKER_RACCSS( 25, 13) =  0.638726E+00
  PKER_RACCSS( 25, 14) =  0.449351E+00
  PKER_RACCSS( 25, 15) =  0.307558E+00
  PKER_RACCSS( 25, 16) =  0.211438E+00
  PKER_RACCSS( 25, 17) =  0.160608E+00
  PKER_RACCSS( 25, 18) =  0.152419E+00
  PKER_RACCSS( 25, 19) =  0.178285E+00
  PKER_RACCSS( 25, 20) =  0.223628E+00
  PKER_RACCSS( 25, 21) =  0.273609E+00
  PKER_RACCSS( 25, 22) =  0.318759E+00
  PKER_RACCSS( 25, 23) =  0.356134E+00
  PKER_RACCSS( 25, 24) =  0.386398E+00
  PKER_RACCSS( 25, 25) =  0.410983E+00
  PKER_RACCSS( 25, 26) =  0.431059E+00
  PKER_RACCSS( 25, 27) =  0.447500E+00
  PKER_RACCSS( 25, 28) =  0.460986E+00
  PKER_RACCSS( 25, 29) =  0.472065E+00
  PKER_RACCSS( 25, 30) =  0.481178E+00
  PKER_RACCSS( 25, 31) =  0.488681E+00
  PKER_RACCSS( 25, 32) =  0.494864E+00
  PKER_RACCSS( 25, 33) =  0.499963E+00
  PKER_RACCSS( 25, 34) =  0.504169E+00
  PKER_RACCSS( 25, 35) =  0.507642E+00
  PKER_RACCSS( 25, 36) =  0.510510E+00
  PKER_RACCSS( 25, 37) =  0.512879E+00
  PKER_RACCSS( 25, 38) =  0.514836E+00
  PKER_RACCSS( 25, 39) =  0.516454E+00
  PKER_RACCSS( 25, 40) =  0.517791E+00
  PKER_RACCSS( 26,  1) =  0.132742E+02
  PKER_RACCSS( 26,  2) =  0.108337E+02
  PKER_RACCSS( 26,  3) =  0.872586E+01
  PKER_RACCSS( 26,  4) =  0.703900E+01
  PKER_RACCSS( 26,  5) =  0.562634E+01
  PKER_RACCSS( 26,  6) =  0.444059E+01
  PKER_RACCSS( 26,  7) =  0.356562E+01
  PKER_RACCSS( 26,  8) =  0.274250E+01
  PKER_RACCSS( 26,  9) =  0.216207E+01
  PKER_RACCSS( 26, 10) =  0.168328E+01
  PKER_RACCSS( 26, 11) =  0.128971E+01
  PKER_RACCSS( 26, 12) =  0.967844E+00
  PKER_RACCSS( 26, 13) =  0.707228E+00
  PKER_RACCSS( 26, 14) =  0.499963E+00
  PKER_RACCSS( 26, 15) =  0.341292E+00
  PKER_RACCSS( 26, 16) =  0.229353E+00
  PKER_RACCSS( 26, 17) =  0.164063E+00
  PKER_RACCSS( 26, 18) =  0.143754E+00
  PKER_RACCSS( 26, 19) =  0.160834E+00
  PKER_RACCSS( 26, 20) =  0.201345E+00
  PKER_RACCSS( 26, 21) =  0.249884E+00
  PKER_RACCSS( 26, 22) =  0.295670E+00
  PKER_RACCSS( 26, 23) =  0.334320E+00
  PKER_RACCSS( 26, 24) =  0.365515E+00
  PKER_RACCSS( 26, 25) =  0.390474E+00
  PKER_RACCSS( 26, 26) =  0.410622E+00
  PKER_RACCSS( 26, 27) =  0.427051E+00
  PKER_RACCSS( 26, 28) =  0.440513E+00
  PKER_RACCSS( 26, 29) =  0.451566E+00
  PKER_RACCSS( 26, 30) =  0.460654E+00
  PKER_RACCSS( 26, 31) =  0.468135E+00
  PKER_RACCSS( 26, 32) =  0.474298E+00
  PKER_RACCSS( 26, 33) =  0.479380E+00
  PKER_RACCSS( 26, 34) =  0.483572E+00
  PKER_RACCSS( 26, 35) =  0.487033E+00
  PKER_RACCSS( 26, 36) =  0.489891E+00
  PKER_RACCSS( 26, 37) =  0.492252E+00
  PKER_RACCSS( 26, 38) =  0.494203E+00
  PKER_RACCSS( 26, 39) =  0.495815E+00
  PKER_RACCSS( 26, 40) =  0.497148E+00
  PKER_RACCSS( 27,  1) =  0.133097E+02
  PKER_RACCSS( 27,  2) =  0.109011E+02
  PKER_RACCSS( 27,  3) =  0.888269E+01
  PKER_RACCSS( 27,  4) =  0.719362E+01
  PKER_RACCSS( 27,  5) =  0.580985E+01
  PKER_RACCSS( 27,  6) =  0.465501E+01
  PKER_RACCSS( 27,  7) =  0.374781E+01
  PKER_RACCSS( 27,  8) =  0.294825E+01
  PKER_RACCSS( 27,  9) =  0.233507E+01
  PKER_RACCSS( 27, 10) =  0.182826E+01
  PKER_RACCSS( 27, 11) =  0.141027E+01
  PKER_RACCSS( 27, 12) =  0.106668E+01
  PKER_RACCSS( 27, 13) =  0.786260E+00
  PKER_RACCSS( 27, 14) =  0.560532E+00
  PKER_RACCSS( 27, 15) =  0.384455E+00
  PKER_RACCSS( 27, 16) =  0.256127E+00
  PKER_RACCSS( 27, 17) =  0.176040E+00
  PKER_RACCSS( 27, 18) =  0.143310E+00
  PKER_RACCSS( 27, 19) =  0.151524E+00
  PKER_RACCSS( 27, 20) =  0.186916E+00
  PKER_RACCSS( 27, 21) =  0.233004E+00
  PKER_RACCSS( 27, 22) =  0.277474E+00
  PKER_RACCSS( 27, 23) =  0.315252E+00
  PKER_RACCSS( 27, 24) =  0.345942E+00
  PKER_RACCSS( 27, 25) =  0.370729E+00
  PKER_RACCSS( 27, 26) =  0.390865E+00
  PKER_RACCSS( 27, 27) =  0.407311E+00
  PKER_RACCSS( 27, 28) =  0.420780E+00
  PKER_RACCSS( 27, 29) =  0.431832E+00
  PKER_RACCSS( 27, 30) =  0.440914E+00
  PKER_RACCSS( 27, 31) =  0.448386E+00
  PKER_RACCSS( 27, 32) =  0.454540E+00
  PKER_RACCSS( 27, 33) =  0.459613E+00
  PKER_RACCSS( 27, 34) =  0.463798E+00
  PKER_RACCSS( 27, 35) =  0.467251E+00
  PKER_RACCSS( 27, 36) =  0.470104E+00
  PKER_RACCSS( 27, 37) =  0.472459E+00
  PKER_RACCSS( 27, 38) =  0.474406E+00
  PKER_RACCSS( 27, 39) =  0.476015E+00
  PKER_RACCSS( 27, 40) =  0.477346E+00
  PKER_RACCSS( 28,  1) =  0.133115E+02
  PKER_RACCSS( 28,  2) =  0.109156E+02
  PKER_RACCSS( 28,  3) =  0.892137E+01
  PKER_RACCSS( 28,  4) =  0.726595E+01
  PKER_RACCSS( 28,  5) =  0.588073E+01
  PKER_RACCSS( 28,  6) =  0.474162E+01
  PKER_RACCSS( 28,  7) =  0.379341E+01
  PKER_RACCSS( 28,  8) =  0.303518E+01
  PKER_RACCSS( 28,  9) =  0.240761E+01
  PKER_RACCSS( 28, 10) =  0.188860E+01
  PKER_RACCSS( 28, 11) =  0.146011E+01
  PKER_RACCSS( 28, 12) =  0.110727E+01
  PKER_RACCSS( 28, 13) =  0.818541E+00
  PKER_RACCSS( 28, 14) =  0.585150E+00
  PKER_RACCSS( 28, 15) =  0.401892E+00
  PKER_RACCSS( 28, 16) =  0.266865E+00
  PKER_RACCSS( 28, 17) =  0.180994E+00
  PKER_RACCSS( 28, 18) =  0.143621E+00
  PKER_RACCSS( 28, 19) =  0.148709E+00
  PKER_RACCSS( 28, 20) =  0.182192E+00
  PKER_RACCSS( 28, 21) =  0.227050E+00
  PKER_RACCSS( 28, 22) =  0.270562E+00
  PKER_RACCSS( 28, 23) =  0.307571E+00
  PKER_RACCSS( 28, 24) =  0.337783E+00
  PKER_RACCSS( 28, 25) =  0.362333E+00
  PKER_RACCSS( 28, 26) =  0.382340E+00
  PKER_RACCSS( 28, 27) =  0.398692E+00
  PKER_RACCSS( 28, 28) =  0.412083E+00
  PKER_RACCSS( 28, 29) =  0.423069E+00
  PKER_RACCSS( 28, 30) =  0.432097E+00
  PKER_RACCSS( 28, 31) =  0.439525E+00
  PKER_RACCSS( 28, 32) =  0.445643E+00
  PKER_RACCSS( 28, 33) =  0.450687E+00
  PKER_RACCSS( 28, 34) =  0.454848E+00
  PKER_RACCSS( 28, 35) =  0.458283E+00
  PKER_RACCSS( 28, 36) =  0.461119E+00
  PKER_RACCSS( 28, 37) =  0.463463E+00
  PKER_RACCSS( 28, 38) =  0.465400E+00
  PKER_RACCSS( 28, 39) =  0.467002E+00
  PKER_RACCSS( 28, 40) =  0.468326E+00
  PKER_RACCSS( 29,  1) =  0.133215E+02
  PKER_RACCSS( 29,  2) =  0.109289E+02
  PKER_RACCSS( 29,  3) =  0.894604E+01
  PKER_RACCSS( 29,  4) =  0.730119E+01
  PKER_RACCSS( 29,  5) =  0.593124E+01
  PKER_RACCSS( 29,  6) =  0.480144E+01
  PKER_RACCSS( 29,  7) =  0.386406E+01
  PKER_RACCSS( 29,  8) =  0.309611E+01
  PKER_RACCSS( 29,  9) =  0.246034E+01
  PKER_RACCSS( 29, 10) =  0.193432E+01
  PKER_RACCSS( 29, 11) =  0.149394E+01
  PKER_RACCSS( 29, 12) =  0.113665E+01
  PKER_RACCSS( 29, 13) =  0.843665E+00
  PKER_RACCSS( 29, 14) =  0.605916E+00
  PKER_RACCSS( 29, 15) =  0.417943E+00
  PKER_RACCSS( 29, 16) =  0.277581E+00
  PKER_RACCSS( 29, 17) =  0.185747E+00
  PKER_RACCSS( 29, 18) =  0.142370E+00
  PKER_RACCSS( 29, 19) =  0.142343E+00
  PKER_RACCSS( 29, 20) =  0.172458E+00
  PKER_RACCSS( 29, 21) =  0.215669E+00
  PKER_RACCSS( 29, 22) =  0.258726E+00
  PKER_RACCSS( 29, 23) =  0.295879E+00
  PKER_RACCSS( 29, 24) =  0.326452E+00
  PKER_RACCSS( 29, 25) =  0.351334E+00
  PKER_RACCSS( 29, 26) =  0.371529E+00
  PKER_RACCSS( 29, 27) =  0.387939E+00
  PKER_RACCSS( 29, 28) =  0.401329E+00
  PKER_RACCSS( 29, 29) =  0.412300E+00
  PKER_RACCSS( 29, 30) =  0.421310E+00
  PKER_RACCSS( 29, 31) =  0.428722E+00
  PKER_RACCSS( 29, 32) =  0.434825E+00
  PKER_RACCSS( 29, 33) =  0.439856E+00
  PKER_RACCSS( 29, 34) =  0.444007E+00
  PKER_RACCSS( 29, 35) =  0.447433E+00
  PKER_RACCSS( 29, 36) =  0.450262E+00
  PKER_RACCSS( 29, 37) =  0.452600E+00
  PKER_RACCSS( 29, 38) =  0.454532E+00
  PKER_RACCSS( 29, 39) =  0.456130E+00
  PKER_RACCSS( 29, 40) =  0.457451E+00
  PKER_RACCSS( 30,  1) =  0.133375E+02
  PKER_RACCSS( 30,  2) =  0.109457E+02
  PKER_RACCSS( 30,  3) =  0.896468E+01
  PKER_RACCSS( 30,  4) =  0.732350E+01
  PKER_RACCSS( 30,  5) =  0.596323E+01
  PKER_RACCSS( 30,  6) =  0.483579E+01
  PKER_RACCSS( 30,  7) =  0.390254E+01
  PKER_RACCSS( 30,  8) =  0.313132E+01
  PKER_RACCSS( 30,  9) =  0.249276E+01
  PKER_RACCSS( 30, 10) =  0.196278E+01
  PKER_RACCSS( 30, 11) =  0.152606E+01
  PKER_RACCSS( 30, 12) =  0.116570E+01
  PKER_RACCSS( 30, 13) =  0.869566E+00
  PKER_RACCSS( 30, 14) =  0.628357E+00
  PKER_RACCSS( 30, 15) =  0.436329E+00
  PKER_RACCSS( 30, 16) =  0.290939E+00
  PKER_RACCSS( 30, 17) =  0.192920E+00
  PKER_RACCSS( 30, 18) =  0.142864E+00
  PKER_RACCSS( 30, 19) =  0.136857E+00
  PKER_RACCSS( 30, 20) =  0.162977E+00
  PKER_RACCSS( 30, 21) =  0.204357E+00
  PKER_RACCSS( 30, 22) =  0.246873E+00
  PKER_RACCSS( 30, 23) =  0.283849E+00
  PKER_RACCSS( 30, 24) =  0.314229E+00
  PKER_RACCSS( 30, 25) =  0.338918E+00
  PKER_RACCSS( 30, 26) =  0.359002E+00
  PKER_RACCSS( 30, 27) =  0.375384E+00
  PKER_RACCSS( 30, 28) =  0.388781E+00
  PKER_RACCSS( 30, 29) =  0.399761E+00
  PKER_RACCSS( 30, 30) =  0.408775E+00
  PKER_RACCSS( 30, 31) =  0.416186E+00
  PKER_RACCSS( 30, 32) =  0.422287E+00
  PKER_RACCSS( 30, 33) =  0.427315E+00
  PKER_RACCSS( 30, 34) =  0.431462E+00
  PKER_RACCSS( 30, 35) =  0.434884E+00
  PKER_RACCSS( 30, 36) =  0.437711E+00
  PKER_RACCSS( 30, 37) =  0.440046E+00
  PKER_RACCSS( 30, 38) =  0.441975E+00
  PKER_RACCSS( 30, 39) =  0.443571E+00
  PKER_RACCSS( 30, 40) =  0.444890E+00
  PKER_RACCSS( 31,  1) =  0.133457E+02
  PKER_RACCSS( 31,  2) =  0.109540E+02
  PKER_RACCSS( 31,  3) =  0.897333E+01
  PKER_RACCSS( 31,  4) =  0.733289E+01
  PKER_RACCSS( 31,  5) =  0.597403E+01
  PKER_RACCSS( 31,  6) =  0.484844E+01
  PKER_RACCSS( 31,  7) =  0.391622E+01
  PKER_RACCSS( 31,  8) =  0.314409E+01
  PKER_RACCSS( 31,  9) =  0.250503E+01
  PKER_RACCSS( 31, 10) =  0.197608E+01
  PKER_RACCSS( 31, 11) =  0.153866E+01
  PKER_RACCSS( 31, 12) =  0.117759E+01
  PKER_RACCSS( 31, 13) =  0.880647E+00
  PKER_RACCSS( 31, 14) =  0.638378E+00
  PKER_RACCSS( 31, 15) =  0.444889E+00
  PKER_RACCSS( 31, 16) =  0.297371E+00
  PKER_RACCSS( 31, 17) =  0.196420E+00
  PKER_RACCSS( 31, 18) =  0.142908E+00
  PKER_RACCSS( 31, 19) =  0.133631E+00
  PKER_RACCSS( 31, 20) =  0.157422E+00
  PKER_RACCSS( 31, 21) =  0.197662E+00
  PKER_RACCSS( 31, 22) =  0.239819E+00
  PKER_RACCSS( 31, 23) =  0.276723E+00
  PKER_RACCSS( 31, 24) =  0.307082E+00
  PKER_RACCSS( 31, 25) =  0.331764E+00
  PKER_RACCSS( 31, 26) =  0.351849E+00
  PKER_RACCSS( 31, 27) =  0.368231E+00
  PKER_RACCSS( 31, 28) =  0.381625E+00
  PKER_RACCSS( 31, 29) =  0.392598E+00
  PKER_RACCSS( 31, 30) =  0.401604E+00
  PKER_RACCSS( 31, 31) =  0.409008E+00
  PKER_RACCSS( 31, 32) =  0.415101E+00
  PKER_RACCSS( 31, 33) =  0.420122E+00
  PKER_RACCSS( 31, 34) =  0.424262E+00
  PKER_RACCSS( 31, 35) =  0.427680E+00
  PKER_RACCSS( 31, 36) =  0.430501E+00
  PKER_RACCSS( 31, 37) =  0.432833E+00
  PKER_RACCSS( 31, 38) =  0.434760E+00
  PKER_RACCSS( 31, 39) =  0.436352E+00
  PKER_RACCSS( 31, 40) =  0.437670E+00
  PKER_RACCSS( 32,  1) =  0.133505E+02
  PKER_RACCSS( 32,  2) =  0.109589E+02
  PKER_RACCSS( 32,  3) =  0.897836E+01
  PKER_RACCSS( 32,  4) =  0.733809E+01
  PKER_RACCSS( 32,  5) =  0.597956E+01
  PKER_RACCSS( 32,  6) =  0.485431E+01
  PKER_RACCSS( 32,  7) =  0.392231E+01
  PKER_RACCSS( 32,  8) =  0.315042E+01
  PKER_RACCSS( 32,  9) =  0.251126E+01
  PKER_RACCSS( 32, 10) =  0.198225E+01
  PKER_RACCSS( 32, 11) =  0.154473E+01
  PKER_RACCSS( 32, 12) =  0.118355E+01
  PKER_RACCSS( 32, 13) =  0.886389E+00
  PKER_RACCSS( 32, 14) =  0.643737E+00
  PKER_RACCSS( 32, 15) =  0.449607E+00
  PKER_RACCSS( 32, 16) =  0.300995E+00
  PKER_RACCSS( 32, 17) =  0.198415E+00
  PKER_RACCSS( 32, 18) =  0.142843E+00
  PKER_RACCSS( 32, 19) =  0.131565E+00
  PKER_RACCSS( 32, 20) =  0.153886E+00
  PKER_RACCSS( 32, 21) =  0.193406E+00
  PKER_RACCSS( 32, 22) =  0.235356E+00
  PKER_RACCSS( 32, 23) =  0.272245E+00
  PKER_RACCSS( 32, 24) =  0.302622E+00
  PKER_RACCSS( 32, 25) =  0.327315E+00
  PKER_RACCSS( 32, 26) =  0.347401E+00
  PKER_RACCSS( 32, 27) =  0.363781E+00
  PKER_RACCSS( 32, 28) =  0.377168E+00
  PKER_RACCSS( 32, 29) =  0.388134E+00
  PKER_RACCSS( 32, 30) =  0.397132E+00
  PKER_RACCSS( 32, 31) =  0.404527E+00
  PKER_RACCSS( 32, 32) =  0.410614E+00
  PKER_RACCSS( 32, 33) =  0.415629E+00
  PKER_RACCSS( 32, 34) =  0.419764E+00
  PKER_RACCSS( 32, 35) =  0.423177E+00
  PKER_RACCSS( 32, 36) =  0.425995E+00
  PKER_RACCSS( 32, 37) =  0.428323E+00
  PKER_RACCSS( 32, 38) =  0.430248E+00
  PKER_RACCSS( 32, 39) =  0.431839E+00
  PKER_RACCSS( 32, 40) =  0.433154E+00
  PKER_RACCSS( 33,  1) =  0.133549E+02
  PKER_RACCSS( 33,  2) =  0.109634E+02
  PKER_RACCSS( 33,  3) =  0.898293E+01
  PKER_RACCSS( 33,  4) =  0.734275E+01
  PKER_RACCSS( 33,  5) =  0.598430E+01
  PKER_RACCSS( 33,  6) =  0.485916E+01
  PKER_RACCSS( 33,  7) =  0.392725E+01
  PKER_RACCSS( 33,  8) =  0.315543E+01
  PKER_RACCSS( 33,  9) =  0.251634E+01
  PKER_RACCSS( 33, 10) =  0.198734E+01
  PKER_RACCSS( 33, 11) =  0.154980E+01
  PKER_RACCSS( 33, 12) =  0.118857E+01
  PKER_RACCSS( 33, 13) =  0.891252E+00
  PKER_RACCSS( 33, 14) =  0.648304E+00
  PKER_RACCSS( 33, 15) =  0.453668E+00
  PKER_RACCSS( 33, 16) =  0.304190E+00
  PKER_RACCSS( 33, 17) =  0.200247E+00
  PKER_RACCSS( 33, 18) =  0.142958E+00
  PKER_RACCSS( 33, 19) =  0.129943E+00
  PKER_RACCSS( 33, 20) =  0.150972E+00
  PKER_RACCSS( 33, 21) =  0.189862E+00
  PKER_RACCSS( 33, 22) =  0.231629E+00
  PKER_RACCSS( 33, 23) =  0.268519E+00
  PKER_RACCSS( 33, 24) =  0.298923E+00
  PKER_RACCSS( 33, 25) =  0.323635E+00
  PKER_RACCSS( 33, 26) =  0.343732E+00
  PKER_RACCSS( 33, 27) =  0.360115E+00
  PKER_RACCSS( 33, 28) =  0.373503E+00
  PKER_RACCSS( 33, 29) =  0.384466E+00
  PKER_RACCSS( 33, 30) =  0.393460E+00
  PKER_RACCSS( 33, 31) =  0.400852E+00
  PKER_RACCSS( 33, 32) =  0.406935E+00
  PKER_RACCSS( 33, 33) =  0.411946E+00
  PKER_RACCSS( 33, 34) =  0.416078E+00
  PKER_RACCSS( 33, 35) =  0.419488E+00
  PKER_RACCSS( 33, 36) =  0.422304E+00
  PKER_RACCSS( 33, 37) =  0.424631E+00
  PKER_RACCSS( 33, 38) =  0.426553E+00
  PKER_RACCSS( 33, 39) =  0.428143E+00
  PKER_RACCSS( 33, 40) =  0.429458E+00
  PKER_RACCSS( 34,  1) =  0.133545E+02
  PKER_RACCSS( 34,  2) =  0.109630E+02
  PKER_RACCSS( 34,  3) =  0.898249E+01
  PKER_RACCSS( 34,  4) =  0.734231E+01
  PKER_RACCSS( 34,  5) =  0.598387E+01
  PKER_RACCSS( 34,  6) =  0.485874E+01
  PKER_RACCSS( 34,  7) =  0.392685E+01
  PKER_RACCSS( 34,  8) =  0.315505E+01
  PKER_RACCSS( 34,  9) =  0.251599E+01
  PKER_RACCSS( 34, 10) =  0.198703E+01
  PKER_RACCSS( 34, 11) =  0.154953E+01
  PKER_RACCSS( 34, 12) =  0.118835E+01
  PKER_RACCSS( 34, 13) =  0.891084E+00
  PKER_RACCSS( 34, 14) =  0.648191E+00
  PKER_RACCSS( 34, 15) =  0.453598E+00
  PKER_RACCSS( 34, 16) =  0.304088E+00
  PKER_RACCSS( 34, 17) =  0.200150E+00
  PKER_RACCSS( 34, 18) =  0.142751E+00
  PKER_RACCSS( 34, 19) =  0.129699E+00
  PKER_RACCSS( 34, 20) =  0.150660E+00
  PKER_RACCSS( 34, 21) =  0.189538E+00
  PKER_RACCSS( 34, 22) =  0.231282E+00
  PKER_RACCSS( 34, 23) =  0.268145E+00
  PKER_RACCSS( 34, 24) =  0.298523E+00
  PKER_RACCSS( 34, 25) =  0.323213E+00
  PKER_RACCSS( 34, 26) =  0.343290E+00
  PKER_RACCSS( 34, 27) =  0.359658E+00
  PKER_RACCSS( 34, 28) =  0.373032E+00
  PKER_RACCSS( 34, 29) =  0.383985E+00
  PKER_RACCSS( 34, 30) =  0.392971E+00
  PKER_RACCSS( 34, 31) =  0.400356E+00
  PKER_RACCSS( 34, 32) =  0.406433E+00
  PKER_RACCSS( 34, 33) =  0.411440E+00
  PKER_RACCSS( 34, 34) =  0.415568E+00
  PKER_RACCSS( 34, 35) =  0.418976E+00
  PKER_RACCSS( 34, 36) =  0.421789E+00
  PKER_RACCSS( 34, 37) =  0.424114E+00
  PKER_RACCSS( 34, 38) =  0.426035E+00
  PKER_RACCSS( 34, 39) =  0.427624E+00
  PKER_RACCSS( 34, 40) =  0.428937E+00
  PKER_RACCSS( 35,  1) =  0.133588E+02
  PKER_RACCSS( 35,  2) =  0.109673E+02
  PKER_RACCSS( 35,  3) =  0.898695E+01
  PKER_RACCSS( 35,  4) =  0.734684E+01
  PKER_RACCSS( 35,  5) =  0.598848E+01
  PKER_RACCSS( 35,  6) =  0.486341E+01
  PKER_RACCSS( 35,  7) =  0.393158E+01
  PKER_RACCSS( 35,  8) =  0.315983E+01
  PKER_RACCSS( 35,  9) =  0.252079E+01
  PKER_RACCSS( 35, 10) =  0.199184E+01
  PKER_RACCSS( 35, 11) =  0.155430E+01
  PKER_RACCSS( 35, 12) =  0.119306E+01
  PKER_RACCSS( 35, 13) =  0.895641E+00
  PKER_RACCSS( 35, 14) =  0.652461E+00
  PKER_RACCSS( 35, 15) =  0.457402E+00
  PKER_RACCSS( 35, 16) =  0.307153E+00
  PKER_RACCSS( 35, 17) =  0.201981E+00
  PKER_RACCSS( 35, 18) =  0.143041E+00
  PKER_RACCSS( 35, 19) =  0.128393E+00
  PKER_RACCSS( 35, 20) =  0.148145E+00
  PKER_RACCSS( 35, 21) =  0.186428E+00
  PKER_RACCSS( 35, 22) =  0.228006E+00
  PKER_RACCSS( 35, 23) =  0.264882E+00
  PKER_RACCSS( 35, 24) =  0.295301E+00
  PKER_RACCSS( 35, 25) =  0.320021E+00
  PKER_RACCSS( 35, 26) =  0.340118E+00
  PKER_RACCSS( 35, 27) =  0.356498E+00
  PKER_RACCSS( 35, 28) =  0.369879E+00
  PKER_RACCSS( 35, 29) =  0.380835E+00
  PKER_RACCSS( 35, 30) =  0.389822E+00
  PKER_RACCSS( 35, 31) =  0.397206E+00
  PKER_RACCSS( 35, 32) =  0.403283E+00
  PKER_RACCSS( 35, 33) =  0.408288E+00
  PKER_RACCSS( 35, 34) =  0.412416E+00
  PKER_RACCSS( 35, 35) =  0.415822E+00
  PKER_RACCSS( 35, 36) =  0.418634E+00
  PKER_RACCSS( 35, 37) =  0.420958E+00
  PKER_RACCSS( 35, 38) =  0.422879E+00
  PKER_RACCSS( 35, 39) =  0.424467E+00
  PKER_RACCSS( 35, 40) =  0.425780E+00
  PKER_RACCSS( 36,  1) =  0.133693E+02
  PKER_RACCSS( 36,  2) =  0.109781E+02
  PKER_RACCSS( 36,  3) =  0.899787E+01
  PKER_RACCSS( 36,  4) =  0.735793E+01
  PKER_RACCSS( 36,  5) =  0.599972E+01
  PKER_RACCSS( 36,  6) =  0.487480E+01
  PKER_RACCSS( 36,  7) =  0.394309E+01
  PKER_RACCSS( 36,  8) =  0.317142E+01
  PKER_RACCSS( 36,  9) =  0.253243E+01
  PKER_RACCSS( 36, 10) =  0.200346E+01
  PKER_RACCSS( 36, 11) =  0.156582E+01
  PKER_RACCSS( 36, 12) =  0.120440E+01
  PKER_RACCSS( 36, 13) =  0.906578E+00
  PKER_RACCSS( 36, 14) =  0.662698E+00
  PKER_RACCSS( 36, 15) =  0.466524E+00
  PKER_RACCSS( 36, 16) =  0.314682E+00
  PKER_RACCSS( 36, 17) =  0.206574E+00
  PKER_RACCSS( 36, 18) =  0.144245E+00
  PKER_RACCSS( 36, 19) =  0.125763E+00
  PKER_RACCSS( 36, 20) =  0.142684E+00
  PKER_RACCSS( 36, 21) =  0.179440E+00
  PKER_RACCSS( 36, 22) =  0.220596E+00
  PKER_RACCSS( 36, 23) =  0.257524E+00
  PKER_RACCSS( 36, 24) =  0.288068E+00
  PKER_RACCSS( 36, 25) =  0.312888E+00
  PKER_RACCSS( 36, 26) =  0.333055E+00
  PKER_RACCSS( 36, 27) =  0.349481E+00
  PKER_RACCSS( 36, 28) =  0.362892E+00
  PKER_RACCSS( 36, 29) =  0.373867E+00
  PKER_RACCSS( 36, 30) =  0.382866E+00
  PKER_RACCSS( 36, 31) =  0.390258E+00
  PKER_RACCSS( 36, 32) =  0.396339E+00
  PKER_RACCSS( 36, 33) =  0.401346E+00
  PKER_RACCSS( 36, 34) =  0.405475E+00
  PKER_RACCSS( 36, 35) =  0.408881E+00
  PKER_RACCSS( 36, 36) =  0.411694E+00
  PKER_RACCSS( 36, 37) =  0.414017E+00
  PKER_RACCSS( 36, 38) =  0.415937E+00
  PKER_RACCSS( 36, 39) =  0.417525E+00
  PKER_RACCSS( 36, 40) =  0.418837E+00
  PKER_RACCSS( 37,  1) =  0.000000E+00
  PKER_RACCSS( 37,  2) =  0.000000E+00
  PKER_RACCSS( 37,  3) =  0.000000E+00
  PKER_RACCSS( 37,  4) =  0.000000E+00
  PKER_RACCSS( 37,  5) =  0.000000E+00
  PKER_RACCSS( 37,  6) =  0.000000E+00
  PKER_RACCSS( 37,  7) =  0.000000E+00
  PKER_RACCSS( 37,  8) =  0.000000E+00
  PKER_RACCSS( 37,  9) =  0.000000E+00
  PKER_RACCSS( 37, 10) =  0.000000E+00
  PKER_RACCSS( 37, 11) =  0.000000E+00
  PKER_RACCSS( 37, 12) =  0.000000E+00
  PKER_RACCSS( 37, 13) =  0.000000E+00
  PKER_RACCSS( 37, 14) =  0.000000E+00
  PKER_RACCSS( 37, 15) =  0.000000E+00
  PKER_RACCSS( 37, 16) =  0.000000E+00
  PKER_RACCSS( 37, 17) =  0.000000E+00
  PKER_RACCSS( 37, 18) =  0.000000E+00
  PKER_RACCSS( 37, 19) =  0.000000E+00
  PKER_RACCSS( 37, 20) =  0.000000E+00
  PKER_RACCSS( 37, 21) =  0.000000E+00
  PKER_RACCSS( 37, 22) =  0.000000E+00
  PKER_RACCSS( 37, 23) =  0.000000E+00
  PKER_RACCSS( 37, 24) =  0.000000E+00
  PKER_RACCSS( 37, 25) =  0.000000E+00
  PKER_RACCSS( 37, 26) =  0.000000E+00
  PKER_RACCSS( 37, 27) =  0.000000E+00
  PKER_RACCSS( 37, 28) =  0.000000E+00
  PKER_RACCSS( 37, 29) =  0.000000E+00
  PKER_RACCSS( 37, 30) =  0.000000E+00
  PKER_RACCSS( 37, 31) =  0.000000E+00
  PKER_RACCSS( 37, 32) =  0.000000E+00
  PKER_RACCSS( 37, 33) =  0.000000E+00
  PKER_RACCSS( 37, 34) =  0.000000E+00
  PKER_RACCSS( 37, 35) =  0.000000E+00
  PKER_RACCSS( 37, 36) =  0.000000E+00
  PKER_RACCSS( 37, 37) =  0.000000E+00
  PKER_RACCSS( 37, 38) =  0.000000E+00
  PKER_RACCSS( 37, 39) =  0.000000E+00
  PKER_RACCSS( 37, 40) =  0.000000E+00
  PKER_RACCSS( 38,  1) =  0.000000E+00
  PKER_RACCSS( 38,  2) =  0.000000E+00
  PKER_RACCSS( 38,  3) =  0.000000E+00
  PKER_RACCSS( 38,  4) =  0.000000E+00
  PKER_RACCSS( 38,  5) =  0.000000E+00
  PKER_RACCSS( 38,  6) =  0.000000E+00
  PKER_RACCSS( 38,  7) =  0.000000E+00
  PKER_RACCSS( 38,  8) =  0.000000E+00
  PKER_RACCSS( 38,  9) =  0.000000E+00
  PKER_RACCSS( 38, 10) =  0.000000E+00
  PKER_RACCSS( 38, 11) =  0.000000E+00
  PKER_RACCSS( 38, 12) =  0.000000E+00
  PKER_RACCSS( 38, 13) =  0.000000E+00
  PKER_RACCSS( 38, 14) =  0.000000E+00
  PKER_RACCSS( 38, 15) =  0.000000E+00
  PKER_RACCSS( 38, 16) =  0.000000E+00
  PKER_RACCSS( 38, 17) =  0.000000E+00
  PKER_RACCSS( 38, 18) =  0.000000E+00
  PKER_RACCSS( 38, 19) =  0.000000E+00
  PKER_RACCSS( 38, 20) =  0.000000E+00
  PKER_RACCSS( 38, 21) =  0.000000E+00
  PKER_RACCSS( 38, 22) =  0.000000E+00
  PKER_RACCSS( 38, 23) =  0.000000E+00
  PKER_RACCSS( 38, 24) =  0.000000E+00
  PKER_RACCSS( 38, 25) =  0.000000E+00
  PKER_RACCSS( 38, 26) =  0.000000E+00
  PKER_RACCSS( 38, 27) =  0.000000E+00
  PKER_RACCSS( 38, 28) =  0.000000E+00
  PKER_RACCSS( 38, 29) =  0.000000E+00
  PKER_RACCSS( 38, 30) =  0.000000E+00
  PKER_RACCSS( 38, 31) =  0.000000E+00
  PKER_RACCSS( 38, 32) =  0.000000E+00
  PKER_RACCSS( 38, 33) =  0.000000E+00
  PKER_RACCSS( 38, 34) =  0.000000E+00
  PKER_RACCSS( 38, 35) =  0.000000E+00
  PKER_RACCSS( 38, 36) =  0.000000E+00
  PKER_RACCSS( 38, 37) =  0.000000E+00
  PKER_RACCSS( 38, 38) =  0.000000E+00
  PKER_RACCSS( 38, 39) =  0.000000E+00
  PKER_RACCSS( 38, 40) =  0.000000E+00
  PKER_RACCSS( 39,  1) =  0.000000E+00
  PKER_RACCSS( 39,  2) =  0.000000E+00
  PKER_RACCSS( 39,  3) =  0.000000E+00
  PKER_RACCSS( 39,  4) =  0.000000E+00
  PKER_RACCSS( 39,  5) =  0.000000E+00
  PKER_RACCSS( 39,  6) =  0.000000E+00
  PKER_RACCSS( 39,  7) =  0.000000E+00
  PKER_RACCSS( 39,  8) =  0.000000E+00
  PKER_RACCSS( 39,  9) =  0.000000E+00
  PKER_RACCSS( 39, 10) =  0.000000E+00
  PKER_RACCSS( 39, 11) =  0.000000E+00
  PKER_RACCSS( 39, 12) =  0.000000E+00
  PKER_RACCSS( 39, 13) =  0.000000E+00
  PKER_RACCSS( 39, 14) =  0.000000E+00
  PKER_RACCSS( 39, 15) =  0.000000E+00
  PKER_RACCSS( 39, 16) =  0.000000E+00
  PKER_RACCSS( 39, 17) =  0.000000E+00
  PKER_RACCSS( 39, 18) =  0.000000E+00
  PKER_RACCSS( 39, 19) =  0.000000E+00
  PKER_RACCSS( 39, 20) =  0.000000E+00
  PKER_RACCSS( 39, 21) =  0.000000E+00
  PKER_RACCSS( 39, 22) =  0.000000E+00
  PKER_RACCSS( 39, 23) =  0.000000E+00
  PKER_RACCSS( 39, 24) =  0.000000E+00
  PKER_RACCSS( 39, 25) =  0.000000E+00
  PKER_RACCSS( 39, 26) =  0.000000E+00
  PKER_RACCSS( 39, 27) =  0.000000E+00
  PKER_RACCSS( 39, 28) =  0.000000E+00
  PKER_RACCSS( 39, 29) =  0.000000E+00
  PKER_RACCSS( 39, 30) =  0.000000E+00
  PKER_RACCSS( 39, 31) =  0.000000E+00
  PKER_RACCSS( 39, 32) =  0.000000E+00
  PKER_RACCSS( 39, 33) =  0.000000E+00
  PKER_RACCSS( 39, 34) =  0.000000E+00
  PKER_RACCSS( 39, 35) =  0.000000E+00
  PKER_RACCSS( 39, 36) =  0.000000E+00
  PKER_RACCSS( 39, 37) =  0.000000E+00
  PKER_RACCSS( 39, 38) =  0.000000E+00
  PKER_RACCSS( 39, 39) =  0.000000E+00
  PKER_RACCSS( 39, 40) =  0.000000E+00
  PKER_RACCSS( 40,  1) =  0.000000E+00
  PKER_RACCSS( 40,  2) =  0.000000E+00
  PKER_RACCSS( 40,  3) =  0.000000E+00
  PKER_RACCSS( 40,  4) =  0.000000E+00
  PKER_RACCSS( 40,  5) =  0.000000E+00
  PKER_RACCSS( 40,  6) =  0.000000E+00
  PKER_RACCSS( 40,  7) =  0.000000E+00
  PKER_RACCSS( 40,  8) =  0.000000E+00
  PKER_RACCSS( 40,  9) =  0.000000E+00
  PKER_RACCSS( 40, 10) =  0.000000E+00
  PKER_RACCSS( 40, 11) =  0.000000E+00
  PKER_RACCSS( 40, 12) =  0.000000E+00
  PKER_RACCSS( 40, 13) =  0.000000E+00
  PKER_RACCSS( 40, 14) =  0.000000E+00
  PKER_RACCSS( 40, 15) =  0.000000E+00
  PKER_RACCSS( 40, 16) =  0.000000E+00
  PKER_RACCSS( 40, 17) =  0.000000E+00
  PKER_RACCSS( 40, 18) =  0.000000E+00
  PKER_RACCSS( 40, 19) =  0.000000E+00
  PKER_RACCSS( 40, 20) =  0.000000E+00
  PKER_RACCSS( 40, 21) =  0.000000E+00
  PKER_RACCSS( 40, 22) =  0.000000E+00
  PKER_RACCSS( 40, 23) =  0.000000E+00
  PKER_RACCSS( 40, 24) =  0.000000E+00
  PKER_RACCSS( 40, 25) =  0.000000E+00
  PKER_RACCSS( 40, 26) =  0.000000E+00
  PKER_RACCSS( 40, 27) =  0.000000E+00
  PKER_RACCSS( 40, 28) =  0.000000E+00
  PKER_RACCSS( 40, 29) =  0.000000E+00
  PKER_RACCSS( 40, 30) =  0.000000E+00
  PKER_RACCSS( 40, 31) =  0.000000E+00
  PKER_RACCSS( 40, 32) =  0.000000E+00
  PKER_RACCSS( 40, 33) =  0.000000E+00
  PKER_RACCSS( 40, 34) =  0.000000E+00
  PKER_RACCSS( 40, 35) =  0.000000E+00
  PKER_RACCSS( 40, 36) =  0.000000E+00
  PKER_RACCSS( 40, 37) =  0.000000E+00
  PKER_RACCSS( 40, 38) =  0.000000E+00
  PKER_RACCSS( 40, 39) =  0.000000E+00
  PKER_RACCSS( 40, 40) =  0.000000E+00
END IF
!
IF( PRESENT(PKER_RACCS ) ) THEN
  PKER_RACCS (  1,  1) =  0.810035E+01
  PKER_RACCS (  1,  2) =  0.624606E+01
  PKER_RACCS (  1,  3) =  0.474070E+01
  PKER_RACCS (  1,  4) =  0.352376E+01
  PKER_RACCS (  1,  5) =  0.255333E+01
  PKER_RACCS (  1,  6) =  0.180384E+01
  PKER_RACCS (  1,  7) =  0.126294E+01
  PKER_RACCS (  1,  8) =  0.924202E+00
  PKER_RACCS (  1,  9) =  0.775231E+00
  PKER_RACCS (  1, 10) =  0.787292E+00
  PKER_RACCS (  1, 11) =  0.911536E+00
  PKER_RACCS (  1, 12) =  0.109094E+01
  PKER_RACCS (  1, 13) =  0.127926E+01
  PKER_RACCS (  1, 14) =  0.145083E+01
  PKER_RACCS (  1, 15) =  0.159745E+01
  PKER_RACCS (  1, 16) =  0.171978E+01
  PKER_RACCS (  1, 17) =  0.182114E+01
  PKER_RACCS (  1, 18) =  0.190501E+01
  PKER_RACCS (  1, 19) =  0.197441E+01
  PKER_RACCS (  1, 20) =  0.203184E+01
  PKER_RACCS (  1, 21) =  0.207937E+01
  PKER_RACCS (  1, 22) =  0.211870E+01
  PKER_RACCS (  1, 23) =  0.215125E+01
  PKER_RACCS (  1, 24) =  0.217819E+01
  PKER_RACCS (  1, 25) =  0.220049E+01
  PKER_RACCS (  1, 26) =  0.221895E+01
  PKER_RACCS (  1, 27) =  0.223423E+01
  PKER_RACCS (  1, 28) =  0.224687E+01
  PKER_RACCS (  1, 29) =  0.225734E+01
  PKER_RACCS (  1, 30) =  0.226601E+01
  PKER_RACCS (  1, 31) =  0.227318E+01
  PKER_RACCS (  1, 32) =  0.227911E+01
  PKER_RACCS (  1, 33) =  0.228403E+01
  PKER_RACCS (  1, 34) =  0.228810E+01
  PKER_RACCS (  1, 35) =  0.229146E+01
  PKER_RACCS (  1, 36) =  0.229425E+01
  PKER_RACCS (  1, 37) =  0.229656E+01
  PKER_RACCS (  1, 38) =  0.229847E+01
  PKER_RACCS (  1, 39) =  0.230005E+01
  PKER_RACCS (  1, 40) =  0.230136E+01
  PKER_RACCS (  2,  1) =  0.835048E+01
  PKER_RACCS (  2,  2) =  0.645953E+01
  PKER_RACCS (  2,  3) =  0.492716E+01
  PKER_RACCS (  2,  4) =  0.368761E+01
  PKER_RACCS (  2,  5) =  0.269450E+01
  PKER_RACCS (  2,  6) =  0.191744E+01
  PKER_RACCS (  2,  7) =  0.134059E+01
  PKER_RACCS (  2,  8) =  0.956675E+00
  PKER_RACCS (  2,  9) =  0.757265E+00
  PKER_RACCS (  2, 10) =  0.720633E+00
  PKER_RACCS (  2, 11) =  0.806882E+00
  PKER_RACCS (  2, 12) =  0.963181E+00
  PKER_RACCS (  2, 13) =  0.114076E+01
  PKER_RACCS (  2, 14) =  0.130870E+01
  PKER_RACCS (  2, 15) =  0.145451E+01
  PKER_RACCS (  2, 16) =  0.157680E+01
  PKER_RACCS (  2, 17) =  0.167825E+01
  PKER_RACCS (  2, 18) =  0.176221E+01
  PKER_RACCS (  2, 19) =  0.183168E+01
  PKER_RACCS (  2, 20) =  0.188915E+01
  PKER_RACCS (  2, 21) =  0.193671E+01
  PKER_RACCS (  2, 22) =  0.197607E+01
  PKER_RACCS (  2, 23) =  0.200864E+01
  PKER_RACCS (  2, 24) =  0.203559E+01
  PKER_RACCS (  2, 25) =  0.205790E+01
  PKER_RACCS (  2, 26) =  0.207637E+01
  PKER_RACCS (  2, 27) =  0.209165E+01
  PKER_RACCS (  2, 28) =  0.210430E+01
  PKER_RACCS (  2, 29) =  0.211478E+01
  PKER_RACCS (  2, 30) =  0.212344E+01
  PKER_RACCS (  2, 31) =  0.213062E+01
  PKER_RACCS (  2, 32) =  0.213656E+01
  PKER_RACCS (  2, 33) =  0.214147E+01
  PKER_RACCS (  2, 34) =  0.214554E+01
  PKER_RACCS (  2, 35) =  0.214891E+01
  PKER_RACCS (  2, 36) =  0.215170E+01
  PKER_RACCS (  2, 37) =  0.215401E+01
  PKER_RACCS (  2, 38) =  0.215592E+01
  PKER_RACCS (  2, 39) =  0.215750E+01
  PKER_RACCS (  2, 40) =  0.215881E+01
  PKER_RACCS (  3,  1) =  0.861642E+01
  PKER_RACCS (  3,  2) =  0.668233E+01
  PKER_RACCS (  3,  3) =  0.511848E+01
  PKER_RACCS (  3,  4) =  0.385427E+01
  PKER_RACCS (  3,  5) =  0.283858E+01
  PKER_RACCS (  3,  6) =  0.203643E+01
  PKER_RACCS (  3,  7) =  0.142806E+01
  PKER_RACCS (  3,  8) =  0.100397E+01
  PKER_RACCS (  3,  9) =  0.757020E+00
  PKER_RACCS (  3, 10) =  0.673206E+00
  PKER_RACCS (  3, 11) =  0.719335E+00
  PKER_RACCS (  3, 12) =  0.849040E+00
  PKER_RACCS (  3, 13) =  0.101307E+01
  PKER_RACCS (  3, 14) =  0.117592E+01
  PKER_RACCS (  3, 15) =  0.132041E+01
  PKER_RACCS (  3, 16) =  0.144256E+01
  PKER_RACCS (  3, 17) =  0.154410E+01
  PKER_RACCS (  3, 18) =  0.162816E+01
  PKER_RACCS (  3, 19) =  0.169770E+01
  PKER_RACCS (  3, 20) =  0.175523E+01
  PKER_RACCS (  3, 21) =  0.180284E+01
  PKER_RACCS (  3, 22) =  0.184222E+01
  PKER_RACCS (  3, 23) =  0.187482E+01
  PKER_RACCS (  3, 24) =  0.190179E+01
  PKER_RACCS (  3, 25) =  0.192411E+01
  PKER_RACCS (  3, 26) =  0.194259E+01
  PKER_RACCS (  3, 27) =  0.195788E+01
  PKER_RACCS (  3, 28) =  0.197054E+01
  PKER_RACCS (  3, 29) =  0.198101E+01
  PKER_RACCS (  3, 30) =  0.198968E+01
  PKER_RACCS (  3, 31) =  0.199686E+01
  PKER_RACCS (  3, 32) =  0.200280E+01
  PKER_RACCS (  3, 33) =  0.200772E+01
  PKER_RACCS (  3, 34) =  0.201179E+01
  PKER_RACCS (  3, 35) =  0.201516E+01
  PKER_RACCS (  3, 36) =  0.201795E+01
  PKER_RACCS (  3, 37) =  0.202026E+01
  PKER_RACCS (  3, 38) =  0.202217E+01
  PKER_RACCS (  3, 39) =  0.202375E+01
  PKER_RACCS (  3, 40) =  0.202506E+01
  PKER_RACCS (  4,  1) =  0.890193E+01
  PKER_RACCS (  4,  2) =  0.691781E+01
  PKER_RACCS (  4,  3) =  0.531713E+01
  PKER_RACCS (  4,  4) =  0.402519E+01
  PKER_RACCS (  4,  5) =  0.298590E+01
  PKER_RACCS (  4,  6) =  0.216006E+01
  PKER_RACCS (  4,  7) =  0.152334E+01
  PKER_RACCS (  4,  8) =  0.106334E+01
  PKER_RACCS (  4,  9) =  0.773535E+00
  PKER_RACCS (  4, 10) =  0.643200E+00
  PKER_RACCS (  4, 11) =  0.648455E+00
  PKER_RACCS (  4, 12) =  0.748702E+00
  PKER_RACCS (  4, 13) =  0.896286E+00
  PKER_RACCS (  4, 14) =  0.105225E+01
  PKER_RACCS (  4, 15) =  0.119469E+01
  PKER_RACCS (  4, 16) =  0.131651E+01
  PKER_RACCS (  4, 17) =  0.141813E+01
  PKER_RACCS (  4, 18) =  0.150231E+01
  PKER_RACCS (  4, 19) =  0.157195E+01
  PKER_RACCS (  4, 20) =  0.162955E+01
  PKER_RACCS (  4, 21) =  0.167720E+01
  PKER_RACCS (  4, 22) =  0.171662E+01
  PKER_RACCS (  4, 23) =  0.174924E+01
  PKER_RACCS (  4, 24) =  0.177624E+01
  PKER_RACCS (  4, 25) =  0.179858E+01
  PKER_RACCS (  4, 26) =  0.181706E+01
  PKER_RACCS (  4, 27) =  0.183237E+01
  PKER_RACCS (  4, 28) =  0.184503E+01
  PKER_RACCS (  4, 29) =  0.185551E+01
  PKER_RACCS (  4, 30) =  0.186419E+01
  PKER_RACCS (  4, 31) =  0.187137E+01
  PKER_RACCS (  4, 32) =  0.187731E+01
  PKER_RACCS (  4, 33) =  0.188223E+01
  PKER_RACCS (  4, 34) =  0.188630E+01
  PKER_RACCS (  4, 35) =  0.188967E+01
  PKER_RACCS (  4, 36) =  0.189246E+01
  PKER_RACCS (  4, 37) =  0.189477E+01
  PKER_RACCS (  4, 38) =  0.189668E+01
  PKER_RACCS (  4, 39) =  0.189826E+01
  PKER_RACCS (  4, 40) =  0.189957E+01
  PKER_RACCS (  5,  1) =  0.920977E+01
  PKER_RACCS (  5,  2) =  0.716900E+01
  PKER_RACCS (  5,  3) =  0.552588E+01
  PKER_RACCS (  5,  4) =  0.420224E+01
  PKER_RACCS (  5,  5) =  0.313744E+01
  PKER_RACCS (  5,  6) =  0.228804E+01
  PKER_RACCS (  5,  7) =  0.162515E+01
  PKER_RACCS (  5,  8) =  0.113305E+01
  PKER_RACCS (  5,  9) =  0.804245E+00
  PKER_RACCS (  5, 10) =  0.630831E+00
  PKER_RACCS (  5, 11) =  0.594727E+00
  PKER_RACCS (  5, 12) =  0.662791E+00
  PKER_RACCS (  5, 13) =  0.790719E+00
  PKER_RACCS (  5, 14) =  0.937530E+00
  PKER_RACCS (  5, 15) =  0.107695E+01
  PKER_RACCS (  5, 16) =  0.119816E+01
  PKER_RACCS (  5, 17) =  0.129982E+01
  PKER_RACCS (  5, 18) =  0.138414E+01
  PKER_RACCS (  5, 19) =  0.145388E+01
  PKER_RACCS (  5, 20) =  0.151157E+01
  PKER_RACCS (  5, 21) =  0.155928E+01
  PKER_RACCS (  5, 22) =  0.159875E+01
  PKER_RACCS (  5, 23) =  0.163140E+01
  PKER_RACCS (  5, 24) =  0.165842E+01
  PKER_RACCS (  5, 25) =  0.168078E+01
  PKER_RACCS (  5, 26) =  0.169928E+01
  PKER_RACCS (  5, 27) =  0.171459E+01
  PKER_RACCS (  5, 28) =  0.172727E+01
  PKER_RACCS (  5, 29) =  0.173775E+01
  PKER_RACCS (  5, 30) =  0.174643E+01
  PKER_RACCS (  5, 31) =  0.175362E+01
  PKER_RACCS (  5, 32) =  0.175957E+01
  PKER_RACCS (  5, 33) =  0.176449E+01
  PKER_RACCS (  5, 34) =  0.176856E+01
  PKER_RACCS (  5, 35) =  0.177193E+01
  PKER_RACCS (  5, 36) =  0.177472E+01
  PKER_RACCS (  5, 37) =  0.177703E+01
  PKER_RACCS (  5, 38) =  0.177895E+01
  PKER_RACCS (  5, 39) =  0.178053E+01
  PKER_RACCS (  5, 40) =  0.178184E+01
  PKER_RACCS (  6,  1) =  0.954082E+01
  PKER_RACCS (  6,  2) =  0.743810E+01
  PKER_RACCS (  6,  3) =  0.574728E+01
  PKER_RACCS (  6,  4) =  0.438753E+01
  PKER_RACCS (  6,  5) =  0.329456E+01
  PKER_RACCS (  6,  6) =  0.242082E+01
  PKER_RACCS (  6,  7) =  0.173320E+01
  PKER_RACCS (  6,  8) =  0.121220E+01
  PKER_RACCS (  6,  9) =  0.848100E+00
  PKER_RACCS (  6, 10) =  0.633831E+00
  PKER_RACCS (  6, 11) =  0.557416E+00
  PKER_RACCS (  6, 12) =  0.591242E+00
  PKER_RACCS (  6, 13) =  0.696457E+00
  PKER_RACCS (  6, 14) =  0.831746E+00
  PKER_RACCS (  6, 15) =  0.966879E+00
  PKER_RACCS (  6, 16) =  0.108705E+01
  PKER_RACCS (  6, 17) =  0.118868E+01
  PKER_RACCS (  6, 18) =  0.127314E+01
  PKER_RACCS (  6, 19) =  0.134302E+01
  PKER_RACCS (  6, 20) =  0.140081E+01
  PKER_RACCS (  6, 21) =  0.144859E+01
  PKER_RACCS (  6, 22) =  0.148812E+01
  PKER_RACCS (  6, 23) =  0.152081E+01
  PKER_RACCS (  6, 24) =  0.154786E+01
  PKER_RACCS (  6, 25) =  0.157025E+01
  PKER_RACCS (  6, 26) =  0.158876E+01
  PKER_RACCS (  6, 27) =  0.160409E+01
  PKER_RACCS (  6, 28) =  0.161677E+01
  PKER_RACCS (  6, 29) =  0.162727E+01
  PKER_RACCS (  6, 30) =  0.163595E+01
  PKER_RACCS (  6, 31) =  0.164314E+01
  PKER_RACCS (  6, 32) =  0.164909E+01
  PKER_RACCS (  6, 33) =  0.165402E+01
  PKER_RACCS (  6, 34) =  0.165809E+01
  PKER_RACCS (  6, 35) =  0.166147E+01
  PKER_RACCS (  6, 36) =  0.166426E+01
  PKER_RACCS (  6, 37) =  0.166657E+01
  PKER_RACCS (  6, 38) =  0.166848E+01
  PKER_RACCS (  6, 39) =  0.167007E+01
  PKER_RACCS (  6, 40) =  0.167138E+01
  PKER_RACCS (  7,  1) =  0.989299E+01
  PKER_RACCS (  7,  2) =  0.772578E+01
  PKER_RACCS (  7,  3) =  0.598316E+01
  PKER_RACCS (  7,  4) =  0.458298E+01
  PKER_RACCS (  7,  5) =  0.345874E+01
  PKER_RACCS (  7,  6) =  0.255904E+01
  PKER_RACCS (  7,  7) =  0.184707E+01
  PKER_RACCS (  7,  8) =  0.129931E+01
  PKER_RACCS (  7,  9) =  0.903048E+00
  PKER_RACCS (  7, 10) =  0.651461E+00
  PKER_RACCS (  7, 11) =  0.535102E+00
  PKER_RACCS (  7, 12) =  0.533793E+00
  PKER_RACCS (  7, 13) =  0.613816E+00
  PKER_RACCS (  7, 14) =  0.735010E+00
  PKER_RACCS (  7, 15) =  0.864301E+00
  PKER_RACCS (  7, 16) =  0.982807E+00
  PKER_RACCS (  7, 17) =  0.108425E+01
  PKER_RACCS (  7, 18) =  0.116886E+01
  PKER_RACCS (  7, 19) =  0.123890E+01
  PKER_RACCS (  7, 20) =  0.129681E+01
  PKER_RACCS (  7, 21) =  0.134469E+01
  PKER_RACCS (  7, 22) =  0.138428E+01
  PKER_RACCS (  7, 23) =  0.141702E+01
  PKER_RACCS (  7, 24) =  0.144411E+01
  PKER_RACCS (  7, 25) =  0.146652E+01
  PKER_RACCS (  7, 26) =  0.148506E+01
  PKER_RACCS (  7, 27) =  0.150040E+01
  PKER_RACCS (  7, 28) =  0.151309E+01
  PKER_RACCS (  7, 29) =  0.152360E+01
  PKER_RACCS (  7, 30) =  0.153229E+01
  PKER_RACCS (  7, 31) =  0.153949E+01
  PKER_RACCS (  7, 32) =  0.154544E+01
  PKER_RACCS (  7, 33) =  0.155037E+01
  PKER_RACCS (  7, 34) =  0.155445E+01
  PKER_RACCS (  7, 35) =  0.155782E+01
  PKER_RACCS (  7, 36) =  0.156062E+01
  PKER_RACCS (  7, 37) =  0.156293E+01
  PKER_RACCS (  7, 38) =  0.156484E+01
  PKER_RACCS (  7, 39) =  0.156643E+01
  PKER_RACCS (  7, 40) =  0.156774E+01
  PKER_RACCS (  8,  1) =  0.102606E+02
  PKER_RACCS (  8,  2) =  0.803025E+01
  PKER_RACCS (  8,  3) =  0.623398E+01
  PKER_RACCS (  8,  4) =  0.479013E+01
  PKER_RACCS (  8,  5) =  0.363141E+01
  PKER_RACCS (  8,  6) =  0.270370E+01
  PKER_RACCS (  8,  7) =  0.196690E+01
  PKER_RACCS (  8,  8) =  0.139353E+01
  PKER_RACCS (  8,  9) =  0.967762E+00
  PKER_RACCS (  8, 10) =  0.681746E+00
  PKER_RACCS (  8, 11) =  0.527901E+00
  PKER_RACCS (  8, 12) =  0.491036E+00
  PKER_RACCS (  8, 13) =  0.543394E+00
  PKER_RACCS (  8, 14) =  0.647673E+00
  PKER_RACCS (  8, 15) =  0.769109E+00
  PKER_RACCS (  8, 16) =  0.885089E+00
  PKER_RACCS (  8, 17) =  0.986107E+00
  PKER_RACCS (  8, 18) =  0.107085E+01
  PKER_RACCS (  8, 19) =  0.114108E+01
  PKER_RACCS (  8, 20) =  0.119914E+01
  PKER_RACCS (  8, 21) =  0.124712E+01
  PKER_RACCS (  8, 22) =  0.128680E+01
  PKER_RACCS (  8, 23) =  0.131960E+01
  PKER_RACCS (  8, 24) =  0.134673E+01
  PKER_RACCS (  8, 25) =  0.136917E+01
  PKER_RACCS (  8, 26) =  0.138774E+01
  PKER_RACCS (  8, 27) =  0.140310E+01
  PKER_RACCS (  8, 28) =  0.141581E+01
  PKER_RACCS (  8, 29) =  0.142633E+01
  PKER_RACCS (  8, 30) =  0.143503E+01
  PKER_RACCS (  8, 31) =  0.144223E+01
  PKER_RACCS (  8, 32) =  0.144819E+01
  PKER_RACCS (  8, 33) =  0.145312E+01
  PKER_RACCS (  8, 34) =  0.145720E+01
  PKER_RACCS (  8, 35) =  0.146058E+01
  PKER_RACCS (  8, 36) =  0.146338E+01
  PKER_RACCS (  8, 37) =  0.146569E+01
  PKER_RACCS (  8, 38) =  0.146761E+01
  PKER_RACCS (  8, 39) =  0.146919E+01
  PKER_RACCS (  8, 40) =  0.147050E+01
  PKER_RACCS (  9,  1) =  0.106345E+02
  PKER_RACCS (  9,  2) =  0.834678E+01
  PKER_RACCS (  9,  3) =  0.649814E+01
  PKER_RACCS (  9,  4) =  0.500932E+01
  PKER_RACCS (  9,  5) =  0.381363E+01
  PKER_RACCS (  9,  6) =  0.285581E+01
  PKER_RACCS (  9,  7) =  0.209316E+01
  PKER_RACCS (  9,  8) =  0.149490E+01
  PKER_RACCS (  9,  9) =  0.104191E+01
  PKER_RACCS (  9, 10) =  0.724098E+00
  PKER_RACCS (  9, 11) =  0.534431E+00
  PKER_RACCS (  9, 12) =  0.462476E+00
  PKER_RACCS (  9, 13) =  0.485184E+00
  PKER_RACCS (  9, 14) =  0.569779E+00
  PKER_RACCS (  9, 15) =  0.681282E+00
  PKER_RACCS (  9, 16) =  0.793641E+00
  PKER_RACCS (  9, 17) =  0.893878E+00
  PKER_RACCS (  9, 18) =  0.978690E+00
  PKER_RACCS (  9, 19) =  0.104914E+01
  PKER_RACCS (  9, 20) =  0.110738E+01
  PKER_RACCS (  9, 21) =  0.115550E+01
  PKER_RACCS (  9, 22) =  0.119527E+01
  PKER_RACCS (  9, 23) =  0.122815E+01
  PKER_RACCS (  9, 24) =  0.125533E+01
  PKER_RACCS (  9, 25) =  0.127782E+01
  PKER_RACCS (  9, 26) =  0.129641E+01
  PKER_RACCS (  9, 27) =  0.131179E+01
  PKER_RACCS (  9, 28) =  0.132452E+01
  PKER_RACCS (  9, 29) =  0.133505E+01
  PKER_RACCS (  9, 30) =  0.134376E+01
  PKER_RACCS (  9, 31) =  0.135097E+01
  PKER_RACCS (  9, 32) =  0.135694E+01
  PKER_RACCS (  9, 33) =  0.136188E+01
  PKER_RACCS (  9, 34) =  0.136596E+01
  PKER_RACCS (  9, 35) =  0.136934E+01
  PKER_RACCS (  9, 36) =  0.137214E+01
  PKER_RACCS (  9, 37) =  0.137446E+01
  PKER_RACCS (  9, 38) =  0.137637E+01
  PKER_RACCS (  9, 39) =  0.137796E+01
  PKER_RACCS (  9, 40) =  0.137927E+01
  PKER_RACCS ( 10,  1) =  0.110031E+02
  PKER_RACCS ( 10,  2) =  0.866775E+01
  PKER_RACCS ( 10,  3) =  0.677164E+01
  PKER_RACCS ( 10,  4) =  0.523918E+01
  PKER_RACCS ( 10,  5) =  0.400557E+01
  PKER_RACCS ( 10,  6) =  0.301605E+01
  PKER_RACCS ( 10,  7) =  0.222631E+01
  PKER_RACCS ( 10,  8) =  0.160312E+01
  PKER_RACCS ( 10,  9) =  0.112426E+01
  PKER_RACCS ( 10, 10) =  0.776925E+00
  PKER_RACCS ( 10, 11) =  0.554023E+00
  PKER_RACCS ( 10, 12) =  0.447142E+00
  PKER_RACCS ( 10, 13) =  0.439159E+00
  PKER_RACCS ( 10, 14) =  0.501788E+00
  PKER_RACCS ( 10, 15) =  0.601002E+00
  PKER_RACCS ( 10, 16) =  0.708335E+00
  PKER_RACCS ( 10, 17) =  0.807233E+00
  PKER_RACCS ( 10, 18) =  0.892004E+00
  PKER_RACCS ( 10, 19) =  0.962681E+00
  PKER_RACCS ( 10, 20) =  0.102114E+01
  PKER_RACCS ( 10, 21) =  0.106943E+01
  PKER_RACCS ( 10, 22) =  0.110932E+01
  PKER_RACCS ( 10, 23) =  0.114228E+01
  PKER_RACCS ( 10, 24) =  0.116953E+01
  PKER_RACCS ( 10, 25) =  0.119207E+01
  PKER_RACCS ( 10, 26) =  0.121070E+01
  PKER_RACCS ( 10, 27) =  0.122611E+01
  PKER_RACCS ( 10, 28) =  0.123886E+01
  PKER_RACCS ( 10, 29) =  0.124940E+01
  PKER_RACCS ( 10, 30) =  0.125813E+01
  PKER_RACCS ( 10, 31) =  0.126535E+01
  PKER_RACCS ( 10, 32) =  0.127132E+01
  PKER_RACCS ( 10, 33) =  0.127626E+01
  PKER_RACCS ( 10, 34) =  0.128035E+01
  PKER_RACCS ( 10, 35) =  0.128374E+01
  PKER_RACCS ( 10, 36) =  0.128654E+01
  PKER_RACCS ( 10, 37) =  0.128886E+01
  PKER_RACCS ( 10, 38) =  0.129077E+01
  PKER_RACCS ( 10, 39) =  0.129236E+01
  PKER_RACCS ( 10, 40) =  0.129368E+01
  PKER_RACCS ( 11,  1) =  0.113549E+02
  PKER_RACCS ( 11,  2) =  0.898364E+01
  PKER_RACCS ( 11,  3) =  0.704811E+01
  PKER_RACCS ( 11,  4) =  0.547629E+01
  PKER_RACCS ( 11,  5) =  0.420604E+01
  PKER_RACCS ( 11,  6) =  0.318436E+01
  PKER_RACCS ( 11,  7) =  0.236670E+01
  PKER_RACCS ( 11,  8) =  0.171835E+01
  PKER_RACCS ( 11,  9) =  0.121434E+01
  PKER_RACCS ( 11, 10) =  0.839328E+00
  PKER_RACCS ( 11, 11) =  0.585308E+00
  PKER_RACCS ( 11, 12) =  0.445062E+00
  PKER_RACCS ( 11, 13) =  0.405828E+00
  PKER_RACCS ( 11, 14) =  0.444237E+00
  PKER_RACCS ( 11, 15) =  0.528618E+00
  PKER_RACCS ( 11, 16) =  0.629105E+00
  PKER_RACCS ( 11, 17) =  0.725893E+00
  PKER_RACCS ( 11, 18) =  0.810425E+00
  PKER_RACCS ( 11, 19) =  0.881336E+00
  PKER_RACCS ( 11, 20) =  0.940053E+00
  PKER_RACCS ( 11, 21) =  0.988540E+00
  PKER_RACCS ( 11, 22) =  0.102858E+01
  PKER_RACCS ( 11, 23) =  0.106165E+01
  PKER_RACCS ( 11, 24) =  0.108898E+01
  PKER_RACCS ( 11, 25) =  0.111157E+01
  PKER_RACCS ( 11, 26) =  0.113025E+01
  PKER_RACCS ( 11, 27) =  0.114569E+01
  PKER_RACCS ( 11, 28) =  0.115847E+01
  PKER_RACCS ( 11, 29) =  0.116903E+01
  PKER_RACCS ( 11, 30) =  0.117777E+01
  PKER_RACCS ( 11, 31) =  0.118500E+01
  PKER_RACCS ( 11, 32) =  0.119098E+01
  PKER_RACCS ( 11, 33) =  0.119593E+01
  PKER_RACCS ( 11, 34) =  0.120003E+01
  PKER_RACCS ( 11, 35) =  0.120342E+01
  PKER_RACCS ( 11, 36) =  0.120622E+01
  PKER_RACCS ( 11, 37) =  0.120854E+01
  PKER_RACCS ( 11, 38) =  0.121046E+01
  PKER_RACCS ( 11, 39) =  0.121205E+01
  PKER_RACCS ( 11, 40) =  0.121337E+01
  PKER_RACCS ( 12,  1) =  0.116799E+02
  PKER_RACCS ( 12,  2) =  0.928469E+01
  PKER_RACCS ( 12,  3) =  0.731960E+01
  PKER_RACCS ( 12,  4) =  0.571522E+01
  PKER_RACCS ( 12,  5) =  0.441213E+01
  PKER_RACCS ( 12,  6) =  0.335956E+01
  PKER_RACCS ( 12,  7) =  0.251408E+01
  PKER_RACCS ( 12,  8) =  0.184047E+01
  PKER_RACCS ( 12,  9) =  0.131203E+01
  PKER_RACCS ( 12, 10) =  0.911145E+00
  PKER_RACCS ( 12, 11) =  0.627927E+00
  PKER_RACCS ( 12, 12) =  0.455629E+00
  PKER_RACCS ( 12, 13) =  0.385139E+00
  PKER_RACCS ( 12, 14) =  0.397299E+00
  PKER_RACCS ( 12, 15) =  0.464231E+00
  PKER_RACCS ( 12, 16) =  0.555964E+00
  PKER_RACCS ( 12, 17) =  0.649649E+00
  PKER_RACCS ( 12, 18) =  0.733631E+00
  PKER_RACCS ( 12, 19) =  0.804744E+00
  PKER_RACCS ( 12, 20) =  0.863761E+00
  PKER_RACCS ( 12, 21) =  0.912491E+00
  PKER_RACCS ( 12, 22) =  0.952708E+00
  PKER_RACCS ( 12, 23) =  0.985912E+00
  PKER_RACCS ( 12, 24) =  0.101334E+01
  PKER_RACCS ( 12, 25) =  0.103600E+01
  PKER_RACCS ( 12, 26) =  0.105473E+01
  PKER_RACCS ( 12, 27) =  0.107022E+01
  PKER_RACCS ( 12, 28) =  0.108302E+01
  PKER_RACCS ( 12, 29) =  0.109361E+01
  PKER_RACCS ( 12, 30) =  0.110236E+01
  PKER_RACCS ( 12, 31) =  0.110961E+01
  PKER_RACCS ( 12, 32) =  0.111560E+01
  PKER_RACCS ( 12, 33) =  0.112056E+01
  PKER_RACCS ( 12, 34) =  0.112466E+01
  PKER_RACCS ( 12, 35) =  0.112805E+01
  PKER_RACCS ( 12, 36) =  0.113086E+01
  PKER_RACCS ( 12, 37) =  0.113319E+01
  PKER_RACCS ( 12, 38) =  0.113511E+01
  PKER_RACCS ( 12, 39) =  0.113670E+01
  PKER_RACCS ( 12, 40) =  0.113802E+01
  PKER_RACCS ( 13,  1) =  0.119715E+02
  PKER_RACCS ( 13,  2) =  0.956269E+01
  PKER_RACCS ( 13,  3) =  0.757802E+01
  PKER_RACCS ( 13,  4) =  0.594935E+01
  PKER_RACCS ( 13,  5) =  0.461927E+01
  PKER_RACCS ( 13,  6) =  0.353911E+01
  PKER_RACCS ( 13,  7) =  0.266730E+01
  PKER_RACCS ( 13,  8) =  0.196897E+01
  PKER_RACCS ( 13,  9) =  0.141674E+01
  PKER_RACCS ( 13, 10) =  0.991267E+00
  PKER_RACCS ( 13, 11) =  0.680645E+00
  PKER_RACCS ( 13, 12) =  0.478159E+00
  PKER_RACCS ( 13, 13) =  0.376423E+00
  PKER_RACCS ( 13, 14) =  0.361128E+00
  PKER_RACCS ( 13, 15) =  0.408438E+00
  PKER_RACCS ( 13, 16) =  0.489166E+00
  PKER_RACCS ( 13, 17) =  0.578426E+00
  PKER_RACCS ( 13, 18) =  0.661345E+00
  PKER_RACCS ( 13, 19) =  0.732571E+00
  PKER_RACCS ( 13, 20) =  0.791923E+00
  PKER_RACCS ( 13, 21) =  0.840945E+00
  PKER_RACCS ( 13, 22) =  0.881381E+00
  PKER_RACCS ( 13, 23) =  0.914745E+00
  PKER_RACCS ( 13, 24) =  0.942288E+00
  PKER_RACCS ( 13, 25) =  0.965037E+00
  PKER_RACCS ( 13, 26) =  0.983832E+00
  PKER_RACCS ( 13, 27) =  0.999365E+00
  PKER_RACCS ( 13, 28) =  0.101221E+01
  PKER_RACCS ( 13, 29) =  0.102282E+01
  PKER_RACCS ( 13, 30) =  0.103160E+01
  PKER_RACCS ( 13, 31) =  0.103886E+01
  PKER_RACCS ( 13, 32) =  0.104487E+01
  PKER_RACCS ( 13, 33) =  0.104983E+01
  PKER_RACCS ( 13, 34) =  0.105394E+01
  PKER_RACCS ( 13, 35) =  0.105734E+01
  PKER_RACCS ( 13, 36) =  0.106016E+01
  PKER_RACCS ( 13, 37) =  0.106248E+01
  PKER_RACCS ( 13, 38) =  0.106441E+01
  PKER_RACCS ( 13, 39) =  0.106600E+01
  PKER_RACCS ( 13, 40) =  0.106732E+01
  PKER_RACCS ( 14,  1) =  0.122269E+02
  PKER_RACCS ( 14,  2) =  0.981222E+01
  PKER_RACCS ( 14,  3) =  0.781657E+01
  PKER_RACCS ( 14,  4) =  0.617190E+01
  PKER_RACCS ( 14,  5) =  0.482183E+01
  PKER_RACCS ( 14,  6) =  0.371915E+01
  PKER_RACCS ( 14,  7) =  0.282402E+01
  PKER_RACCS ( 14,  8) =  0.210269E+01
  PKER_RACCS ( 14,  9) =  0.152785E+01
  PKER_RACCS ( 14, 10) =  0.107897E+01
  PKER_RACCS ( 14, 11) =  0.742682E+00
  PKER_RACCS ( 14, 12) =  0.511717E+00
  PKER_RACCS ( 14, 13) =  0.379723E+00
  PKER_RACCS ( 14, 14) =  0.336223E+00
  PKER_RACCS ( 14, 15) =  0.361708E+00
  PKER_RACCS ( 14, 16) =  0.429063E+00
  PKER_RACCS ( 14, 17) =  0.512196E+00
  PKER_RACCS ( 14, 18) =  0.593334E+00
  PKER_RACCS ( 14, 19) =  0.664504E+00
  PKER_RACCS ( 14, 20) =  0.724213E+00
  PKER_RACCS ( 14, 21) =  0.773584E+00
  PKER_RACCS ( 14, 22) =  0.814286E+00
  PKER_RACCS ( 14, 23) =  0.847845E+00
  PKER_RACCS ( 14, 24) =  0.875531E+00
  PKER_RACCS ( 14, 25) =  0.898385E+00
  PKER_RACCS ( 14, 26) =  0.917258E+00
  PKER_RACCS ( 14, 27) =  0.932850E+00
  PKER_RACCS ( 14, 28) =  0.945734E+00
  PKER_RACCS ( 14, 29) =  0.956384E+00
  PKER_RACCS ( 14, 30) =  0.965189E+00
  PKER_RACCS ( 14, 31) =  0.972469E+00
  PKER_RACCS ( 14, 32) =  0.978490E+00
  PKER_RACCS ( 14, 33) =  0.983469E+00
  PKER_RACCS ( 14, 34) =  0.987588E+00
  PKER_RACCS ( 14, 35) =  0.990995E+00
  PKER_RACCS ( 14, 36) =  0.993813E+00
  PKER_RACCS ( 14, 37) =  0.996145E+00
  PKER_RACCS ( 14, 38) =  0.998074E+00
  PKER_RACCS ( 14, 39) =  0.999670E+00
  PKER_RACCS ( 14, 40) =  0.100099E+01
  PKER_RACCS ( 15,  1) =  0.124464E+02
  PKER_RACCS ( 15,  2) =  0.100310E+02
  PKER_RACCS ( 15,  3) =  0.803077E+01
  PKER_RACCS ( 15,  4) =  0.637725E+01
  PKER_RACCS ( 15,  5) =  0.501415E+01
  PKER_RACCS ( 15,  6) =  0.389492E+01
  PKER_RACCS ( 15,  7) =  0.298087E+01
  PKER_RACCS ( 15,  8) =  0.223947E+01
  PKER_RACCS ( 15,  9) =  0.164395E+01
  PKER_RACCS ( 15, 10) =  0.117348E+01
  PKER_RACCS ( 15, 11) =  0.813603E+00
  PKER_RACCS ( 15, 12) =  0.555940E+00
  PKER_RACCS ( 15, 13) =  0.394860E+00
  PKER_RACCS ( 15, 14) =  0.322907E+00
  PKER_RACCS ( 15, 15) =  0.324503E+00
  PKER_RACCS ( 15, 16) =  0.375896E+00
  PKER_RACCS ( 15, 17) =  0.451039E+00
  PKER_RACCS ( 15, 18) =  0.529435E+00
  PKER_RACCS ( 15, 19) =  0.600261E+00
  PKER_RACCS ( 15, 20) =  0.660320E+00
  PKER_RACCS ( 15, 21) =  0.710100E+00
  PKER_RACCS ( 15, 22) =  0.751124E+00
  PKER_RACCS ( 15, 23) =  0.784920E+00
  PKER_RACCS ( 15, 24) =  0.812780E+00
  PKER_RACCS ( 15, 25) =  0.835762E+00
  PKER_RACCS ( 15, 26) =  0.854730E+00
  PKER_RACCS ( 15, 27) =  0.870393E+00
  PKER_RACCS ( 15, 28) =  0.883331E+00
  PKER_RACCS ( 15, 29) =  0.894022E+00
  PKER_RACCS ( 15, 30) =  0.902857E+00
  PKER_RACCS ( 15, 31) =  0.910161E+00
  PKER_RACCS ( 15, 32) =  0.916200E+00
  PKER_RACCS ( 15, 33) =  0.921193E+00
  PKER_RACCS ( 15, 34) =  0.925323E+00
  PKER_RACCS ( 15, 35) =  0.928738E+00
  PKER_RACCS ( 15, 36) =  0.931563E+00
  PKER_RACCS ( 15, 37) =  0.933900E+00
  PKER_RACCS ( 15, 38) =  0.935833E+00
  PKER_RACCS ( 15, 39) =  0.937432E+00
  PKER_RACCS ( 15, 40) =  0.938755E+00
  PKER_RACCS ( 16,  1) =  0.126327E+02
  PKER_RACCS ( 16,  2) =  0.102194E+02
  PKER_RACCS ( 16,  3) =  0.821876E+01
  PKER_RACCS ( 16,  4) =  0.656171E+01
  PKER_RACCS ( 16,  5) =  0.519153E+01
  PKER_RACCS ( 16,  6) =  0.406164E+01
  PKER_RACCS ( 16,  7) =  0.313379E+01
  PKER_RACCS ( 16,  8) =  0.237630E+01
  PKER_RACCS ( 16,  9) =  0.176301E+01
  PKER_RACCS ( 16, 10) =  0.127321E+01
  PKER_RACCS ( 16, 11) =  0.891908E+00
  PKER_RACCS ( 16, 12) =  0.609619E+00
  PKER_RACCS ( 16, 13) =  0.421108E+00
  PKER_RACCS ( 16, 14) =  0.320728E+00
  PKER_RACCS ( 16, 15) =  0.297097E+00
  PKER_RACCS ( 16, 16) =  0.330361E+00
  PKER_RACCS ( 16, 17) =  0.395280E+00
  PKER_RACCS ( 16, 18) =  0.469630E+00
  PKER_RACCS ( 16, 19) =  0.539613E+00
  PKER_RACCS ( 16, 20) =  0.599949E+00
  PKER_RACCS ( 16, 21) =  0.650193E+00
  PKER_RACCS ( 16, 22) =  0.691608E+00
  PKER_RACCS ( 16, 23) =  0.725693E+00
  PKER_RACCS ( 16, 24) =  0.753765E+00
  PKER_RACCS ( 16, 25) =  0.776902E+00
  PKER_RACCS ( 16, 26) =  0.795985E+00
  PKER_RACCS ( 16, 27) =  0.811734E+00
  PKER_RACCS ( 16, 28) =  0.824737E+00
  PKER_RACCS ( 16, 29) =  0.835476E+00
  PKER_RACCS ( 16, 30) =  0.844348E+00
  PKER_RACCS ( 16, 31) =  0.851681E+00
  PKER_RACCS ( 16, 32) =  0.857741E+00
  PKER_RACCS ( 16, 33) =  0.862751E+00
  PKER_RACCS ( 16, 34) =  0.866894E+00
  PKER_RACCS ( 16, 35) =  0.870319E+00
  PKER_RACCS ( 16, 36) =  0.873152E+00
  PKER_RACCS ( 16, 37) =  0.875495E+00
  PKER_RACCS ( 16, 38) =  0.877433E+00
  PKER_RACCS ( 16, 39) =  0.879036E+00
  PKER_RACCS ( 16, 40) =  0.880362E+00
  PKER_RACCS ( 17,  1) =  0.127896E+02
  PKER_RACCS ( 17,  2) =  0.103796E+02
  PKER_RACCS ( 17,  3) =  0.838093E+01
  PKER_RACCS ( 17,  4) =  0.672380E+01
  PKER_RACCS ( 17,  5) =  0.535093E+01
  PKER_RACCS ( 17,  6) =  0.421538E+01
  PKER_RACCS ( 17,  7) =  0.327875E+01
  PKER_RACCS ( 17,  8) =  0.250965E+01
  PKER_RACCS ( 17,  9) =  0.188231E+01
  PKER_RACCS ( 17, 10) =  0.137624E+01
  PKER_RACCS ( 17, 11) =  0.976041E+00
  PKER_RACCS ( 17, 12) =  0.671601E+00
  PKER_RACCS ( 17, 13) =  0.457610E+00
  PKER_RACCS ( 17, 14) =  0.329677E+00
  PKER_RACCS ( 17, 15) =  0.280046E+00
  PKER_RACCS ( 17, 16) =  0.292981E+00
  PKER_RACCS ( 17, 17) =  0.345338E+00
  PKER_RACCS ( 17, 18) =  0.413953E+00
  PKER_RACCS ( 17, 19) =  0.482373E+00
  PKER_RACCS ( 17, 20) =  0.542827E+00
  PKER_RACCS ( 17, 21) =  0.593577E+00
  PKER_RACCS ( 17, 22) =  0.635456E+00
  PKER_RACCS ( 17, 23) =  0.669894E+00
  PKER_RACCS ( 17, 24) =  0.698224E+00
  PKER_RACCS ( 17, 25) =  0.721550E+00
  PKER_RACCS ( 17, 26) =  0.740773E+00
  PKER_RACCS ( 17, 27) =  0.756626E+00
  PKER_RACCS ( 17, 28) =  0.769706E+00
  PKER_RACCS ( 17, 29) =  0.780504E+00
  PKER_RACCS ( 17, 30) =  0.789421E+00
  PKER_RACCS ( 17, 31) =  0.796788E+00
  PKER_RACCS ( 17, 32) =  0.802874E+00
  PKER_RACCS ( 17, 33) =  0.807905E+00
  PKER_RACCS ( 17, 34) =  0.812063E+00
  PKER_RACCS ( 17, 35) =  0.815500E+00
  PKER_RACCS ( 17, 36) =  0.818342E+00
  PKER_RACCS ( 17, 37) =  0.820693E+00
  PKER_RACCS ( 17, 38) =  0.822636E+00
  PKER_RACCS ( 17, 39) =  0.824244E+00
  PKER_RACCS ( 17, 40) =  0.825573E+00
  PKER_RACCS ( 18,  1) =  0.129213E+02
  PKER_RACCS ( 18,  2) =  0.105149E+02
  PKER_RACCS ( 18,  3) =  0.851921E+01
  PKER_RACCS ( 18,  4) =  0.686389E+01
  PKER_RACCS ( 18,  5) =  0.549117E+01
  PKER_RACCS ( 18,  6) =  0.435362E+01
  PKER_RACCS ( 18,  7) =  0.341243E+01
  PKER_RACCS ( 18,  8) =  0.263602E+01
  PKER_RACCS ( 18,  9) =  0.199868E+01
  PKER_RACCS ( 18, 10) =  0.147991E+01
  PKER_RACCS ( 18, 11) =  0.106410E+01
  PKER_RACCS ( 18, 12) =  0.740604E+00
  PKER_RACCS ( 18, 13) =  0.503591E+00
  PKER_RACCS ( 18, 14) =  0.349646E+00
  PKER_RACCS ( 18, 15) =  0.273846E+00
  PKER_RACCS ( 18, 16) =  0.264450E+00
  PKER_RACCS ( 18, 17) =  0.301632E+00
  PKER_RACCS ( 18, 18) =  0.362584E+00
  PKER_RACCS ( 18, 19) =  0.428436E+00
  PKER_RACCS ( 18, 20) =  0.488711E+00
  PKER_RACCS ( 18, 21) =  0.539973E+00
  PKER_RACCS ( 18, 22) =  0.582398E+00
  PKER_RACCS ( 18, 23) =  0.617263E+00
  PKER_RACCS ( 18, 24) =  0.645906E+00
  PKER_RACCS ( 18, 25) =  0.669463E+00
  PKER_RACCS ( 18, 26) =  0.688855E+00
  PKER_RACCS ( 18, 27) =  0.704834E+00
  PKER_RACCS ( 18, 28) =  0.718008E+00
  PKER_RACCS ( 18, 29) =  0.728877E+00
  PKER_RACCS ( 18, 30) =  0.737848E+00
  PKER_RACCS ( 18, 31) =  0.745255E+00
  PKER_RACCS ( 18, 32) =  0.751373E+00
  PKER_RACCS ( 18, 33) =  0.756428E+00
  PKER_RACCS ( 18, 34) =  0.760604E+00
  PKER_RACCS ( 18, 35) =  0.764056E+00
  PKER_RACCS ( 18, 36) =  0.766910E+00
  PKER_RACCS ( 18, 37) =  0.769269E+00
  PKER_RACCS ( 18, 38) =  0.771219E+00
  PKER_RACCS ( 18, 39) =  0.772832E+00
  PKER_RACCS ( 18, 40) =  0.774166E+00
  PKER_RACCS ( 19,  1) =  0.130318E+02
  PKER_RACCS ( 19,  2) =  0.106289E+02
  PKER_RACCS ( 19,  3) =  0.863636E+01
  PKER_RACCS ( 19,  4) =  0.698365E+01
  PKER_RACCS ( 19,  5) =  0.561261E+01
  PKER_RACCS ( 19,  6) =  0.447539E+01
  PKER_RACCS ( 19,  7) =  0.353272E+01
  PKER_RACCS ( 19,  8) =  0.275260E+01
  PKER_RACCS ( 19,  9) =  0.210907E+01
  PKER_RACCS ( 19, 10) =  0.158135E+01
  PKER_RACCS ( 19, 11) =  0.115350E+01
  PKER_RACCS ( 19, 12) =  0.814363E+00
  PKER_RACCS ( 19, 13) =  0.557360E+00
  PKER_RACCS ( 19, 14) =  0.379586E+00
  PKER_RACCS ( 19, 15) =  0.278114E+00
  PKER_RACCS ( 19, 16) =  0.245146E+00
  PKER_RACCS ( 19, 17) =  0.264975E+00
  PKER_RACCS ( 19, 18) =  0.315944E+00
  PKER_RACCS ( 19, 19) =  0.377850E+00
  PKER_RACCS ( 19, 20) =  0.437417E+00
  PKER_RACCS ( 19, 21) =  0.489121E+00
  PKER_RACCS ( 19, 22) =  0.532165E+00
  PKER_RACCS ( 19, 23) =  0.567544E+00
  PKER_RACCS ( 19, 24) =  0.596569E+00
  PKER_RACCS ( 19, 25) =  0.620406E+00
  PKER_RACCS ( 19, 26) =  0.640004E+00
  PKER_RACCS ( 19, 27) =  0.656135E+00
  PKER_RACCS ( 19, 28) =  0.669424E+00
  PKER_RACCS ( 19, 29) =  0.680378E+00
  PKER_RACCS ( 19, 30) =  0.689414E+00
  PKER_RACCS ( 19, 31) =  0.696870E+00
  PKER_RACCS ( 19, 32) =  0.703026E+00
  PKER_RACCS ( 19, 33) =  0.708109E+00
  PKER_RACCS ( 19, 34) =  0.712308E+00
  PKER_RACCS ( 19, 35) =  0.715777E+00
  PKER_RACCS ( 19, 36) =  0.718644E+00
  PKER_RACCS ( 19, 37) =  0.721014E+00
  PKER_RACCS ( 19, 38) =  0.722972E+00
  PKER_RACCS ( 19, 39) =  0.724592E+00
  PKER_RACCS ( 19, 40) =  0.725930E+00
  PKER_RACCS ( 20,  1) =  0.131249E+02
  PKER_RACCS ( 20,  2) =  0.107250E+02
  PKER_RACCS ( 20,  3) =  0.873538E+01
  PKER_RACCS ( 20,  4) =  0.708543E+01
  PKER_RACCS ( 20,  5) =  0.571670E+01
  PKER_RACCS ( 20,  6) =  0.458105E+01
  PKER_RACCS ( 20,  7) =  0.363884E+01
  PKER_RACCS ( 20,  8) =  0.285761E+01
  PKER_RACCS ( 20,  9) =  0.221101E+01
  PKER_RACCS ( 20, 10) =  0.167782E+01
  PKER_RACCS ( 20, 11) =  0.124159E+01
  PKER_RACCS ( 20, 12) =  0.890407E+00
  PKER_RACCS ( 20, 13) =  0.616977E+00
  PKER_RACCS ( 20, 14) =  0.418242E+00
  PKER_RACCS ( 20, 15) =  0.292524E+00
  PKER_RACCS ( 20, 16) =  0.235581E+00
  PKER_RACCS ( 20, 17) =  0.235983E+00
  PKER_RACCS ( 20, 18) =  0.274591E+00
  PKER_RACCS ( 20, 19) =  0.330763E+00
  PKER_RACCS ( 20, 20) =  0.388819E+00
  PKER_RACCS ( 20, 21) =  0.440784E+00
  PKER_RACCS ( 20, 22) =  0.484500E+00
  PKER_RACCS ( 20, 23) =  0.520487E+00
  PKER_RACCS ( 20, 24) =  0.549976E+00
  PKER_RACCS ( 20, 25) =  0.574153E+00
  PKER_RACCS ( 20, 26) =  0.594001E+00
  PKER_RACCS ( 20, 27) =  0.610317E+00
  PKER_RACCS ( 20, 28) =  0.623744E+00
  PKER_RACCS ( 20, 29) =  0.634801E+00
  PKER_RACCS ( 20, 30) =  0.643915E+00
  PKER_RACCS ( 20, 31) =  0.651431E+00
  PKER_RACCS ( 20, 32) =  0.657631E+00
  PKER_RACCS ( 20, 33) =  0.662749E+00
  PKER_RACCS ( 20, 34) =  0.666975E+00
  PKER_RACCS ( 20, 35) =  0.670465E+00
  PKER_RACCS ( 20, 36) =  0.673348E+00
  PKER_RACCS ( 20, 37) =  0.675730E+00
  PKER_RACCS ( 20, 38) =  0.677698E+00
  PKER_RACCS ( 20, 39) =  0.679325E+00
  PKER_RACCS ( 20, 40) =  0.680670E+00
  PKER_RACCS ( 21,  1) =  0.132036E+02
  PKER_RACCS ( 21,  2) =  0.108062E+02
  PKER_RACCS ( 21,  3) =  0.881918E+01
  PKER_RACCS ( 21,  4) =  0.717177E+01
  PKER_RACCS ( 21,  5) =  0.580546E+01
  PKER_RACCS ( 21,  6) =  0.467187E+01
  PKER_RACCS ( 21,  7) =  0.373113E+01
  PKER_RACCS ( 21,  8) =  0.295042E+01
  PKER_RACCS ( 21,  9) =  0.230297E+01
  PKER_RACCS ( 21, 10) =  0.176711E+01
  PKER_RACCS ( 21, 11) =  0.132575E+01
  PKER_RACCS ( 21, 12) =  0.966211E+00
  PKER_RACCS ( 21, 13) =  0.680246E+00
  PKER_RACCS ( 21, 14) =  0.464064E+00
  PKER_RACCS ( 21, 15) =  0.316605E+00
  PKER_RACCS ( 21, 16) =  0.236157E+00
  PKER_RACCS ( 21, 17) =  0.215485E+00
  PKER_RACCS ( 21, 18) =  0.239150E+00
  PKER_RACCS ( 21, 19) =  0.287499E+00
  PKER_RACCS ( 21, 20) =  0.342900E+00
  PKER_RACCS ( 21, 21) =  0.394764E+00
  PKER_RACCS ( 21, 22) =  0.439154E+00
  PKER_RACCS ( 21, 23) =  0.475848E+00
  PKER_RACCS ( 21, 24) =  0.505894E+00
  PKER_RACCS ( 21, 25) =  0.530484E+00
  PKER_RACCS ( 21, 26) =  0.550636E+00
  PKER_RACCS ( 21, 27) =  0.567176E+00
  PKER_RACCS ( 21, 28) =  0.580769E+00
  PKER_RACCS ( 21, 29) =  0.591952E+00
  PKER_RACCS ( 21, 30) =  0.601159E+00
  PKER_RACCS ( 21, 31) =  0.608746E+00
  PKER_RACCS ( 21, 32) =  0.615001E+00
  PKER_RACCS ( 21, 33) =  0.620161E+00
  PKER_RACCS ( 21, 34) =  0.624418E+00
  PKER_RACCS ( 21, 35) =  0.627933E+00
  PKER_RACCS ( 21, 36) =  0.630835E+00
  PKER_RACCS ( 21, 37) =  0.633232E+00
  PKER_RACCS ( 21, 38) =  0.635212E+00
  PKER_RACCS ( 21, 39) =  0.636848E+00
  PKER_RACCS ( 21, 40) =  0.638199E+00
  PKER_RACCS ( 22,  1) =  0.132706E+02
  PKER_RACCS ( 22,  2) =  0.108752E+02
  PKER_RACCS ( 22,  3) =  0.889034E+01
  PKER_RACCS ( 22,  4) =  0.724514E+01
  PKER_RACCS ( 22,  5) =  0.588103E+01
  PKER_RACCS ( 22,  6) =  0.474956E+01
  PKER_RACCS ( 22,  7) =  0.381066E+01
  PKER_RACCS ( 22,  8) =  0.303131E+01
  PKER_RACCS ( 22,  9) =  0.238440E+01
  PKER_RACCS ( 22, 10) =  0.184783E+01
  PKER_RACCS ( 22, 11) =  0.140395E+01
  PKER_RACCS ( 22, 12) =  0.103925E+01
  PKER_RACCS ( 22, 13) =  0.744489E+00
  PKER_RACCS ( 22, 14) =  0.514665E+00
  PKER_RACCS ( 22, 15) =  0.348618E+00
  PKER_RACCS ( 22, 16) =  0.246213E+00
  PKER_RACCS ( 22, 17) =  0.203810E+00
  PKER_RACCS ( 22, 18) =  0.210527E+00
  PKER_RACCS ( 22, 19) =  0.248639E+00
  PKER_RACCS ( 22, 20) =  0.299821E+00
  PKER_RACCS ( 22, 21) =  0.350944E+00
  PKER_RACCS ( 22, 22) =  0.395903E+00
  PKER_RACCS ( 22, 23) =  0.433386E+00
  PKER_RACCS ( 22, 24) =  0.464095E+00
  PKER_RACCS ( 22, 25) =  0.489182E+00
  PKER_RACCS ( 22, 26) =  0.509702E+00
  PKER_RACCS ( 22, 27) =  0.526514E+00
  PKER_RACCS ( 22, 28) =  0.540309E+00
  PKER_RACCS ( 22, 29) =  0.551642E+00
  PKER_RACCS ( 22, 30) =  0.560963E+00
  PKER_RACCS ( 22, 31) =  0.568636E+00
  PKER_RACCS ( 22, 32) =  0.574956E+00
  PKER_RACCS ( 22, 33) =  0.580166E+00
  PKER_RACCS ( 22, 34) =  0.584462E+00
  PKER_RACCS ( 22, 35) =  0.588006E+00
  PKER_RACCS ( 22, 36) =  0.590931E+00
  PKER_RACCS ( 22, 37) =  0.593346E+00
  PKER_RACCS ( 22, 38) =  0.595339E+00
  PKER_RACCS ( 22, 39) =  0.596986E+00
  PKER_RACCS ( 22, 40) =  0.598346E+00
  PKER_RACCS ( 23,  1) =  0.133280E+02
  PKER_RACCS ( 23,  2) =  0.109343E+02
  PKER_RACCS ( 23,  3) =  0.895109E+01
  PKER_RACCS ( 23,  4) =  0.730772E+01
  PKER_RACCS ( 23,  5) =  0.594552E+01
  PKER_RACCS ( 23,  6) =  0.481597E+01
  PKER_RACCS ( 23,  7) =  0.387893E+01
  PKER_RACCS ( 23,  8) =  0.310124E+01
  PKER_RACCS ( 23,  9) =  0.245555E+01
  PKER_RACCS ( 23, 10) =  0.191949E+01
  PKER_RACCS ( 23, 11) =  0.147491E+01
  PKER_RACCS ( 23, 12) =  0.110760E+01
  PKER_RACCS ( 23, 13) =  0.807248E+00
  PKER_RACCS ( 23, 14) =  0.567629E+00
  PKER_RACCS ( 23, 15) =  0.386696E+00
  PKER_RACCS ( 23, 16) =  0.264772E+00
  PKER_RACCS ( 23, 17) =  0.201168E+00
  PKER_RACCS ( 23, 18) =  0.189359E+00
  PKER_RACCS ( 23, 19) =  0.214892E+00
  PKER_RACCS ( 23, 20) =  0.259902E+00
  PKER_RACCS ( 23, 21) =  0.309296E+00
  PKER_RACCS ( 23, 22) =  0.354562E+00
  PKER_RACCS ( 23, 23) =  0.392871E+00
  PKER_RACCS ( 23, 24) =  0.424352E+00
  PKER_RACCS ( 23, 25) =  0.450037E+00
  PKER_RACCS ( 23, 26) =  0.471000E+00
  PKER_RACCS ( 23, 27) =  0.488140E+00
  PKER_RACCS ( 23, 28) =  0.502179E+00
  PKER_RACCS ( 23, 29) =  0.513695E+00
  PKER_RACCS ( 23, 30) =  0.523153E+00
  PKER_RACCS ( 23, 31) =  0.530929E+00
  PKER_RACCS ( 23, 32) =  0.537328E+00
  PKER_RACCS ( 23, 33) =  0.542597E+00
  PKER_RACCS ( 23, 34) =  0.546939E+00
  PKER_RACCS ( 23, 35) =  0.550519E+00
  PKER_RACCS ( 23, 36) =  0.553471E+00
  PKER_RACCS ( 23, 37) =  0.555907E+00
  PKER_RACCS ( 23, 38) =  0.557917E+00
  PKER_RACCS ( 23, 39) =  0.559577E+00
  PKER_RACCS ( 23, 40) =  0.560947E+00
  PKER_RACCS ( 24,  1) =  0.133776E+02
  PKER_RACCS ( 24,  2) =  0.109851E+02
  PKER_RACCS ( 24,  3) =  0.900330E+01
  PKER_RACCS ( 24,  4) =  0.736141E+01
  PKER_RACCS ( 24,  5) =  0.600078E+01
  PKER_RACCS ( 24,  6) =  0.487288E+01
  PKER_RACCS ( 24,  7) =  0.393752E+01
  PKER_RACCS ( 24,  8) =  0.316146E+01
  PKER_RACCS ( 24,  9) =  0.251726E+01
  PKER_RACCS ( 24, 10) =  0.198229E+01
  PKER_RACCS ( 24, 11) =  0.153812E+01
  PKER_RACCS ( 24, 12) =  0.116995E+01
  PKER_RACCS ( 24, 13) =  0.866612E+00
  PKER_RACCS ( 24, 14) =  0.620643E+00
  PKER_RACCS ( 24, 15) =  0.428690E+00
  PKER_RACCS ( 24, 16) =  0.290707E+00
  PKER_RACCS ( 24, 17) =  0.207519E+00
  PKER_RACCS ( 24, 18) =  0.176401E+00
  PKER_RACCS ( 24, 19) =  0.187072E+00
  PKER_RACCS ( 24, 20) =  0.223666E+00
  PKER_RACCS ( 24, 21) =  0.269955E+00
  PKER_RACCS ( 24, 22) =  0.315007E+00
  PKER_RACCS ( 24, 23) =  0.354096E+00
  PKER_RACCS ( 24, 24) =  0.386445E+00
  PKER_RACCS ( 24, 25) =  0.412837E+00
  PKER_RACCS ( 24, 26) =  0.434333E+00
  PKER_RACCS ( 24, 27) =  0.451869E+00
  PKER_RACCS ( 24, 28) =  0.466202E+00
  PKER_RACCS ( 24, 29) =  0.477938E+00
  PKER_RACCS ( 24, 30) =  0.487561E+00
  PKER_RACCS ( 24, 31) =  0.495462E+00
  PKER_RACCS ( 24, 32) =  0.501955E+00
  PKER_RACCS ( 24, 33) =  0.507296E+00
  PKER_RACCS ( 24, 34) =  0.511693E+00
  PKER_RACCS ( 24, 35) =  0.515315E+00
  PKER_RACCS ( 24, 36) =  0.518300E+00
  PKER_RACCS ( 24, 37) =  0.520762E+00
  PKER_RACCS ( 24, 38) =  0.522792E+00
  PKER_RACCS ( 24, 39) =  0.524467E+00
  PKER_RACCS ( 24, 40) =  0.525849E+00
  PKER_RACCS ( 25,  1) =  0.134206E+02
  PKER_RACCS ( 25,  2) =  0.110292E+02
  PKER_RACCS ( 25,  3) =  0.904847E+01
  PKER_RACCS ( 25,  4) =  0.740776E+01
  PKER_RACCS ( 25,  5) =  0.604841E+01
  PKER_RACCS ( 25,  6) =  0.492186E+01
  PKER_RACCS ( 25,  7) =  0.398793E+01
  PKER_RACCS ( 25,  8) =  0.321335E+01
  PKER_RACCS ( 25,  9) =  0.257059E+01
  PKER_RACCS ( 25, 10) =  0.203693E+01
  PKER_RACCS ( 25, 11) =  0.159370E+01
  PKER_RACCS ( 25, 12) =  0.122575E+01
  PKER_RACCS ( 25, 13) =  0.921214E+00
  PKER_RACCS ( 25, 14) =  0.671617E+00
  PKER_RACCS ( 25, 15) =  0.472110E+00
  PKER_RACCS ( 25, 16) =  0.321676E+00
  PKER_RACCS ( 25, 17) =  0.221561E+00
  PKER_RACCS ( 25, 18) =  0.171605E+00
  PKER_RACCS ( 25, 19) =  0.166038E+00
  PKER_RACCS ( 25, 20) =  0.191877E+00
  PKER_RACCS ( 25, 21) =  0.233259E+00
  PKER_RACCS ( 25, 22) =  0.277238E+00
  PKER_RACCS ( 25, 23) =  0.316894E+00
  PKER_RACCS ( 25, 24) =  0.350169E+00
  PKER_RACCS ( 25, 25) =  0.377379E+00
  PKER_RACCS ( 25, 26) =  0.399506E+00
  PKER_RACCS ( 25, 27) =  0.417517E+00
  PKER_RACCS ( 25, 28) =  0.432204E+00
  PKER_RACCS ( 25, 29) =  0.444205E+00
  PKER_RACCS ( 25, 30) =  0.454027E+00
  PKER_RACCS ( 25, 31) =  0.462077E+00
  PKER_RACCS ( 25, 32) =  0.468684E+00
  PKER_RACCS ( 25, 33) =  0.474112E+00
  PKER_RACCS ( 25, 34) =  0.478576E+00
  PKER_RACCS ( 25, 35) =  0.482249E+00
  PKER_RACCS ( 25, 36) =  0.485273E+00
  PKER_RACCS ( 25, 37) =  0.487764E+00
  PKER_RACCS ( 25, 38) =  0.489818E+00
  PKER_RACCS ( 25, 39) =  0.491511E+00
  PKER_RACCS ( 25, 40) =  0.492908E+00
  PKER_RACCS ( 26,  1) =  0.134583E+02
  PKER_RACCS ( 26,  2) =  0.110677E+02
  PKER_RACCS ( 26,  3) =  0.908784E+01
  PKER_RACCS ( 26,  4) =  0.744807E+01
  PKER_RACCS ( 26,  5) =  0.608972E+01
  PKER_RACCS ( 26,  6) =  0.496427E+01
  PKER_RACCS ( 26,  7) =  0.403151E+01
  PKER_RACCS ( 26,  8) =  0.325817E+01
  PKER_RACCS ( 26,  9) =  0.261671E+01
  PKER_RACCS ( 26, 10) =  0.208432E+01
  PKER_RACCS ( 26, 11) =  0.164223E+01
  PKER_RACCS ( 26, 12) =  0.127505E+01
  PKER_RACCS ( 26, 13) =  0.970445E+00
  PKER_RACCS ( 26, 14) =  0.719103E+00
  PKER_RACCS ( 26, 15) =  0.514960E+00
  PKER_RACCS ( 26, 16) =  0.355619E+00
  PKER_RACCS ( 26, 17) =  0.241696E+00
  PKER_RACCS ( 26, 18) =  0.174597E+00
  PKER_RACCS ( 26, 19) =  0.152207E+00
  PKER_RACCS ( 26, 20) =  0.165325E+00
  PKER_RACCS ( 26, 21) =  0.199742E+00
  PKER_RACCS ( 26, 22) =  0.241398E+00
  PKER_RACCS ( 26, 23) =  0.281177E+00
  PKER_RACCS ( 26, 24) =  0.315343E+00
  PKER_RACCS ( 26, 25) =  0.343466E+00
  PKER_RACCS ( 26, 26) =  0.366332E+00
  PKER_RACCS ( 26, 27) =  0.384904E+00
  PKER_RACCS ( 26, 28) =  0.400015E+00
  PKER_RACCS ( 26, 29) =  0.412334E+00
  PKER_RACCS ( 26, 30) =  0.422395E+00
  PKER_RACCS ( 26, 31) =  0.430626E+00
  PKER_RACCS ( 26, 32) =  0.437370E+00
  PKER_RACCS ( 26, 33) =  0.442902E+00
  PKER_RACCS ( 26, 34) =  0.447445E+00
  PKER_RACCS ( 26, 35) =  0.451179E+00
  PKER_RACCS ( 26, 36) =  0.454250E+00
  PKER_RACCS ( 26, 37) =  0.456778E+00
  PKER_RACCS ( 26, 38) =  0.458860E+00
  PKER_RACCS ( 26, 39) =  0.460575E+00
  PKER_RACCS ( 26, 40) =  0.461988E+00
  PKER_RACCS ( 27,  1) =  0.134916E+02
  PKER_RACCS ( 27,  2) =  0.111016E+02
  PKER_RACCS ( 27,  3) =  0.912241E+01
  PKER_RACCS ( 27,  4) =  0.748337E+01
  PKER_RACCS ( 27,  5) =  0.612582E+01
  PKER_RACCS ( 27,  6) =  0.500123E+01
  PKER_RACCS ( 27,  7) =  0.406942E+01
  PKER_RACCS ( 27,  8) =  0.329710E+01
  PKER_RACCS ( 27,  9) =  0.265672E+01
  PKER_RACCS ( 27, 10) =  0.212547E+01
  PKER_RACCS ( 27, 11) =  0.168449E+01
  PKER_RACCS ( 27, 12) =  0.131827E+01
  PKER_RACCS ( 27, 13) =  0.101419E+01
  PKER_RACCS ( 27, 14) =  0.762350E+00
  PKER_RACCS ( 27, 15) =  0.555726E+00
  PKER_RACCS ( 27, 16) =  0.390561E+00
  PKER_RACCS ( 27, 17) =  0.266359E+00
  PKER_RACCS ( 27, 18) =  0.184682E+00
  PKER_RACCS ( 27, 19) =  0.145925E+00
  PKER_RACCS ( 27, 20) =  0.144842E+00
  PKER_RACCS ( 27, 21) =  0.170126E+00
  PKER_RACCS ( 27, 22) =  0.207837E+00
  PKER_RACCS ( 27, 23) =  0.246960E+00
  PKER_RACCS ( 27, 24) =  0.281834E+00
  PKER_RACCS ( 27, 25) =  0.310921E+00
  PKER_RACCS ( 27, 26) =  0.334627E+00
  PKER_RACCS ( 27, 27) =  0.353857E+00
  PKER_RACCS ( 27, 28) =  0.369470E+00
  PKER_RACCS ( 27, 29) =  0.382168E+00
  PKER_RACCS ( 27, 30) =  0.392516E+00
  PKER_RACCS ( 27, 31) =  0.400964E+00
  PKER_RACCS ( 27, 32) =  0.407872E+00
  PKER_RACCS ( 27, 33) =  0.413529E+00
  PKER_RACCS ( 27, 34) =  0.418167E+00
  PKER_RACCS ( 27, 35) =  0.421974E+00
  PKER_RACCS ( 27, 36) =  0.425101E+00
  PKER_RACCS ( 27, 37) =  0.427673E+00
  PKER_RACCS ( 27, 38) =  0.429788E+00
  PKER_RACCS ( 27, 39) =  0.431529E+00
  PKER_RACCS ( 27, 40) =  0.432963E+00
  PKER_RACCS ( 28,  1) =  0.135212E+02
  PKER_RACCS ( 28,  2) =  0.111316E+02
  PKER_RACCS ( 28,  3) =  0.915297E+01
  PKER_RACCS ( 28,  4) =  0.751450E+01
  PKER_RACCS ( 28,  5) =  0.615758E+01
  PKER_RACCS ( 28,  6) =  0.503368E+01
  PKER_RACCS ( 28,  7) =  0.410261E+01
  PKER_RACCS ( 28,  8) =  0.333111E+01
  PKER_RACCS ( 28,  9) =  0.269162E+01
  PKER_RACCS ( 28, 10) =  0.216132E+01
  PKER_RACCS ( 28, 11) =  0.172133E+01
  PKER_RACCS ( 28, 12) =  0.135607E+01
  PKER_RACCS ( 28, 13) =  0.105274E+01
  PKER_RACCS ( 28, 14) =  0.801085E+00
  PKER_RACCS ( 28, 15) =  0.593401E+00
  PKER_RACCS ( 28, 16) =  0.424717E+00
  PKER_RACCS ( 28, 17) =  0.293277E+00
  PKER_RACCS ( 28, 18) =  0.200068E+00
  PKER_RACCS ( 28, 19) =  0.146527E+00
  PKER_RACCS ( 28, 20) =  0.130912E+00
  PKER_RACCS ( 28, 21) =  0.145240E+00
  PKER_RACCS ( 28, 22) =  0.177100E+00
  PKER_RACCS ( 28, 23) =  0.214430E+00
  PKER_RACCS ( 28, 24) =  0.249591E+00
  PKER_RACCS ( 28, 25) =  0.279602E+00
  PKER_RACCS ( 28, 26) =  0.304226E+00
  PKER_RACCS ( 28, 27) =  0.324208E+00
  PKER_RACCS ( 28, 28) =  0.340405E+00
  PKER_RACCS ( 28, 29) =  0.353552E+00
  PKER_RACCS ( 28, 30) =  0.364242E+00
  PKER_RACCS ( 28, 31) =  0.372949E+00
  PKER_RACCS ( 28, 32) =  0.380054E+00
  PKER_RACCS ( 28, 33) =  0.385860E+00
  PKER_RACCS ( 28, 34) =  0.390613E+00
  PKER_RACCS ( 28, 35) =  0.394508E+00
  PKER_RACCS ( 28, 36) =  0.397703E+00
  PKER_RACCS ( 28, 37) =  0.400326E+00
  PKER_RACCS ( 28, 38) =  0.402482E+00
  PKER_RACCS ( 28, 39) =  0.404254E+00
  PKER_RACCS ( 28, 40) =  0.405713E+00
  PKER_RACCS ( 29,  1) =  0.135476E+02
  PKER_RACCS ( 29,  2) =  0.111584E+02
  PKER_RACCS ( 29,  3) =  0.918018E+01
  PKER_RACCS ( 29,  4) =  0.754216E+01
  PKER_RACCS ( 29,  5) =  0.618572E+01
  PKER_RACCS ( 29,  6) =  0.506235E+01
  PKER_RACCS ( 29,  7) =  0.413187E+01
  PKER_RACCS ( 29,  8) =  0.336101E+01
  PKER_RACCS ( 29,  9) =  0.272223E+01
  PKER_RACCS ( 29, 10) =  0.219271E+01
  PKER_RACCS ( 29, 11) =  0.175356E+01
  PKER_RACCS ( 29, 12) =  0.138915E+01
  PKER_RACCS ( 29, 13) =  0.108662E+01
  PKER_RACCS ( 29, 14) =  0.835482E+00
  PKER_RACCS ( 29, 15) =  0.627544E+00
  PKER_RACCS ( 29, 16) =  0.457003E+00
  PKER_RACCS ( 29, 17) =  0.320871E+00
  PKER_RACCS ( 29, 18) =  0.218993E+00
  PKER_RACCS ( 29, 19) =  0.153040E+00
  PKER_RACCS ( 29, 20) =  0.123480E+00
  PKER_RACCS ( 29, 21) =  0.125714E+00
  PKER_RACCS ( 29, 22) =  0.149873E+00
  PKER_RACCS ( 29, 23) =  0.183944E+00
  PKER_RACCS ( 29, 24) =  0.218688E+00
  PKER_RACCS ( 29, 25) =  0.249424E+00
  PKER_RACCS ( 29, 26) =  0.274989E+00
  PKER_RACCS ( 29, 27) =  0.295803E+00
  PKER_RACCS ( 29, 28) =  0.312668E+00
  PKER_RACCS ( 29, 29) =  0.326337E+00
  PKER_RACCS ( 29, 30) =  0.337429E+00
  PKER_RACCS ( 29, 31) =  0.346444E+00
  PKER_RACCS ( 29, 32) =  0.353785E+00
  PKER_RACCS ( 29, 33) =  0.359771E+00
  PKER_RACCS ( 29, 34) =  0.364661E+00
  PKER_RACCS ( 29, 35) =  0.368660E+00
  PKER_RACCS ( 29, 36) =  0.371936E+00
  PKER_RACCS ( 29, 37) =  0.374622E+00
  PKER_RACCS ( 29, 38) =  0.376826E+00
  PKER_RACCS ( 29, 39) =  0.378635E+00
  PKER_RACCS ( 29, 40) =  0.380123E+00
  PKER_RACCS ( 30,  1) =  0.135713E+02
  PKER_RACCS ( 30,  2) =  0.111824E+02
  PKER_RACCS ( 30,  3) =  0.920455E+01
  PKER_RACCS ( 30,  4) =  0.756688E+01
  PKER_RACCS ( 30,  5) =  0.621082E+01
  PKER_RACCS ( 30,  6) =  0.508787E+01
  PKER_RACCS ( 30,  7) =  0.415784E+01
  PKER_RACCS ( 30,  8) =  0.338749E+01
  PKER_RACCS ( 30,  9) =  0.274927E+01
  PKER_RACCS ( 30, 10) =  0.222037E+01
  PKER_RACCS ( 30, 11) =  0.178189E+01
  PKER_RACCS ( 30, 12) =  0.141821E+01
  PKER_RACCS ( 30, 13) =  0.111641E+01
  PKER_RACCS ( 30, 14) =  0.865882E+00
  PKER_RACCS ( 30, 15) =  0.658144E+00
  PKER_RACCS ( 30, 16) =  0.486803E+00
  PKER_RACCS ( 30, 17) =  0.347889E+00
  PKER_RACCS ( 30, 18) =  0.240079E+00
  PKER_RACCS ( 30, 19) =  0.164371E+00
  PKER_RACCS ( 30, 20) =  0.122278E+00
  PKER_RACCS ( 30, 21) =  0.112067E+00
  PKER_RACCS ( 30, 22) =  0.126909E+00
  PKER_RACCS ( 30, 23) =  0.156066E+00
  PKER_RACCS ( 30, 24) =  0.189340E+00
  PKER_RACCS ( 30, 25) =  0.220392E+00
  PKER_RACCS ( 30, 26) =  0.246822E+00
  PKER_RACCS ( 30, 27) =  0.268510E+00
  PKER_RACCS ( 30, 28) =  0.286117E+00
  PKER_RACCS ( 30, 29) =  0.300380E+00
  PKER_RACCS ( 30, 30) =  0.311940E+00
  PKER_RACCS ( 30, 31) =  0.321318E+00
  PKER_RACCS ( 30, 32) =  0.328937E+00
  PKER_RACCS ( 30, 33) =  0.335137E+00
  PKER_RACCS ( 30, 34) =  0.340191E+00
  PKER_RACCS ( 30, 35) =  0.344317E+00
  PKER_RACCS ( 30, 36) =  0.347689E+00
  PKER_RACCS ( 30, 37) =  0.350449E+00
  PKER_RACCS ( 30, 38) =  0.352711E+00
  PKER_RACCS ( 30, 39) =  0.354565E+00
  PKER_RACCS ( 30, 40) =  0.356087E+00
  PKER_RACCS ( 31,  1) =  0.135928E+02
  PKER_RACCS ( 31,  2) =  0.112041E+02
  PKER_RACCS ( 31,  3) =  0.922651E+01
  PKER_RACCS ( 31,  4) =  0.758911E+01
  PKER_RACCS ( 31,  5) =  0.623334E+01
  PKER_RACCS ( 31,  6) =  0.511071E+01
  PKER_RACCS ( 31,  7) =  0.418105E+01
  PKER_RACCS ( 31,  8) =  0.341109E+01
  PKER_RACCS ( 31,  9) =  0.277330E+01
  PKER_RACCS ( 31, 10) =  0.224489E+01
  PKER_RACCS ( 31, 11) =  0.180695E+01
  PKER_RACCS ( 31, 12) =  0.144386E+01
  PKER_RACCS ( 31, 13) =  0.114268E+01
  PKER_RACCS ( 31, 14) =  0.892748E+00
  PKER_RACCS ( 31, 15) =  0.685391E+00
  PKER_RACCS ( 31, 16) =  0.513859E+00
  PKER_RACCS ( 31, 17) =  0.373398E+00
  PKER_RACCS ( 31, 18) =  0.261665E+00
  PKER_RACCS ( 31, 19) =  0.178785E+00
  PKER_RACCS ( 31, 20) =  0.126188E+00
  PKER_RACCS ( 31, 21) =  0.104190E+00
  PKER_RACCS ( 31, 22) =  0.108781E+00
  PKER_RACCS ( 31, 23) =  0.131410E+00
  PKER_RACCS ( 31, 24) =  0.161929E+00
  PKER_RACCS ( 31, 25) =  0.192628E+00
  PKER_RACCS ( 31, 26) =  0.219702E+00
  PKER_RACCS ( 31, 27) =  0.242240E+00
  PKER_RACCS ( 31, 28) =  0.260630E+00
  PKER_RACCS ( 31, 29) =  0.275551E+00
  PKER_RACCS ( 31, 30) =  0.287642E+00
  PKER_RACCS ( 31, 31) =  0.297440E+00
  PKER_RACCS ( 31, 32) =  0.305387E+00
  PKER_RACCS ( 31, 33) =  0.311841E+00
  PKER_RACCS ( 31, 34) =  0.317090E+00
  PKER_RACCS ( 31, 35) =  0.321366E+00
  PKER_RACCS ( 31, 36) =  0.324854E+00
  PKER_RACCS ( 31, 37) =  0.327703E+00
  PKER_RACCS ( 31, 38) =  0.330033E+00
  PKER_RACCS ( 31, 39) =  0.331941E+00
  PKER_RACCS ( 31, 40) =  0.333505E+00
  PKER_RACCS ( 32,  1) =  0.136123E+02
  PKER_RACCS ( 32,  2) =  0.112238E+02
  PKER_RACCS ( 32,  3) =  0.924639E+01
  PKER_RACCS ( 32,  4) =  0.760920E+01
  PKER_RACCS ( 32,  5) =  0.625367E+01
  PKER_RACCS ( 32,  6) =  0.513129E+01
  PKER_RACCS ( 32,  7) =  0.420190E+01
  PKER_RACCS ( 32,  8) =  0.343225E+01
  PKER_RACCS ( 32,  9) =  0.279481E+01
  PKER_RACCS ( 32, 10) =  0.226677E+01
  PKER_RACCS ( 32, 11) =  0.182926E+01
  PKER_RACCS ( 32, 12) =  0.146664E+01
  PKER_RACCS ( 32, 13) =  0.116597E+01
  PKER_RACCS ( 32, 14) =  0.916557E+00
  PKER_RACCS ( 32, 15) =  0.709637E+00
  PKER_RACCS ( 32, 16) =  0.538201E+00
  PKER_RACCS ( 32, 17) =  0.397009E+00
  PKER_RACCS ( 32, 18) =  0.282874E+00
  PKER_RACCS ( 32, 19) =  0.194862E+00
  PKER_RACCS ( 32, 20) =  0.133999E+00
  PKER_RACCS ( 32, 21) =  0.101519E+00
  PKER_RACCS ( 32, 22) =  0.957088E-01
  PKER_RACCS ( 32, 23) =  0.110579E+00
  PKER_RACCS ( 32, 24) =  0.136947E+00
  PKER_RACCS ( 32, 25) =  0.166392E+00
  PKER_RACCS ( 32, 26) =  0.193693E+00
  PKER_RACCS ( 32, 27) =  0.216957E+00
  PKER_RACCS ( 32, 28) =  0.236123E+00
  PKER_RACCS ( 32, 29) =  0.251739E+00
  PKER_RACCS ( 32, 30) =  0.264414E+00
  PKER_RACCS ( 32, 31) =  0.274689E+00
  PKER_RACCS ( 32, 32) =  0.283015E+00
  PKER_RACCS ( 32, 33) =  0.289766E+00
  PKER_RACCS ( 32, 34) =  0.295246E+00
  PKER_RACCS ( 32, 35) =  0.299700E+00
  PKER_RACCS ( 32, 36) =  0.303326E+00
  PKER_RACCS ( 32, 37) =  0.306282E+00
  PKER_RACCS ( 32, 38) =  0.308695E+00
  PKER_RACCS ( 32, 39) =  0.310666E+00
  PKER_RACCS ( 32, 40) =  0.312279E+00
  PKER_RACCS ( 33,  1) =  0.136301E+02
  PKER_RACCS ( 33,  2) =  0.112418E+02
  PKER_RACCS ( 33,  3) =  0.926449E+01
  PKER_RACCS ( 33,  4) =  0.762746E+01
  PKER_RACCS ( 33,  5) =  0.627211E+01
  PKER_RACCS ( 33,  6) =  0.514993E+01
  PKER_RACCS ( 33,  7) =  0.422075E+01
  PKER_RACCS ( 33,  8) =  0.345134E+01
  PKER_RACCS ( 33,  9) =  0.281416E+01
  PKER_RACCS ( 33, 10) =  0.228641E+01
  PKER_RACCS ( 33, 11) =  0.184923E+01
  PKER_RACCS ( 33, 12) =  0.148699E+01
  PKER_RACCS ( 33, 13) =  0.118672E+01
  PKER_RACCS ( 33, 14) =  0.937747E+00
  PKER_RACCS ( 33, 15) =  0.731237E+00
  PKER_RACCS ( 33, 16) =  0.560038E+00
  PKER_RACCS ( 33, 17) =  0.418590E+00
  PKER_RACCS ( 33, 18) =  0.303093E+00
  PKER_RACCS ( 33, 19) =  0.211735E+00
  PKER_RACCS ( 33, 20) =  0.144709E+00
  PKER_RACCS ( 33, 21) =  0.103389E+00
  PKER_RACCS ( 33, 22) =  0.876948E-01
  PKER_RACCS ( 33, 23) =  0.940326E-01
  PKER_RACCS ( 33, 24) =  0.114972E+00
  PKER_RACCS ( 33, 25) =  0.142046E+00
  PKER_RACCS ( 33, 26) =  0.168966E+00
  PKER_RACCS ( 33, 27) =  0.192699E+00
  PKER_RACCS ( 33, 28) =  0.212559E+00
  PKER_RACCS ( 33, 29) =  0.228864E+00
  PKER_RACCS ( 33, 30) =  0.242156E+00
  PKER_RACCS ( 33, 31) =  0.252953E+00
  PKER_RACCS ( 33, 32) =  0.261707E+00
  PKER_RACCS ( 33, 33) =  0.268801E+00
  PKER_RACCS ( 33, 34) =  0.274551E+00
  PKER_RACCS ( 33, 35) =  0.279216E+00
  PKER_RACCS ( 33, 36) =  0.283006E+00
  PKER_RACCS ( 33, 37) =  0.286089E+00
  PKER_RACCS ( 33, 38) =  0.288600E+00
  PKER_RACCS ( 33, 39) =  0.290648E+00
  PKER_RACCS ( 33, 40) =  0.292320E+00
  PKER_RACCS ( 34,  1) =  0.136464E+02
  PKER_RACCS ( 34,  2) =  0.112582E+02
  PKER_RACCS ( 34,  3) =  0.928102E+01
  PKER_RACCS ( 34,  4) =  0.764412E+01
  PKER_RACCS ( 34,  5) =  0.628891E+01
  PKER_RACCS ( 34,  6) =  0.516688E+01
  PKER_RACCS ( 34,  7) =  0.423787E+01
  PKER_RACCS ( 34,  8) =  0.346865E+01
  PKER_RACCS ( 34,  9) =  0.283167E+01
  PKER_RACCS ( 34, 10) =  0.230415E+01
  PKER_RACCS ( 34, 11) =  0.186723E+01
  PKER_RACCS ( 34, 12) =  0.150527E+01
  PKER_RACCS ( 34, 13) =  0.120533E+01
  PKER_RACCS ( 34, 14) =  0.956703E+00
  PKER_RACCS ( 34, 15) =  0.750546E+00
  PKER_RACCS ( 34, 16) =  0.579618E+00
  PKER_RACCS ( 34, 17) =  0.438164E+00
  PKER_RACCS ( 34, 18) =  0.321920E+00
  PKER_RACCS ( 34, 19) =  0.228381E+00
  PKER_RACCS ( 34, 20) =  0.157004E+00
  PKER_RACCS ( 34, 21) =  0.108653E+00
  PKER_RACCS ( 34, 22) =  0.841812E-01
  PKER_RACCS ( 34, 23) =  0.818931E-01
  PKER_RACCS ( 34, 24) =  0.964120E-01
  PKER_RACCS ( 34, 25) =  0.120012E+00
  PKER_RACCS ( 34, 26) =  0.145780E+00
  PKER_RACCS ( 34, 27) =  0.169586E+00
  PKER_RACCS ( 34, 28) =  0.189966E+00
  PKER_RACCS ( 34, 29) =  0.206893E+00
  PKER_RACCS ( 34, 30) =  0.220793E+00
  PKER_RACCS ( 34, 31) =  0.232137E+00
  PKER_RACCS ( 34, 32) =  0.241360E+00
  PKER_RACCS ( 34, 33) =  0.248841E+00
  PKER_RACCS ( 34, 34) =  0.254902E+00
  PKER_RACCS ( 34, 35) =  0.259814E+00
  PKER_RACCS ( 34, 36) =  0.263797E+00
  PKER_RACCS ( 34, 37) =  0.267030E+00
  PKER_RACCS ( 34, 38) =  0.269658E+00
  PKER_RACCS ( 34, 39) =  0.271797E+00
  PKER_RACCS ( 34, 40) =  0.273540E+00
  PKER_RACCS ( 35,  1) =  0.136614E+02
  PKER_RACCS ( 35,  2) =  0.112733E+02
  PKER_RACCS ( 35,  3) =  0.929618E+01
  PKER_RACCS ( 35,  4) =  0.765939E+01
  PKER_RACCS ( 35,  5) =  0.630429E+01
  PKER_RACCS ( 35,  6) =  0.518237E+01
  PKER_RACCS ( 35,  7) =  0.425350E+01
  PKER_RACCS ( 35,  8) =  0.348441E+01
  PKER_RACCS ( 35,  9) =  0.284759E+01
  PKER_RACCS ( 35, 10) =  0.232025E+01
  PKER_RACCS ( 35, 11) =  0.188353E+01
  PKER_RACCS ( 35, 12) =  0.152179E+01
  PKER_RACCS ( 35, 13) =  0.122210E+01
  PKER_RACCS ( 35, 14) =  0.973753E+00
  PKER_RACCS ( 35, 15) =  0.767890E+00
  PKER_RACCS ( 35, 16) =  0.597225E+00
  PKER_RACCS ( 35, 17) =  0.455867E+00
  PKER_RACCS ( 35, 18) =  0.339275E+00
  PKER_RACCS ( 35, 19) =  0.244416E+00
  PKER_RACCS ( 35, 20) =  0.169957E+00
  PKER_RACCS ( 35, 21) =  0.116255E+00
  PKER_RACCS ( 35, 22) =  0.843838E-01
  PKER_RACCS ( 35, 23) =  0.739429E-01
  PKER_RACCS ( 35, 24) =  0.815390E-01
  PKER_RACCS ( 35, 25) =  0.100685E+00
  PKER_RACCS ( 35, 26) =  0.124455E+00
  PKER_RACCS ( 35, 27) =  0.147808E+00
  PKER_RACCS ( 35, 28) =  0.168434E+00
  PKER_RACCS ( 35, 29) =  0.185847E+00
  PKER_RACCS ( 35, 30) =  0.200294E+00
  PKER_RACCS ( 35, 31) =  0.212176E+00
  PKER_RACCS ( 35, 32) =  0.221887E+00
  PKER_RACCS ( 35, 33) =  0.229789E+00
  PKER_RACCS ( 35, 34) =  0.236201E+00
  PKER_RACCS ( 35, 35) =  0.241396E+00
  PKER_RACCS ( 35, 36) =  0.245605E+00
  PKER_RACCS ( 35, 37) =  0.249015E+00
  PKER_RACCS ( 35, 38) =  0.251782E+00
  PKER_RACCS ( 35, 39) =  0.254029E+00
  PKER_RACCS ( 35, 40) =  0.255856E+00
  PKER_RACCS ( 36,  1) =  0.136752E+02
  PKER_RACCS ( 36,  2) =  0.112871E+02
  PKER_RACCS ( 36,  3) =  0.931013E+01
  PKER_RACCS ( 36,  4) =  0.767342E+01
  PKER_RACCS ( 36,  5) =  0.631840E+01
  PKER_RACCS ( 36,  6) =  0.519658E+01
  PKER_RACCS ( 36,  7) =  0.426781E+01
  PKER_RACCS ( 36,  8) =  0.349883E+01
  PKER_RACCS ( 36,  9) =  0.286213E+01
  PKER_RACCS ( 36, 10) =  0.233493E+01
  PKER_RACCS ( 36, 11) =  0.189836E+01
  PKER_RACCS ( 36, 12) =  0.153679E+01
  PKER_RACCS ( 36, 13) =  0.123730E+01
  PKER_RACCS ( 36, 14) =  0.989170E+00
  PKER_RACCS ( 36, 15) =  0.783542E+00
  PKER_RACCS ( 36, 16) =  0.613107E+00
  PKER_RACCS ( 36, 17) =  0.471895E+00
  PKER_RACCS ( 36, 18) =  0.355181E+00
  PKER_RACCS ( 36, 19) =  0.259564E+00
  PKER_RACCS ( 36, 20) =  0.183119E+00
  PKER_RACCS ( 36, 21) =  0.125501E+00
  PKER_RACCS ( 36, 22) =  0.876130E-01
  PKER_RACCS ( 36, 23) =  0.698509E-01
  PKER_RACCS ( 36, 24) =  0.704131E-01
  PKER_RACCS ( 36, 25) =  0.843947E-01
  PKER_RACCS ( 36, 26) =  0.105303E+00
  PKER_RACCS ( 36, 27) =  0.127595E+00
  PKER_RACCS ( 36, 28) =  0.148112E+00
  PKER_RACCS ( 36, 29) =  0.165804E+00
  PKER_RACCS ( 36, 30) =  0.180678E+00
  PKER_RACCS ( 36, 31) =  0.193038E+00
  PKER_RACCS ( 36, 32) =  0.203226E+00
  PKER_RACCS ( 36, 33) =  0.211566E+00
  PKER_RACCS ( 36, 34) =  0.218358E+00
  PKER_RACCS ( 36, 35) =  0.223872E+00
  PKER_RACCS ( 36, 36) =  0.228339E+00
  PKER_RACCS ( 36, 37) =  0.231956E+00
  PKER_RACCS ( 36, 38) =  0.234886E+00
  PKER_RACCS ( 36, 39) =  0.237261E+00
  PKER_RACCS ( 36, 40) =  0.239188E+00
  PKER_RACCS ( 37,  1) =  0.136880E+02
  PKER_RACCS ( 37,  2) =  0.113000E+02
  PKER_RACCS ( 37,  3) =  0.932301E+01
  PKER_RACCS ( 37,  4) =  0.768635E+01
  PKER_RACCS ( 37,  5) =  0.633140E+01
  PKER_RACCS ( 37,  6) =  0.520966E+01
  PKER_RACCS ( 37,  7) =  0.428096E+01
  PKER_RACCS ( 37,  8) =  0.351207E+01
  PKER_RACCS ( 37,  9) =  0.287547E+01
  PKER_RACCS ( 37, 10) =  0.234837E+01
  PKER_RACCS ( 37, 11) =  0.191192E+01
  PKER_RACCS ( 37, 12) =  0.155048E+01
  PKER_RACCS ( 37, 13) =  0.125114E+01
  PKER_RACCS ( 37, 14) =  0.100318E+01
  PKER_RACCS ( 37, 15) =  0.797739E+00
  PKER_RACCS ( 37, 16) =  0.627493E+00
  PKER_RACCS ( 37, 17) =  0.486429E+00
  PKER_RACCS ( 37, 18) =  0.369711E+00
  PKER_RACCS ( 37, 19) =  0.273656E+00
  PKER_RACCS ( 37, 20) =  0.195887E+00
  PKER_RACCS ( 37, 21) =  0.135541E+00
  PKER_RACCS ( 37, 22) =  0.929713E-01
  PKER_RACCS ( 37, 23) =  0.689449E-01
  PKER_RACCS ( 37, 24) =  0.628067E-01
  PKER_RACCS ( 37, 25) =  0.712146E-01
  PKER_RACCS ( 37, 26) =  0.885642E-01
  PKER_RACCS ( 37, 27) =  0.109176E+00
  PKER_RACCS ( 37, 28) =  0.129175E+00
  PKER_RACCS ( 37, 29) =  0.146887E+00
  PKER_RACCS ( 37, 30) =  0.162013E+00
  PKER_RACCS ( 37, 31) =  0.174742E+00
  PKER_RACCS ( 37, 32) =  0.185350E+00
  PKER_RACCS ( 37, 33) =  0.194114E+00
  PKER_RACCS ( 37, 34) =  0.201300E+00
  PKER_RACCS ( 37, 35) =  0.207158E+00
  PKER_RACCS ( 37, 36) =  0.211915E+00
  PKER_RACCS ( 37, 37) =  0.215769E+00
  PKER_RACCS ( 37, 38) =  0.218888E+00
  PKER_RACCS ( 37, 39) =  0.221414E+00
  PKER_RACCS ( 37, 40) =  0.223459E+00
  PKER_RACCS ( 38,  1) =  0.136998E+02
  PKER_RACCS ( 38,  2) =  0.113118E+02
  PKER_RACCS ( 38,  3) =  0.933491E+01
  PKER_RACCS ( 38,  4) =  0.769831E+01
  PKER_RACCS ( 38,  5) =  0.634341E+01
  PKER_RACCS ( 38,  6) =  0.522172E+01
  PKER_RACCS ( 38,  7) =  0.429308E+01
  PKER_RACCS ( 38,  8) =  0.352426E+01
  PKER_RACCS ( 38,  9) =  0.288774E+01
  PKER_RACCS ( 38, 10) =  0.236072E+01
  PKER_RACCS ( 38, 11) =  0.192436E+01
  PKER_RACCS ( 38, 12) =  0.156302E+01
  PKER_RACCS ( 38, 13) =  0.126380E+01
  PKER_RACCS ( 38, 14) =  0.101597E+01
  PKER_RACCS ( 38, 15) =  0.810672E+00
  PKER_RACCS ( 38, 16) =  0.640582E+00
  PKER_RACCS ( 38, 17) =  0.499655E+00
  PKER_RACCS ( 38, 18) =  0.382979E+00
  PKER_RACCS ( 38, 19) =  0.286703E+00
  PKER_RACCS ( 38, 20) =  0.208118E+00
  PKER_RACCS ( 38, 21) =  0.145802E+00
  PKER_RACCS ( 38, 22) =  0.996958E-01
  PKER_RACCS ( 38, 23) =  0.705180E-01
  PKER_RACCS ( 38, 24) =  0.583121E-01
  PKER_RACCS ( 38, 25) =  0.611067E-01
  PKER_RACCS ( 38, 26) =  0.743784E-01
  PKER_RACCS ( 38, 27) =  0.927345E-01
  PKER_RACCS ( 38, 28) =  0.111788E+00
  PKER_RACCS ( 38, 29) =  0.129236E+00
  PKER_RACCS ( 38, 30) =  0.144407E+00
  PKER_RACCS ( 38, 31) =  0.157347E+00
  PKER_RACCS ( 38, 32) =  0.168273E+00
  PKER_RACCS ( 38, 33) =  0.177407E+00
  PKER_RACCS ( 38, 34) =  0.184972E+00
  PKER_RACCS ( 38, 35) =  0.191185E+00
  PKER_RACCS ( 38, 36) =  0.196255E+00
  PKER_RACCS ( 38, 37) =  0.200374E+00
  PKER_RACCS ( 38, 38) =  0.203711E+00
  PKER_RACCS ( 38, 39) =  0.206411E+00
  PKER_RACCS ( 38, 40) =  0.208595E+00
  PKER_RACCS ( 39,  1) =  0.137108E+02
  PKER_RACCS ( 39,  2) =  0.113228E+02
  PKER_RACCS ( 39,  3) =  0.934595E+01
  PKER_RACCS ( 39,  4) =  0.770939E+01
  PKER_RACCS ( 39,  5) =  0.635453E+01
  PKER_RACCS ( 39,  6) =  0.523288E+01
  PKER_RACCS ( 39,  7) =  0.430429E+01
  PKER_RACCS ( 39,  8) =  0.353552E+01
  PKER_RACCS ( 39,  9) =  0.289905E+01
  PKER_RACCS ( 39, 10) =  0.237210E+01
  PKER_RACCS ( 39, 11) =  0.193581E+01
  PKER_RACCS ( 39, 12) =  0.157455E+01
  PKER_RACCS ( 39, 13) =  0.127542E+01
  PKER_RACCS ( 39, 14) =  0.102769E+01
  PKER_RACCS ( 39, 15) =  0.822505E+00
  PKER_RACCS ( 39, 16) =  0.652537E+00
  PKER_RACCS ( 39, 17) =  0.511728E+00
  PKER_RACCS ( 39, 18) =  0.395120E+00
  PKER_RACCS ( 39, 19) =  0.298748E+00
  PKER_RACCS ( 39, 20) =  0.219673E+00
  PKER_RACCS ( 39, 21) =  0.156076E+00
  PKER_RACCS ( 39, 22) =  0.107363E+00
  PKER_RACCS ( 39, 23) =  0.740476E-01
  PKER_RACCS ( 39, 24) =  0.565449E-01
  PKER_RACCS ( 39, 25) =  0.539031E-01
  PKER_RACCS ( 39, 26) =  0.628068E-01
  PKER_RACCS ( 39, 27) =  0.783909E-01
  PKER_RACCS ( 39, 28) =  0.960758E-01
  PKER_RACCS ( 39, 29) =  0.112978E+00
  PKER_RACCS ( 39, 30) =  0.127980E+00
  PKER_RACCS ( 39, 31) =  0.140952E+00
  PKER_RACCS ( 39, 32) =  0.152050E+00
  PKER_RACCS ( 39, 33) =  0.161459E+00
  PKER_RACCS ( 39, 34) =  0.169352E+00
  PKER_RACCS ( 39, 35) =  0.175905E+00
  PKER_RACCS ( 39, 36) =  0.181296E+00
  PKER_RACCS ( 39, 37) =  0.185700E+00
  PKER_RACCS ( 39, 38) =  0.189279E+00
  PKER_RACCS ( 39, 39) =  0.192179E+00
  PKER_RACCS ( 39, 40) =  0.194525E+00
  PKER_RACCS ( 40,  1) =  0.137209E+02
  PKER_RACCS ( 40,  2) =  0.113330E+02
  PKER_RACCS ( 40,  3) =  0.935620E+01
  PKER_RACCS ( 40,  4) =  0.771967E+01
  PKER_RACCS ( 40,  5) =  0.636484E+01
  PKER_RACCS ( 40,  6) =  0.524323E+01
  PKER_RACCS ( 40,  7) =  0.431468E+01
  PKER_RACCS ( 40,  8) =  0.354595E+01
  PKER_RACCS ( 40,  9) =  0.290952E+01
  PKER_RACCS ( 40, 10) =  0.238262E+01
  PKER_RACCS ( 40, 11) =  0.194638E+01
  PKER_RACCS ( 40, 12) =  0.158519E+01
  PKER_RACCS ( 40, 13) =  0.128612E+01
  PKER_RACCS ( 40, 14) =  0.103847E+01
  PKER_RACCS ( 40, 15) =  0.833372E+00
  PKER_RACCS ( 40, 16) =  0.663500E+00
  PKER_RACCS ( 40, 17) =  0.522788E+00
  PKER_RACCS ( 40, 18) =  0.406248E+00
  PKER_RACCS ( 40, 19) =  0.309849E+00
  PKER_RACCS ( 40, 20) =  0.230469E+00
  PKER_RACCS ( 40, 21) =  0.165985E+00
  PKER_RACCS ( 40, 22) =  0.115455E+00
  PKER_RACCS ( 40, 23) =  0.789238E-01
  PKER_RACCS ( 40, 24) =  0.569440E-01
  PKER_RACCS ( 40, 25) =  0.492680E-01
  PKER_RACCS ( 40, 26) =  0.537042E-01
  PKER_RACCS ( 40, 27) =  0.661559E-01
  PKER_RACCS ( 40, 28) =  0.821048E-01
  PKER_RACCS ( 40, 29) =  0.981944E-01
  PKER_RACCS ( 40, 30) =  0.112835E+00
  PKER_RACCS ( 40, 31) =  0.125662E+00
  PKER_RACCS ( 40, 32) =  0.136771E+00
  PKER_RACCS ( 40, 33) =  0.146319E+00
  PKER_RACCS ( 40, 34) =  0.154449E+00
  PKER_RACCS ( 40, 35) =  0.161294E+00
  PKER_RACCS ( 40, 36) =  0.166991E+00
  PKER_RACCS ( 40, 37) =  0.171687E+00
  PKER_RACCS ( 40, 38) =  0.175527E+00
  PKER_RACCS ( 40, 39) =  0.178649E+00
  PKER_RACCS ( 40, 40) =  0.181179E+00
END IF
!
IF( PRESENT(PKER_SACCRG) ) THEN
  PKER_SACCRG(  1,  1) =  0.438311E-02
  PKER_SACCRG(  1,  2) =  0.641932E-02
  PKER_SACCRG(  1,  3) =  0.104323E-01
  PKER_SACCRG(  1,  4) =  0.135168E-01
  PKER_SACCRG(  1,  5) =  0.186190E-01
  PKER_SACCRG(  1,  6) =  0.326141E-01
  PKER_SACCRG(  1,  7) =  0.629897E-01
  PKER_SACCRG(  1,  8) =  0.120410E+00
  PKER_SACCRG(  1,  9) =  0.232733E+00
  PKER_SACCRG(  1, 10) =  0.430353E+00
  PKER_SACCRG(  1, 11) =  0.742288E+00
  PKER_SACCRG(  1, 12) =  0.118527E+01
  PKER_SACCRG(  1, 13) =  0.175377E+01
  PKER_SACCRG(  1, 14) =  0.241509E+01
  PKER_SACCRG(  1, 15) =  0.311676E+01
  PKER_SACCRG(  1, 16) =  0.380271E+01
  PKER_SACCRG(  1, 17) =  0.442968E+01
  PKER_SACCRG(  1, 18) =  0.497509E+01
  PKER_SACCRG(  1, 19) =  0.543503E+01
  PKER_SACCRG(  1, 20) =  0.579503E+01
  PKER_SACCRG(  1, 21) =  0.611243E+01
  PKER_SACCRG(  1, 22) =  0.637529E+01
  PKER_SACCRG(  1, 23) =  0.655579E+01
  PKER_SACCRG(  1, 24) =  0.674119E+01
  PKER_SACCRG(  1, 25) =  0.685610E+01
  PKER_SACCRG(  1, 26) =  0.695045E+01
  PKER_SACCRG(  1, 27) =  0.703114E+01
  PKER_SACCRG(  1, 28) =  0.706922E+01
  PKER_SACCRG(  1, 29) =  0.710917E+01
  PKER_SACCRG(  1, 30) =  0.715122E+01
  PKER_SACCRG(  1, 31) =  0.717481E+01
  PKER_SACCRG(  1, 32) =  0.718927E+01
  PKER_SACCRG(  1, 33) =  0.720073E+01
  PKER_SACCRG(  1, 34) =  0.720264E+01
  PKER_SACCRG(  1, 35) =  0.721205E+01
  PKER_SACCRG(  1, 36) =  0.723197E+01
  PKER_SACCRG(  1, 37) =  0.000000E+00
  PKER_SACCRG(  1, 38) =  0.000000E+00
  PKER_SACCRG(  1, 39) =  0.000000E+00
  PKER_SACCRG(  1, 40) =  0.000000E+00
  PKER_SACCRG(  2,  1) =  0.277360E-02
  PKER_SACCRG(  2,  2) =  0.359904E-02
  PKER_SACCRG(  2,  3) =  0.526623E-02
  PKER_SACCRG(  2,  4) =  0.855403E-02
  PKER_SACCRG(  2,  5) =  0.110798E-01
  PKER_SACCRG(  2,  6) =  0.152575E-01
  PKER_SACCRG(  2,  7) =  0.267157E-01
  PKER_SACCRG(  2,  8) =  0.515725E-01
  PKER_SACCRG(  2,  9) =  0.985371E-01
  PKER_SACCRG(  2, 10) =  0.190336E+00
  PKER_SACCRG(  2, 11) =  0.351702E+00
  PKER_SACCRG(  2, 12) =  0.606144E+00
  PKER_SACCRG(  2, 13) =  0.967078E+00
  PKER_SACCRG(  2, 14) =  0.142977E+01
  PKER_SACCRG(  2, 15) =  0.196754E+01
  PKER_SACCRG(  2, 16) =  0.253781E+01
  PKER_SACCRG(  2, 17) =  0.309551E+01
  PKER_SACCRG(  2, 18) =  0.360619E+01
  PKER_SACCRG(  2, 19) =  0.405195E+01
  PKER_SACCRG(  2, 20) =  0.441025E+01
  PKER_SACCRG(  2, 21) =  0.472710E+01
  PKER_SACCRG(  2, 22) =  0.499143E+01
  PKER_SACCRG(  2, 23) =  0.517586E+01
  PKER_SACCRG(  2, 24) =  0.536386E+01
  PKER_SACCRG(  2, 25) =  0.548206E+01
  PKER_SACCRG(  2, 26) =  0.557912E+01
  PKER_SACCRG(  2, 27) =  0.566202E+01
  PKER_SACCRG(  2, 28) =  0.570152E+01
  PKER_SACCRG(  2, 29) =  0.574264E+01
  PKER_SACCRG(  2, 30) =  0.578573E+01
  PKER_SACCRG(  2, 31) =  0.580997E+01
  PKER_SACCRG(  2, 32) =  0.582483E+01
  PKER_SACCRG(  2, 33) =  0.583658E+01
  PKER_SACCRG(  2, 34) =  0.583857E+01
  PKER_SACCRG(  2, 35) =  0.584821E+01
  PKER_SACCRG(  2, 36) =  0.586858E+01
  PKER_SACCRG(  2, 37) =  0.000000E+00
  PKER_SACCRG(  2, 38) =  0.000000E+00
  PKER_SACCRG(  2, 39) =  0.000000E+00
  PKER_SACCRG(  2, 40) =  0.000000E+00
  PKER_SACCRG(  3,  1) =  0.213410E-02
  PKER_SACCRG(  3,  2) =  0.228042E-02
  PKER_SACCRG(  3,  3) =  0.295439E-02
  PKER_SACCRG(  3,  4) =  0.431810E-02
  PKER_SACCRG(  3,  5) =  0.700935E-02
  PKER_SACCRG(  3,  6) =  0.907613E-02
  PKER_SACCRG(  3,  7) =  0.124938E-01
  PKER_SACCRG(  3,  8) =  0.218668E-01
  PKER_SACCRG(  3,  9) =  0.421887E-01
  PKER_SACCRG(  3, 10) =  0.805544E-01
  PKER_SACCRG(  3, 11) =  0.155474E+00
  PKER_SACCRG(  3, 12) =  0.287036E+00
  PKER_SACCRG(  3, 13) =  0.494206E+00
  PKER_SACCRG(  3, 14) =  0.787675E+00
  PKER_SACCRG(  3, 15) =  0.116334E+01
  PKER_SACCRG(  3, 16) =  0.159943E+01
  PKER_SACCRG(  3, 17) =  0.206153E+01
  PKER_SACCRG(  3, 18) =  0.251365E+01
  PKER_SACCRG(  3, 19) =  0.292842E+01
  PKER_SACCRG(  3, 20) =  0.327509E+01
  PKER_SACCRG(  3, 21) =  0.358546E+01
  PKER_SACCRG(  3, 22) =  0.384740E+01
  PKER_SACCRG(  3, 23) =  0.403374E+01
  PKER_SACCRG(  3, 24) =  0.422232E+01
  PKER_SACCRG(  3, 25) =  0.434292E+01
  PKER_SACCRG(  3, 26) =  0.444208E+01
  PKER_SACCRG(  3, 27) =  0.452673E+01
  PKER_SACCRG(  3, 28) =  0.456755E+01
  PKER_SACCRG(  3, 29) =  0.460968E+01
  PKER_SACCRG(  3, 30) =  0.465368E+01
  PKER_SACCRG(  3, 31) =  0.467850E+01
  PKER_SACCRG(  3, 32) =  0.469374E+01
  PKER_SACCRG(  3, 33) =  0.470577E+01
  PKER_SACCRG(  3, 34) =  0.470785E+01
  PKER_SACCRG(  3, 35) =  0.471769E+01
  PKER_SACCRG(  3, 36) =  0.473846E+01
  PKER_SACCRG(  3, 37) =  0.000000E+00
  PKER_SACCRG(  3, 38) =  0.000000E+00
  PKER_SACCRG(  3, 39) =  0.000000E+00
  PKER_SACCRG(  3, 40) =  0.000000E+00
  PKER_SACCRG(  4,  1) =  0.295930E-03
  PKER_SACCRG(  4,  2) =  0.175883E-02
  PKER_SACCRG(  4,  3) =  0.187537E-02
  PKER_SACCRG(  4,  4) =  0.242497E-02
  PKER_SACCRG(  4,  5) =  0.353954E-02
  PKER_SACCRG(  4,  6) =  0.574121E-02
  PKER_SACCRG(  4,  7) =  0.743054E-02
  PKER_SACCRG(  4,  8) =  0.102239E-01
  PKER_SACCRG(  4,  9) =  0.178843E-01
  PKER_SACCRG(  4, 10) =  0.344817E-01
  PKER_SACCRG(  4, 11) =  0.657827E-01
  PKER_SACCRG(  4, 12) =  0.126844E+00
  PKER_SACCRG(  4, 13) =  0.233919E+00
  PKER_SACCRG(  4, 14) =  0.402255E+00
  PKER_SACCRG(  4, 15) =  0.640286E+00
  PKER_SACCRG(  4, 16) =  0.944426E+00
  PKER_SACCRG(  4, 17) =  0.129689E+01
  PKER_SACCRG(  4, 18) =  0.167004E+01
  PKER_SACCRG(  4, 19) =  0.203514E+01
  PKER_SACCRG(  4, 20) =  0.235706E+01
  PKER_SACCRG(  4, 21) =  0.265244E+01
  PKER_SACCRG(  4, 22) =  0.290663E+01
  PKER_SACCRG(  4, 23) =  0.309194E+01
  PKER_SACCRG(  4, 24) =  0.327835E+01
  PKER_SACCRG(  4, 25) =  0.339993E+01
  PKER_SACCRG(  4, 26) =  0.350021E+01
  PKER_SACCRG(  4, 27) =  0.358586E+01
  PKER_SACCRG(  4, 28) =  0.362775E+01
  PKER_SACCRG(  4, 29) =  0.367067E+01
  PKER_SACCRG(  4, 30) =  0.371533E+01
  PKER_SACCRG(  4, 31) =  0.374064E+01
  PKER_SACCRG(  4, 32) =  0.375621E+01
  PKER_SACCRG(  4, 33) =  0.376848E+01
  PKER_SACCRG(  4, 34) =  0.377064E+01
  PKER_SACCRG(  4, 35) =  0.378066E+01
  PKER_SACCRG(  4, 36) =  0.380174E+01
  PKER_SACCRG(  4, 37) =  0.000000E+00
  PKER_SACCRG(  4, 38) =  0.000000E+00
  PKER_SACCRG(  4, 39) =  0.000000E+00
  PKER_SACCRG(  4, 40) =  0.000000E+00
  PKER_SACCRG(  5,  1) =  0.258805E-03
  PKER_SACCRG(  5,  2) =  0.244750E-03
  PKER_SACCRG(  5,  3) =  0.145106E-02
  PKER_SACCRG(  5,  4) =  0.154319E-02
  PKER_SACCRG(  5,  5) =  0.199078E-02
  PKER_SACCRG(  5,  6) =  0.290099E-02
  PKER_SACCRG(  5,  7) =  0.470103E-02
  PKER_SACCRG(  5,  8) =  0.608063E-02
  PKER_SACCRG(  5,  9) =  0.836193E-02
  PKER_SACCRG(  5, 10) =  0.146173E-01
  PKER_SACCRG(  5, 11) =  0.281586E-01
  PKER_SACCRG(  5, 12) =  0.536650E-01
  PKER_SACCRG(  5, 13) =  0.103352E+00
  PKER_SACCRG(  5, 14) =  0.190326E+00
  PKER_SACCRG(  5, 15) =  0.326791E+00
  PKER_SACCRG(  5, 16) =  0.519290E+00
  PKER_SACCRG(  5, 17) =  0.764650E+00
  PKER_SACCRG(  5, 18) =  0.104842E+01
  PKER_SACCRG(  5, 19) =  0.134831E+01
  PKER_SACCRG(  5, 20) =  0.163103E+01
  PKER_SACCRG(  5, 21) =  0.190095E+01
  PKER_SACCRG(  5, 22) =  0.214036E+01
  PKER_SACCRG(  5, 23) =  0.232046E+01
  PKER_SACCRG(  5, 24) =  0.250112E+01
  PKER_SACCRG(  5, 25) =  0.262167E+01
  PKER_SACCRG(  5, 26) =  0.272160E+01
  PKER_SACCRG(  5, 27) =  0.280712E+01
  PKER_SACCRG(  5, 28) =  0.284966E+01
  PKER_SACCRG(  5, 29) =  0.289298E+01
  PKER_SACCRG(  5, 30) =  0.293794E+01
  PKER_SACCRG(  5, 31) =  0.296358E+01
  PKER_SACCRG(  5, 32) =  0.297938E+01
  PKER_SACCRG(  5, 33) =  0.299183E+01
  PKER_SACCRG(  5, 34) =  0.299407E+01
  PKER_SACCRG(  5, 35) =  0.300421E+01
  PKER_SACCRG(  5, 36) =  0.302549E+01
  PKER_SACCRG(  5, 37) =  0.000000E+00
  PKER_SACCRG(  5, 38) =  0.000000E+00
  PKER_SACCRG(  5, 39) =  0.000000E+00
  PKER_SACCRG(  5, 40) =  0.000000E+00
  PKER_SACCRG(  6,  1) =  0.113399E-04
  PKER_SACCRG(  6,  2) =  0.215064E-03
  PKER_SACCRG(  6,  3) =  0.202732E-03
  PKER_SACCRG(  6,  4) =  0.119915E-02
  PKER_SACCRG(  6,  5) =  0.127127E-02
  PKER_SACCRG(  6,  6) =  0.163527E-02
  PKER_SACCRG(  6,  7) =  0.237805E-02
  PKER_SACCRG(  6,  8) =  0.384847E-02
  PKER_SACCRG(  6,  9) =  0.497431E-02
  PKER_SACCRG(  6, 10) =  0.683637E-02
  PKER_SACCRG(  6, 11) =  0.119405E-01
  PKER_SACCRG(  6, 12) =  0.229776E-01
  PKER_SACCRG(  6, 13) =  0.437340E-01
  PKER_SACCRG(  6, 14) =  0.840961E-01
  PKER_SACCRG(  6, 15) =  0.154590E+00
  PKER_SACCRG(  6, 16) =  0.264896E+00
  PKER_SACCRG(  6, 17) =  0.420012E+00
  PKER_SACCRG(  6, 18) =  0.617142E+00
  PKER_SACCRG(  6, 19) =  0.844302E+00
  PKER_SACCRG(  6, 20) =  0.107600E+01
  PKER_SACCRG(  6, 21) =  0.130965E+01
  PKER_SACCRG(  6, 22) =  0.152596E+01
  PKER_SACCRG(  6, 23) =  0.169541E+01
  PKER_SACCRG(  6, 24) =  0.186600E+01
  PKER_SACCRG(  6, 25) =  0.198276E+01
  PKER_SACCRG(  6, 26) =  0.208029E+01
  PKER_SACCRG(  6, 27) =  0.216408E+01
  PKER_SACCRG(  6, 28) =  0.220656E+01
  PKER_SACCRG(  6, 29) =  0.224971E+01
  PKER_SACCRG(  6, 30) =  0.229446E+01
  PKER_SACCRG(  6, 31) =  0.232020E+01
  PKER_SACCRG(  6, 32) =  0.233613E+01
  PKER_SACCRG(  6, 33) =  0.234866E+01
  PKER_SACCRG(  6, 34) =  0.235098E+01
  PKER_SACCRG(  6, 35) =  0.236115E+01
  PKER_SACCRG(  6, 36) =  0.238249E+01
  PKER_SACCRG(  6, 37) =  0.000000E+00
  PKER_SACCRG(  6, 38) =  0.000000E+00
  PKER_SACCRG(  6, 39) =  0.000000E+00
  PKER_SACCRG(  6, 40) =  0.000000E+00
  PKER_SACCRG(  7,  1) =  0.140987E-06
  PKER_SACCRG(  7,  2) =  0.947184E-05
  PKER_SACCRG(  7,  3) =  0.179369E-03
  PKER_SACCRG(  7,  4) =  0.168563E-03
  PKER_SACCRG(  7,  5) =  0.993006E-03
  PKER_SACCRG(  7,  6) =  0.104915E-02
  PKER_SACCRG(  7,  7) =  0.134474E-02
  PKER_SACCRG(  7,  8) =  0.195051E-02
  PKER_SACCRG(  7,  9) =  0.315182E-02
  PKER_SACCRG(  7, 10) =  0.406997E-02
  PKER_SACCRG(  7, 11) =  0.558802E-02
  PKER_SACCRG(  7, 12) =  0.975020E-02
  PKER_SACCRG(  7, 13) =  0.187363E-01
  PKER_SACCRG(  7, 14) =  0.356024E-01
  PKER_SACCRG(  7, 15) =  0.683270E-01
  PKER_SACCRG(  7, 16) =  0.125305E+00
  PKER_SACCRG(  7, 17) =  0.214147E+00
  PKER_SACCRG(  7, 18) =  0.338617E+00
  PKER_SACCRG(  7, 19) =  0.495951E+00
  PKER_SACCRG(  7, 20) =  0.671057E+00
  PKER_SACCRG(  7, 21) =  0.860119E+00
  PKER_SACCRG(  7, 22) =  0.104532E+01
  PKER_SACCRG(  7, 23) =  0.119790E+01
  PKER_SACCRG(  7, 24) =  0.135335E+01
  PKER_SACCRG(  7, 25) =  0.146305E+01
  PKER_SACCRG(  7, 26) =  0.155556E+01
  PKER_SACCRG(  7, 27) =  0.163553E+01
  PKER_SACCRG(  7, 28) =  0.167695E+01
  PKER_SACCRG(  7, 29) =  0.171904E+01
  PKER_SACCRG(  7, 30) =  0.176289E+01
  PKER_SACCRG(  7, 31) =  0.178841E+01
  PKER_SACCRG(  7, 32) =  0.180429E+01
  PKER_SACCRG(  7, 33) =  0.181678E+01
  PKER_SACCRG(  7, 34) =  0.181916E+01
  PKER_SACCRG(  7, 35) =  0.182927E+01
  PKER_SACCRG(  7, 36) =  0.185045E+01
  PKER_SACCRG(  7, 37) =  0.000000E+00
  PKER_SACCRG(  7, 38) =  0.000000E+00
  PKER_SACCRG(  7, 39) =  0.000000E+00
  PKER_SACCRG(  7, 40) =  0.000000E+00
  PKER_SACCRG(  8,  1) =  0.000000E+00
  PKER_SACCRG(  8,  2) =  0.120931E-06
  PKER_SACCRG(  8,  3) =  0.796677E-05
  PKER_SACCRG(  8,  4) =  0.150232E-03
  PKER_SACCRG(  8,  5) =  0.140781E-03
  PKER_SACCRG(  8,  6) =  0.825725E-03
  PKER_SACCRG(  8,  7) =  0.867958E-03
  PKER_SACCRG(  8,  8) =  0.110764E-02
  PKER_SACCRG(  8,  9) =  0.160165E-02
  PKER_SACCRG(  8, 10) =  0.258288E-02
  PKER_SACCRG(  8, 11) =  0.333132E-02
  PKER_SACCRG(  8, 12) =  0.456846E-02
  PKER_SACCRG(  8, 13) =  0.795989E-02
  PKER_SACCRG(  8, 14) =  0.152680E-01
  PKER_SACCRG(  8, 15) =  0.289527E-01
  PKER_SACCRG(  8, 16) =  0.554343E-01
  PKER_SACCRG(  8, 17) =  0.101328E+00
  PKER_SACCRG(  8, 18) =  0.172576E+00
  PKER_SACCRG(  8, 19) =  0.271870E+00
  PKER_SACCRG(  8, 20) =  0.392855E+00
  PKER_SACCRG(  8, 21) =  0.534703E+00
  PKER_SACCRG(  8, 22) =  0.683665E+00
  PKER_SACCRG(  8, 23) =  0.814385E+00
  PKER_SACCRG(  8, 24) =  0.950462E+00
  PKER_SACCRG(  8, 25) =  0.105116E+01
  PKER_SACCRG(  8, 26) =  0.113664E+01
  PKER_SACCRG(  8, 27) =  0.121103E+01
  PKER_SACCRG(  8, 28) =  0.125059E+01
  PKER_SACCRG(  8, 29) =  0.128945E+01
  PKER_SACCRG(  8, 30) =  0.132965E+01
  PKER_SACCRG(  8, 31) =  0.135316E+01
  PKER_SACCRG(  8, 32) =  0.136781E+01
  PKER_SACCRG(  8, 33) =  0.137937E+01
  PKER_SACCRG(  8, 34) =  0.138153E+01
  PKER_SACCRG(  8, 35) =  0.139094E+01
  PKER_SACCRG(  8, 36) =  0.141107E+01
  PKER_SACCRG(  8, 37) =  0.000000E+00
  PKER_SACCRG(  8, 38) =  0.000000E+00
  PKER_SACCRG(  8, 39) =  0.000000E+00
  PKER_SACCRG(  8, 40) =  0.000000E+00
  PKER_SACCRG(  9,  1) =  0.000000E+00
  PKER_SACCRG(  9,  2) =  0.000000E+00
  PKER_SACCRG(  9,  3) =  0.104997E-06
  PKER_SACCRG(  9,  4) =  0.675258E-05
  PKER_SACCRG(  9,  5) =  0.126824E-03
  PKER_SACCRG(  9,  6) =  0.118316E-03
  PKER_SACCRG(  9,  7) =  0.690238E-03
  PKER_SACCRG(  9,  8) =  0.721206E-03
  PKER_SACCRG(  9,  9) =  0.915100E-03
  PKER_SACCRG(  9, 10) =  0.131754E-02
  PKER_SACCRG(  9, 11) =  0.143784E-02
  PKER_SACCRG(  9, 12) =  0.272855E-02
  PKER_SACCRG(  9, 13) =  0.373587E-02
  PKER_SACCRG(  9, 14) =  0.649562E-02
  PKER_SACCRG(  9, 15) =  0.120098E-01
  PKER_SACCRG(  9, 16) =  0.235379E-01
  PKER_SACCRG(  9, 17) =  0.448605E-01
  PKER_SACCRG(  9, 18) =  0.816757E-01
  PKER_SACCRG(  9, 19) =  0.138586E+00
  PKER_SACCRG(  9, 20) =  0.214609E+00
  PKER_SACCRG(  9, 21) =  0.312274E+00
  PKER_SACCRG(  9, 22) =  0.423436E+00
  PKER_SACCRG(  9, 23) =  0.528300E+00
  PKER_SACCRG(  9, 24) =  0.641806E+00
  PKER_SACCRG(  9, 25) =  0.730809E+00
  PKER_SACCRG(  9, 26) =  0.808021E+00
  PKER_SACCRG(  9, 27) =  0.875899E+00
  PKER_SACCRG(  9, 28) =  0.913416E+00
  PKER_SACCRG(  9, 29) =  0.949497E+00
  PKER_SACCRG(  9, 30) =  0.986085E+00
  PKER_SACCRG(  9, 31) =  0.100768E+01
  PKER_SACCRG(  9, 32) =  0.102123E+01
  PKER_SACCRG(  9, 33) =  0.103190E+01
  PKER_SACCRG(  9, 34) =  0.103403E+01
  PKER_SACCRG(  9, 35) =  0.104270E+01
  PKER_SACCRG(  9, 36) =  0.106096E+01
  PKER_SACCRG(  9, 37) =  0.000000E+00
  PKER_SACCRG(  9, 38) =  0.000000E+00
  PKER_SACCRG(  9, 39) =  0.000000E+00
  PKER_SACCRG(  9, 40) =  0.000000E+00
  PKER_SACCRG( 10,  1) =  0.000000E+00
  PKER_SACCRG( 10,  2) =  0.000000E+00
  PKER_SACCRG( 10,  3) =  0.000000E+00
  PKER_SACCRG( 10,  4) =  0.925928E-07
  PKER_SACCRG( 10,  5) =  0.578353E-05
  PKER_SACCRG( 10,  6) =  0.108100E-03
  PKER_SACCRG( 10,  7) =  0.100301E-03
  PKER_SACCRG( 10,  8) =  0.581236E-03
  PKER_SACCRG( 10,  9) =  0.602709E-03
  PKER_SACCRG( 10, 10) =  0.759037E-03
  PKER_SACCRG( 10, 11) =  0.108651E-02
  PKER_SACCRG( 10, 12) =  0.118139E-02
  PKER_SACCRG( 10, 13) =  0.223637E-02
  PKER_SACCRG( 10, 14) =  0.305413E-02
  PKER_SACCRG( 10, 15) =  0.529953E-02
  PKER_SACCRG( 10, 16) =  0.980986E-02
  PKER_SACCRG( 10, 17) =  0.190727E-01
  PKER_SACCRG( 10, 18) =  0.361040E-01
  PKER_SACCRG( 10, 19) =  0.657489E-01
  PKER_SACCRG( 10, 20) =  0.108973E+00
  PKER_SACCRG( 10, 21) =  0.170419E+00
  PKER_SACCRG( 10, 22) =  0.246769E+00
  PKER_SACCRG( 10, 23) =  0.324574E+00
  PKER_SACCRG( 10, 24) =  0.413749E+00
  PKER_SACCRG( 10, 25) =  0.487749E+00
  PKER_SACCRG( 10, 26) =  0.555040E+00
  PKER_SACCRG( 10, 27) =  0.614174E+00
  PKER_SACCRG( 10, 28) =  0.647730E+00
  PKER_SACCRG( 10, 29) =  0.679592E+00
  PKER_SACCRG( 10, 30) =  0.711627E+00
  PKER_SACCRG( 10, 31) =  0.730757E+00
  PKER_SACCRG( 10, 32) =  0.742853E+00
  PKER_SACCRG( 10, 33) =  0.752426E+00
  PKER_SACCRG( 10, 34) =  0.754388E+00
  PKER_SACCRG( 10, 35) =  0.762180E+00
  PKER_SACCRG( 10, 36) =  0.778605E+00
  PKER_SACCRG( 10, 37) =  0.000000E+00
  PKER_SACCRG( 10, 38) =  0.000000E+00
  PKER_SACCRG( 10, 39) =  0.000000E+00
  PKER_SACCRG( 10, 40) =  0.000000E+00
  PKER_SACCRG( 11,  1) =  0.000000E+00
  PKER_SACCRG( 11,  2) =  0.000000E+00
  PKER_SACCRG( 11,  3) =  0.000000E+00
  PKER_SACCRG( 11,  4) =  0.000000E+00
  PKER_SACCRG( 11,  5) =  0.832906E-07
  PKER_SACCRG( 11,  6) =  0.502409E-05
  PKER_SACCRG( 11,  7) =  0.933604E-04
  PKER_SACCRG( 11,  8) =  0.860483E-04
  PKER_SACCRG( 11,  9) =  0.494464E-03
  PKER_SACCRG( 11, 10) =  0.507648E-03
  PKER_SACCRG( 11, 11) =  0.632846E-03
  PKER_SACCRG( 11, 12) =  0.898351E-03
  PKER_SACCRG( 11, 13) =  0.971535E-03
  PKER_SACCRG( 11, 14) =  0.183107E-02
  PKER_SACCRG( 11, 15) =  0.249471E-02
  PKER_SACCRG( 11, 16) =  0.439233E-02
  PKER_SACCRG( 11, 17) =  0.797693E-02
  PKER_SACCRG( 11, 18) =  0.152441E-01
  PKER_SACCRG( 11, 19) =  0.293789E-01
  PKER_SACCRG( 11, 20) =  0.515725E-01
  PKER_SACCRG( 11, 21) =  0.871846E-01
  PKER_SACCRG( 11, 22) =  0.135867E+00
  PKER_SACCRG( 11, 23) =  0.189869E+00
  PKER_SACCRG( 11, 24) =  0.256544E+00
  PKER_SACCRG( 11, 25) =  0.317064E+00
  PKER_SACCRG( 11, 26) =  0.373502E+00
  PKER_SACCRG( 11, 27) =  0.424161E+00
  PKER_SACCRG( 11, 28) =  0.454262E+00
  PKER_SACCRG( 11, 29) =  0.480107E+00
  PKER_SACCRG( 11, 30) =  0.504244E+00
  PKER_SACCRG( 11, 31) =  0.518345E+00
  PKER_SACCRG( 11, 32) =  0.527147E+00
  PKER_SACCRG( 11, 33) =  0.534136E+00
  PKER_SACCRG( 11, 34) =  0.535557E+00
  PKER_SACCRG( 11, 35) =  0.541319E+00
  PKER_SACCRG( 11, 36) =  0.553653E+00
  PKER_SACCRG( 11, 37) =  0.000000E+00
  PKER_SACCRG( 11, 38) =  0.000000E+00
  PKER_SACCRG( 11, 39) =  0.000000E+00
  PKER_SACCRG( 11, 40) =  0.000000E+00
  PKER_SACCRG( 12,  1) =  0.000000E+00
  PKER_SACCRG( 12,  2) =  0.000000E+00
  PKER_SACCRG( 12,  3) =  0.000000E+00
  PKER_SACCRG( 12,  4) =  0.000000E+00
  PKER_SACCRG( 12,  5) =  0.000000E+00
  PKER_SACCRG( 12,  6) =  0.773960E-07
  PKER_SACCRG( 12,  7) =  0.444316E-05
  PKER_SACCRG( 12,  8) =  0.820904E-04
  PKER_SACCRG( 12,  9) =  0.749946E-04
  PKER_SACCRG( 12, 10) =  0.426372E-03
  PKER_SACCRG( 12, 11) =  0.431983E-03
  PKER_SACCRG( 12, 12) =  0.530818E-03
  PKER_SACCRG( 12, 13) =  0.743872E-03
  PKER_SACCRG( 12, 14) =  0.796002E-03
  PKER_SACCRG( 12, 15) =  0.116910E-02
  PKER_SACCRG( 12, 16) =  0.216714E-02
  PKER_SACCRG( 12, 17) =  0.358946E-02
  PKER_SACCRG( 12, 18) =  0.644847E-02
  PKER_SACCRG( 12, 19) =  0.128412E-01
  PKER_SACCRG( 12, 20) =  0.229402E-01
  PKER_SACCRG( 12, 21) =  0.422368E-01
  PKER_SACCRG( 12, 22) =  0.714492E-01
  PKER_SACCRG( 12, 23) =  0.106564E+00
  PKER_SACCRG( 12, 24) =  0.153890E+00
  PKER_SACCRG( 12, 25) =  0.202266E+00
  PKER_SACCRG( 12, 26) =  0.249410E+00
  PKER_SACCRG( 12, 27) =  0.293259E+00
  PKER_SACCRG( 12, 28) =  0.320617E+00
  PKER_SACCRG( 12, 29) =  0.341855E+00
  PKER_SACCRG( 12, 30) =  0.359983E+00
  PKER_SACCRG( 12, 31) =  0.370284E+00
  PKER_SACCRG( 12, 32) =  0.376667E+00
  PKER_SACCRG( 12, 33) =  0.381816E+00
  PKER_SACCRG( 12, 34) =  0.382869E+00
  PKER_SACCRG( 12, 35) =  0.387206E+00
  PKER_SACCRG( 12, 36) =  0.396588E+00
  PKER_SACCRG( 12, 37) =  0.000000E+00
  PKER_SACCRG( 12, 38) =  0.000000E+00
  PKER_SACCRG( 12, 39) =  0.000000E+00
  PKER_SACCRG( 12, 40) =  0.000000E+00
  PKER_SACCRG( 13,  1) =  0.000000E+00
  PKER_SACCRG( 13,  2) =  0.000000E+00
  PKER_SACCRG( 13,  3) =  0.000000E+00
  PKER_SACCRG( 13,  4) =  0.000000E+00
  PKER_SACCRG( 13,  5) =  0.000000E+00
  PKER_SACCRG( 13,  6) =  0.000000E+00
  PKER_SACCRG( 13,  7) =  0.735833E-07
  PKER_SACCRG( 13,  8) =  0.403716E-05
  PKER_SACCRG( 13,  9) =  0.739090E-04
  PKER_SACCRG( 13, 10) =  0.668732E-04
  PKER_SACCRG( 13, 11) =  0.374752E-03
  PKER_SACCRG( 13, 12) =  0.372451E-03
  PKER_SACCRG( 13, 13) =  0.447074E-03
  PKER_SACCRG( 13, 14) =  0.610717E-03
  PKER_SACCRG( 13, 15) =  0.641614E-03
  PKER_SACCRG( 13, 16) =  0.119058E-02
  PKER_SACCRG( 13, 17) =  0.179867E-02
  PKER_SACCRG( 13, 18) =  0.291204E-02
  PKER_SACCRG( 13, 19) =  0.606676E-02
  PKER_SACCRG( 13, 20) =  0.100429E-01
  PKER_SACCRG( 13, 21) =  0.203541E-01
  PKER_SACCRG( 13, 22) =  0.377872E-01
  PKER_SACCRG( 13, 23) =  0.606389E-01
  PKER_SACCRG( 13, 24) =  0.937549E-01
  PKER_SACCRG( 13, 25) =  0.133605E+00
  PKER_SACCRG( 13, 26) =  0.174990E+00
  PKER_SACCRG( 13, 27) =  0.214629E+00
  PKER_SACCRG( 13, 28) =  0.241011E+00
  PKER_SACCRG( 13, 29) =  0.258073E+00
  PKER_SACCRG( 13, 30) =  0.269310E+00
  PKER_SACCRG( 13, 31) =  0.274592E+00
  PKER_SACCRG( 13, 32) =  0.277413E+00
  PKER_SACCRG( 13, 33) =  0.279664E+00
  PKER_SACCRG( 13, 34) =  0.280055E+00
  PKER_SACCRG( 13, 35) =  0.282059E+00
  PKER_SACCRG( 13, 36) =  0.286665E+00
  PKER_SACCRG( 13, 37) =  0.000000E+00
  PKER_SACCRG( 13, 38) =  0.000000E+00
  PKER_SACCRG( 13, 39) =  0.000000E+00
  PKER_SACCRG( 13, 40) =  0.000000E+00
  PKER_SACCRG( 14,  1) =  0.000000E+00
  PKER_SACCRG( 14,  2) =  0.000000E+00
  PKER_SACCRG( 14,  3) =  0.000000E+00
  PKER_SACCRG( 14,  4) =  0.000000E+00
  PKER_SACCRG( 14,  5) =  0.000000E+00
  PKER_SACCRG( 14,  6) =  0.000000E+00
  PKER_SACCRG( 14,  7) =  0.000000E+00
  PKER_SACCRG( 14,  8) =  0.728176E-07
  PKER_SACCRG( 14,  9) =  0.379948E-05
  PKER_SACCRG( 14, 10) =  0.688582E-04
  PKER_SACCRG( 14, 11) =  0.614350E-04
  PKER_SACCRG( 14, 12) =  0.337324E-03
  PKER_SACCRG( 14, 13) =  0.324899E-03
  PKER_SACCRG( 14, 14) =  0.371520E-03
  PKER_SACCRG( 14, 15) =  0.478804E-03
  PKER_SACCRG( 14, 16) =  0.101697E-02
  PKER_SACCRG( 14, 17) =  0.102728E-02
  PKER_SACCRG( 14, 18) =  0.147349E-02
  PKER_SACCRG( 14, 19) =  0.368922E-02
  PKER_SACCRG( 14, 20) =  0.484994E-02
  PKER_SACCRG( 14, 21) =  0.109319E-01
  PKER_SACCRG( 14, 22) =  0.222066E-01
  PKER_SACCRG( 14, 23) =  0.380174E-01
  PKER_SACCRG( 14, 24) =  0.622359E-01
  PKER_SACCRG( 14, 25) =  0.978747E-01
  PKER_SACCRG( 14, 26) =  0.135839E+00
  PKER_SACCRG( 14, 27) =  0.174342E+00
  PKER_SACCRG( 14, 28) =  0.201882E+00
  PKER_SACCRG( 14, 29) =  0.216326E+00
  PKER_SACCRG( 14, 30) =  0.222044E+00
  PKER_SACCRG( 14, 31) =  0.222867E+00
  PKER_SACCRG( 14, 32) =  0.222379E+00
  PKER_SACCRG( 14, 33) =  0.221925E+00
  PKER_SACCRG( 14, 34) =  0.221667E+00
  PKER_SACCRG( 14, 35) =  0.221502E+00
  PKER_SACCRG( 14, 36) =  0.221629E+00
  PKER_SACCRG( 14, 37) =  0.000000E+00
  PKER_SACCRG( 14, 38) =  0.000000E+00
  PKER_SACCRG( 14, 39) =  0.000000E+00
  PKER_SACCRG( 14, 40) =  0.000000E+00
  PKER_SACCRG( 15,  1) =  0.000000E+00
  PKER_SACCRG( 15,  2) =  0.000000E+00
  PKER_SACCRG( 15,  3) =  0.000000E+00
  PKER_SACCRG( 15,  4) =  0.000000E+00
  PKER_SACCRG( 15,  5) =  0.000000E+00
  PKER_SACCRG( 15,  6) =  0.000000E+00
  PKER_SACCRG( 15,  7) =  0.000000E+00
  PKER_SACCRG( 15,  8) =  0.000000E+00
  PKER_SACCRG( 15,  9) =  0.759585E-07
  PKER_SACCRG( 15, 10) =  0.374710E-05
  PKER_SACCRG( 15, 11) =  0.671091E-04
  PKER_SACCRG( 15, 12) =  0.588014E-04
  PKER_SACCRG( 15, 13) =  0.311989E-03
  PKER_SACCRG( 15, 14) =  0.280346E-03
  PKER_SACCRG( 15, 15) =  0.278888E-03
  PKER_SACCRG( 15, 16) =  0.181122E-02
  PKER_SACCRG( 15, 17) =  0.951550E-03
  PKER_SACCRG( 15, 18) =  0.874685E-03
  PKER_SACCRG( 15, 19) =  0.341647E-02
  PKER_SACCRG( 15, 20) =  0.313074E-02
  PKER_SACCRG( 15, 21) =  0.790628E-02
  PKER_SACCRG( 15, 22) =  0.167408E-01
  PKER_SACCRG( 15, 23) =  0.292368E-01
  PKER_SACCRG( 15, 24) =  0.493019E-01
  PKER_SACCRG( 15, 25) =  0.846089E-01
  PKER_SACCRG( 15, 26) =  0.122848E+00
  PKER_SACCRG( 15, 27) =  0.164348E+00
  PKER_SACCRG( 15, 28) =  0.195653E+00
  PKER_SACCRG( 15, 29) =  0.209699E+00
  PKER_SACCRG( 15, 30) =  0.212297E+00
  PKER_SACCRG( 15, 31) =  0.209959E+00
  PKER_SACCRG( 15, 32) =  0.206919E+00
  PKER_SACCRG( 15, 33) =  0.204381E+00
  PKER_SACCRG( 15, 34) =  0.203587E+00
  PKER_SACCRG( 15, 35) =  0.201798E+00
  PKER_SACCRG( 15, 36) =  0.198561E+00
  PKER_SACCRG( 15, 37) =  0.000000E+00
  PKER_SACCRG( 15, 38) =  0.000000E+00
  PKER_SACCRG( 15, 39) =  0.000000E+00
  PKER_SACCRG( 15, 40) =  0.000000E+00
  PKER_SACCRG( 16,  1) =  0.000000E+00
  PKER_SACCRG( 16,  2) =  0.000000E+00
  PKER_SACCRG( 16,  3) =  0.000000E+00
  PKER_SACCRG( 16,  4) =  0.000000E+00
  PKER_SACCRG( 16,  5) =  0.000000E+00
  PKER_SACCRG( 16,  6) =  0.000000E+00
  PKER_SACCRG( 16,  7) =  0.000000E+00
  PKER_SACCRG( 16,  8) =  0.000000E+00
  PKER_SACCRG( 16,  9) =  0.000000E+00
  PKER_SACCRG( 16, 10) =  0.844481E-07
  PKER_SACCRG( 16, 11) =  0.394811E-05
  PKER_SACCRG( 16, 12) =  0.696323E-04
  PKER_SACCRG( 16, 13) =  0.591332E-04
  PKER_SACCRG( 16, 14) =  0.289674E-03
  PKER_SACCRG( 16, 15) =  0.202537E-03
  PKER_SACCRG( 16, 16) =  0.336844E-02
  PKER_SACCRG( 16, 17) =  0.178312E-02
  PKER_SACCRG( 16, 18) =  0.868492E-03
  PKER_SACCRG( 16, 19) =  0.435445E-02
  PKER_SACCRG( 16, 20) =  0.306476E-02
  PKER_SACCRG( 16, 21) =  0.776119E-02
  PKER_SACCRG( 16, 22) =  0.161954E-01
  PKER_SACCRG( 16, 23) =  0.276331E-01
  PKER_SACCRG( 16, 24) =  0.458394E-01
  PKER_SACCRG( 16, 25) =  0.831396E-01
  PKER_SACCRG( 16, 26) =  0.123760E+00
  PKER_SACCRG( 16, 27) =  0.170508E+00
  PKER_SACCRG( 16, 28) =  0.207373E+00
  PKER_SACCRG( 16, 29) =  0.222851E+00
  PKER_SACCRG( 16, 30) =  0.224550E+00
  PKER_SACCRG( 16, 31) =  0.220359E+00
  PKER_SACCRG( 16, 32) =  0.215498E+00
  PKER_SACCRG( 16, 33) =  0.211386E+00
  PKER_SACCRG( 16, 34) =  0.210132E+00
  PKER_SACCRG( 16, 35) =  0.207094E+00
  PKER_SACCRG( 16, 36) =  0.201428E+00
  PKER_SACCRG( 16, 37) =  0.000000E+00
  PKER_SACCRG( 16, 38) =  0.000000E+00
  PKER_SACCRG( 16, 39) =  0.000000E+00
  PKER_SACCRG( 16, 40) =  0.000000E+00
  PKER_SACCRG( 17,  1) =  0.000000E+00
  PKER_SACCRG( 17,  2) =  0.000000E+00
  PKER_SACCRG( 17,  3) =  0.000000E+00
  PKER_SACCRG( 17,  4) =  0.000000E+00
  PKER_SACCRG( 17,  5) =  0.000000E+00
  PKER_SACCRG( 17,  6) =  0.000000E+00
  PKER_SACCRG( 17,  7) =  0.000000E+00
  PKER_SACCRG( 17,  8) =  0.000000E+00
  PKER_SACCRG( 17,  9) =  0.000000E+00
  PKER_SACCRG( 17, 10) =  0.000000E+00
  PKER_SACCRG( 17, 11) =  0.102418E-06
  PKER_SACCRG( 17, 12) =  0.455940E-05
  PKER_SACCRG( 17, 13) =  0.784312E-04
  PKER_SACCRG( 17, 14) =  0.614879E-04
  PKER_SACCRG( 17, 15) =  0.207160E-03
  PKER_SACCRG( 17, 16) =  0.889438E-02
  PKER_SACCRG( 17, 17) =  0.339624E-02
  PKER_SACCRG( 17, 18) =  0.106437E-02
  PKER_SACCRG( 17, 19) =  0.779689E-02
  PKER_SACCRG( 17, 20) =  0.404959E-02
  PKER_SACCRG( 17, 21) =  0.101250E-01
  PKER_SACCRG( 17, 22) =  0.196042E-01
  PKER_SACCRG( 17, 23) =  0.307730E-01
  PKER_SACCRG( 17, 24) =  0.480533E-01
  PKER_SACCRG( 17, 25) =  0.885797E-01
  PKER_SACCRG( 17, 26) =  0.132905E+00
  PKER_SACCRG( 17, 27) =  0.187039E+00
  PKER_SACCRG( 17, 28) =  0.231099E+00
  PKER_SACCRG( 17, 29) =  0.249500E+00
  PKER_SACCRG( 17, 30) =  0.252291E+00
  PKER_SACCRG( 17, 31) =  0.247487E+00
  PKER_SACCRG( 17, 32) =  0.241587E+00
  PKER_SACCRG( 17, 33) =  0.236485E+00
  PKER_SACCRG( 17, 34) =  0.234962E+00
  PKER_SACCRG( 17, 35) =  0.231075E+00
  PKER_SACCRG( 17, 36) =  0.223581E+00
  PKER_SACCRG( 17, 37) =  0.000000E+00
  PKER_SACCRG( 17, 38) =  0.000000E+00
  PKER_SACCRG( 17, 39) =  0.000000E+00
  PKER_SACCRG( 17, 40) =  0.000000E+00
  PKER_SACCRG( 18,  1) =  0.000000E+00
  PKER_SACCRG( 18,  2) =  0.000000E+00
  PKER_SACCRG( 18,  3) =  0.000000E+00
  PKER_SACCRG( 18,  4) =  0.000000E+00
  PKER_SACCRG( 18,  5) =  0.000000E+00
  PKER_SACCRG( 18,  6) =  0.000000E+00
  PKER_SACCRG( 18,  7) =  0.000000E+00
  PKER_SACCRG( 18,  8) =  0.000000E+00
  PKER_SACCRG( 18,  9) =  0.000000E+00
  PKER_SACCRG( 18, 10) =  0.000000E+00
  PKER_SACCRG( 18, 11) =  0.000000E+00
  PKER_SACCRG( 18, 12) =  0.140103E-06
  PKER_SACCRG( 18, 13) =  0.596643E-05
  PKER_SACCRG( 18, 14) =  0.955662E-04
  PKER_SACCRG( 18, 15) =  0.467666E-04
  PKER_SACCRG( 18, 16) =  0.950209E-02
  PKER_SACCRG( 18, 17) =  0.886291E-02
  PKER_SACCRG( 18, 18) =  0.338287E-02
  PKER_SACCRG( 18, 19) =  0.122056E-01
  PKER_SACCRG( 18, 20) =  0.719648E-02
  PKER_SACCRG( 18, 21) =  0.173349E-01
  PKER_SACCRG( 18, 22) =  0.268718E-01
  PKER_SACCRG( 18, 23) =  0.384549E-01
  PKER_SACCRG( 18, 24) =  0.531665E-01
  PKER_SACCRG( 18, 25) =  0.967650E-01
  PKER_SACCRG( 18, 26) =  0.143690E+00
  PKER_SACCRG( 18, 27) =  0.205036E+00
  PKER_SACCRG( 18, 28) =  0.256245E+00
  PKER_SACCRG( 18, 29) =  0.278068E+00
  PKER_SACCRG( 18, 30) =  0.283239E+00
  PKER_SACCRG( 18, 31) =  0.278809E+00
  PKER_SACCRG( 18, 32) =  0.272567E+00
  PKER_SACCRG( 18, 33) =  0.267046E+00
  PKER_SACCRG( 18, 34) =  0.265383E+00
  PKER_SACCRG( 18, 35) =  0.261124E+00
  PKER_SACCRG( 18, 36) =  0.252857E+00
  PKER_SACCRG( 18, 37) =  0.000000E+00
  PKER_SACCRG( 18, 38) =  0.000000E+00
  PKER_SACCRG( 18, 39) =  0.000000E+00
  PKER_SACCRG( 18, 40) =  0.000000E+00
  PKER_SACCRG( 19,  1) =  0.000000E+00
  PKER_SACCRG( 19,  2) =  0.000000E+00
  PKER_SACCRG( 19,  3) =  0.000000E+00
  PKER_SACCRG( 19,  4) =  0.000000E+00
  PKER_SACCRG( 19,  5) =  0.000000E+00
  PKER_SACCRG( 19,  6) =  0.000000E+00
  PKER_SACCRG( 19,  7) =  0.000000E+00
  PKER_SACCRG( 19,  8) =  0.000000E+00
  PKER_SACCRG( 19,  9) =  0.000000E+00
  PKER_SACCRG( 19, 10) =  0.000000E+00
  PKER_SACCRG( 19, 11) =  0.000000E+00
  PKER_SACCRG( 19, 12) =  0.000000E+00
  PKER_SACCRG( 19, 13) =  0.227778E-06
  PKER_SACCRG( 19, 14) =  0.900623E-05
  PKER_SACCRG( 19, 15) =  0.841460E-04
  PKER_SACCRG( 19, 16) =  0.386383E-01
  PKER_SACCRG( 19, 17) =  0.931861E-02
  PKER_SACCRG( 19, 18) =  0.873078E-02
  PKER_SACCRG( 19, 19) =  0.212263E-01
  PKER_SACCRG( 19, 20) =  0.110801E-01
  PKER_SACCRG( 19, 21) =  0.233312E-01
  PKER_SACCRG( 19, 22) =  0.377998E-01
  PKER_SACCRG( 19, 23) =  0.473076E-01
  PKER_SACCRG( 19, 24) =  0.634436E-01
  PKER_SACCRG( 19, 25) =  0.108864E+00
  PKER_SACCRG( 19, 26) =  0.154870E+00
  PKER_SACCRG( 19, 27) =  0.221137E+00
  PKER_SACCRG( 19, 28) =  0.278289E+00
  PKER_SACCRG( 19, 29) =  0.303277E+00
  PKER_SACCRG( 19, 30) =  0.311313E+00
  PKER_SACCRG( 19, 31) =  0.307763E+00
  PKER_SACCRG( 19, 32) =  0.301613E+00
  PKER_SACCRG( 19, 33) =  0.296055E+00
  PKER_SACCRG( 19, 34) =  0.294365E+00
  PKER_SACCRG( 19, 35) =  0.290056E+00
  PKER_SACCRG( 19, 36) =  0.281642E+00
  PKER_SACCRG( 19, 37) =  0.000000E+00
  PKER_SACCRG( 19, 38) =  0.000000E+00
  PKER_SACCRG( 19, 39) =  0.000000E+00
  PKER_SACCRG( 19, 40) =  0.000000E+00
  PKER_SACCRG( 20,  1) =  0.000000E+00
  PKER_SACCRG( 20,  2) =  0.000000E+00
  PKER_SACCRG( 20,  3) =  0.000000E+00
  PKER_SACCRG( 20,  4) =  0.000000E+00
  PKER_SACCRG( 20,  5) =  0.000000E+00
  PKER_SACCRG( 20,  6) =  0.000000E+00
  PKER_SACCRG( 20,  7) =  0.000000E+00
  PKER_SACCRG( 20,  8) =  0.000000E+00
  PKER_SACCRG( 20,  9) =  0.000000E+00
  PKER_SACCRG( 20, 10) =  0.000000E+00
  PKER_SACCRG( 20, 11) =  0.000000E+00
  PKER_SACCRG( 20, 12) =  0.000000E+00
  PKER_SACCRG( 20, 13) =  0.129560E-08
  PKER_SACCRG( 20, 14) =  0.461750E-06
  PKER_SACCRG( 20, 15) =  0.991868E-05
  PKER_SACCRG( 20, 16) =  0.404619E-01
  PKER_SACCRG( 20, 17) =  0.376740E-01
  PKER_SACCRG( 20, 18) =  0.912299E-02
  PKER_SACCRG( 20, 19) =  0.431984E-01
  PKER_SACCRG( 20, 20) =  0.191703E-01
  PKER_SACCRG( 20, 21) =  0.492406E-01
  PKER_SACCRG( 20, 22) =  0.618254E-01
  PKER_SACCRG( 20, 23) =  0.738280E-01
  PKER_SACCRG( 20, 24) =  0.817314E-01
  PKER_SACCRG( 20, 25) =  0.125224E+00
  PKER_SACCRG( 20, 26) =  0.171144E+00
  PKER_SACCRG( 20, 27) =  0.237848E+00
  PKER_SACCRG( 20, 28) =  0.298348E+00
  PKER_SACCRG( 20, 29) =  0.325776E+00
  PKER_SACCRG( 20, 30) =  0.336589E+00
  PKER_SACCRG( 20, 31) =  0.333991E+00
  PKER_SACCRG( 20, 32) =  0.328042E+00
  PKER_SACCRG( 20, 33) =  0.322558E+00
  PKER_SACCRG( 20, 34) =  0.320859E+00
  PKER_SACCRG( 20, 35) =  0.316600E+00
  PKER_SACCRG( 20, 36) =  0.308313E+00
  PKER_SACCRG( 20, 37) =  0.000000E+00
  PKER_SACCRG( 20, 38) =  0.000000E+00
  PKER_SACCRG( 20, 39) =  0.000000E+00
  PKER_SACCRG( 20, 40) =  0.000000E+00
  PKER_SACCRG( 21,  1) =  0.000000E+00
  PKER_SACCRG( 21,  2) =  0.000000E+00
  PKER_SACCRG( 21,  3) =  0.000000E+00
  PKER_SACCRG( 21,  4) =  0.000000E+00
  PKER_SACCRG( 21,  5) =  0.000000E+00
  PKER_SACCRG( 21,  6) =  0.000000E+00
  PKER_SACCRG( 21,  7) =  0.000000E+00
  PKER_SACCRG( 21,  8) =  0.000000E+00
  PKER_SACCRG( 21,  9) =  0.000000E+00
  PKER_SACCRG( 21, 10) =  0.000000E+00
  PKER_SACCRG( 21, 11) =  0.000000E+00
  PKER_SACCRG( 21, 12) =  0.000000E+00
  PKER_SACCRG( 21, 13) =  0.000000E+00
  PKER_SACCRG( 21, 14) =  0.944456E-08
  PKER_SACCRG( 21, 15) =  0.743621E-06
  PKER_SACCRG( 21, 16) =  0.442453E+00
  PKER_SACCRG( 21, 17) =  0.391188E-01
  PKER_SACCRG( 21, 18) =  0.365342E-01
  PKER_SACCRG( 21, 19) =  0.111999E+00
  PKER_SACCRG( 21, 20) =  0.388643E-01
  PKER_SACCRG( 21, 21) =  0.848382E-01
  PKER_SACCRG( 21, 22) =  0.875713E-01
  PKER_SACCRG( 21, 23) =  0.938496E-01
  PKER_SACCRG( 21, 24) =  0.107423E+00
  PKER_SACCRG( 21, 25) =  0.155062E+00
  PKER_SACCRG( 21, 26) =  0.191831E+00
  PKER_SACCRG( 21, 27) =  0.256278E+00
  PKER_SACCRG( 21, 28) =  0.316744E+00
  PKER_SACCRG( 21, 29) =  0.344380E+00
  PKER_SACCRG( 21, 30) =  0.357297E+00
  PKER_SACCRG( 21, 31) =  0.355528E+00
  PKER_SACCRG( 21, 32) =  0.349787E+00
  PKER_SACCRG( 21, 33) =  0.344401E+00
  PKER_SACCRG( 21, 34) =  0.342705E+00
  PKER_SACCRG( 21, 35) =  0.338523E+00
  PKER_SACCRG( 21, 36) =  0.330421E+00
  PKER_SACCRG( 21, 37) =  0.000000E+00
  PKER_SACCRG( 21, 38) =  0.000000E+00
  PKER_SACCRG( 21, 39) =  0.000000E+00
  PKER_SACCRG( 21, 40) =  0.000000E+00
  PKER_SACCRG( 22,  1) =  0.000000E+00
  PKER_SACCRG( 22,  2) =  0.000000E+00
  PKER_SACCRG( 22,  3) =  0.000000E+00
  PKER_SACCRG( 22,  4) =  0.000000E+00
  PKER_SACCRG( 22,  5) =  0.000000E+00
  PKER_SACCRG( 22,  6) =  0.000000E+00
  PKER_SACCRG( 22,  7) =  0.000000E+00
  PKER_SACCRG( 22,  8) =  0.000000E+00
  PKER_SACCRG( 22,  9) =  0.000000E+00
  PKER_SACCRG( 22, 10) =  0.000000E+00
  PKER_SACCRG( 22, 11) =  0.000000E+00
  PKER_SACCRG( 22, 12) =  0.000000E+00
  PKER_SACCRG( 22, 13) =  0.000000E+00
  PKER_SACCRG( 22, 14) =  0.000000E+00
  PKER_SACCRG( 22, 15) =  0.301594E-07
  PKER_SACCRG( 22, 16) =  0.458593E+00
  PKER_SACCRG( 22, 17) =  0.425018E+00
  PKER_SACCRG( 22, 18) =  0.376611E-01
  PKER_SACCRG( 22, 19) =  0.115562E+00
  PKER_SACCRG( 22, 20) =  0.101686E+00
  PKER_SACCRG( 22, 21) =  0.171258E+00
  PKER_SACCRG( 22, 22) =  0.133854E+00
  PKER_SACCRG( 22, 23) =  0.170618E+00
  PKER_SACCRG( 22, 24) =  0.159301E+00
  PKER_SACCRG( 22, 25) =  0.195009E+00
  PKER_SACCRG( 22, 26) =  0.229057E+00
  PKER_SACCRG( 22, 27) =  0.279005E+00
  PKER_SACCRG( 22, 28) =  0.335986E+00
  PKER_SACCRG( 22, 29) =  0.360465E+00
  PKER_SACCRG( 22, 30) =  0.374161E+00
  PKER_SACCRG( 22, 31) =  0.372873E+00
  PKER_SACCRG( 22, 32) =  0.367297E+00
  PKER_SACCRG( 22, 33) =  0.361988E+00
  PKER_SACCRG( 22, 34) =  0.360293E+00
  PKER_SACCRG( 22, 35) =  0.356173E+00
  PKER_SACCRG( 22, 36) =  0.348226E+00
  PKER_SACCRG( 22, 37) =  0.000000E+00
  PKER_SACCRG( 22, 38) =  0.000000E+00
  PKER_SACCRG( 22, 39) =  0.000000E+00
  PKER_SACCRG( 22, 40) =  0.000000E+00
  PKER_SACCRG( 23,  1) =  0.000000E+00
  PKER_SACCRG( 23,  2) =  0.000000E+00
  PKER_SACCRG( 23,  3) =  0.000000E+00
  PKER_SACCRG( 23,  4) =  0.000000E+00
  PKER_SACCRG( 23,  5) =  0.000000E+00
  PKER_SACCRG( 23,  6) =  0.000000E+00
  PKER_SACCRG( 23,  7) =  0.000000E+00
  PKER_SACCRG( 23,  8) =  0.000000E+00
  PKER_SACCRG( 23,  9) =  0.000000E+00
  PKER_SACCRG( 23, 10) =  0.000000E+00
  PKER_SACCRG( 23, 11) =  0.000000E+00
  PKER_SACCRG( 23, 12) =  0.000000E+00
  PKER_SACCRG( 23, 13) =  0.000000E+00
  PKER_SACCRG( 23, 14) =  0.000000E+00
  PKER_SACCRG( 23, 15) =  0.474816E-09
  PKER_SACCRG( 23, 16) =  0.471716E+00
  PKER_SACCRG( 23, 17) =  0.438382E+00
  PKER_SACCRG( 23, 18) =  0.385478E-01
  PKER_SACCRG( 23, 19) =  0.460661E+00
  PKER_SACCRG( 23, 20) =  0.104389E+00
  PKER_SACCRG( 23, 21) =  0.175908E+00
  PKER_SACCRG( 23, 22) =  0.228218E+00
  PKER_SACCRG( 23, 23) =  0.262318E+00
  PKER_SACCRG( 23, 24) =  0.210313E+00
  PKER_SACCRG( 23, 25) =  0.229302E+00
  PKER_SACCRG( 23, 26) =  0.277715E+00
  PKER_SACCRG( 23, 27) =  0.316637E+00
  PKER_SACCRG( 23, 28) =  0.358767E+00
  PKER_SACCRG( 23, 29) =  0.376353E+00
  PKER_SACCRG( 23, 30) =  0.388397E+00
  PKER_SACCRG( 23, 31) =  0.386871E+00
  PKER_SACCRG( 23, 32) =  0.381361E+00
  PKER_SACCRG( 23, 33) =  0.376104E+00
  PKER_SACCRG( 23, 34) =  0.374406E+00
  PKER_SACCRG( 23, 35) =  0.370329E+00
  PKER_SACCRG( 23, 36) =  0.362490E+00
  PKER_SACCRG( 23, 37) =  0.000000E+00
  PKER_SACCRG( 23, 38) =  0.000000E+00
  PKER_SACCRG( 23, 39) =  0.000000E+00
  PKER_SACCRG( 23, 40) =  0.000000E+00
  PKER_SACCRG( 24,  1) =  0.000000E+00
  PKER_SACCRG( 24,  2) =  0.000000E+00
  PKER_SACCRG( 24,  3) =  0.000000E+00
  PKER_SACCRG( 24,  4) =  0.000000E+00
  PKER_SACCRG( 24,  5) =  0.000000E+00
  PKER_SACCRG( 24,  6) =  0.000000E+00
  PKER_SACCRG( 24,  7) =  0.000000E+00
  PKER_SACCRG( 24,  8) =  0.000000E+00
  PKER_SACCRG( 24,  9) =  0.000000E+00
  PKER_SACCRG( 24, 10) =  0.000000E+00
  PKER_SACCRG( 24, 11) =  0.000000E+00
  PKER_SACCRG( 24, 12) =  0.000000E+00
  PKER_SACCRG( 24, 13) =  0.000000E+00
  PKER_SACCRG( 24, 14) =  0.000000E+00
  PKER_SACCRG( 24, 15) =  0.000000E+00
  PKER_SACCRG( 24, 16) =  0.482421E+00
  PKER_SACCRG( 24, 17) =  0.449246E+00
  PKER_SACCRG( 24, 18) =  0.418021E+00
  PKER_SACCRG( 24, 19) =  0.471528E+00
  PKER_SACCRG( 24, 20) =  0.106574E+00
  PKER_SACCRG( 24, 21) =  0.457583E+00
  PKER_SACCRG( 24, 22) =  0.457441E+00
  PKER_SACCRG( 24, 23) =  0.268282E+00
  PKER_SACCRG( 24, 24) =  0.295154E+00
  PKER_SACCRG( 24, 25) =  0.277246E+00
  PKER_SACCRG( 24, 26) =  0.318509E+00
  PKER_SACCRG( 24, 27) =  0.341083E+00
  PKER_SACCRG( 24, 28) =  0.383566E+00
  PKER_SACCRG( 24, 29) =  0.393965E+00
  PKER_SACCRG( 24, 30) =  0.400814E+00
  PKER_SACCRG( 24, 31) =  0.398325E+00
  PKER_SACCRG( 24, 32) =  0.392699E+00
  PKER_SACCRG( 24, 33) =  0.387475E+00
  PKER_SACCRG( 24, 34) =  0.385773E+00
  PKER_SACCRG( 24, 35) =  0.381723E+00
  PKER_SACCRG( 24, 36) =  0.373956E+00
  PKER_SACCRG( 24, 37) =  0.000000E+00
  PKER_SACCRG( 24, 38) =  0.000000E+00
  PKER_SACCRG( 24, 39) =  0.000000E+00
  PKER_SACCRG( 24, 40) =  0.000000E+00
  PKER_SACCRG( 25,  1) =  0.000000E+00
  PKER_SACCRG( 25,  2) =  0.000000E+00
  PKER_SACCRG( 25,  3) =  0.000000E+00
  PKER_SACCRG( 25,  4) =  0.000000E+00
  PKER_SACCRG( 25,  5) =  0.000000E+00
  PKER_SACCRG( 25,  6) =  0.000000E+00
  PKER_SACCRG( 25,  7) =  0.000000E+00
  PKER_SACCRG( 25,  8) =  0.000000E+00
  PKER_SACCRG( 25,  9) =  0.000000E+00
  PKER_SACCRG( 25, 10) =  0.000000E+00
  PKER_SACCRG( 25, 11) =  0.000000E+00
  PKER_SACCRG( 25, 12) =  0.000000E+00
  PKER_SACCRG( 25, 13) =  0.000000E+00
  PKER_SACCRG( 25, 14) =  0.000000E+00
  PKER_SACCRG( 25, 15) =  0.000000E+00
  PKER_SACCRG( 25, 16) =  0.493305E+00
  PKER_SACCRG( 25, 17) =  0.460084E+00
  PKER_SACCRG( 25, 18) =  0.428847E+00
  PKER_SACCRG( 25, 19) =  0.482480E+00
  PKER_SACCRG( 25, 20) =  0.457996E+00
  PKER_SACCRG( 25, 21) =  0.468489E+00
  PKER_SACCRG( 25, 22) =  0.468385E+00
  PKER_SACCRG( 25, 23) =  0.465913E+00
  PKER_SACCRG( 25, 24) =  0.302045E+00
  PKER_SACCRG( 25, 25) =  0.349681E+00
  PKER_SACCRG( 25, 26) =  0.375849E+00
  PKER_SACCRG( 25, 27) =  0.372009E+00
  PKER_SACCRG( 25, 28) =  0.404973E+00
  PKER_SACCRG( 25, 29) =  0.408427E+00
  PKER_SACCRG( 25, 30) =  0.413563E+00
  PKER_SACCRG( 25, 31) =  0.409638E+00
  PKER_SACCRG( 25, 32) =  0.403614E+00
  PKER_SACCRG( 25, 33) =  0.398367E+00
  PKER_SACCRG( 25, 34) =  0.396652E+00
  PKER_SACCRG( 25, 35) =  0.392598E+00
  PKER_SACCRG( 25, 36) =  0.384841E+00
  PKER_SACCRG( 25, 37) =  0.000000E+00
  PKER_SACCRG( 25, 38) =  0.000000E+00
  PKER_SACCRG( 25, 39) =  0.000000E+00
  PKER_SACCRG( 25, 40) =  0.000000E+00
  PKER_SACCRG( 26,  1) =  0.000000E+00
  PKER_SACCRG( 26,  2) =  0.000000E+00
  PKER_SACCRG( 26,  3) =  0.000000E+00
  PKER_SACCRG( 26,  4) =  0.000000E+00
  PKER_SACCRG( 26,  5) =  0.000000E+00
  PKER_SACCRG( 26,  6) =  0.000000E+00
  PKER_SACCRG( 26,  7) =  0.000000E+00
  PKER_SACCRG( 26,  8) =  0.000000E+00
  PKER_SACCRG( 26,  9) =  0.000000E+00
  PKER_SACCRG( 26, 10) =  0.000000E+00
  PKER_SACCRG( 26, 11) =  0.000000E+00
  PKER_SACCRG( 26, 12) =  0.000000E+00
  PKER_SACCRG( 26, 13) =  0.000000E+00
  PKER_SACCRG( 26, 14) =  0.000000E+00
  PKER_SACCRG( 26, 15) =  0.000000E+00
  PKER_SACCRG( 26, 16) =  0.498360E+00
  PKER_SACCRG( 26, 17) =  0.465358E+00
  PKER_SACCRG( 26, 18) =  0.434351E+00
  PKER_SACCRG( 26, 19) =  0.487671E+00
  PKER_SACCRG( 26, 20) =  0.463284E+00
  PKER_SACCRG( 26, 21) =  0.473752E+00
  PKER_SACCRG( 26, 22) =  0.473679E+00
  PKER_SACCRG( 26, 23) =  0.471200E+00
  PKER_SACCRG( 26, 24) =  0.305321E+00
  PKER_SACCRG( 26, 25) =  0.460272E+00
  PKER_SACCRG( 26, 26) =  0.380186E+00
  PKER_SACCRG( 26, 27) =  0.407235E+00
  PKER_SACCRG( 26, 28) =  0.425703E+00
  PKER_SACCRG( 26, 29) =  0.419464E+00
  PKER_SACCRG( 26, 30) =  0.420713E+00
  PKER_SACCRG( 26, 31) =  0.415965E+00
  PKER_SACCRG( 26, 32) =  0.409433E+00
  PKER_SACCRG( 26, 33) =  0.404156E+00
  PKER_SACCRG( 26, 34) =  0.402444E+00
  PKER_SACCRG( 26, 35) =  0.398420E+00
  PKER_SACCRG( 26, 36) =  0.390729E+00
  PKER_SACCRG( 26, 37) =  0.000000E+00
  PKER_SACCRG( 26, 38) =  0.000000E+00
  PKER_SACCRG( 26, 39) =  0.000000E+00
  PKER_SACCRG( 26, 40) =  0.000000E+00
  PKER_SACCRG( 27,  1) =  0.000000E+00
  PKER_SACCRG( 27,  2) =  0.000000E+00
  PKER_SACCRG( 27,  3) =  0.000000E+00
  PKER_SACCRG( 27,  4) =  0.000000E+00
  PKER_SACCRG( 27,  5) =  0.000000E+00
  PKER_SACCRG( 27,  6) =  0.000000E+00
  PKER_SACCRG( 27,  7) =  0.000000E+00
  PKER_SACCRG( 27,  8) =  0.000000E+00
  PKER_SACCRG( 27,  9) =  0.000000E+00
  PKER_SACCRG( 27, 10) =  0.000000E+00
  PKER_SACCRG( 27, 11) =  0.000000E+00
  PKER_SACCRG( 27, 12) =  0.000000E+00
  PKER_SACCRG( 27, 13) =  0.000000E+00
  PKER_SACCRG( 27, 14) =  0.000000E+00
  PKER_SACCRG( 27, 15) =  0.000000E+00
  PKER_SACCRG( 27, 16) =  0.504260E+00
  PKER_SACCRG( 27, 17) =  0.471302E+00
  PKER_SACCRG( 27, 18) =  0.440353E+00
  PKER_SACCRG( 27, 19) =  0.493636E+00
  PKER_SACCRG( 27, 20) =  0.469232E+00
  PKER_SACCRG( 27, 21) =  0.479719E+00
  PKER_SACCRG( 27, 22) =  0.479669E+00
  PKER_SACCRG( 27, 23) =  0.477177E+00
  PKER_SACCRG( 27, 24) =  0.464189E+00
  PKER_SACCRG( 27, 25) =  0.466286E+00
  PKER_SACCRG( 27, 26) =  0.385058E+00
  PKER_SACCRG( 27, 27) =  0.412596E+00
  PKER_SACCRG( 27, 28) =  0.452611E+00
  PKER_SACCRG( 27, 29) =  0.433046E+00
  PKER_SACCRG( 27, 30) =  0.428880E+00
  PKER_SACCRG( 27, 31) =  0.422050E+00
  PKER_SACCRG( 27, 32) =  0.415579E+00
  PKER_SACCRG( 27, 33) =  0.410255E+00
  PKER_SACCRG( 27, 34) =  0.408538E+00
  PKER_SACCRG( 27, 35) =  0.404518E+00
  PKER_SACCRG( 27, 36) =  0.396847E+00
  PKER_SACCRG( 27, 37) =  0.000000E+00
  PKER_SACCRG( 27, 38) =  0.000000E+00
  PKER_SACCRG( 27, 39) =  0.000000E+00
  PKER_SACCRG( 27, 40) =  0.000000E+00
  PKER_SACCRG( 28,  1) =  0.000000E+00
  PKER_SACCRG( 28,  2) =  0.000000E+00
  PKER_SACCRG( 28,  3) =  0.000000E+00
  PKER_SACCRG( 28,  4) =  0.000000E+00
  PKER_SACCRG( 28,  5) =  0.000000E+00
  PKER_SACCRG( 28,  6) =  0.000000E+00
  PKER_SACCRG( 28,  7) =  0.000000E+00
  PKER_SACCRG( 28,  8) =  0.000000E+00
  PKER_SACCRG( 28,  9) =  0.000000E+00
  PKER_SACCRG( 28, 10) =  0.000000E+00
  PKER_SACCRG( 28, 11) =  0.000000E+00
  PKER_SACCRG( 28, 12) =  0.000000E+00
  PKER_SACCRG( 28, 13) =  0.000000E+00
  PKER_SACCRG( 28, 14) =  0.000000E+00
  PKER_SACCRG( 28, 15) =  0.000000E+00
  PKER_SACCRG( 28, 16) =  0.511289E+00
  PKER_SACCRG( 28, 17) =  0.478218E+00
  PKER_SACCRG( 28, 18) =  0.447169E+00
  PKER_SACCRG( 28, 19) =  0.500667E+00
  PKER_SACCRG( 28, 20) =  0.476141E+00
  PKER_SACCRG( 28, 21) =  0.486690E+00
  PKER_SACCRG( 28, 22) =  0.486657E+00
  PKER_SACCRG( 28, 23) =  0.484143E+00
  PKER_SACCRG( 28, 24) =  0.471128E+00
  PKER_SACCRG( 28, 25) =  0.473232E+00
  PKER_SACCRG( 28, 26) =  0.467330E+00
  PKER_SACCRG( 28, 27) =  0.462303E+00
  PKER_SACCRG( 28, 28) =  0.459518E+00
  PKER_SACCRG( 28, 29) =  0.439730E+00
  PKER_SACCRG( 28, 30) =  0.435663E+00
  PKER_SACCRG( 28, 31) =  0.429350E+00
  PKER_SACCRG( 28, 32) =  0.422348E+00
  PKER_SACCRG( 28, 33) =  0.417002E+00
  PKER_SACCRG( 28, 34) =  0.415273E+00
  PKER_SACCRG( 28, 35) =  0.411238E+00
  PKER_SACCRG( 28, 36) =  0.403544E+00
  PKER_SACCRG( 28, 37) =  0.000000E+00
  PKER_SACCRG( 28, 38) =  0.000000E+00
  PKER_SACCRG( 28, 39) =  0.000000E+00
  PKER_SACCRG( 28, 40) =  0.000000E+00
  PKER_SACCRG( 29,  1) =  0.000000E+00
  PKER_SACCRG( 29,  2) =  0.000000E+00
  PKER_SACCRG( 29,  3) =  0.000000E+00
  PKER_SACCRG( 29,  4) =  0.000000E+00
  PKER_SACCRG( 29,  5) =  0.000000E+00
  PKER_SACCRG( 29,  6) =  0.000000E+00
  PKER_SACCRG( 29,  7) =  0.000000E+00
  PKER_SACCRG( 29,  8) =  0.000000E+00
  PKER_SACCRG( 29,  9) =  0.000000E+00
  PKER_SACCRG( 29, 10) =  0.000000E+00
  PKER_SACCRG( 29, 11) =  0.000000E+00
  PKER_SACCRG( 29, 12) =  0.000000E+00
  PKER_SACCRG( 29, 13) =  0.000000E+00
  PKER_SACCRG( 29, 14) =  0.000000E+00
  PKER_SACCRG( 29, 15) =  0.000000E+00
  PKER_SACCRG( 29, 16) =  0.515299E+00
  PKER_SACCRG( 29, 17) =  0.482248E+00
  PKER_SACCRG( 29, 18) =  0.451226E+00
  PKER_SACCRG( 29, 19) =  0.504714E+00
  PKER_SACCRG( 29, 20) =  0.480173E+00
  PKER_SACCRG( 29, 21) =  0.490737E+00
  PKER_SACCRG( 29, 22) =  0.490717E+00
  PKER_SACCRG( 29, 23) =  0.488194E+00
  PKER_SACCRG( 29, 24) =  0.475202E+00
  PKER_SACCRG( 29, 25) =  0.477303E+00
  PKER_SACCRG( 29, 26) =  0.471406E+00
  PKER_SACCRG( 29, 27) =  0.466391E+00
  PKER_SACCRG( 29, 28) =  0.463606E+00
  PKER_SACCRG( 29, 29) =  0.443703E+00
  PKER_SACCRG( 29, 30) =  0.442690E+00
  PKER_SACCRG( 29, 31) =  0.433456E+00
  PKER_SACCRG( 29, 32) =  0.426527E+00
  PKER_SACCRG( 29, 33) =  0.421106E+00
  PKER_SACCRG( 29, 34) =  0.419373E+00
  PKER_SACCRG( 29, 35) =  0.415340E+00
  PKER_SACCRG( 29, 36) =  0.407653E+00
  PKER_SACCRG( 29, 37) =  0.000000E+00
  PKER_SACCRG( 29, 38) =  0.000000E+00
  PKER_SACCRG( 29, 39) =  0.000000E+00
  PKER_SACCRG( 29, 40) =  0.000000E+00
  PKER_SACCRG( 30,  1) =  0.000000E+00
  PKER_SACCRG( 30,  2) =  0.000000E+00
  PKER_SACCRG( 30,  3) =  0.000000E+00
  PKER_SACCRG( 30,  4) =  0.000000E+00
  PKER_SACCRG( 30,  5) =  0.000000E+00
  PKER_SACCRG( 30,  6) =  0.000000E+00
  PKER_SACCRG( 30,  7) =  0.000000E+00
  PKER_SACCRG( 30,  8) =  0.000000E+00
  PKER_SACCRG( 30,  9) =  0.000000E+00
  PKER_SACCRG( 30, 10) =  0.000000E+00
  PKER_SACCRG( 30, 11) =  0.000000E+00
  PKER_SACCRG( 30, 12) =  0.000000E+00
  PKER_SACCRG( 30, 13) =  0.000000E+00
  PKER_SACCRG( 30, 14) =  0.000000E+00
  PKER_SACCRG( 30, 15) =  0.000000E+00
  PKER_SACCRG( 30, 16) =  0.518606E+00
  PKER_SACCRG( 30, 17) =  0.485568E+00
  PKER_SACCRG( 30, 18) =  0.454563E+00
  PKER_SACCRG( 30, 19) =  0.508049E+00
  PKER_SACCRG( 30, 20) =  0.483494E+00
  PKER_SACCRG( 30, 21) =  0.494070E+00
  PKER_SACCRG( 30, 22) =  0.494061E+00
  PKER_SACCRG( 30, 23) =  0.491531E+00
  PKER_SACCRG( 30, 24) =  0.478555E+00
  PKER_SACCRG( 30, 25) =  0.480655E+00
  PKER_SACCRG( 30, 26) =  0.474762E+00
  PKER_SACCRG( 30, 27) =  0.469755E+00
  PKER_SACCRG( 30, 28) =  0.466968E+00
  PKER_SACCRG( 30, 29) =  0.457637E+00
  PKER_SACCRG( 30, 30) =  0.446063E+00
  PKER_SACCRG( 30, 31) =  0.436830E+00
  PKER_SACCRG( 30, 32) =  0.429899E+00
  PKER_SACCRG( 30, 33) =  0.424476E+00
  PKER_SACCRG( 30, 34) =  0.422741E+00
  PKER_SACCRG( 30, 35) =  0.418708E+00
  PKER_SACCRG( 30, 36) =  0.411026E+00
  PKER_SACCRG( 30, 37) =  0.000000E+00
  PKER_SACCRG( 30, 38) =  0.000000E+00
  PKER_SACCRG( 30, 39) =  0.000000E+00
  PKER_SACCRG( 30, 40) =  0.000000E+00
  PKER_SACCRG( 31,  1) =  0.000000E+00
  PKER_SACCRG( 31,  2) =  0.000000E+00
  PKER_SACCRG( 31,  3) =  0.000000E+00
  PKER_SACCRG( 31,  4) =  0.000000E+00
  PKER_SACCRG( 31,  5) =  0.000000E+00
  PKER_SACCRG( 31,  6) =  0.000000E+00
  PKER_SACCRG( 31,  7) =  0.000000E+00
  PKER_SACCRG( 31,  8) =  0.000000E+00
  PKER_SACCRG( 31,  9) =  0.000000E+00
  PKER_SACCRG( 31, 10) =  0.000000E+00
  PKER_SACCRG( 31, 11) =  0.000000E+00
  PKER_SACCRG( 31, 12) =  0.000000E+00
  PKER_SACCRG( 31, 13) =  0.000000E+00
  PKER_SACCRG( 31, 14) =  0.000000E+00
  PKER_SACCRG( 31, 15) =  0.000000E+00
  PKER_SACCRG( 31, 16) =  0.521335E+00
  PKER_SACCRG( 31, 17) =  0.488306E+00
  PKER_SACCRG( 31, 18) =  0.457313E+00
  PKER_SACCRG( 31, 19) =  0.510799E+00
  PKER_SACCRG( 31, 20) =  0.486233E+00
  PKER_SACCRG( 31, 21) =  0.496818E+00
  PKER_SACCRG( 31, 22) =  0.496818E+00
  PKER_SACCRG( 31, 23) =  0.494282E+00
  PKER_SACCRG( 31, 24) =  0.481318E+00
  PKER_SACCRG( 31, 25) =  0.483417E+00
  PKER_SACCRG( 31, 26) =  0.477526E+00
  PKER_SACCRG( 31, 27) =  0.472527E+00
  PKER_SACCRG( 31, 28) =  0.469738E+00
  PKER_SACCRG( 31, 29) =  0.460409E+00
  PKER_SACCRG( 31, 30) =  0.448841E+00
  PKER_SACCRG( 31, 31) =  0.439607E+00
  PKER_SACCRG( 31, 32) =  0.432673E+00
  PKER_SACCRG( 31, 33) =  0.427249E+00
  PKER_SACCRG( 31, 34) =  0.425511E+00
  PKER_SACCRG( 31, 35) =  0.421478E+00
  PKER_SACCRG( 31, 36) =  0.413798E+00
  PKER_SACCRG( 31, 37) =  0.000000E+00
  PKER_SACCRG( 31, 38) =  0.000000E+00
  PKER_SACCRG( 31, 39) =  0.000000E+00
  PKER_SACCRG( 31, 40) =  0.000000E+00
  PKER_SACCRG( 32,  1) =  0.000000E+00
  PKER_SACCRG( 32,  2) =  0.000000E+00
  PKER_SACCRG( 32,  3) =  0.000000E+00
  PKER_SACCRG( 32,  4) =  0.000000E+00
  PKER_SACCRG( 32,  5) =  0.000000E+00
  PKER_SACCRG( 32,  6) =  0.000000E+00
  PKER_SACCRG( 32,  7) =  0.000000E+00
  PKER_SACCRG( 32,  8) =  0.000000E+00
  PKER_SACCRG( 32,  9) =  0.000000E+00
  PKER_SACCRG( 32, 10) =  0.000000E+00
  PKER_SACCRG( 32, 11) =  0.000000E+00
  PKER_SACCRG( 32, 12) =  0.000000E+00
  PKER_SACCRG( 32, 13) =  0.000000E+00
  PKER_SACCRG( 32, 14) =  0.000000E+00
  PKER_SACCRG( 32, 15) =  0.000000E+00
  PKER_SACCRG( 32, 16) =  0.521382E+00
  PKER_SACCRG( 32, 17) =  0.488500E+00
  PKER_SACCRG( 32, 18) =  0.457646E+00
  PKER_SACCRG( 32, 19) =  0.510908E+00
  PKER_SACCRG( 32, 20) =  0.486436E+00
  PKER_SACCRG( 32, 21) =  0.496984E+00
  PKER_SACCRG( 32, 22) =  0.496990E+00
  PKER_SACCRG( 32, 23) =  0.494461E+00
  PKER_SACCRG( 32, 24) =  0.481561E+00
  PKER_SACCRG( 32, 25) =  0.483650E+00
  PKER_SACCRG( 32, 26) =  0.477787E+00
  PKER_SACCRG( 32, 27) =  0.472813E+00
  PKER_SACCRG( 32, 28) =  0.470036E+00
  PKER_SACCRG( 32, 29) =  0.460747E+00
  PKER_SACCRG( 32, 30) =  0.449232E+00
  PKER_SACCRG( 32, 31) =  0.440036E+00
  PKER_SACCRG( 32, 32) =  0.433130E+00
  PKER_SACCRG( 32, 33) =  0.427727E+00
  PKER_SACCRG( 32, 34) =  0.425995E+00
  PKER_SACCRG( 32, 35) =  0.421979E+00
  PKER_SACCRG( 32, 36) =  0.414334E+00
  PKER_SACCRG( 32, 37) =  0.000000E+00
  PKER_SACCRG( 32, 38) =  0.000000E+00
  PKER_SACCRG( 32, 39) =  0.000000E+00
  PKER_SACCRG( 32, 40) =  0.000000E+00
  PKER_SACCRG( 33,  1) =  0.000000E+00
  PKER_SACCRG( 33,  2) =  0.000000E+00
  PKER_SACCRG( 33,  3) =  0.000000E+00
  PKER_SACCRG( 33,  4) =  0.000000E+00
  PKER_SACCRG( 33,  5) =  0.000000E+00
  PKER_SACCRG( 33,  6) =  0.000000E+00
  PKER_SACCRG( 33,  7) =  0.000000E+00
  PKER_SACCRG( 33,  8) =  0.000000E+00
  PKER_SACCRG( 33,  9) =  0.000000E+00
  PKER_SACCRG( 33, 10) =  0.000000E+00
  PKER_SACCRG( 33, 11) =  0.000000E+00
  PKER_SACCRG( 33, 12) =  0.000000E+00
  PKER_SACCRG( 33, 13) =  0.000000E+00
  PKER_SACCRG( 33, 14) =  0.000000E+00
  PKER_SACCRG( 33, 15) =  0.000000E+00
  PKER_SACCRG( 33, 16) =  0.523239E+00
  PKER_SACCRG( 33, 17) =  0.490361E+00
  PKER_SACCRG( 33, 18) =  0.459511E+00
  PKER_SACCRG( 33, 19) =  0.512778E+00
  PKER_SACCRG( 33, 20) =  0.488297E+00
  PKER_SACCRG( 33, 21) =  0.498852E+00
  PKER_SACCRG( 33, 22) =  0.498864E+00
  PKER_SACCRG( 33, 23) =  0.496331E+00
  PKER_SACCRG( 33, 24) =  0.483437E+00
  PKER_SACCRG( 33, 25) =  0.485525E+00
  PKER_SACCRG( 33, 26) =  0.479663E+00
  PKER_SACCRG( 33, 27) =  0.474693E+00
  PKER_SACCRG( 33, 28) =  0.471915E+00
  PKER_SACCRG( 33, 29) =  0.462627E+00
  PKER_SACCRG( 33, 30) =  0.451113E+00
  PKER_SACCRG( 33, 31) =  0.441917E+00
  PKER_SACCRG( 33, 32) =  0.435008E+00
  PKER_SACCRG( 33, 33) =  0.429604E+00
  PKER_SACCRG( 33, 34) =  0.427870E+00
  PKER_SACCRG( 33, 35) =  0.423853E+00
  PKER_SACCRG( 33, 36) =  0.416209E+00
  PKER_SACCRG( 33, 37) =  0.000000E+00
  PKER_SACCRG( 33, 38) =  0.000000E+00
  PKER_SACCRG( 33, 39) =  0.000000E+00
  PKER_SACCRG( 33, 40) =  0.000000E+00
  PKER_SACCRG( 34,  1) =  0.000000E+00
  PKER_SACCRG( 34,  2) =  0.000000E+00
  PKER_SACCRG( 34,  3) =  0.000000E+00
  PKER_SACCRG( 34,  4) =  0.000000E+00
  PKER_SACCRG( 34,  5) =  0.000000E+00
  PKER_SACCRG( 34,  6) =  0.000000E+00
  PKER_SACCRG( 34,  7) =  0.000000E+00
  PKER_SACCRG( 34,  8) =  0.000000E+00
  PKER_SACCRG( 34,  9) =  0.000000E+00
  PKER_SACCRG( 34, 10) =  0.000000E+00
  PKER_SACCRG( 34, 11) =  0.000000E+00
  PKER_SACCRG( 34, 12) =  0.000000E+00
  PKER_SACCRG( 34, 13) =  0.000000E+00
  PKER_SACCRG( 34, 14) =  0.000000E+00
  PKER_SACCRG( 34, 15) =  0.000000E+00
  PKER_SACCRG( 34, 16) =  0.526989E+00
  PKER_SACCRG( 34, 17) =  0.493974E+00
  PKER_SACCRG( 34, 18) =  0.462996E+00
  PKER_SACCRG( 34, 19) =  0.516493E+00
  PKER_SACCRG( 34, 20) =  0.491901E+00
  PKER_SACCRG( 34, 21) =  0.502507E+00
  PKER_SACCRG( 34, 22) =  0.502522E+00
  PKER_SACCRG( 34, 23) =  0.499975E+00
  PKER_SACCRG( 34, 24) =  0.487032E+00
  PKER_SACCRG( 34, 25) =  0.489128E+00
  PKER_SACCRG( 34, 26) =  0.483242E+00
  PKER_SACCRG( 34, 27) =  0.478253E+00
  PKER_SACCRG( 34, 28) =  0.475463E+00
  PKER_SACCRG( 34, 29) =  0.466135E+00
  PKER_SACCRG( 34, 30) =  0.454574E+00
  PKER_SACCRG( 34, 31) =  0.445337E+00
  PKER_SACCRG( 34, 32) =  0.438397E+00
  PKER_SACCRG( 34, 33) =  0.432968E+00
  PKER_SACCRG( 34, 34) =  0.431225E+00
  PKER_SACCRG( 34, 35) =  0.427191E+00
  PKER_SACCRG( 34, 36) =  0.419515E+00
  PKER_SACCRG( 34, 37) =  0.000000E+00
  PKER_SACCRG( 34, 38) =  0.000000E+00
  PKER_SACCRG( 34, 39) =  0.000000E+00
  PKER_SACCRG( 34, 40) =  0.000000E+00
  PKER_SACCRG( 35,  1) =  0.000000E+00
  PKER_SACCRG( 35,  2) =  0.000000E+00
  PKER_SACCRG( 35,  3) =  0.000000E+00
  PKER_SACCRG( 35,  4) =  0.000000E+00
  PKER_SACCRG( 35,  5) =  0.000000E+00
  PKER_SACCRG( 35,  6) =  0.000000E+00
  PKER_SACCRG( 35,  7) =  0.000000E+00
  PKER_SACCRG( 35,  8) =  0.000000E+00
  PKER_SACCRG( 35,  9) =  0.000000E+00
  PKER_SACCRG( 35, 10) =  0.000000E+00
  PKER_SACCRG( 35, 11) =  0.000000E+00
  PKER_SACCRG( 35, 12) =  0.000000E+00
  PKER_SACCRG( 35, 13) =  0.000000E+00
  PKER_SACCRG( 35, 14) =  0.000000E+00
  PKER_SACCRG( 35, 15) =  0.000000E+00
  PKER_SACCRG( 35, 16) =  0.526044E+00
  PKER_SACCRG( 35, 17) =  0.493170E+00
  PKER_SACCRG( 35, 18) =  0.462325E+00
  PKER_SACCRG( 35, 19) =  0.515600E+00
  PKER_SACCRG( 35, 20) =  0.491106E+00
  PKER_SACCRG( 35, 21) =  0.501671E+00
  PKER_SACCRG( 35, 22) =  0.501689E+00
  PKER_SACCRG( 35, 23) =  0.499151E+00
  PKER_SACCRG( 35, 24) =  0.486266E+00
  PKER_SACCRG( 35, 25) =  0.488354E+00
  PKER_SACCRG( 35, 26) =  0.482493E+00
  PKER_SACCRG( 35, 27) =  0.477528E+00
  PKER_SACCRG( 35, 28) =  0.474748E+00
  PKER_SACCRG( 35, 29) =  0.465460E+00
  PKER_SACCRG( 35, 30) =  0.453949E+00
  PKER_SACCRG( 35, 31) =  0.444750E+00
  PKER_SACCRG( 35, 32) =  0.437837E+00
  PKER_SACCRG( 35, 33) =  0.432431E+00
  PKER_SACCRG( 35, 34) =  0.430694E+00
  PKER_SACCRG( 35, 35) =  0.426676E+00
  PKER_SACCRG( 35, 36) =  0.419033E+00
  PKER_SACCRG( 35, 37) =  0.000000E+00
  PKER_SACCRG( 35, 38) =  0.000000E+00
  PKER_SACCRG( 35, 39) =  0.000000E+00
  PKER_SACCRG( 35, 40) =  0.000000E+00
  PKER_SACCRG( 36,  1) =  0.000000E+00
  PKER_SACCRG( 36,  2) =  0.000000E+00
  PKER_SACCRG( 36,  3) =  0.000000E+00
  PKER_SACCRG( 36,  4) =  0.000000E+00
  PKER_SACCRG( 36,  5) =  0.000000E+00
  PKER_SACCRG( 36,  6) =  0.000000E+00
  PKER_SACCRG( 36,  7) =  0.000000E+00
  PKER_SACCRG( 36,  8) =  0.000000E+00
  PKER_SACCRG( 36,  9) =  0.000000E+00
  PKER_SACCRG( 36, 10) =  0.000000E+00
  PKER_SACCRG( 36, 11) =  0.000000E+00
  PKER_SACCRG( 36, 12) =  0.000000E+00
  PKER_SACCRG( 36, 13) =  0.000000E+00
  PKER_SACCRG( 36, 14) =  0.000000E+00
  PKER_SACCRG( 36, 15) =  0.000000E+00
  PKER_SACCRG( 36, 16) =  0.527094E+00
  PKER_SACCRG( 36, 17) =  0.494221E+00
  PKER_SACCRG( 36, 18) =  0.463377E+00
  PKER_SACCRG( 36, 19) =  0.516656E+00
  PKER_SACCRG( 36, 20) =  0.492157E+00
  PKER_SACCRG( 36, 21) =  0.502726E+00
  PKER_SACCRG( 36, 22) =  0.502746E+00
  PKER_SACCRG( 36, 23) =  0.500207E+00
  PKER_SACCRG( 36, 24) =  0.487324E+00
  PKER_SACCRG( 36, 25) =  0.489412E+00
  PKER_SACCRG( 36, 26) =  0.483551E+00
  PKER_SACCRG( 36, 27) =  0.478587E+00
  PKER_SACCRG( 36, 28) =  0.475807E+00
  PKER_SACCRG( 36, 29) =  0.466519E+00
  PKER_SACCRG( 36, 30) =  0.455008E+00
  PKER_SACCRG( 36, 31) =  0.445809E+00
  PKER_SACCRG( 36, 32) =  0.438895E+00
  PKER_SACCRG( 36, 33) =  0.433487E+00
  PKER_SACCRG( 36, 34) =  0.431749E+00
  PKER_SACCRG( 36, 35) =  0.427731E+00
  PKER_SACCRG( 36, 36) =  0.420087E+00
  PKER_SACCRG( 36, 37) =  0.000000E+00
  PKER_SACCRG( 36, 38) =  0.000000E+00
  PKER_SACCRG( 36, 39) =  0.000000E+00
  PKER_SACCRG( 36, 40) =  0.000000E+00
  PKER_SACCRG( 37,  1) =  0.000000E+00
  PKER_SACCRG( 37,  2) =  0.000000E+00
  PKER_SACCRG( 37,  3) =  0.000000E+00
  PKER_SACCRG( 37,  4) =  0.000000E+00
  PKER_SACCRG( 37,  5) =  0.000000E+00
  PKER_SACCRG( 37,  6) =  0.000000E+00
  PKER_SACCRG( 37,  7) =  0.000000E+00
  PKER_SACCRG( 37,  8) =  0.000000E+00
  PKER_SACCRG( 37,  9) =  0.000000E+00
  PKER_SACCRG( 37, 10) =  0.000000E+00
  PKER_SACCRG( 37, 11) =  0.000000E+00
  PKER_SACCRG( 37, 12) =  0.000000E+00
  PKER_SACCRG( 37, 13) =  0.000000E+00
  PKER_SACCRG( 37, 14) =  0.000000E+00
  PKER_SACCRG( 37, 15) =  0.000000E+00
  PKER_SACCRG( 37, 16) =  0.527963E+00
  PKER_SACCRG( 37, 17) =  0.495090E+00
  PKER_SACCRG( 37, 18) =  0.464247E+00
  PKER_SACCRG( 37, 19) =  0.517529E+00
  PKER_SACCRG( 37, 20) =  0.493026E+00
  PKER_SACCRG( 37, 21) =  0.503598E+00
  PKER_SACCRG( 37, 22) =  0.503620E+00
  PKER_SACCRG( 37, 23) =  0.501079E+00
  PKER_SACCRG( 37, 24) =  0.488199E+00
  PKER_SACCRG( 37, 25) =  0.490286E+00
  PKER_SACCRG( 37, 26) =  0.484426E+00
  PKER_SACCRG( 37, 27) =  0.479463E+00
  PKER_SACCRG( 37, 28) =  0.476683E+00
  PKER_SACCRG( 37, 29) =  0.467394E+00
  PKER_SACCRG( 37, 30) =  0.455884E+00
  PKER_SACCRG( 37, 31) =  0.446684E+00
  PKER_SACCRG( 37, 32) =  0.439768E+00
  PKER_SACCRG( 37, 33) =  0.434360E+00
  PKER_SACCRG( 37, 34) =  0.432621E+00
  PKER_SACCRG( 37, 35) =  0.428603E+00
  PKER_SACCRG( 37, 36) =  0.420959E+00
  PKER_SACCRG( 37, 37) =  0.000000E+00
  PKER_SACCRG( 37, 38) =  0.000000E+00
  PKER_SACCRG( 37, 39) =  0.000000E+00
  PKER_SACCRG( 37, 40) =  0.000000E+00
  PKER_SACCRG( 38,  1) =  0.000000E+00
  PKER_SACCRG( 38,  2) =  0.000000E+00
  PKER_SACCRG( 38,  3) =  0.000000E+00
  PKER_SACCRG( 38,  4) =  0.000000E+00
  PKER_SACCRG( 38,  5) =  0.000000E+00
  PKER_SACCRG( 38,  6) =  0.000000E+00
  PKER_SACCRG( 38,  7) =  0.000000E+00
  PKER_SACCRG( 38,  8) =  0.000000E+00
  PKER_SACCRG( 38,  9) =  0.000000E+00
  PKER_SACCRG( 38, 10) =  0.000000E+00
  PKER_SACCRG( 38, 11) =  0.000000E+00
  PKER_SACCRG( 38, 12) =  0.000000E+00
  PKER_SACCRG( 38, 13) =  0.000000E+00
  PKER_SACCRG( 38, 14) =  0.000000E+00
  PKER_SACCRG( 38, 15) =  0.000000E+00
  PKER_SACCRG( 38, 16) =  0.530904E+00
  PKER_SACCRG( 38, 17) =  0.497893E+00
  PKER_SACCRG( 38, 18) =  0.466921E+00
  PKER_SACCRG( 38, 19) =  0.520430E+00
  PKER_SACCRG( 38, 20) =  0.495821E+00
  PKER_SACCRG( 38, 21) =  0.506439E+00
  PKER_SACCRG( 38, 22) =  0.506463E+00
  PKER_SACCRG( 38, 23) =  0.503910E+00
  PKER_SACCRG( 38, 24) =  0.490978E+00
  PKER_SACCRG( 38, 25) =  0.493073E+00
  PKER_SACCRG( 38, 26) =  0.487189E+00
  PKER_SACCRG( 38, 27) =  0.482206E+00
  PKER_SACCRG( 38, 28) =  0.479414E+00
  PKER_SACCRG( 38, 29) =  0.470086E+00
  PKER_SACCRG( 38, 30) =  0.458527E+00
  PKER_SACCRG( 38, 31) =  0.449287E+00
  PKER_SACCRG( 38, 32) =  0.442342E+00
  PKER_SACCRG( 38, 33) =  0.436910E+00
  PKER_SACCRG( 38, 34) =  0.435164E+00
  PKER_SACCRG( 38, 35) =  0.431128E+00
  PKER_SACCRG( 38, 36) =  0.423452E+00
  PKER_SACCRG( 38, 37) =  0.000000E+00
  PKER_SACCRG( 38, 38) =  0.000000E+00
  PKER_SACCRG( 38, 39) =  0.000000E+00
  PKER_SACCRG( 38, 40) =  0.000000E+00
  PKER_SACCRG( 39,  1) =  0.000000E+00
  PKER_SACCRG( 39,  2) =  0.000000E+00
  PKER_SACCRG( 39,  3) =  0.000000E+00
  PKER_SACCRG( 39,  4) =  0.000000E+00
  PKER_SACCRG( 39,  5) =  0.000000E+00
  PKER_SACCRG( 39,  6) =  0.000000E+00
  PKER_SACCRG( 39,  7) =  0.000000E+00
  PKER_SACCRG( 39,  8) =  0.000000E+00
  PKER_SACCRG( 39,  9) =  0.000000E+00
  PKER_SACCRG( 39, 10) =  0.000000E+00
  PKER_SACCRG( 39, 11) =  0.000000E+00
  PKER_SACCRG( 39, 12) =  0.000000E+00
  PKER_SACCRG( 39, 13) =  0.000000E+00
  PKER_SACCRG( 39, 14) =  0.000000E+00
  PKER_SACCRG( 39, 15) =  0.000000E+00
  PKER_SACCRG( 39, 16) =  0.531500E+00
  PKER_SACCRG( 39, 17) =  0.498490E+00
  PKER_SACCRG( 39, 18) =  0.467518E+00
  PKER_SACCRG( 39, 19) =  0.521029E+00
  PKER_SACCRG( 39, 20) =  0.496417E+00
  PKER_SACCRG( 39, 21) =  0.507037E+00
  PKER_SACCRG( 39, 22) =  0.507063E+00
  PKER_SACCRG( 39, 23) =  0.504509E+00
  PKER_SACCRG( 39, 24) =  0.491577E+00
  PKER_SACCRG( 39, 25) =  0.493673E+00
  PKER_SACCRG( 39, 26) =  0.487788E+00
  PKER_SACCRG( 39, 27) =  0.482807E+00
  PKER_SACCRG( 39, 28) =  0.480014E+00
  PKER_SACCRG( 39, 29) =  0.470686E+00
  PKER_SACCRG( 39, 30) =  0.459128E+00
  PKER_SACCRG( 39, 31) =  0.449887E+00
  PKER_SACCRG( 39, 32) =  0.442941E+00
  PKER_SACCRG( 39, 33) =  0.437508E+00
  PKER_SACCRG( 39, 34) =  0.435762E+00
  PKER_SACCRG( 39, 35) =  0.431726E+00
  PKER_SACCRG( 39, 36) =  0.424049E+00
  PKER_SACCRG( 39, 37) =  0.000000E+00
  PKER_SACCRG( 39, 38) =  0.000000E+00
  PKER_SACCRG( 39, 39) =  0.000000E+00
  PKER_SACCRG( 39, 40) =  0.000000E+00
  PKER_SACCRG( 40,  1) =  0.000000E+00
  PKER_SACCRG( 40,  2) =  0.000000E+00
  PKER_SACCRG( 40,  3) =  0.000000E+00
  PKER_SACCRG( 40,  4) =  0.000000E+00
  PKER_SACCRG( 40,  5) =  0.000000E+00
  PKER_SACCRG( 40,  6) =  0.000000E+00
  PKER_SACCRG( 40,  7) =  0.000000E+00
  PKER_SACCRG( 40,  8) =  0.000000E+00
  PKER_SACCRG( 40,  9) =  0.000000E+00
  PKER_SACCRG( 40, 10) =  0.000000E+00
  PKER_SACCRG( 40, 11) =  0.000000E+00
  PKER_SACCRG( 40, 12) =  0.000000E+00
  PKER_SACCRG( 40, 13) =  0.000000E+00
  PKER_SACCRG( 40, 14) =  0.000000E+00
  PKER_SACCRG( 40, 15) =  0.000000E+00
  PKER_SACCRG( 40, 16) =  0.531993E+00
  PKER_SACCRG( 40, 17) =  0.498983E+00
  PKER_SACCRG( 40, 18) =  0.468012E+00
  PKER_SACCRG( 40, 19) =  0.521524E+00
  PKER_SACCRG( 40, 20) =  0.496911E+00
  PKER_SACCRG( 40, 21) =  0.507532E+00
  PKER_SACCRG( 40, 22) =  0.507558E+00
  PKER_SACCRG( 40, 23) =  0.505004E+00
  PKER_SACCRG( 40, 24) =  0.492073E+00
  PKER_SACCRG( 40, 25) =  0.494169E+00
  PKER_SACCRG( 40, 26) =  0.488284E+00
  PKER_SACCRG( 40, 27) =  0.483303E+00
  PKER_SACCRG( 40, 28) =  0.480510E+00
  PKER_SACCRG( 40, 29) =  0.471182E+00
  PKER_SACCRG( 40, 30) =  0.459624E+00
  PKER_SACCRG( 40, 31) =  0.450383E+00
  PKER_SACCRG( 40, 32) =  0.443437E+00
  PKER_SACCRG( 40, 33) =  0.438004E+00
  PKER_SACCRG( 40, 34) =  0.436256E+00
  PKER_SACCRG( 40, 35) =  0.432220E+00
  PKER_SACCRG( 40, 36) =  0.424544E+00
  PKER_SACCRG( 40, 37) =  0.000000E+00
  PKER_SACCRG( 40, 38) =  0.000000E+00
  PKER_SACCRG( 40, 39) =  0.000000E+00
  PKER_SACCRG( 40, 40) =  0.000000E+00
END IF
!
IF (LHOOK) CALL DR_HOOK('READ_XKER_RACCS',1,ZHOOK_HANDLE)
END SUBROUTINE READ_XKER_RACCS
END MODULE MODE_READ_XKER_RACCS
